/**
 * AuditFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the filter to limit which audits are
 *                         to be returned from the audit list operation.
 */
public class AuditFilter  implements java.io.Serializable {
    /* If specified, only audits with the given
     *                                 sequence number are returned. */
    private Long seqNo;

    /* If specified, only audits with a
     *                                 sequence number greater than or equal
     * to
     *                                 this value are returned. */
    private Long seqNoStart;

    /* If specified, only audits with a
     *                                 sequence number less than or equal
     * to
     *                                 this value are returned. */
    private Long seqNoEnd;

    /* If specified, only audits whose host match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String host;

    /* If specified, only audits whose level match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String level;

    /* If specified, only audits with the given
     *                                 code are returned. */
    private Integer code;

    /* If specified, only audits with one of the
     *                                 given codes are returned. */
    private int[] codes;

    /* If specified, only audits with a
     *                                 code greater than or equal to
     *                                 this value are returned. */
    private Integer codeStart;

    /* If specified, only audits with a
     *                                 code less than or equal to
     *                                 this value are returned. */
    private Integer codeEnd;

    /* If specified, returns only audits whose
     *                                 date is after the given date. */
    private java.util.Calendar dateStart;

    /* If specified, returns only audits whose
     *                                 date is before the given date. */
    private java.util.Calendar dateEnd;

    /* If specified, only audits whose service match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String service;

    /* If specified, only audits whose admin group
     *                                 match this expression are returned.
     * This string
     *                                 can include the '*' character for
     * wildcard
     *                                 matching. */
    private String adminGroup;

    /* If specified, only audits whose admin name
     *                                 match this expression are returned.
     * This string
     *                                 can include the '*' character for
     * wildcard
     *                                 matching. */
    private String adminName;

    /* If specified, only audits whose target type
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching. */
    private String targetType;

    /* If specified, only audits whose target type
     *                                 matches one of these expressions are
     * returned.
     *                                 Each value can include the '*' character
     * for
     *                                 wildcard matching. */
    private String[] targetTypes;

    /* If specified, only audits whose target op
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching. */
    private String targetOp;

    /* If specified, only audits whose target op
     *                                 match one of these expressions are
     * returned.
     *                                 Each value can include the '*' character
     * for
     *                                 wildcard matching. */
    private String[] targetOps;

    /* If specified, only audits whose target group
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching. */
    private String targetGroup;

    /* If specified, only audits whose target name
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching. */
    private String targetName;

    /* If specified, only audits whose target subname
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching. */
    private String targetSubname;

    /* If specified, only audits whose external
     *                                 code match this expression are returned.
     * This
     *                                 string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String externalCode;

    /* If specified, only audits whose external
     *                                 service match this expression are
     * returned.
     *                                 This string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String externalService;

    /* If specified, only audits whose text match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String text;

    /* The number of audits to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100. */
    private Integer maxReturn;

    public AuditFilter() {
    }

    public AuditFilter(
           Long seqNo,
           Long seqNoStart,
           Long seqNoEnd,
           String host,
           String level,
           Integer code,
           int[] codes,
           Integer codeStart,
           Integer codeEnd,
           java.util.Calendar dateStart,
           java.util.Calendar dateEnd,
           String service,
           String adminGroup,
           String adminName,
           String targetType,
           String[] targetTypes,
           String targetOp,
           String[] targetOps,
           String targetGroup,
           String targetName,
           String targetSubname,
           String externalCode,
           String externalService,
           String text,
           Integer maxReturn) {
           this.seqNo = seqNo;
           this.seqNoStart = seqNoStart;
           this.seqNoEnd = seqNoEnd;
           this.host = host;
           this.level = level;
           this.code = code;
           this.codes = codes;
           this.codeStart = codeStart;
           this.codeEnd = codeEnd;
           this.dateStart = dateStart;
           this.dateEnd = dateEnd;
           this.service = service;
           this.adminGroup = adminGroup;
           this.adminName = adminName;
           this.targetType = targetType;
           this.targetTypes = targetTypes;
           this.targetOp = targetOp;
           this.targetOps = targetOps;
           this.targetGroup = targetGroup;
           this.targetName = targetName;
           this.targetSubname = targetSubname;
           this.externalCode = externalCode;
           this.externalService = externalService;
           this.text = text;
           this.maxReturn = maxReturn;
    }


    /**
     * Gets the seqNo value for this AuditFilter.
     * 
     * @return seqNo   * If specified, only audits with the given
     *                                 sequence number are returned.
     */
    public Long getSeqNo() {
        return seqNo;
    }


    /**
     * Sets the seqNo value for this AuditFilter.
     * 
     * @param seqNo   * If specified, only audits with the given
     *                                 sequence number are returned.
     */
    public void setSeqNo(Long seqNo) {
        this.seqNo = seqNo;
    }


    /**
     * Gets the seqNoStart value for this AuditFilter.
     * 
     * @return seqNoStart   * If specified, only audits with a
     *                                 sequence number greater than or equal
     * to
     *                                 this value are returned.
     */
    public Long getSeqNoStart() {
        return seqNoStart;
    }


    /**
     * Sets the seqNoStart value for this AuditFilter.
     * 
     * @param seqNoStart   * If specified, only audits with a
     *                                 sequence number greater than or equal
     * to
     *                                 this value are returned.
     */
    public void setSeqNoStart(Long seqNoStart) {
        this.seqNoStart = seqNoStart;
    }


    /**
     * Gets the seqNoEnd value for this AuditFilter.
     * 
     * @return seqNoEnd   * If specified, only audits with a
     *                                 sequence number less than or equal
     * to
     *                                 this value are returned.
     */
    public Long getSeqNoEnd() {
        return seqNoEnd;
    }


    /**
     * Sets the seqNoEnd value for this AuditFilter.
     * 
     * @param seqNoEnd   * If specified, only audits with a
     *                                 sequence number less than or equal
     * to
     *                                 this value are returned.
     */
    public void setSeqNoEnd(Long seqNoEnd) {
        this.seqNoEnd = seqNoEnd;
    }


    /**
     * Gets the host value for this AuditFilter.
     * 
     * @return host   * If specified, only audits whose host match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getHost() {
        return host;
    }


    /**
     * Sets the host value for this AuditFilter.
     * 
     * @param host   * If specified, only audits whose host match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setHost(String host) {
        this.host = host;
    }


    /**
     * Gets the level value for this AuditFilter.
     * 
     * @return level   * If specified, only audits whose level match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getLevel() {
        return level;
    }


    /**
     * Sets the level value for this AuditFilter.
     * 
     * @param level   * If specified, only audits whose level match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setLevel(String level) {
        this.level = level;
    }


    /**
     * Gets the code value for this AuditFilter.
     * 
     * @return code   * If specified, only audits with the given
     *                                 code are returned.
     */
    public Integer getCode() {
        return code;
    }


    /**
     * Sets the code value for this AuditFilter.
     * 
     * @param code   * If specified, only audits with the given
     *                                 code are returned.
     */
    public void setCode(Integer code) {
        this.code = code;
    }


    /**
     * Gets the codes value for this AuditFilter.
     * 
     * @return codes   * If specified, only audits with one of the
     *                                 given codes are returned.
     */
    public int[] getCodes() {
        return codes;
    }


    /**
     * Sets the codes value for this AuditFilter.
     * 
     * @param codes   * If specified, only audits with one of the
     *                                 given codes are returned.
     */
    public void setCodes(int[] codes) {
        this.codes = codes;
    }


    /**
     * Gets the codeStart value for this AuditFilter.
     * 
     * @return codeStart   * If specified, only audits with a
     *                                 code greater than or equal to
     *                                 this value are returned.
     */
    public Integer getCodeStart() {
        return codeStart;
    }


    /**
     * Sets the codeStart value for this AuditFilter.
     * 
     * @param codeStart   * If specified, only audits with a
     *                                 code greater than or equal to
     *                                 this value are returned.
     */
    public void setCodeStart(Integer codeStart) {
        this.codeStart = codeStart;
    }


    /**
     * Gets the codeEnd value for this AuditFilter.
     * 
     * @return codeEnd   * If specified, only audits with a
     *                                 code less than or equal to
     *                                 this value are returned.
     */
    public Integer getCodeEnd() {
        return codeEnd;
    }


    /**
     * Sets the codeEnd value for this AuditFilter.
     * 
     * @param codeEnd   * If specified, only audits with a
     *                                 code less than or equal to
     *                                 this value are returned.
     */
    public void setCodeEnd(Integer codeEnd) {
        this.codeEnd = codeEnd;
    }


    /**
     * Gets the dateStart value for this AuditFilter.
     * 
     * @return dateStart   * If specified, returns only audits whose
     *                                 date is after the given date.
     */
    public java.util.Calendar getDateStart() {
        return dateStart;
    }


    /**
     * Sets the dateStart value for this AuditFilter.
     * 
     * @param dateStart   * If specified, returns only audits whose
     *                                 date is after the given date.
     */
    public void setDateStart(java.util.Calendar dateStart) {
        this.dateStart = dateStart;
    }


    /**
     * Gets the dateEnd value for this AuditFilter.
     * 
     * @return dateEnd   * If specified, returns only audits whose
     *                                 date is before the given date.
     */
    public java.util.Calendar getDateEnd() {
        return dateEnd;
    }


    /**
     * Sets the dateEnd value for this AuditFilter.
     * 
     * @param dateEnd   * If specified, returns only audits whose
     *                                 date is before the given date.
     */
    public void setDateEnd(java.util.Calendar dateEnd) {
        this.dateEnd = dateEnd;
    }


    /**
     * Gets the service value for this AuditFilter.
     * 
     * @return service   * If specified, only audits whose service match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getService() {
        return service;
    }


    /**
     * Sets the service value for this AuditFilter.
     * 
     * @param service   * If specified, only audits whose service match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setService(String service) {
        this.service = service;
    }


    /**
     * Gets the adminGroup value for this AuditFilter.
     * 
     * @return adminGroup   * If specified, only audits whose admin group
     *                                 match this expression are returned.
     * This string
     *                                 can include the '*' character for
     * wildcard
     *                                 matching.
     */
    public String getAdminGroup() {
        return adminGroup;
    }


    /**
     * Sets the adminGroup value for this AuditFilter.
     * 
     * @param adminGroup   * If specified, only audits whose admin group
     *                                 match this expression are returned.
     * This string
     *                                 can include the '*' character for
     * wildcard
     *                                 matching.
     */
    public void setAdminGroup(String adminGroup) {
        this.adminGroup = adminGroup;
    }


    /**
     * Gets the adminName value for this AuditFilter.
     * 
     * @return adminName   * If specified, only audits whose admin name
     *                                 match this expression are returned.
     * This string
     *                                 can include the '*' character for
     * wildcard
     *                                 matching.
     */
    public String getAdminName() {
        return adminName;
    }


    /**
     * Sets the adminName value for this AuditFilter.
     * 
     * @param adminName   * If specified, only audits whose admin name
     *                                 match this expression are returned.
     * This string
     *                                 can include the '*' character for
     * wildcard
     *                                 matching.
     */
    public void setAdminName(String adminName) {
        this.adminName = adminName;
    }


    /**
     * Gets the targetType value for this AuditFilter.
     * 
     * @return targetType   * If specified, only audits whose target type
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String getTargetType() {
        return targetType;
    }


    /**
     * Sets the targetType value for this AuditFilter.
     * 
     * @param targetType   * If specified, only audits whose target type
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetType(String targetType) {
        this.targetType = targetType;
    }


    /**
     * Gets the targetTypes value for this AuditFilter.
     * 
     * @return targetTypes   * If specified, only audits whose target type
     *                                 matches one of these expressions are
     * returned.
     *                                 Each value can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String[] getTargetTypes() {
        return targetTypes;
    }


    /**
     * Sets the targetTypes value for this AuditFilter.
     * 
     * @param targetTypes   * If specified, only audits whose target type
     *                                 matches one of these expressions are
     * returned.
     *                                 Each value can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetTypes(String[] targetTypes) {
        this.targetTypes = targetTypes;
    }


    /**
     * Gets the targetOp value for this AuditFilter.
     * 
     * @return targetOp   * If specified, only audits whose target op
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String getTargetOp() {
        return targetOp;
    }


    /**
     * Sets the targetOp value for this AuditFilter.
     * 
     * @param targetOp   * If specified, only audits whose target op
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetOp(String targetOp) {
        this.targetOp = targetOp;
    }


    /**
     * Gets the targetOps value for this AuditFilter.
     * 
     * @return targetOps   * If specified, only audits whose target op
     *                                 match one of these expressions are
     * returned.
     *                                 Each value can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String[] getTargetOps() {
        return targetOps;
    }


    /**
     * Sets the targetOps value for this AuditFilter.
     * 
     * @param targetOps   * If specified, only audits whose target op
     *                                 match one of these expressions are
     * returned.
     *                                 Each value can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetOps(String[] targetOps) {
        this.targetOps = targetOps;
    }


    /**
     * Gets the targetGroup value for this AuditFilter.
     * 
     * @return targetGroup   * If specified, only audits whose target group
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String getTargetGroup() {
        return targetGroup;
    }


    /**
     * Sets the targetGroup value for this AuditFilter.
     * 
     * @param targetGroup   * If specified, only audits whose target group
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetGroup(String targetGroup) {
        this.targetGroup = targetGroup;
    }


    /**
     * Gets the targetName value for this AuditFilter.
     * 
     * @return targetName   * If specified, only audits whose target name
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String getTargetName() {
        return targetName;
    }


    /**
     * Sets the targetName value for this AuditFilter.
     * 
     * @param targetName   * If specified, only audits whose target name
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }


    /**
     * Gets the targetSubname value for this AuditFilter.
     * 
     * @return targetSubname   * If specified, only audits whose target subname
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public String getTargetSubname() {
        return targetSubname;
    }


    /**
     * Sets the targetSubname value for this AuditFilter.
     * 
     * @param targetSubname   * If specified, only audits whose target subname
     *                                 match this expression are returned.
     * This
     *                                 string can include the '*' character
     * for
     *                                 wildcard matching.
     */
    public void setTargetSubname(String targetSubname) {
        this.targetSubname = targetSubname;
    }


    /**
     * Gets the externalCode value for this AuditFilter.
     * 
     * @return externalCode   * If specified, only audits whose external
     *                                 code match this expression are returned.
     * This
     *                                 string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getExternalCode() {
        return externalCode;
    }


    /**
     * Sets the externalCode value for this AuditFilter.
     * 
     * @param externalCode   * If specified, only audits whose external
     *                                 code match this expression are returned.
     * This
     *                                 string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setExternalCode(String externalCode) {
        this.externalCode = externalCode;
    }


    /**
     * Gets the externalService value for this AuditFilter.
     * 
     * @return externalService   * If specified, only audits whose external
     *                                 service match this expression are
     * returned.
     *                                 This string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getExternalService() {
        return externalService;
    }


    /**
     * Sets the externalService value for this AuditFilter.
     * 
     * @param externalService   * If specified, only audits whose external
     *                                 service match this expression are
     * returned.
     *                                 This string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setExternalService(String externalService) {
        this.externalService = externalService;
    }


    /**
     * Gets the text value for this AuditFilter.
     * 
     * @return text   * If specified, only audits whose text match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getText() {
        return text;
    }


    /**
     * Sets the text value for this AuditFilter.
     * 
     * @param text   * If specified, only audits whose text match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setText(String text) {
        this.text = text;
    }


    /**
     * Gets the maxReturn value for this AuditFilter.
     * 
     * @return maxReturn   * The number of audits to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100.
     */
    public Integer getMaxReturn() {
        return maxReturn;
    }


    /**
     * Sets the maxReturn value for this AuditFilter.
     * 
     * @param maxReturn   * The number of audits to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100.
     */
    public void setMaxReturn(Integer maxReturn) {
        this.maxReturn = maxReturn;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof AuditFilter)) return false;
        AuditFilter other = (AuditFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.seqNo==null && other.getSeqNo()==null) || 
             (this.seqNo!=null &&
              this.seqNo.equals(other.getSeqNo()))) &&
            ((this.seqNoStart==null && other.getSeqNoStart()==null) || 
             (this.seqNoStart!=null &&
              this.seqNoStart.equals(other.getSeqNoStart()))) &&
            ((this.seqNoEnd==null && other.getSeqNoEnd()==null) || 
             (this.seqNoEnd!=null &&
              this.seqNoEnd.equals(other.getSeqNoEnd()))) &&
            ((this.host==null && other.getHost()==null) || 
             (this.host!=null &&
              this.host.equals(other.getHost()))) &&
            ((this.level==null && other.getLevel()==null) || 
             (this.level!=null &&
              this.level.equals(other.getLevel()))) &&
            ((this.code==null && other.getCode()==null) || 
             (this.code!=null &&
              this.code.equals(other.getCode()))) &&
            ((this.codes==null && other.getCodes()==null) || 
             (this.codes!=null &&
              java.util.Arrays.equals(this.codes, other.getCodes()))) &&
            ((this.codeStart==null && other.getCodeStart()==null) || 
             (this.codeStart!=null &&
              this.codeStart.equals(other.getCodeStart()))) &&
            ((this.codeEnd==null && other.getCodeEnd()==null) || 
             (this.codeEnd!=null &&
              this.codeEnd.equals(other.getCodeEnd()))) &&
            ((this.dateStart==null && other.getDateStart()==null) || 
             (this.dateStart!=null &&
              this.dateStart.equals(other.getDateStart()))) &&
            ((this.dateEnd==null && other.getDateEnd()==null) || 
             (this.dateEnd!=null &&
              this.dateEnd.equals(other.getDateEnd()))) &&
            ((this.service==null && other.getService()==null) || 
             (this.service!=null &&
              this.service.equals(other.getService()))) &&
            ((this.adminGroup==null && other.getAdminGroup()==null) || 
             (this.adminGroup!=null &&
              this.adminGroup.equals(other.getAdminGroup()))) &&
            ((this.adminName==null && other.getAdminName()==null) || 
             (this.adminName!=null &&
              this.adminName.equals(other.getAdminName()))) &&
            ((this.targetType==null && other.getTargetType()==null) || 
             (this.targetType!=null &&
              this.targetType.equals(other.getTargetType()))) &&
            ((this.targetTypes==null && other.getTargetTypes()==null) || 
             (this.targetTypes!=null &&
              java.util.Arrays.equals(this.targetTypes, other.getTargetTypes()))) &&
            ((this.targetOp==null && other.getTargetOp()==null) || 
             (this.targetOp!=null &&
              this.targetOp.equals(other.getTargetOp()))) &&
            ((this.targetOps==null && other.getTargetOps()==null) || 
             (this.targetOps!=null &&
              java.util.Arrays.equals(this.targetOps, other.getTargetOps()))) &&
            ((this.targetGroup==null && other.getTargetGroup()==null) || 
             (this.targetGroup!=null &&
              this.targetGroup.equals(other.getTargetGroup()))) &&
            ((this.targetName==null && other.getTargetName()==null) || 
             (this.targetName!=null &&
              this.targetName.equals(other.getTargetName()))) &&
            ((this.targetSubname==null && other.getTargetSubname()==null) || 
             (this.targetSubname!=null &&
              this.targetSubname.equals(other.getTargetSubname()))) &&
            ((this.externalCode==null && other.getExternalCode()==null) || 
             (this.externalCode!=null &&
              this.externalCode.equals(other.getExternalCode()))) &&
            ((this.externalService==null && other.getExternalService()==null) || 
             (this.externalService!=null &&
              this.externalService.equals(other.getExternalService()))) &&
            ((this.text==null && other.getText()==null) || 
             (this.text!=null &&
              this.text.equals(other.getText()))) &&
            ((this.maxReturn==null && other.getMaxReturn()==null) || 
             (this.maxReturn!=null &&
              this.maxReturn.equals(other.getMaxReturn())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getSeqNo() != null) {
            _hashCode += getSeqNo().hashCode();
        }
        if (getSeqNoStart() != null) {
            _hashCode += getSeqNoStart().hashCode();
        }
        if (getSeqNoEnd() != null) {
            _hashCode += getSeqNoEnd().hashCode();
        }
        if (getHost() != null) {
            _hashCode += getHost().hashCode();
        }
        if (getLevel() != null) {
            _hashCode += getLevel().hashCode();
        }
        if (getCode() != null) {
            _hashCode += getCode().hashCode();
        }
        if (getCodes() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCodes());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCodes(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCodeStart() != null) {
            _hashCode += getCodeStart().hashCode();
        }
        if (getCodeEnd() != null) {
            _hashCode += getCodeEnd().hashCode();
        }
        if (getDateStart() != null) {
            _hashCode += getDateStart().hashCode();
        }
        if (getDateEnd() != null) {
            _hashCode += getDateEnd().hashCode();
        }
        if (getService() != null) {
            _hashCode += getService().hashCode();
        }
        if (getAdminGroup() != null) {
            _hashCode += getAdminGroup().hashCode();
        }
        if (getAdminName() != null) {
            _hashCode += getAdminName().hashCode();
        }
        if (getTargetType() != null) {
            _hashCode += getTargetType().hashCode();
        }
        if (getTargetTypes() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTargetTypes());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTargetTypes(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getTargetOp() != null) {
            _hashCode += getTargetOp().hashCode();
        }
        if (getTargetOps() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTargetOps());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTargetOps(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getTargetGroup() != null) {
            _hashCode += getTargetGroup().hashCode();
        }
        if (getTargetName() != null) {
            _hashCode += getTargetName().hashCode();
        }
        if (getTargetSubname() != null) {
            _hashCode += getTargetSubname().hashCode();
        }
        if (getExternalCode() != null) {
            _hashCode += getExternalCode().hashCode();
        }
        if (getExternalService() != null) {
            _hashCode += getExternalService().hashCode();
        }
        if (getText() != null) {
            _hashCode += getText().hashCode();
        }
        if (getMaxReturn() != null) {
            _hashCode += getMaxReturn().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(AuditFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuditFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("seqNo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "seqNo"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("seqNoStart");
        elemField.setXmlName(new javax.xml.namespace.QName("", "seqNoStart"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("seqNoEnd");
        elemField.setXmlName(new javax.xml.namespace.QName("", "seqNoEnd"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("host");
        elemField.setXmlName(new javax.xml.namespace.QName("", "host"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("level");
        elemField.setXmlName(new javax.xml.namespace.QName("", "level"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("code");
        elemField.setXmlName(new javax.xml.namespace.QName("", "code"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("codes");
        elemField.setXmlName(new javax.xml.namespace.QName("", "codes"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("codeStart");
        elemField.setXmlName(new javax.xml.namespace.QName("", "codeStart"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("codeEnd");
        elemField.setXmlName(new javax.xml.namespace.QName("", "codeEnd"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dateStart");
        elemField.setXmlName(new javax.xml.namespace.QName("", "dateStart"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dateEnd");
        elemField.setXmlName(new javax.xml.namespace.QName("", "dateEnd"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("service");
        elemField.setXmlName(new javax.xml.namespace.QName("", "service"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("adminGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "adminGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("adminName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "adminName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetTypes");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetTypes"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetOp");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetOp"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetOps");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetOps"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetSubname");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetSubname"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("externalCode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "externalCode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("externalService");
        elemField.setXmlName(new javax.xml.namespace.QName("", "externalService"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("text");
        elemField.setXmlName(new javax.xml.namespace.QName("", "text"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxReturn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxReturn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
