/**
 * AuditInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned about an audit
 */
public class AuditInfo  implements java.io.Serializable {
    /* The sequence number of the audit. */
    private long seqNo;

    /* The date on which the audit was generated */
    private java.util.Calendar date;

    /* The host of the audit. */
    private String host;

    /* The level of the audit. */
    private String level;

    /* The code of the audit. */
    private int code;

    /* The symbolic name for the code of the audit. */
    private String symbol;

    /* The group of the administrator performing this
     *                                 operation.  This value will be null
     * if the
     *                                 audit was not generated by an administrator. */
    private String adminGroup;

    /* The name of the administrator or master user
     *                                 performing this operation.  This value
     * will be
     *                                 null if the audit was not generated
     * by an
     *                                 administrator or master user. */
    private String adminName;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetType describes the type of the target
     *                                 object.  Example target types include
     * USER,
     *                                 USERCARD, USERTOKEN and POLICY. */
    private String targetType;

    /* The targetOp describes the operation performed
     *                                 on the target object.  Example target
     * operations include CREATE, DELETE and MODIFY. */
    private String targetOp;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  If
     * the
     *                                 name of the target includes a group,
     * the
     *                                 targetGroup will be the group of the
     * target
     *                                 object.  An example of a name that
     * includes
     *                                 a group are userids that include both
     * a
     *                                 group and username. */
    private String targetGroup;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetName
     *                                 will be the name of the target object.
     * value will be the group of the userid.  An
     *                                 example of an object name is the username
     * of a user, the name of a policy, role or group
     *                                 or the serial number of an unassigned
     * token
     *                                 or preproduced card. */
    private String targetName;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  For
     * objects
     *                                 that have subnames, the targetSubname
     * will
     *                                 be the subname of the object.  An
     * example
     *                                 of a subname is the serial number
     * for a user
     *                                 card or token. */
    private String targetSubname;

    /* The Entrust IdentityGuard service that 
     *                                 generated this audit. */
    private String service;

    /* If this audit was generated by an external
     *                                 service, this value will include the
     * code
     *                                 provided by the external service. */
    private String externalCode;

    /* If this audit was generated by an external
     *                                 service, this value will include the
     * service
     *                                 name provided by the external service. */
    private String externalService;

    /* The text of this audit. */
    private String text;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public AuditInfo() {
    }

    public AuditInfo(
           long seqNo,
           java.util.Calendar date,
           String host,
           String level,
           int code,
           String symbol,
           String adminGroup,
           String adminName,
           String targetType,
           String targetOp,
           String targetGroup,
           String targetName,
           String targetSubname,
           String service,
           String externalCode,
           String externalService,
           String text,
           String[] rolesGrantingAccess) {
           this.seqNo = seqNo;
           this.date = date;
           this.host = host;
           this.level = level;
           this.code = code;
           this.symbol = symbol;
           this.adminGroup = adminGroup;
           this.adminName = adminName;
           this.targetType = targetType;
           this.targetOp = targetOp;
           this.targetGroup = targetGroup;
           this.targetName = targetName;
           this.targetSubname = targetSubname;
           this.service = service;
           this.externalCode = externalCode;
           this.externalService = externalService;
           this.text = text;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the seqNo value for this AuditInfo.
     * 
     * @return seqNo   * The sequence number of the audit.
     */
    public long getSeqNo() {
        return seqNo;
    }


    /**
     * Sets the seqNo value for this AuditInfo.
     * 
     * @param seqNo   * The sequence number of the audit.
     */
    public void setSeqNo(long seqNo) {
        this.seqNo = seqNo;
    }


    /**
     * Gets the date value for this AuditInfo.
     * 
     * @return date   * The date on which the audit was generated
     */
    public java.util.Calendar getDate() {
        return date;
    }


    /**
     * Sets the date value for this AuditInfo.
     * 
     * @param date   * The date on which the audit was generated
     */
    public void setDate(java.util.Calendar date) {
        this.date = date;
    }


    /**
     * Gets the host value for this AuditInfo.
     * 
     * @return host   * The host of the audit.
     */
    public String getHost() {
        return host;
    }


    /**
     * Sets the host value for this AuditInfo.
     * 
     * @param host   * The host of the audit.
     */
    public void setHost(String host) {
        this.host = host;
    }


    /**
     * Gets the level value for this AuditInfo.
     * 
     * @return level   * The level of the audit.
     */
    public String getLevel() {
        return level;
    }


    /**
     * Sets the level value for this AuditInfo.
     * 
     * @param level   * The level of the audit.
     */
    public void setLevel(String level) {
        this.level = level;
    }


    /**
     * Gets the code value for this AuditInfo.
     * 
     * @return code   * The code of the audit.
     */
    public int getCode() {
        return code;
    }


    /**
     * Sets the code value for this AuditInfo.
     * 
     * @param code   * The code of the audit.
     */
    public void setCode(int code) {
        this.code = code;
    }


    /**
     * Gets the symbol value for this AuditInfo.
     * 
     * @return symbol   * The symbolic name for the code of the audit.
     */
    public String getSymbol() {
        return symbol;
    }


    /**
     * Sets the symbol value for this AuditInfo.
     * 
     * @param symbol   * The symbolic name for the code of the audit.
     */
    public void setSymbol(String symbol) {
        this.symbol = symbol;
    }


    /**
     * Gets the adminGroup value for this AuditInfo.
     * 
     * @return adminGroup   * The group of the administrator performing this
     *                                 operation.  This value will be null
     * if the
     *                                 audit was not generated by an administrator.
     */
    public String getAdminGroup() {
        return adminGroup;
    }


    /**
     * Sets the adminGroup value for this AuditInfo.
     * 
     * @param adminGroup   * The group of the administrator performing this
     *                                 operation.  This value will be null
     * if the
     *                                 audit was not generated by an administrator.
     */
    public void setAdminGroup(String adminGroup) {
        this.adminGroup = adminGroup;
    }


    /**
     * Gets the adminName value for this AuditInfo.
     * 
     * @return adminName   * The name of the administrator or master user
     *                                 performing this operation.  This value
     * will be
     *                                 null if the audit was not generated
     * by an
     *                                 administrator or master user.
     */
    public String getAdminName() {
        return adminName;
    }


    /**
     * Sets the adminName value for this AuditInfo.
     * 
     * @param adminName   * The name of the administrator or master user
     *                                 performing this operation.  This value
     * will be
     *                                 null if the audit was not generated
     * by an
     *                                 administrator or master user.
     */
    public void setAdminName(String adminName) {
        this.adminName = adminName;
    }


    /**
     * Gets the targetType value for this AuditInfo.
     * 
     * @return targetType   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetType describes the type of the target
     *                                 object.  Example target types include
     * USER,
     *                                 USERCARD, USERTOKEN and POLICY.
     */
    public String getTargetType() {
        return targetType;
    }


    /**
     * Sets the targetType value for this AuditInfo.
     * 
     * @param targetType   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetType describes the type of the target
     *                                 object.  Example target types include
     * USER,
     *                                 USERCARD, USERTOKEN and POLICY.
     */
    public void setTargetType(String targetType) {
        this.targetType = targetType;
    }


    /**
     * Gets the targetOp value for this AuditInfo.
     * 
     * @return targetOp   * The targetOp describes the operation performed
     *                                 on the target object.  Example target
     * operations include CREATE, DELETE and MODIFY.
     */
    public String getTargetOp() {
        return targetOp;
    }


    /**
     * Sets the targetOp value for this AuditInfo.
     * 
     * @param targetOp   * The targetOp describes the operation performed
     *                                 on the target object.  Example target
     * operations include CREATE, DELETE and MODIFY.
     */
    public void setTargetOp(String targetOp) {
        this.targetOp = targetOp;
    }


    /**
     * Gets the targetGroup value for this AuditInfo.
     * 
     * @return targetGroup   * The target of the audit is the object that
     *                                 the operation was performed on.  If
     * the
     *                                 name of the target includes a group,
     * the
     *                                 targetGroup will be the group of the
     * target
     *                                 object.  An example of a name that
     * includes
     *                                 a group are userids that include both
     * a
     *                                 group and username.
     */
    public String getTargetGroup() {
        return targetGroup;
    }


    /**
     * Sets the targetGroup value for this AuditInfo.
     * 
     * @param targetGroup   * The target of the audit is the object that
     *                                 the operation was performed on.  If
     * the
     *                                 name of the target includes a group,
     * the
     *                                 targetGroup will be the group of the
     * target
     *                                 object.  An example of a name that
     * includes
     *                                 a group are userids that include both
     * a
     *                                 group and username.
     */
    public void setTargetGroup(String targetGroup) {
        this.targetGroup = targetGroup;
    }


    /**
     * Gets the targetName value for this AuditInfo.
     * 
     * @return targetName   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetName
     *                                 will be the name of the target object.
     * value will be the group of the userid.  An
     *                                 example of an object name is the username
     * of a user, the name of a policy, role or group
     *                                 or the serial number of an unassigned
     * token
     *                                 or preproduced card.
     */
    public String getTargetName() {
        return targetName;
    }


    /**
     * Sets the targetName value for this AuditInfo.
     * 
     * @param targetName   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetName
     *                                 will be the name of the target object.
     * value will be the group of the userid.  An
     *                                 example of an object name is the username
     * of a user, the name of a policy, role or group
     *                                 or the serial number of an unassigned
     * token
     *                                 or preproduced card.
     */
    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }


    /**
     * Gets the targetSubname value for this AuditInfo.
     * 
     * @return targetSubname   * The target of the audit is the object that
     *                                 the operation was performed on.  For
     * objects
     *                                 that have subnames, the targetSubname
     * will
     *                                 be the subname of the object.  An
     * example
     *                                 of a subname is the serial number
     * for a user
     *                                 card or token.
     */
    public String getTargetSubname() {
        return targetSubname;
    }


    /**
     * Sets the targetSubname value for this AuditInfo.
     * 
     * @param targetSubname   * The target of the audit is the object that
     *                                 the operation was performed on.  For
     * objects
     *                                 that have subnames, the targetSubname
     * will
     *                                 be the subname of the object.  An
     * example
     *                                 of a subname is the serial number
     * for a user
     *                                 card or token.
     */
    public void setTargetSubname(String targetSubname) {
        this.targetSubname = targetSubname;
    }


    /**
     * Gets the service value for this AuditInfo.
     * 
     * @return service   * The Entrust IdentityGuard service that 
     *                                 generated this audit.
     */
    public String getService() {
        return service;
    }


    /**
     * Sets the service value for this AuditInfo.
     * 
     * @param service   * The Entrust IdentityGuard service that 
     *                                 generated this audit.
     */
    public void setService(String service) {
        this.service = service;
    }


    /**
     * Gets the externalCode value for this AuditInfo.
     * 
     * @return externalCode   * If this audit was generated by an external
     *                                 service, this value will include the
     * code
     *                                 provided by the external service.
     */
    public String getExternalCode() {
        return externalCode;
    }


    /**
     * Sets the externalCode value for this AuditInfo.
     * 
     * @param externalCode   * If this audit was generated by an external
     *                                 service, this value will include the
     * code
     *                                 provided by the external service.
     */
    public void setExternalCode(String externalCode) {
        this.externalCode = externalCode;
    }


    /**
     * Gets the externalService value for this AuditInfo.
     * 
     * @return externalService   * If this audit was generated by an external
     *                                 service, this value will include the
     * service
     *                                 name provided by the external service.
     */
    public String getExternalService() {
        return externalService;
    }


    /**
     * Sets the externalService value for this AuditInfo.
     * 
     * @param externalService   * If this audit was generated by an external
     *                                 service, this value will include the
     * service
     *                                 name provided by the external service.
     */
    public void setExternalService(String externalService) {
        this.externalService = externalService;
    }


    /**
     * Gets the text value for this AuditInfo.
     * 
     * @return text   * The text of this audit.
     */
    public String getText() {
        return text;
    }


    /**
     * Sets the text value for this AuditInfo.
     * 
     * @param text   * The text of this audit.
     */
    public void setText(String text) {
        this.text = text;
    }


    /**
     * Gets the rolesGrantingAccess value for this AuditInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this AuditInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof AuditInfo)) return false;
        AuditInfo other = (AuditInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            this.seqNo == other.getSeqNo() &&
            ((this.date==null && other.getDate()==null) || 
             (this.date!=null &&
              this.date.equals(other.getDate()))) &&
            ((this.host==null && other.getHost()==null) || 
             (this.host!=null &&
              this.host.equals(other.getHost()))) &&
            ((this.level==null && other.getLevel()==null) || 
             (this.level!=null &&
              this.level.equals(other.getLevel()))) &&
            this.code == other.getCode() &&
            ((this.symbol==null && other.getSymbol()==null) || 
             (this.symbol!=null &&
              this.symbol.equals(other.getSymbol()))) &&
            ((this.adminGroup==null && other.getAdminGroup()==null) || 
             (this.adminGroup!=null &&
              this.adminGroup.equals(other.getAdminGroup()))) &&
            ((this.adminName==null && other.getAdminName()==null) || 
             (this.adminName!=null &&
              this.adminName.equals(other.getAdminName()))) &&
            ((this.targetType==null && other.getTargetType()==null) || 
             (this.targetType!=null &&
              this.targetType.equals(other.getTargetType()))) &&
            ((this.targetOp==null && other.getTargetOp()==null) || 
             (this.targetOp!=null &&
              this.targetOp.equals(other.getTargetOp()))) &&
            ((this.targetGroup==null && other.getTargetGroup()==null) || 
             (this.targetGroup!=null &&
              this.targetGroup.equals(other.getTargetGroup()))) &&
            ((this.targetName==null && other.getTargetName()==null) || 
             (this.targetName!=null &&
              this.targetName.equals(other.getTargetName()))) &&
            ((this.targetSubname==null && other.getTargetSubname()==null) || 
             (this.targetSubname!=null &&
              this.targetSubname.equals(other.getTargetSubname()))) &&
            ((this.service==null && other.getService()==null) || 
             (this.service!=null &&
              this.service.equals(other.getService()))) &&
            ((this.externalCode==null && other.getExternalCode()==null) || 
             (this.externalCode!=null &&
              this.externalCode.equals(other.getExternalCode()))) &&
            ((this.externalService==null && other.getExternalService()==null) || 
             (this.externalService!=null &&
              this.externalService.equals(other.getExternalService()))) &&
            ((this.text==null && other.getText()==null) || 
             (this.text!=null &&
              this.text.equals(other.getText()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        _hashCode += new Long(getSeqNo()).hashCode();
        if (getDate() != null) {
            _hashCode += getDate().hashCode();
        }
        if (getHost() != null) {
            _hashCode += getHost().hashCode();
        }
        if (getLevel() != null) {
            _hashCode += getLevel().hashCode();
        }
        _hashCode += getCode();
        if (getSymbol() != null) {
            _hashCode += getSymbol().hashCode();
        }
        if (getAdminGroup() != null) {
            _hashCode += getAdminGroup().hashCode();
        }
        if (getAdminName() != null) {
            _hashCode += getAdminName().hashCode();
        }
        if (getTargetType() != null) {
            _hashCode += getTargetType().hashCode();
        }
        if (getTargetOp() != null) {
            _hashCode += getTargetOp().hashCode();
        }
        if (getTargetGroup() != null) {
            _hashCode += getTargetGroup().hashCode();
        }
        if (getTargetName() != null) {
            _hashCode += getTargetName().hashCode();
        }
        if (getTargetSubname() != null) {
            _hashCode += getTargetSubname().hashCode();
        }
        if (getService() != null) {
            _hashCode += getService().hashCode();
        }
        if (getExternalCode() != null) {
            _hashCode += getExternalCode().hashCode();
        }
        if (getExternalService() != null) {
            _hashCode += getExternalService().hashCode();
        }
        if (getText() != null) {
            _hashCode += getText().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(AuditInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuditInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("seqNo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "seqNo"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("date");
        elemField.setXmlName(new javax.xml.namespace.QName("", "date"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("host");
        elemField.setXmlName(new javax.xml.namespace.QName("", "host"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("level");
        elemField.setXmlName(new javax.xml.namespace.QName("", "level"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("code");
        elemField.setXmlName(new javax.xml.namespace.QName("", "code"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("symbol");
        elemField.setXmlName(new javax.xml.namespace.QName("", "symbol"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("adminGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "adminGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("adminName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "adminName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetOp");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetOp"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetSubname");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetSubname"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("service");
        elemField.setXmlName(new javax.xml.namespace.QName("", "service"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("externalCode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "externalCode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("externalService");
        elemField.setXmlName(new javax.xml.namespace.QName("", "externalService"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("text");
        elemField.setXmlName(new javax.xml.namespace.QName("", "text"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
