/**
 * AuditParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information that can be specified when
 *                         an external service creates an audit using
 * the
 *                         auditCreate method.
 */
public class AuditParms  implements java.io.Serializable {
    /* The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetType describes the type of the target
     *                                 object.  Example target types include
     * USER,
     *                                 USERCARD, USERTOKEN and POLICY.  If
     * specified,
     *                                 the value has a maximum length of
     * 20
     *                                 characters. */
    private String targetType;

    /* The targetOp describes the operation performed
     *                                 on the target object.  Example target
     * operations include CREATE, DELETE and MODIFY.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 20 characters. */
    private String targetOp;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  If
     * the
     *                                 name of the target includes a group,
     * the
     *                                 targetGroup will be the group of the
     * target
     *                                 object.  An example of a name that
     * includes
     *                                 a group are userids that include both
     * a
     *                                 group and username.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters. */
    private String targetGroup;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetName
     *                                 will be the name of the target object.
     * value will be the group of the userid.  An
     *                                 example of an object name is the username
     * of a user, the name of a policy, role or group
     *                                 or the serial number of an unassigned
     * token
     *                                 or preproduced card.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters. */
    private String targetName;

    /* The target of the audit is the object that
     *                                 the operation was performed on.  For
     * objects
     *                                 that have subnames, the targetSubname
     * will
     *                                 be the subname of the object.  An
     * example
     *                                 of a subname is the serial number
     * for a user
     *                                 card or token.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters. */
    private String targetSubname;

    /* If this audit was generated by an external
     *                                 service, this value will include the
     * code
     *                                 provided by the external service.
     *                                 The value has a maximum length
     *                                 of 20 characters. */
    private String externalCode;

    /* If this audit was generated by an external
     *                                 service, this value will include the
     * service
     *                                 name provided by the external service.
     * The value has a maximum length
     *                                 of 255 characters. */
    private String externalService;

    /* The text of this audit.
     *                                 The value has a maximum length of
     * 4096
     *                                 characters. */
    private String text;

    public AuditParms() {
    }

    public AuditParms(
           String targetType,
           String targetOp,
           String targetGroup,
           String targetName,
           String targetSubname,
           String externalCode,
           String externalService,
           String text) {
           this.targetType = targetType;
           this.targetOp = targetOp;
           this.targetGroup = targetGroup;
           this.targetName = targetName;
           this.targetSubname = targetSubname;
           this.externalCode = externalCode;
           this.externalService = externalService;
           this.text = text;
    }


    /**
     * Gets the targetType value for this AuditParms.
     * 
     * @return targetType   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetType describes the type of the target
     *                                 object.  Example target types include
     * USER,
     *                                 USERCARD, USERTOKEN and POLICY.  If
     * specified,
     *                                 the value has a maximum length of
     * 20
     *                                 characters.
     */
    public String getTargetType() {
        return targetType;
    }


    /**
     * Sets the targetType value for this AuditParms.
     * 
     * @param targetType   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetType describes the type of the target
     *                                 object.  Example target types include
     * USER,
     *                                 USERCARD, USERTOKEN and POLICY.  If
     * specified,
     *                                 the value has a maximum length of
     * 20
     *                                 characters.
     */
    public void setTargetType(String targetType) {
        this.targetType = targetType;
    }


    /**
     * Gets the targetOp value for this AuditParms.
     * 
     * @return targetOp   * The targetOp describes the operation performed
     *                                 on the target object.  Example target
     * operations include CREATE, DELETE and MODIFY.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 20 characters.
     */
    public String getTargetOp() {
        return targetOp;
    }


    /**
     * Sets the targetOp value for this AuditParms.
     * 
     * @param targetOp   * The targetOp describes the operation performed
     *                                 on the target object.  Example target
     * operations include CREATE, DELETE and MODIFY.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 20 characters.
     */
    public void setTargetOp(String targetOp) {
        this.targetOp = targetOp;
    }


    /**
     * Gets the targetGroup value for this AuditParms.
     * 
     * @return targetGroup   * The target of the audit is the object that
     *                                 the operation was performed on.  If
     * the
     *                                 name of the target includes a group,
     * the
     *                                 targetGroup will be the group of the
     * target
     *                                 object.  An example of a name that
     * includes
     *                                 a group are userids that include both
     * a
     *                                 group and username.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters.
     */
    public String getTargetGroup() {
        return targetGroup;
    }


    /**
     * Sets the targetGroup value for this AuditParms.
     * 
     * @param targetGroup   * The target of the audit is the object that
     *                                 the operation was performed on.  If
     * the
     *                                 name of the target includes a group,
     * the
     *                                 targetGroup will be the group of the
     * target
     *                                 object.  An example of a name that
     * includes
     *                                 a group are userids that include both
     * a
     *                                 group and username.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters.
     */
    public void setTargetGroup(String targetGroup) {
        this.targetGroup = targetGroup;
    }


    /**
     * Gets the targetName value for this AuditParms.
     * 
     * @return targetName   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetName
     *                                 will be the name of the target object.
     * value will be the group of the userid.  An
     *                                 example of an object name is the username
     * of a user, the name of a policy, role or group
     *                                 or the serial number of an unassigned
     * token
     *                                 or preproduced card.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters.
     */
    public String getTargetName() {
        return targetName;
    }


    /**
     * Sets the targetName value for this AuditParms.
     * 
     * @param targetName   * The target of the audit is the object that
     *                                 the operation was performed on.  The
     * targetName
     *                                 will be the name of the target object.
     * value will be the group of the userid.  An
     *                                 example of an object name is the username
     * of a user, the name of a policy, role or group
     *                                 or the serial number of an unassigned
     * token
     *                                 or preproduced card.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters.
     */
    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }


    /**
     * Gets the targetSubname value for this AuditParms.
     * 
     * @return targetSubname   * The target of the audit is the object that
     *                                 the operation was performed on.  For
     * objects
     *                                 that have subnames, the targetSubname
     * will
     *                                 be the subname of the object.  An
     * example
     *                                 of a subname is the serial number
     * for a user
     *                                 card or token.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters.
     */
    public String getTargetSubname() {
        return targetSubname;
    }


    /**
     * Sets the targetSubname value for this AuditParms.
     * 
     * @param targetSubname   * The target of the audit is the object that
     *                                 the operation was performed on.  For
     * objects
     *                                 that have subnames, the targetSubname
     * will
     *                                 be the subname of the object.  An
     * example
     *                                 of a subname is the serial number
     * for a user
     *                                 card or token.
     *                                 If specified, the value has a maximum
     * length
     *                                 of 255 characters.
     */
    public void setTargetSubname(String targetSubname) {
        this.targetSubname = targetSubname;
    }


    /**
     * Gets the externalCode value for this AuditParms.
     * 
     * @return externalCode   * If this audit was generated by an external
     *                                 service, this value will include the
     * code
     *                                 provided by the external service.
     *                                 The value has a maximum length
     *                                 of 20 characters.
     */
    public String getExternalCode() {
        return externalCode;
    }


    /**
     * Sets the externalCode value for this AuditParms.
     * 
     * @param externalCode   * If this audit was generated by an external
     *                                 service, this value will include the
     * code
     *                                 provided by the external service.
     *                                 The value has a maximum length
     *                                 of 20 characters.
     */
    public void setExternalCode(String externalCode) {
        this.externalCode = externalCode;
    }


    /**
     * Gets the externalService value for this AuditParms.
     * 
     * @return externalService   * If this audit was generated by an external
     *                                 service, this value will include the
     * service
     *                                 name provided by the external service.
     * The value has a maximum length
     *                                 of 255 characters.
     */
    public String getExternalService() {
        return externalService;
    }


    /**
     * Sets the externalService value for this AuditParms.
     * 
     * @param externalService   * If this audit was generated by an external
     *                                 service, this value will include the
     * service
     *                                 name provided by the external service.
     * The value has a maximum length
     *                                 of 255 characters.
     */
    public void setExternalService(String externalService) {
        this.externalService = externalService;
    }


    /**
     * Gets the text value for this AuditParms.
     * 
     * @return text   * The text of this audit.
     *                                 The value has a maximum length of
     * 4096
     *                                 characters.
     */
    public String getText() {
        return text;
    }


    /**
     * Sets the text value for this AuditParms.
     * 
     * @param text   * The text of this audit.
     *                                 The value has a maximum length of
     * 4096
     *                                 characters.
     */
    public void setText(String text) {
        this.text = text;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof AuditParms)) return false;
        AuditParms other = (AuditParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.targetType==null && other.getTargetType()==null) || 
             (this.targetType!=null &&
              this.targetType.equals(other.getTargetType()))) &&
            ((this.targetOp==null && other.getTargetOp()==null) || 
             (this.targetOp!=null &&
              this.targetOp.equals(other.getTargetOp()))) &&
            ((this.targetGroup==null && other.getTargetGroup()==null) || 
             (this.targetGroup!=null &&
              this.targetGroup.equals(other.getTargetGroup()))) &&
            ((this.targetName==null && other.getTargetName()==null) || 
             (this.targetName!=null &&
              this.targetName.equals(other.getTargetName()))) &&
            ((this.targetSubname==null && other.getTargetSubname()==null) || 
             (this.targetSubname!=null &&
              this.targetSubname.equals(other.getTargetSubname()))) &&
            ((this.externalCode==null && other.getExternalCode()==null) || 
             (this.externalCode!=null &&
              this.externalCode.equals(other.getExternalCode()))) &&
            ((this.externalService==null && other.getExternalService()==null) || 
             (this.externalService!=null &&
              this.externalService.equals(other.getExternalService()))) &&
            ((this.text==null && other.getText()==null) || 
             (this.text!=null &&
              this.text.equals(other.getText())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getTargetType() != null) {
            _hashCode += getTargetType().hashCode();
        }
        if (getTargetOp() != null) {
            _hashCode += getTargetOp().hashCode();
        }
        if (getTargetGroup() != null) {
            _hashCode += getTargetGroup().hashCode();
        }
        if (getTargetName() != null) {
            _hashCode += getTargetName().hashCode();
        }
        if (getTargetSubname() != null) {
            _hashCode += getTargetSubname().hashCode();
        }
        if (getExternalCode() != null) {
            _hashCode += getExternalCode().hashCode();
        }
        if (getExternalService() != null) {
            _hashCode += getExternalService().hashCode();
        }
        if (getText() != null) {
            _hashCode += getText().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(AuditParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuditParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetOp");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetOp"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("targetSubname");
        elemField.setXmlName(new javax.xml.namespace.QName("", "targetSubname"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("externalCode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "externalCode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("externalService");
        elemField.setXmlName(new javax.xml.namespace.QName("", "externalService"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("text");
        elemField.setXmlName(new javax.xml.namespace.QName("", "text"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
