/**
 * AuthenticatorLockout.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information returned about an authenticator lockout.
 */
public class AuthenticatorLockout  implements java.io.Serializable {
    /* The authenticator lockout id. */
    private AuthenticatorLockoutId id;

    /* The number of failed authentications
     *                                 remaining for this authenticator.
     * A value
     *                                 of 0 indicates the authenticator is
     * locked.
     *                                 A negative value indicates the authenticator
     * will never be locked out due to failing 
     *                                 authentication. Whether the user is
     * locked 
     *                                 out of all authenticators is determined
     * by 
     *                                 the lockout mode policy. */
    private int failureCount;

    /* The date on which the lockout for this
     *                                 specific authenticator will expire.
     * The value is only meaningful if this 
     *                                 specific authenticator's' FailureCount
     * is 0. 
     *                                 A value of Date(0) means the lockout
     * will 
     *                                 not expire (i.e., it must be cleared
     * by an 
     *                                 administrator). */
    private java.util.Calendar lockoutDate;

    public AuthenticatorLockout() {
    }

    public AuthenticatorLockout(
           AuthenticatorLockoutId id,
           int failureCount,
           java.util.Calendar lockoutDate) {
           this.id = id;
           this.failureCount = failureCount;
           this.lockoutDate = lockoutDate;
    }


    /**
     * Gets the id value for this AuthenticatorLockout.
     * 
     * @return id   * The authenticator lockout id.
     */
    public AuthenticatorLockoutId getId() {
        return id;
    }


    /**
     * Sets the id value for this AuthenticatorLockout.
     * 
     * @param id   * The authenticator lockout id.
     */
    public void setId(AuthenticatorLockoutId id) {
        this.id = id;
    }


    /**
     * Gets the failureCount value for this AuthenticatorLockout.
     * 
     * @return failureCount   * The number of failed authentications
     *                                 remaining for this authenticator.
     * A value
     *                                 of 0 indicates the authenticator is
     * locked.
     *                                 A negative value indicates the authenticator
     * will never be locked out due to failing 
     *                                 authentication. Whether the user is
     * locked 
     *                                 out of all authenticators is determined
     * by 
     *                                 the lockout mode policy.
     */
    public int getFailureCount() {
        return failureCount;
    }


    /**
     * Sets the failureCount value for this AuthenticatorLockout.
     * 
     * @param failureCount   * The number of failed authentications
     *                                 remaining for this authenticator.
     * A value
     *                                 of 0 indicates the authenticator is
     * locked.
     *                                 A negative value indicates the authenticator
     * will never be locked out due to failing 
     *                                 authentication. Whether the user is
     * locked 
     *                                 out of all authenticators is determined
     * by 
     *                                 the lockout mode policy.
     */
    public void setFailureCount(int failureCount) {
        this.failureCount = failureCount;
    }


    /**
     * Gets the lockoutDate value for this AuthenticatorLockout.
     * 
     * @return lockoutDate   * The date on which the lockout for this
     *                                 specific authenticator will expire.
     * The value is only meaningful if this 
     *                                 specific authenticator's' FailureCount
     * is 0. 
     *                                 A value of Date(0) means the lockout
     * will 
     *                                 not expire (i.e., it must be cleared
     * by an 
     *                                 administrator).
     */
    public java.util.Calendar getLockoutDate() {
        return lockoutDate;
    }


    /**
     * Sets the lockoutDate value for this AuthenticatorLockout.
     * 
     * @param lockoutDate   * The date on which the lockout for this
     *                                 specific authenticator will expire.
     * The value is only meaningful if this 
     *                                 specific authenticator's' FailureCount
     * is 0. 
     *                                 A value of Date(0) means the lockout
     * will 
     *                                 not expire (i.e., it must be cleared
     * by an 
     *                                 administrator).
     */
    public void setLockoutDate(java.util.Calendar lockoutDate) {
        this.lockoutDate = lockoutDate;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof AuthenticatorLockout)) return false;
        AuthenticatorLockout other = (AuthenticatorLockout) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.id==null && other.getId()==null) || 
             (this.id!=null &&
              this.id.equals(other.getId()))) &&
            this.failureCount == other.getFailureCount() &&
            ((this.lockoutDate==null && other.getLockoutDate()==null) || 
             (this.lockoutDate!=null &&
              this.lockoutDate.equals(other.getLockoutDate())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getId() != null) {
            _hashCode += getId().hashCode();
        }
        _hashCode += getFailureCount();
        if (getLockoutDate() != null) {
            _hashCode += getLockoutDate().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(AuthenticatorLockout.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuthenticatorLockout"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("id");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Id"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuthenticatorLockoutId"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("failureCount");
        elemField.setXmlName(new javax.xml.namespace.QName("", "FailureCount"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("lockoutDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "LockoutDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
