/**
 * ContactInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the user contact information.
 */
public class ContactInfo  implements java.io.Serializable {
    /* Is this contact info mapped from an attribute
     *                                 in the repository? */
    private boolean mapped;

    /* Is this contact info hiding a mapping from a
     *                                 repository attribute to a contact
     * info? This may
     *                                 happen when a user already has a contact
     * info
     *                                 with a particular label, e.g. Email,
     * then a
     *                                 contact info mapping rule is defined
     * for this
     *                                 label. Since a user's contact info
     * labels must
     *                                 be unique, the user cannot have both
     * the
     *                                 original contact information and the
     * mapped
     *                                 contact information.  An application
     * that values
     *                                 mapped contact information over user-defined
     * contact information could use this flag to 
     *                                 automatically delete the user-defined
     * contact
     *                                 information, thus making the mapped
     * contact
     *                                 information available. */
    private boolean hidingMapping;

    /* The user contact info label. */
    private String contactInfoLabel;

    /* Was the label for this contact info created
     *                                 by mapping an attribute in the repository
     * to
     *                                 contact info?
     *                                 If true then yes, otherwise it means
     * the label
     *                                 was set by a user. */
    private boolean contactInfoLabelMapped;

    /* The value of the user contact info. */
    private String value;

    /* Was the value for this contact info created
     *                                 by mapping an attribute in the repository
     * to
     *                                 contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 value of a mapped contact info.  This
     * may
     *                                 indicate that the value in the repository
     * should
     *                                 be updated too. */
    private boolean valueMapped;

    /* The label of the delivery configuration that is
     *                                 associated with this user contact
     * info. */
    private String deliveryConfigLabel;

    /* Was the delivery configuration for this contact
     *                                 info set by mapping an attribute in
     * the
     *                                 repository to contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 delivery configuration of a mapped
     * contact info. */
    private boolean deliveryConfigLabelMapped;

    /* If true, it means this user contact info
     *                                 instance is default. The delivery
     * configuration
     *                                 associated with this contact info
     * is used for
     *                                 out-of-band data delivery when no
     * contact info
     *                                 is specified for delivery. Defaults
     * to false. */
    private boolean defaultContactInfo;

    /* Was the defaultContactInfo flag for this contact
     *                                 info set by mapping an attribute in
     * the
     *                                 repository to contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 defaultContactInfo flag of a mapped
     * contact info. */
    private boolean defaultMapped;

    public ContactInfo() {
    }

    public ContactInfo(
           boolean mapped,
           boolean hidingMapping,
           String contactInfoLabel,
           boolean contactInfoLabelMapped,
           String value,
           boolean valueMapped,
           String deliveryConfigLabel,
           boolean deliveryConfigLabelMapped,
           boolean defaultContactInfo,
           boolean defaultMapped) {
           this.mapped = mapped;
           this.hidingMapping = hidingMapping;
           this.contactInfoLabel = contactInfoLabel;
           this.contactInfoLabelMapped = contactInfoLabelMapped;
           this.value = value;
           this.valueMapped = valueMapped;
           this.deliveryConfigLabel = deliveryConfigLabel;
           this.deliveryConfigLabelMapped = deliveryConfigLabelMapped;
           this.defaultContactInfo = defaultContactInfo;
           this.defaultMapped = defaultMapped;
    }


    /**
     * Gets the mapped value for this ContactInfo.
     * 
     * @return mapped   * Is this contact info mapped from an attribute
     *                                 in the repository?
     */
    public boolean isMapped() {
        return mapped;
    }


    /**
     * Sets the mapped value for this ContactInfo.
     * 
     * @param mapped   * Is this contact info mapped from an attribute
     *                                 in the repository?
     */
    public void setMapped(boolean mapped) {
        this.mapped = mapped;
    }


    /**
     * Gets the hidingMapping value for this ContactInfo.
     * 
     * @return hidingMapping   * Is this contact info hiding a mapping from a
     *                                 repository attribute to a contact
     * info? This may
     *                                 happen when a user already has a contact
     * info
     *                                 with a particular label, e.g. Email,
     * then a
     *                                 contact info mapping rule is defined
     * for this
     *                                 label. Since a user's contact info
     * labels must
     *                                 be unique, the user cannot have both
     * the
     *                                 original contact information and the
     * mapped
     *                                 contact information.  An application
     * that values
     *                                 mapped contact information over user-defined
     * contact information could use this flag to 
     *                                 automatically delete the user-defined
     * contact
     *                                 information, thus making the mapped
     * contact
     *                                 information available.
     */
    public boolean isHidingMapping() {
        return hidingMapping;
    }


    /**
     * Sets the hidingMapping value for this ContactInfo.
     * 
     * @param hidingMapping   * Is this contact info hiding a mapping from a
     *                                 repository attribute to a contact
     * info? This may
     *                                 happen when a user already has a contact
     * info
     *                                 with a particular label, e.g. Email,
     * then a
     *                                 contact info mapping rule is defined
     * for this
     *                                 label. Since a user's contact info
     * labels must
     *                                 be unique, the user cannot have both
     * the
     *                                 original contact information and the
     * mapped
     *                                 contact information.  An application
     * that values
     *                                 mapped contact information over user-defined
     * contact information could use this flag to 
     *                                 automatically delete the user-defined
     * contact
     *                                 information, thus making the mapped
     * contact
     *                                 information available.
     */
    public void setHidingMapping(boolean hidingMapping) {
        this.hidingMapping = hidingMapping;
    }


    /**
     * Gets the contactInfoLabel value for this ContactInfo.
     * 
     * @return contactInfoLabel   * The user contact info label.
     */
    public String getContactInfoLabel() {
        return contactInfoLabel;
    }


    /**
     * Sets the contactInfoLabel value for this ContactInfo.
     * 
     * @param contactInfoLabel   * The user contact info label.
     */
    public void setContactInfoLabel(String contactInfoLabel) {
        this.contactInfoLabel = contactInfoLabel;
    }


    /**
     * Gets the contactInfoLabelMapped value for this ContactInfo.
     * 
     * @return contactInfoLabelMapped   * Was the label for this contact info created
     *                                 by mapping an attribute in the repository
     * to
     *                                 contact info?
     *                                 If true then yes, otherwise it means
     * the label
     *                                 was set by a user.
     */
    public boolean isContactInfoLabelMapped() {
        return contactInfoLabelMapped;
    }


    /**
     * Sets the contactInfoLabelMapped value for this ContactInfo.
     * 
     * @param contactInfoLabelMapped   * Was the label for this contact info created
     *                                 by mapping an attribute in the repository
     * to
     *                                 contact info?
     *                                 If true then yes, otherwise it means
     * the label
     *                                 was set by a user.
     */
    public void setContactInfoLabelMapped(boolean contactInfoLabelMapped) {
        this.contactInfoLabelMapped = contactInfoLabelMapped;
    }


    /**
     * Gets the value value for this ContactInfo.
     * 
     * @return value   * The value of the user contact info.
     */
    public String getValue() {
        return value;
    }


    /**
     * Sets the value value for this ContactInfo.
     * 
     * @param value   * The value of the user contact info.
     */
    public void setValue(String value) {
        this.value = value;
    }


    /**
     * Gets the valueMapped value for this ContactInfo.
     * 
     * @return valueMapped   * Was the value for this contact info created
     *                                 by mapping an attribute in the repository
     * to
     *                                 contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 value of a mapped contact info.  This
     * may
     *                                 indicate that the value in the repository
     * should
     *                                 be updated too.
     */
    public boolean isValueMapped() {
        return valueMapped;
    }


    /**
     * Sets the valueMapped value for this ContactInfo.
     * 
     * @param valueMapped   * Was the value for this contact info created
     *                                 by mapping an attribute in the repository
     * to
     *                                 contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 value of a mapped contact info.  This
     * may
     *                                 indicate that the value in the repository
     * should
     *                                 be updated too.
     */
    public void setValueMapped(boolean valueMapped) {
        this.valueMapped = valueMapped;
    }


    /**
     * Gets the deliveryConfigLabel value for this ContactInfo.
     * 
     * @return deliveryConfigLabel   * The label of the delivery configuration that is
     *                                 associated with this user contact
     * info.
     */
    public String getDeliveryConfigLabel() {
        return deliveryConfigLabel;
    }


    /**
     * Sets the deliveryConfigLabel value for this ContactInfo.
     * 
     * @param deliveryConfigLabel   * The label of the delivery configuration that is
     *                                 associated with this user contact
     * info.
     */
    public void setDeliveryConfigLabel(String deliveryConfigLabel) {
        this.deliveryConfigLabel = deliveryConfigLabel;
    }


    /**
     * Gets the deliveryConfigLabelMapped value for this ContactInfo.
     * 
     * @return deliveryConfigLabelMapped   * Was the delivery configuration for this contact
     *                                 info set by mapping an attribute in
     * the
     *                                 repository to contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 delivery configuration of a mapped
     * contact info.
     */
    public boolean isDeliveryConfigLabelMapped() {
        return deliveryConfigLabelMapped;
    }


    /**
     * Sets the deliveryConfigLabelMapped value for this ContactInfo.
     * 
     * @param deliveryConfigLabelMapped   * Was the delivery configuration for this contact
     *                                 info set by mapping an attribute in
     * the
     *                                 repository to contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 delivery configuration of a mapped
     * contact info.
     */
    public void setDeliveryConfigLabelMapped(boolean deliveryConfigLabelMapped) {
        this.deliveryConfigLabelMapped = deliveryConfigLabelMapped;
    }


    /**
     * Gets the defaultContactInfo value for this ContactInfo.
     * 
     * @return defaultContactInfo   * If true, it means this user contact info
     *                                 instance is default. The delivery
     * configuration
     *                                 associated with this contact info
     * is used for
     *                                 out-of-band data delivery when no
     * contact info
     *                                 is specified for delivery. Defaults
     * to false.
     */
    public boolean isDefaultContactInfo() {
        return defaultContactInfo;
    }


    /**
     * Sets the defaultContactInfo value for this ContactInfo.
     * 
     * @param defaultContactInfo   * If true, it means this user contact info
     *                                 instance is default. The delivery
     * configuration
     *                                 associated with this contact info
     * is used for
     *                                 out-of-band data delivery when no
     * contact info
     *                                 is specified for delivery. Defaults
     * to false.
     */
    public void setDefaultContactInfo(boolean defaultContactInfo) {
        this.defaultContactInfo = defaultContactInfo;
    }


    /**
     * Gets the defaultMapped value for this ContactInfo.
     * 
     * @return defaultMapped   * Was the defaultContactInfo flag for this contact
     *                                 info set by mapping an attribute in
     * the
     *                                 repository to contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 defaultContactInfo flag of a mapped
     * contact info.
     */
    public boolean isDefaultMapped() {
        return defaultMapped;
    }


    /**
     * Sets the defaultMapped value for this ContactInfo.
     * 
     * @param defaultMapped   * Was the defaultContactInfo flag for this contact
     *                                 info set by mapping an attribute in
     * the
     *                                 repository to contact info?
     *                                 If true then yes.  If false, and isMapped
     * is
     *                                 true, it means a user has manually
     * changed the
     *                                 defaultContactInfo flag of a mapped
     * contact info.
     */
    public void setDefaultMapped(boolean defaultMapped) {
        this.defaultMapped = defaultMapped;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ContactInfo)) return false;
        ContactInfo other = (ContactInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            this.mapped == other.isMapped() &&
            this.hidingMapping == other.isHidingMapping() &&
            ((this.contactInfoLabel==null && other.getContactInfoLabel()==null) || 
             (this.contactInfoLabel!=null &&
              this.contactInfoLabel.equals(other.getContactInfoLabel()))) &&
            this.contactInfoLabelMapped == other.isContactInfoLabelMapped() &&
            ((this.value==null && other.getValue()==null) || 
             (this.value!=null &&
              this.value.equals(other.getValue()))) &&
            this.valueMapped == other.isValueMapped() &&
            ((this.deliveryConfigLabel==null && other.getDeliveryConfigLabel()==null) || 
             (this.deliveryConfigLabel!=null &&
              this.deliveryConfigLabel.equals(other.getDeliveryConfigLabel()))) &&
            this.deliveryConfigLabelMapped == other.isDeliveryConfigLabelMapped() &&
            this.defaultContactInfo == other.isDefaultContactInfo() &&
            this.defaultMapped == other.isDefaultMapped();
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        _hashCode += (isMapped() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isHidingMapping() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getContactInfoLabel() != null) {
            _hashCode += getContactInfoLabel().hashCode();
        }
        _hashCode += (isContactInfoLabelMapped() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getValue() != null) {
            _hashCode += getValue().hashCode();
        }
        _hashCode += (isValueMapped() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getDeliveryConfigLabel() != null) {
            _hashCode += getDeliveryConfigLabel().hashCode();
        }
        _hashCode += (isDeliveryConfigLabelMapped() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isDefaultContactInfo() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isDefaultMapped() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ContactInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ContactInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("mapped");
        elemField.setXmlName(new javax.xml.namespace.QName("", "mapped"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("hidingMapping");
        elemField.setXmlName(new javax.xml.namespace.QName("", "hidingMapping"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("contactInfoLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "contactInfoLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("contactInfoLabelMapped");
        elemField.setXmlName(new javax.xml.namespace.QName("", "contactInfoLabelMapped"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("value");
        elemField.setXmlName(new javax.xml.namespace.QName("", "value"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("valueMapped");
        elemField.setXmlName(new javax.xml.namespace.QName("", "valueMapped"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deliveryConfigLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "deliveryConfigLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deliveryConfigLabelMapped");
        elemField.setXmlName(new javax.xml.namespace.QName("", "deliveryConfigLabelMapped"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultContactInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultContactInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultMapped");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultMapped"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
