/**
 * DigitalIdCertResponse.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines a Digital Id Certificate Response.
 */
public class DigitalIdCertResponse  implements java.io.Serializable {
    /* The name and unique identifier of the 
     *                                 certificate stream policy that governs
     * the 
     *                                 issuance the requested certificate.
     * When used 
     *                                 with an Entrust CA, this is the certificate
     * 
     *                                 definition name; when used with a
     * Microsoft CA, 
     *                                 this is the certificate template common
     * name. */
    private com.good.adapters.entrust.stubs.DigitalIdCertStreamPolicyNameAndId certStreamPolicyNamdAndId;

    /* A list (from most newest to oldest) of
     *                                 certificates and private keys. The
     * first entry
     *                                 will always be present; it is the
     * latest key
     *                                 and certificate in the stream. The
     * certificate
     *                                 for this entry will always be present
     * but the 
     *                                 private key will only be present for
     * certificate 
     *                                 streams that indicate server generation
     * and 
     *                                 entries that are recovered from backup.
     * The 
     *                                 remaining entries will be present
     * only during a 
     *                                 key recovery operation. For these
     * entries, 
     *                                 a certificate and private key will
     * always be
     *                                 present. */
    private CertAndKey[] certsAndKeys;

    /* Provides a template for the Microsoft CryptoAPI 
     *                                 (MS-CAPI) key container names when
     * the private
     *                                 keys of this certificate stream are
     * stored in
     *                                 MS-CAPI. */
    private String mscapiKeyContainerNameTemplate;

    public DigitalIdCertResponse() {
    }

    public DigitalIdCertResponse(
           com.good.adapters.entrust.stubs.DigitalIdCertStreamPolicyNameAndId certStreamPolicyNamdAndId,
           CertAndKey[] certsAndKeys,
           String mscapiKeyContainerNameTemplate) {
           this.certStreamPolicyNamdAndId = certStreamPolicyNamdAndId;
           this.certsAndKeys = certsAndKeys;
           this.mscapiKeyContainerNameTemplate = mscapiKeyContainerNameTemplate;
    }


    /**
     * Gets the certStreamPolicyNamdAndId value for this DigitalIdCertResponse.
     * 
     * @return certStreamPolicyNamdAndId   * The name and unique identifier of the 
     *                                 certificate stream policy that governs
     * the 
     *                                 issuance the requested certificate.
     * When used 
     *                                 with an Entrust CA, this is the certificate
     * 
     *                                 definition name; when used with a
     * Microsoft CA, 
     *                                 this is the certificate template common
     * name.
     */
    public com.good.adapters.entrust.stubs.DigitalIdCertStreamPolicyNameAndId getCertStreamPolicyNamdAndId() {
        return certStreamPolicyNamdAndId;
    }


    /**
     * Sets the certStreamPolicyNamdAndId value for this DigitalIdCertResponse.
     * 
     * @param certStreamPolicyNamdAndId   * The name and unique identifier of the 
     *                                 certificate stream policy that governs
     * the 
     *                                 issuance the requested certificate.
     * When used 
     *                                 with an Entrust CA, this is the certificate
     * 
     *                                 definition name; when used with a
     * Microsoft CA, 
     *                                 this is the certificate template common
     * name.
     */
    public void setCertStreamPolicyNamdAndId(com.good.adapters.entrust.stubs.DigitalIdCertStreamPolicyNameAndId certStreamPolicyNamdAndId) {
        this.certStreamPolicyNamdAndId = certStreamPolicyNamdAndId;
    }


    /**
     * Gets the certsAndKeys value for this DigitalIdCertResponse.
     * 
     * @return certsAndKeys   * A list (from most newest to oldest) of
     *                                 certificates and private keys. The
     * first entry
     *                                 will always be present; it is the
     * latest key
     *                                 and certificate in the stream. The
     * certificate
     *                                 for this entry will always be present
     * but the 
     *                                 private key will only be present for
     * certificate 
     *                                 streams that indicate server generation
     * and 
     *                                 entries that are recovered from backup.
     * The 
     *                                 remaining entries will be present
     * only during a 
     *                                 key recovery operation. For these
     * entries, 
     *                                 a certificate and private key will
     * always be
     *                                 present.
     */
    public CertAndKey[] getCertsAndKeys() {
        return certsAndKeys;
    }


    /**
     * Sets the certsAndKeys value for this DigitalIdCertResponse.
     * 
     * @param certsAndKeys   * A list (from most newest to oldest) of
     *                                 certificates and private keys. The
     * first entry
     *                                 will always be present; it is the
     * latest key
     *                                 and certificate in the stream. The
     * certificate
     *                                 for this entry will always be present
     * but the 
     *                                 private key will only be present for
     * certificate 
     *                                 streams that indicate server generation
     * and 
     *                                 entries that are recovered from backup.
     * The 
     *                                 remaining entries will be present
     * only during a 
     *                                 key recovery operation. For these
     * entries, 
     *                                 a certificate and private key will
     * always be
     *                                 present.
     */
    public void setCertsAndKeys(CertAndKey[] certsAndKeys) {
        this.certsAndKeys = certsAndKeys;
    }


    /**
     * Gets the mscapiKeyContainerNameTemplate value for this DigitalIdCertResponse.
     * 
     * @return mscapiKeyContainerNameTemplate   * Provides a template for the Microsoft CryptoAPI 
     *                                 (MS-CAPI) key container names when
     * the private
     *                                 keys of this certificate stream are
     * stored in
     *                                 MS-CAPI.
     */
    public String getMscapiKeyContainerNameTemplate() {
        return mscapiKeyContainerNameTemplate;
    }


    /**
     * Sets the mscapiKeyContainerNameTemplate value for this DigitalIdCertResponse.
     * 
     * @param mscapiKeyContainerNameTemplate   * Provides a template for the Microsoft CryptoAPI 
     *                                 (MS-CAPI) key container names when
     * the private
     *                                 keys of this certificate stream are
     * stored in
     *                                 MS-CAPI.
     */
    public void setMscapiKeyContainerNameTemplate(String mscapiKeyContainerNameTemplate) {
        this.mscapiKeyContainerNameTemplate = mscapiKeyContainerNameTemplate;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdCertResponse)) return false;
        DigitalIdCertResponse other = (DigitalIdCertResponse) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.certStreamPolicyNamdAndId==null && other.getCertStreamPolicyNamdAndId()==null) || 
             (this.certStreamPolicyNamdAndId!=null &&
              this.certStreamPolicyNamdAndId.equals(other.getCertStreamPolicyNamdAndId()))) &&
            ((this.certsAndKeys==null && other.getCertsAndKeys()==null) || 
             (this.certsAndKeys!=null &&
              java.util.Arrays.equals(this.certsAndKeys, other.getCertsAndKeys()))) &&
            ((this.mscapiKeyContainerNameTemplate==null && other.getMscapiKeyContainerNameTemplate()==null) || 
             (this.mscapiKeyContainerNameTemplate!=null &&
              this.mscapiKeyContainerNameTemplate.equals(other.getMscapiKeyContainerNameTemplate())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCertStreamPolicyNamdAndId() != null) {
            _hashCode += getCertStreamPolicyNamdAndId().hashCode();
        }
        if (getCertsAndKeys() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCertsAndKeys());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCertsAndKeys(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMscapiKeyContainerNameTemplate() != null) {
            _hashCode += getMscapiKeyContainerNameTemplate().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdCertResponse.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdCertResponse"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certStreamPolicyNamdAndId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CertStreamPolicyNamdAndId"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdCertStreamPolicyNameAndId"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certsAndKeys");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CertsAndKeys"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "CertAndKey"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("mscapiKeyContainerNameTemplate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "MscapiKeyContainerNameTemplate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
