/**
 * DigitalIdCertStreamPolicyNameAndId.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Identifying information for policy that governs a 
 *                         certificate stream in a Digital ID. For an
 * Entrust CA, 
 *                         this policy object corresponds to a certificate
 * 
 *                         definition. For a Microsoft CA this policy
 * object 
 *                         corresponds to a certificate template.
 */
public class DigitalIdCertStreamPolicyNameAndId  implements java.io.Serializable {
    /* The display name of the certificate stream 
     *                                 policy; intended for human consumption. */
    private String displayName;

    /* The name of the certificate stream policy; 
     *                                 intended for identifying the certificate
     * stream
     *                                 policy to the Certification Authority.
     * For an 
     *                                 Entrust CA, this is the certificate
     * definition 
     *                                 name; for a Microsoft CA, this is
     * the 
     *                                 certificate template name. */
    private String name;

    /* The ID of the certificate stream policy; a CA 
     *                                 wide unique identifier for the certificate
     * 
     *                                 stream. For an Entrust CA, this is
     * the 
     *                                 certificate type ID concatenated with
     * the 
     *                                 certificate definition ID name; for
     * a Microsoft 
     *                                 CA, this is the certificate template
     * name. */
    private String id;

    public DigitalIdCertStreamPolicyNameAndId() {
    }

    public DigitalIdCertStreamPolicyNameAndId(
           String displayName,
           String name,
           String id) {
           this.displayName = displayName;
           this.name = name;
           this.id = id;
    }


    /**
     * Gets the displayName value for this DigitalIdCertStreamPolicyNameAndId.
     * 
     * @return displayName   * The display name of the certificate stream 
     *                                 policy; intended for human consumption.
     */
    public String getDisplayName() {
        return displayName;
    }


    /**
     * Sets the displayName value for this DigitalIdCertStreamPolicyNameAndId.
     * 
     * @param displayName   * The display name of the certificate stream 
     *                                 policy; intended for human consumption.
     */
    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }


    /**
     * Gets the name value for this DigitalIdCertStreamPolicyNameAndId.
     * 
     * @return name   * The name of the certificate stream policy; 
     *                                 intended for identifying the certificate
     * stream
     *                                 policy to the Certification Authority.
     * For an 
     *                                 Entrust CA, this is the certificate
     * definition 
     *                                 name; for a Microsoft CA, this is
     * the 
     *                                 certificate template name.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this DigitalIdCertStreamPolicyNameAndId.
     * 
     * @param name   * The name of the certificate stream policy; 
     *                                 intended for identifying the certificate
     * stream
     *                                 policy to the Certification Authority.
     * For an 
     *                                 Entrust CA, this is the certificate
     * definition 
     *                                 name; for a Microsoft CA, this is
     * the 
     *                                 certificate template name.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the id value for this DigitalIdCertStreamPolicyNameAndId.
     * 
     * @return id   * The ID of the certificate stream policy; a CA 
     *                                 wide unique identifier for the certificate
     * 
     *                                 stream. For an Entrust CA, this is
     * the 
     *                                 certificate type ID concatenated with
     * the 
     *                                 certificate definition ID name; for
     * a Microsoft 
     *                                 CA, this is the certificate template
     * name.
     */
    public String getId() {
        return id;
    }


    /**
     * Sets the id value for this DigitalIdCertStreamPolicyNameAndId.
     * 
     * @param id   * The ID of the certificate stream policy; a CA 
     *                                 wide unique identifier for the certificate
     * 
     *                                 stream. For an Entrust CA, this is
     * the 
     *                                 certificate type ID concatenated with
     * the 
     *                                 certificate definition ID name; for
     * a Microsoft 
     *                                 CA, this is the certificate template
     * name.
     */
    public void setId(String id) {
        this.id = id;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdCertStreamPolicyNameAndId)) return false;
        DigitalIdCertStreamPolicyNameAndId other = (DigitalIdCertStreamPolicyNameAndId) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.displayName==null && other.getDisplayName()==null) || 
             (this.displayName!=null &&
              this.displayName.equals(other.getDisplayName()))) &&
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.id==null && other.getId()==null) || 
             (this.id!=null &&
              this.id.equals(other.getId())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getDisplayName() != null) {
            _hashCode += getDisplayName().hashCode();
        }
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getId() != null) {
            _hashCode += getId().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdCertStreamPolicyNameAndId.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdCertStreamPolicyNameAndId"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("displayName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DisplayName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("id");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Id"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
