/**
 * DigitalIdConfigEntrustSpecificInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information specific to an Entrust Digital Id config.
 */
public class DigitalIdConfigEntrustSpecificInfo  implements java.io.Serializable {
    /* The cert. type of the Digital Id Config. */
    private String certType;

    /* The user type of the Digital Id Config. */
    private String userType;

    /* The role of the Digital Id Config. */
    private String role;

    /* If set to true, the digital id will belong
     *                                 to all groups in Entrust Security
     * Manager. */
    private Boolean allGroups;

    /* The list of Entrust Security Manager groups
     *                                 the digital id will belong to.  This
     * list
     *                                 will not be set if allGroups is true. */
    private String[] groups;

    /* The optional Managed CA variables of the
     *                                 Digital Id Config. */
    private ManagedCaVariable[] variables;

    /* The optional directory mode of the Digital Id
     *                                 Config. */
    private ManagedCaDirectoryMode directoryMode;

    /* The flag indicating if the operation should
     *                                 recover an existing Digital Id. The
     * flag
     *                                 defaults to true if not specified. */
    private Boolean recoverIfExists;

    /* A flag indicating if the operation should
     *                                 add a new Digital Id if one does not
     * exist.
     *                                 The flag defaults to true if not specified. */
    private Boolean createIfNotExists;

    public DigitalIdConfigEntrustSpecificInfo() {
    }

    public DigitalIdConfigEntrustSpecificInfo(
           String certType,
           String userType,
           String role,
           Boolean allGroups,
           String[] groups,
           ManagedCaVariable[] variables,
           ManagedCaDirectoryMode directoryMode,
           Boolean recoverIfExists,
           Boolean createIfNotExists) {
           this.certType = certType;
           this.userType = userType;
           this.role = role;
           this.allGroups = allGroups;
           this.groups = groups;
           this.variables = variables;
           this.directoryMode = directoryMode;
           this.recoverIfExists = recoverIfExists;
           this.createIfNotExists = createIfNotExists;
    }


    /**
     * Gets the certType value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return certType   * The cert. type of the Digital Id Config.
     */
    public String getCertType() {
        return certType;
    }


    /**
     * Sets the certType value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param certType   * The cert. type of the Digital Id Config.
     */
    public void setCertType(String certType) {
        this.certType = certType;
    }


    /**
     * Gets the userType value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return userType   * The user type of the Digital Id Config.
     */
    public String getUserType() {
        return userType;
    }


    /**
     * Sets the userType value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param userType   * The user type of the Digital Id Config.
     */
    public void setUserType(String userType) {
        this.userType = userType;
    }


    /**
     * Gets the role value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return role   * The role of the Digital Id Config.
     */
    public String getRole() {
        return role;
    }


    /**
     * Sets the role value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param role   * The role of the Digital Id Config.
     */
    public void setRole(String role) {
        this.role = role;
    }


    /**
     * Gets the allGroups value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return allGroups   * If set to true, the digital id will belong
     *                                 to all groups in Entrust Security
     * Manager.
     */
    public Boolean getAllGroups() {
        return allGroups;
    }


    /**
     * Sets the allGroups value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param allGroups   * If set to true, the digital id will belong
     *                                 to all groups in Entrust Security
     * Manager.
     */
    public void setAllGroups(Boolean allGroups) {
        this.allGroups = allGroups;
    }


    /**
     * Gets the groups value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return groups   * The list of Entrust Security Manager groups
     *                                 the digital id will belong to.  This
     * list
     *                                 will not be set if allGroups is true.
     */
    public String[] getGroups() {
        return groups;
    }


    /**
     * Sets the groups value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param groups   * The list of Entrust Security Manager groups
     *                                 the digital id will belong to.  This
     * list
     *                                 will not be set if allGroups is true.
     */
    public void setGroups(String[] groups) {
        this.groups = groups;
    }


    /**
     * Gets the variables value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return variables   * The optional Managed CA variables of the
     *                                 Digital Id Config.
     */
    public ManagedCaVariable[] getVariables() {
        return variables;
    }


    /**
     * Sets the variables value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param variables   * The optional Managed CA variables of the
     *                                 Digital Id Config.
     */
    public void setVariables(ManagedCaVariable[] variables) {
        this.variables = variables;
    }


    /**
     * Gets the directoryMode value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return directoryMode   * The optional directory mode of the Digital Id
     *                                 Config.
     */
    public ManagedCaDirectoryMode getDirectoryMode() {
        return directoryMode;
    }


    /**
     * Sets the directoryMode value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param directoryMode   * The optional directory mode of the Digital Id
     *                                 Config.
     */
    public void setDirectoryMode(ManagedCaDirectoryMode directoryMode) {
        this.directoryMode = directoryMode;
    }


    /**
     * Gets the recoverIfExists value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return recoverIfExists   * The flag indicating if the operation should
     *                                 recover an existing Digital Id. The
     * flag
     *                                 defaults to true if not specified.
     */
    public Boolean getRecoverIfExists() {
        return recoverIfExists;
    }


    /**
     * Sets the recoverIfExists value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param recoverIfExists   * The flag indicating if the operation should
     *                                 recover an existing Digital Id. The
     * flag
     *                                 defaults to true if not specified.
     */
    public void setRecoverIfExists(Boolean recoverIfExists) {
        this.recoverIfExists = recoverIfExists;
    }


    /**
     * Gets the createIfNotExists value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @return createIfNotExists   * A flag indicating if the operation should
     *                                 add a new Digital Id if one does not
     * exist.
     *                                 The flag defaults to true if not specified.
     */
    public Boolean getCreateIfNotExists() {
        return createIfNotExists;
    }


    /**
     * Sets the createIfNotExists value for this DigitalIdConfigEntrustSpecificInfo.
     * 
     * @param createIfNotExists   * A flag indicating if the operation should
     *                                 add a new Digital Id if one does not
     * exist.
     *                                 The flag defaults to true if not specified.
     */
    public void setCreateIfNotExists(Boolean createIfNotExists) {
        this.createIfNotExists = createIfNotExists;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdConfigEntrustSpecificInfo)) return false;
        DigitalIdConfigEntrustSpecificInfo other = (DigitalIdConfigEntrustSpecificInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.certType==null && other.getCertType()==null) || 
             (this.certType!=null &&
              this.certType.equals(other.getCertType()))) &&
            ((this.userType==null && other.getUserType()==null) || 
             (this.userType!=null &&
              this.userType.equals(other.getUserType()))) &&
            ((this.role==null && other.getRole()==null) || 
             (this.role!=null &&
              this.role.equals(other.getRole()))) &&
            ((this.allGroups==null && other.getAllGroups()==null) || 
             (this.allGroups!=null &&
              this.allGroups.equals(other.getAllGroups()))) &&
            ((this.groups==null && other.getGroups()==null) || 
             (this.groups!=null &&
              java.util.Arrays.equals(this.groups, other.getGroups()))) &&
            ((this.variables==null && other.getVariables()==null) || 
             (this.variables!=null &&
              java.util.Arrays.equals(this.variables, other.getVariables()))) &&
            ((this.directoryMode==null && other.getDirectoryMode()==null) || 
             (this.directoryMode!=null &&
              this.directoryMode.equals(other.getDirectoryMode()))) &&
            ((this.recoverIfExists==null && other.getRecoverIfExists()==null) || 
             (this.recoverIfExists!=null &&
              this.recoverIfExists.equals(other.getRecoverIfExists()))) &&
            ((this.createIfNotExists==null && other.getCreateIfNotExists()==null) || 
             (this.createIfNotExists!=null &&
              this.createIfNotExists.equals(other.getCreateIfNotExists())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCertType() != null) {
            _hashCode += getCertType().hashCode();
        }
        if (getUserType() != null) {
            _hashCode += getUserType().hashCode();
        }
        if (getRole() != null) {
            _hashCode += getRole().hashCode();
        }
        if (getAllGroups() != null) {
            _hashCode += getAllGroups().hashCode();
        }
        if (getGroups() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroups());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroups(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getVariables() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getVariables());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getVariables(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDirectoryMode() != null) {
            _hashCode += getDirectoryMode().hashCode();
        }
        if (getRecoverIfExists() != null) {
            _hashCode += getRecoverIfExists().hashCode();
        }
        if (getCreateIfNotExists() != null) {
            _hashCode += getCreateIfNotExists().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdConfigEntrustSpecificInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigEntrustSpecificInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CertType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("role");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Role"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allGroups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allGroups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("variables");
        elemField.setXmlName(new javax.xml.namespace.QName("", "variables"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaVariable"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("directoryMode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DirectoryMode"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaDirectoryMode"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("recoverIfExists");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RecoverIfExists"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createIfNotExists");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreateIfNotExists"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
