/**
 * DigitalIdConfigEntrustSpecificParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the Entrust specific paramaters that can be set when creating
 * or modifying an Entrust 
 *                         Digital Id Config.
 */
public class DigitalIdConfigEntrustSpecificParms  implements java.io.Serializable {
    /* The cert. type for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet. */
    private String certType;

    /* The user type for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet. */
    private String userType;

    /* The role for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet. */
    private String role;

    /* If set to true, the digital id will belong
     *                                 to all groups in Entrust Security
     * Manager. */
    private Boolean allGroups;

    /* If set to true, the groups specified in the
     *                                 groups argument are added to the existing
     * values. */
    private Boolean addGroups;

    /* If set to true, the groups specified in the
     *                                 groups argument are removed from the
     * existing
     *                                 values.  This argument is ignored
     * if addGroups
     *                                 is specified as true. */
    private Boolean removeGroups;

    /* The list of Entrust Security Manager groups
     *                                 the digital id will belong to.  This
     * argument
     *                                 is ignored if allGroups is specified
     * as true. */
    private String[] groups;

    /* For the digitalIdConfigSet method,
     *                                 if mergeVariables is specified as
     *                                 true then the variable values 
     *                                 specified by the variables attribute
     * are
     *                                 added to the existing values instead
     * of
     *                                 replacing the existing values. */
    private Boolean mergeVariables;

    /* For the digitalIdConfigSet method,
     *                                 if mergeVariables is not specified
     * as
     *                                 true and the removeVariables attribute
     * is specified as true then the variable
     *                                 values specified by the variables
     *                                 attribute are removed from the existing
     * values. */
    private Boolean removeVariables;

    /* If specified, the Managed CA Variables of the
     *                                 Digital Id Config are set to the specified
     * value.  For the digitalIdConfigSet method,
     *                                 if mergeVariables is specified as
     *                                 true then the specified values are
     * added
     *                                 to the existing values instead of
     * replacing
     *                                 the values.  If mergeVariables
     *                                 is not specified as true and
     *                                 removeVariables is specified as true
     * then the specified Managed CA Variables are
     *                                 removed from the existing values. */
    private ManagedCaVariable[] variables;

    /* If specified, the directory mode of the
     *                                 Digital Id Config is set to the specified
     * value. */
    private ManagedCaDirectoryMode directoryMode;

    /* For the digitalIdConfigSet method, if
     *                                 DirectoryMode is not specified and
     * this attribute is specified as true,
     *                                 then the directory mode of the Digital
     * Id
     *                                 Config is cleared. */
    private Boolean clearDirectoryMode;

    /* A flag indicating if the operation should
     *                                 recover an existing Digital Id.  The
     * flag
     *                                 defaults to true if not specified. */
    private Boolean recoverIfExists;

    /* A flag indicating if the operation should
     *                                 add a new Digital Id if one does not
     * exist.
     *                                 The flag defaults to true if not specified. */
    private Boolean createIfNotExists;

    public DigitalIdConfigEntrustSpecificParms() {
    }

    public DigitalIdConfigEntrustSpecificParms(
           String certType,
           String userType,
           String role,
           Boolean allGroups,
           Boolean addGroups,
           Boolean removeGroups,
           String[] groups,
           Boolean mergeVariables,
           Boolean removeVariables,
           ManagedCaVariable[] variables,
           ManagedCaDirectoryMode directoryMode,
           Boolean clearDirectoryMode,
           Boolean recoverIfExists,
           Boolean createIfNotExists) {
           this.certType = certType;
           this.userType = userType;
           this.role = role;
           this.allGroups = allGroups;
           this.addGroups = addGroups;
           this.removeGroups = removeGroups;
           this.groups = groups;
           this.mergeVariables = mergeVariables;
           this.removeVariables = removeVariables;
           this.variables = variables;
           this.directoryMode = directoryMode;
           this.clearDirectoryMode = clearDirectoryMode;
           this.recoverIfExists = recoverIfExists;
           this.createIfNotExists = createIfNotExists;
    }


    /**
     * Gets the certType value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return certType   * The cert. type for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public String getCertType() {
        return certType;
    }


    /**
     * Sets the certType value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param certType   * The cert. type for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public void setCertType(String certType) {
        this.certType = certType;
    }


    /**
     * Gets the userType value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return userType   * The user type for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public String getUserType() {
        return userType;
    }


    /**
     * Sets the userType value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param userType   * The user type for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public void setUserType(String userType) {
        this.userType = userType;
    }


    /**
     * Gets the role value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return role   * The role for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public String getRole() {
        return role;
    }


    /**
     * Sets the role value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param role   * The role for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public void setRole(String role) {
        this.role = role;
    }


    /**
     * Gets the allGroups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return allGroups   * If set to true, the digital id will belong
     *                                 to all groups in Entrust Security
     * Manager.
     */
    public Boolean getAllGroups() {
        return allGroups;
    }


    /**
     * Sets the allGroups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param allGroups   * If set to true, the digital id will belong
     *                                 to all groups in Entrust Security
     * Manager.
     */
    public void setAllGroups(Boolean allGroups) {
        this.allGroups = allGroups;
    }


    /**
     * Gets the addGroups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return addGroups   * If set to true, the groups specified in the
     *                                 groups argument are added to the existing
     * values.
     */
    public Boolean getAddGroups() {
        return addGroups;
    }


    /**
     * Sets the addGroups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param addGroups   * If set to true, the groups specified in the
     *                                 groups argument are added to the existing
     * values.
     */
    public void setAddGroups(Boolean addGroups) {
        this.addGroups = addGroups;
    }


    /**
     * Gets the removeGroups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return removeGroups   * If set to true, the groups specified in the
     *                                 groups argument are removed from the
     * existing
     *                                 values.  This argument is ignored
     * if addGroups
     *                                 is specified as true.
     */
    public Boolean getRemoveGroups() {
        return removeGroups;
    }


    /**
     * Sets the removeGroups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param removeGroups   * If set to true, the groups specified in the
     *                                 groups argument are removed from the
     * existing
     *                                 values.  This argument is ignored
     * if addGroups
     *                                 is specified as true.
     */
    public void setRemoveGroups(Boolean removeGroups) {
        this.removeGroups = removeGroups;
    }


    /**
     * Gets the groups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return groups   * The list of Entrust Security Manager groups
     *                                 the digital id will belong to.  This
     * argument
     *                                 is ignored if allGroups is specified
     * as true.
     */
    public String[] getGroups() {
        return groups;
    }


    /**
     * Sets the groups value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param groups   * The list of Entrust Security Manager groups
     *                                 the digital id will belong to.  This
     * argument
     *                                 is ignored if allGroups is specified
     * as true.
     */
    public void setGroups(String[] groups) {
        this.groups = groups;
    }


    /**
     * Gets the mergeVariables value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return mergeVariables   * For the digitalIdConfigSet method,
     *                                 if mergeVariables is specified as
     *                                 true then the variable values 
     *                                 specified by the variables attribute
     * are
     *                                 added to the existing values instead
     * of
     *                                 replacing the existing values.
     */
    public Boolean getMergeVariables() {
        return mergeVariables;
    }


    /**
     * Sets the mergeVariables value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param mergeVariables   * For the digitalIdConfigSet method,
     *                                 if mergeVariables is specified as
     *                                 true then the variable values 
     *                                 specified by the variables attribute
     * are
     *                                 added to the existing values instead
     * of
     *                                 replacing the existing values.
     */
    public void setMergeVariables(Boolean mergeVariables) {
        this.mergeVariables = mergeVariables;
    }


    /**
     * Gets the removeVariables value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return removeVariables   * For the digitalIdConfigSet method,
     *                                 if mergeVariables is not specified
     * as
     *                                 true and the removeVariables attribute
     * is specified as true then the variable
     *                                 values specified by the variables
     *                                 attribute are removed from the existing
     * values.
     */
    public Boolean getRemoveVariables() {
        return removeVariables;
    }


    /**
     * Sets the removeVariables value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param removeVariables   * For the digitalIdConfigSet method,
     *                                 if mergeVariables is not specified
     * as
     *                                 true and the removeVariables attribute
     * is specified as true then the variable
     *                                 values specified by the variables
     *                                 attribute are removed from the existing
     * values.
     */
    public void setRemoveVariables(Boolean removeVariables) {
        this.removeVariables = removeVariables;
    }


    /**
     * Gets the variables value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return variables   * If specified, the Managed CA Variables of the
     *                                 Digital Id Config are set to the specified
     * value.  For the digitalIdConfigSet method,
     *                                 if mergeVariables is specified as
     *                                 true then the specified values are
     * added
     *                                 to the existing values instead of
     * replacing
     *                                 the values.  If mergeVariables
     *                                 is not specified as true and
     *                                 removeVariables is specified as true
     * then the specified Managed CA Variables are
     *                                 removed from the existing values.
     */
    public ManagedCaVariable[] getVariables() {
        return variables;
    }


    /**
     * Sets the variables value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param variables   * If specified, the Managed CA Variables of the
     *                                 Digital Id Config are set to the specified
     * value.  For the digitalIdConfigSet method,
     *                                 if mergeVariables is specified as
     *                                 true then the specified values are
     * added
     *                                 to the existing values instead of
     * replacing
     *                                 the values.  If mergeVariables
     *                                 is not specified as true and
     *                                 removeVariables is specified as true
     * then the specified Managed CA Variables are
     *                                 removed from the existing values.
     */
    public void setVariables(ManagedCaVariable[] variables) {
        this.variables = variables;
    }


    /**
     * Gets the directoryMode value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return directoryMode   * If specified, the directory mode of the
     *                                 Digital Id Config is set to the specified
     * value.
     */
    public ManagedCaDirectoryMode getDirectoryMode() {
        return directoryMode;
    }


    /**
     * Sets the directoryMode value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param directoryMode   * If specified, the directory mode of the
     *                                 Digital Id Config is set to the specified
     * value.
     */
    public void setDirectoryMode(ManagedCaDirectoryMode directoryMode) {
        this.directoryMode = directoryMode;
    }


    /**
     * Gets the clearDirectoryMode value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return clearDirectoryMode   * For the digitalIdConfigSet method, if
     *                                 DirectoryMode is not specified and
     * this attribute is specified as true,
     *                                 then the directory mode of the Digital
     * Id
     *                                 Config is cleared.
     */
    public Boolean getClearDirectoryMode() {
        return clearDirectoryMode;
    }


    /**
     * Sets the clearDirectoryMode value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param clearDirectoryMode   * For the digitalIdConfigSet method, if
     *                                 DirectoryMode is not specified and
     * this attribute is specified as true,
     *                                 then the directory mode of the Digital
     * Id
     *                                 Config is cleared.
     */
    public void setClearDirectoryMode(Boolean clearDirectoryMode) {
        this.clearDirectoryMode = clearDirectoryMode;
    }


    /**
     * Gets the recoverIfExists value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return recoverIfExists   * A flag indicating if the operation should
     *                                 recover an existing Digital Id.  The
     * flag
     *                                 defaults to true if not specified.
     */
    public Boolean getRecoverIfExists() {
        return recoverIfExists;
    }


    /**
     * Sets the recoverIfExists value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param recoverIfExists   * A flag indicating if the operation should
     *                                 recover an existing Digital Id.  The
     * flag
     *                                 defaults to true if not specified.
     */
    public void setRecoverIfExists(Boolean recoverIfExists) {
        this.recoverIfExists = recoverIfExists;
    }


    /**
     * Gets the createIfNotExists value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @return createIfNotExists   * A flag indicating if the operation should
     *                                 add a new Digital Id if one does not
     * exist.
     *                                 The flag defaults to true if not specified.
     */
    public Boolean getCreateIfNotExists() {
        return createIfNotExists;
    }


    /**
     * Sets the createIfNotExists value for this DigitalIdConfigEntrustSpecificParms.
     * 
     * @param createIfNotExists   * A flag indicating if the operation should
     *                                 add a new Digital Id if one does not
     * exist.
     *                                 The flag defaults to true if not specified.
     */
    public void setCreateIfNotExists(Boolean createIfNotExists) {
        this.createIfNotExists = createIfNotExists;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdConfigEntrustSpecificParms)) return false;
        DigitalIdConfigEntrustSpecificParms other = (DigitalIdConfigEntrustSpecificParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.certType==null && other.getCertType()==null) || 
             (this.certType!=null &&
              this.certType.equals(other.getCertType()))) &&
            ((this.userType==null && other.getUserType()==null) || 
             (this.userType!=null &&
              this.userType.equals(other.getUserType()))) &&
            ((this.role==null && other.getRole()==null) || 
             (this.role!=null &&
              this.role.equals(other.getRole()))) &&
            ((this.allGroups==null && other.getAllGroups()==null) || 
             (this.allGroups!=null &&
              this.allGroups.equals(other.getAllGroups()))) &&
            ((this.addGroups==null && other.getAddGroups()==null) || 
             (this.addGroups!=null &&
              this.addGroups.equals(other.getAddGroups()))) &&
            ((this.removeGroups==null && other.getRemoveGroups()==null) || 
             (this.removeGroups!=null &&
              this.removeGroups.equals(other.getRemoveGroups()))) &&
            ((this.groups==null && other.getGroups()==null) || 
             (this.groups!=null &&
              java.util.Arrays.equals(this.groups, other.getGroups()))) &&
            ((this.mergeVariables==null && other.getMergeVariables()==null) || 
             (this.mergeVariables!=null &&
              this.mergeVariables.equals(other.getMergeVariables()))) &&
            ((this.removeVariables==null && other.getRemoveVariables()==null) || 
             (this.removeVariables!=null &&
              this.removeVariables.equals(other.getRemoveVariables()))) &&
            ((this.variables==null && other.getVariables()==null) || 
             (this.variables!=null &&
              java.util.Arrays.equals(this.variables, other.getVariables()))) &&
            ((this.directoryMode==null && other.getDirectoryMode()==null) || 
             (this.directoryMode!=null &&
              this.directoryMode.equals(other.getDirectoryMode()))) &&
            ((this.clearDirectoryMode==null && other.getClearDirectoryMode()==null) || 
             (this.clearDirectoryMode!=null &&
              this.clearDirectoryMode.equals(other.getClearDirectoryMode()))) &&
            ((this.recoverIfExists==null && other.getRecoverIfExists()==null) || 
             (this.recoverIfExists!=null &&
              this.recoverIfExists.equals(other.getRecoverIfExists()))) &&
            ((this.createIfNotExists==null && other.getCreateIfNotExists()==null) || 
             (this.createIfNotExists!=null &&
              this.createIfNotExists.equals(other.getCreateIfNotExists())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCertType() != null) {
            _hashCode += getCertType().hashCode();
        }
        if (getUserType() != null) {
            _hashCode += getUserType().hashCode();
        }
        if (getRole() != null) {
            _hashCode += getRole().hashCode();
        }
        if (getAllGroups() != null) {
            _hashCode += getAllGroups().hashCode();
        }
        if (getAddGroups() != null) {
            _hashCode += getAddGroups().hashCode();
        }
        if (getRemoveGroups() != null) {
            _hashCode += getRemoveGroups().hashCode();
        }
        if (getGroups() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroups());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroups(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMergeVariables() != null) {
            _hashCode += getMergeVariables().hashCode();
        }
        if (getRemoveVariables() != null) {
            _hashCode += getRemoveVariables().hashCode();
        }
        if (getVariables() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getVariables());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getVariables(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDirectoryMode() != null) {
            _hashCode += getDirectoryMode().hashCode();
        }
        if (getClearDirectoryMode() != null) {
            _hashCode += getClearDirectoryMode().hashCode();
        }
        if (getRecoverIfExists() != null) {
            _hashCode += getRecoverIfExists().hashCode();
        }
        if (getCreateIfNotExists() != null) {
            _hashCode += getCreateIfNotExists().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdConfigEntrustSpecificParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigEntrustSpecificParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CertType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("role");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Role"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allGroups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allGroups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addGroups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "addGroups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeGroups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeGroups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("mergeVariables");
        elemField.setXmlName(new javax.xml.namespace.QName("", "mergeVariables"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeVariables");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeVariables"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("variables");
        elemField.setXmlName(new javax.xml.namespace.QName("", "variables"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaVariable"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("directoryMode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DirectoryMode"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaDirectoryMode"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("clearDirectoryMode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ClearDirectoryMode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("recoverIfExists");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RecoverIfExists"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createIfNotExists");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreateIfNotExists"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
