/**
 * DigitalIdConfigInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


import java.util.Arrays;

/**
 * Defines information about a Digital Id Config
 */
public class DigitalIdConfigInfo  implements java.io.Serializable {
    /* The name of the Digital Id Config. */
    private String name;

    /* The DNFormat specifies what the DN of
     *                                 Digital Ids for this Config will look
     * like.
     *                                 For example,
     *                                 "cn=<firstname> <lastname>" 
     *                                 or "cn=<uuid>" where <firstname>,
     *                                 <lastname> and <uuid> will be
     *                                 replaced by variable values when the
     * digital Id
     *                                 is created. */
    private String DNFormat;

    /* The searchbase of the Digital Id Config. */
    private String searchbase;

    /* The Managed CA of the Digital Id Config. */
    private String managedCA;

    /* The optional category of the Digital Id Config. */
    private String category;

    /* The optional subjectAltNames of the
     *                                 Digital Id Config. */
    private SubjectAltName[] subjectAltNames;

    /* A description of the Digital Id Config. */
    private String description;

    /* Indicates the type of the digital identity. If the type is
     * ENTRUST, then the 
     *                                 EntrustSpecificInfo component will
     * be non-null; if the type is MICROSOFT, then the 
     *                                 MicrosoftSpecificInfo component will
     * be non-null. */
    private ManagedCaType type;

    /* The optional list of P10 trusted signer 
     *                                 certificates of the Digital Id Config. */
    private byte[][] p10TrustedSignerCertificates;

    /* If set, the default P10 certificate stream 
     *                                 policy. During a create/recover operation
     * in 
     *                                 which P10 certificate requests are
     * provided 
     *                                 without explicitly specifying certificate
     * stream
     *                                 policy, this value (when present)
     * is used as the
     *                                 certificate stream policy for each
     * request.
     *                                 For an Entrust CA, this is a certificate
     * 
     *                                 definition name; for a Microsoft CA,
     * this is a 
     *                                 certificate template common name. */
    private String p10CertStreamPolicy;

    /* If set, indicates that this information is for an Entrust digital
     * identity 
     *                                 configuration and contains the Entrust
     * specific information. */
    private com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificInfo entrustSpecificInfo;

    /* If set, indicates that this information is for a Microsoft
     * digital identity 
     *                                 configuration and contains the Microsoft
     * specific information. */
    private com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificInfo microsoftSpecificInfo;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public DigitalIdConfigInfo() {
    }

    public DigitalIdConfigInfo(
           String name,
           String DNFormat,
           String searchbase,
           String managedCA,
           String category,
           SubjectAltName[] subjectAltNames,
           String description,
           ManagedCaType type,
           byte[][] p10TrustedSignerCertificates,
           String p10CertStreamPolicy,
           com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificInfo entrustSpecificInfo,
           com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificInfo microsoftSpecificInfo,
           String[] rolesGrantingAccess) {
           this.name = name;
           this.DNFormat = DNFormat;
           this.searchbase = searchbase;
           this.managedCA = managedCA;
           this.category = category;
           this.subjectAltNames = subjectAltNames;
           this.description = description;
           this.type = type;
           this.p10TrustedSignerCertificates = p10TrustedSignerCertificates;
           this.p10CertStreamPolicy = p10CertStreamPolicy;
           this.entrustSpecificInfo = entrustSpecificInfo;
           this.microsoftSpecificInfo = microsoftSpecificInfo;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the name value for this DigitalIdConfigInfo.
     * 
     * @return name   * The name of the Digital Id Config.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this DigitalIdConfigInfo.
     * 
     * @param name   * The name of the Digital Id Config.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the DNFormat value for this DigitalIdConfigInfo.
     * 
     * @return DNFormat   * The DNFormat specifies what the DN of
     *                                 Digital Ids for this Config will look
     * like.
     *                                 For example,
     *                                 "cn=<firstname> <lastname>" 
     *                                 or "cn=<uuid>" where <firstname>,
     *                                 <lastname> and <uuid> will be
     *                                 replaced by variable values when the
     * digital Id
     *                                 is created.
     */
    public String getDNFormat() {
        return DNFormat;
    }


    /**
     * Sets the DNFormat value for this DigitalIdConfigInfo.
     * 
     * @param DNFormat   * The DNFormat specifies what the DN of
     *                                 Digital Ids for this Config will look
     * like.
     *                                 For example,
     *                                 "cn=<firstname> <lastname>" 
     *                                 or "cn=<uuid>" where <firstname>,
     *                                 <lastname> and <uuid> will be
     *                                 replaced by variable values when the
     * digital Id
     *                                 is created.
     */
    public void setDNFormat(String DNFormat) {
        this.DNFormat = DNFormat;
    }


    /**
     * Gets the searchbase value for this DigitalIdConfigInfo.
     * 
     * @return searchbase   * The searchbase of the Digital Id Config.
     */
    public String getSearchbase() {
        return searchbase;
    }


    /**
     * Sets the searchbase value for this DigitalIdConfigInfo.
     * 
     * @param searchbase   * The searchbase of the Digital Id Config.
     */
    public void setSearchbase(String searchbase) {
        this.searchbase = searchbase;
    }


    /**
     * Gets the managedCA value for this DigitalIdConfigInfo.
     * 
     * @return managedCA   * The Managed CA of the Digital Id Config.
     */
    public String getManagedCA() {
        return managedCA;
    }


    /**
     * Sets the managedCA value for this DigitalIdConfigInfo.
     * 
     * @param managedCA   * The Managed CA of the Digital Id Config.
     */
    public void setManagedCA(String managedCA) {
        this.managedCA = managedCA;
    }


    /**
     * Gets the category value for this DigitalIdConfigInfo.
     * 
     * @return category   * The optional category of the Digital Id Config.
     */
    public String getCategory() {
        return category;
    }


    /**
     * Sets the category value for this DigitalIdConfigInfo.
     * 
     * @param category   * The optional category of the Digital Id Config.
     */
    public void setCategory(String category) {
        this.category = category;
    }


    /**
     * Gets the subjectAltNames value for this DigitalIdConfigInfo.
     * 
     * @return subjectAltNames   * The optional subjectAltNames of the
     *                                 Digital Id Config.
     */
    public SubjectAltName[] getSubjectAltNames() {
        return subjectAltNames;
    }


    /**
     * Sets the subjectAltNames value for this DigitalIdConfigInfo.
     * 
     * @param subjectAltNames   * The optional subjectAltNames of the
     *                                 Digital Id Config.
     */
    public void setSubjectAltNames(SubjectAltName[] subjectAltNames) {
        this.subjectAltNames = subjectAltNames;
    }


    /**
     * Gets the description value for this DigitalIdConfigInfo.
     * 
     * @return description   * A description of the Digital Id Config.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this DigitalIdConfigInfo.
     * 
     * @param description   * A description of the Digital Id Config.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the type value for this DigitalIdConfigInfo.
     * 
     * @return type   * Indicates the type of the digital identity. If the type is
     * ENTRUST, then the 
     *                                 EntrustSpecificInfo component will
     * be non-null; if the type is MICROSOFT, then the 
     *                                 MicrosoftSpecificInfo component will
     * be non-null.
     */
    public ManagedCaType getType() {
        return type;
    }


    /**
     * Sets the type value for this DigitalIdConfigInfo.
     * 
     * @param type   * Indicates the type of the digital identity. If the type is
     * ENTRUST, then the 
     *                                 EntrustSpecificInfo component will
     * be non-null; if the type is MICROSOFT, then the 
     *                                 MicrosoftSpecificInfo component will
     * be non-null.
     */
    public void setType(ManagedCaType type) {
        this.type = type;
    }


    /**
     * Gets the p10TrustedSignerCertificates value for this DigitalIdConfigInfo.
     * 
     * @return p10TrustedSignerCertificates   * The optional list of P10 trusted signer 
     *                                 certificates of the Digital Id Config.
     */
    public byte[][] getP10TrustedSignerCertificates() {
        return p10TrustedSignerCertificates;
    }


    /**
     * Sets the p10TrustedSignerCertificates value for this DigitalIdConfigInfo.
     * 
     * @param p10TrustedSignerCertificates   * The optional list of P10 trusted signer 
     *                                 certificates of the Digital Id Config.
     */
    public void setP10TrustedSignerCertificates(byte[][] p10TrustedSignerCertificates) {
        this.p10TrustedSignerCertificates = p10TrustedSignerCertificates;
    }


    /**
     * Gets the p10CertStreamPolicy value for this DigitalIdConfigInfo.
     * 
     * @return p10CertStreamPolicy   * If set, the default P10 certificate stream 
     *                                 policy. During a create/recover operation
     * in 
     *                                 which P10 certificate requests are
     * provided 
     *                                 without explicitly specifying certificate
     * stream
     *                                 policy, this value (when present)
     * is used as the
     *                                 certificate stream policy for each
     * request.
     *                                 For an Entrust CA, this is a certificate
     * 
     *                                 definition name; for a Microsoft CA,
     * this is a 
     *                                 certificate template common name.
     */
    public String getP10CertStreamPolicy() {
        return p10CertStreamPolicy;
    }


    /**
     * Sets the p10CertStreamPolicy value for this DigitalIdConfigInfo.
     * 
     * @param p10CertStreamPolicy   * If set, the default P10 certificate stream 
     *                                 policy. During a create/recover operation
     * in 
     *                                 which P10 certificate requests are
     * provided 
     *                                 without explicitly specifying certificate
     * stream
     *                                 policy, this value (when present)
     * is used as the
     *                                 certificate stream policy for each
     * request.
     *                                 For an Entrust CA, this is a certificate
     * 
     *                                 definition name; for a Microsoft CA,
     * this is a 
     *                                 certificate template common name.
     */
    public void setP10CertStreamPolicy(String p10CertStreamPolicy) {
        this.p10CertStreamPolicy = p10CertStreamPolicy;
    }


    /**
     * Gets the entrustSpecificInfo value for this DigitalIdConfigInfo.
     * 
     * @return entrustSpecificInfo   * If set, indicates that this information is for an Entrust digital
     * identity 
     *                                 configuration and contains the Entrust
     * specific information.
     */
    public com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificInfo getEntrustSpecificInfo() {
        return entrustSpecificInfo;
    }


    /**
     * Sets the entrustSpecificInfo value for this DigitalIdConfigInfo.
     * 
     * @param entrustSpecificInfo   * If set, indicates that this information is for an Entrust digital
     * identity 
     *                                 configuration and contains the Entrust
     * specific information.
     */
    public void setEntrustSpecificInfo(com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificInfo entrustSpecificInfo) {
        this.entrustSpecificInfo = entrustSpecificInfo;
    }


    /**
     * Gets the microsoftSpecificInfo value for this DigitalIdConfigInfo.
     * 
     * @return microsoftSpecificInfo   * If set, indicates that this information is for a Microsoft
     * digital identity 
     *                                 configuration and contains the Microsoft
     * specific information.
     */
    public com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificInfo getMicrosoftSpecificInfo() {
        return microsoftSpecificInfo;
    }


    /**
     * Sets the microsoftSpecificInfo value for this DigitalIdConfigInfo.
     * 
     * @param microsoftSpecificInfo   * If set, indicates that this information is for a Microsoft
     * digital identity 
     *                                 configuration and contains the Microsoft
     * specific information.
     */
    public void setMicrosoftSpecificInfo(com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificInfo microsoftSpecificInfo) {
        this.microsoftSpecificInfo = microsoftSpecificInfo;
    }


    /**
     * Gets the rolesGrantingAccess value for this DigitalIdConfigInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this DigitalIdConfigInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdConfigInfo)) return false;
        DigitalIdConfigInfo other = (DigitalIdConfigInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.DNFormat==null && other.getDNFormat()==null) || 
             (this.DNFormat!=null &&
              this.DNFormat.equals(other.getDNFormat()))) &&
            ((this.searchbase==null && other.getSearchbase()==null) || 
             (this.searchbase!=null &&
              this.searchbase.equals(other.getSearchbase()))) &&
            ((this.managedCA==null && other.getManagedCA()==null) || 
             (this.managedCA!=null &&
              this.managedCA.equals(other.getManagedCA()))) &&
            ((this.category==null && other.getCategory()==null) || 
             (this.category!=null &&
              this.category.equals(other.getCategory()))) &&
            ((this.subjectAltNames==null && other.getSubjectAltNames()==null) || 
             (this.subjectAltNames!=null &&
              java.util.Arrays.equals(this.subjectAltNames, other.getSubjectAltNames()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.p10TrustedSignerCertificates==null && other.getP10TrustedSignerCertificates()==null) || 
             (this.p10TrustedSignerCertificates!=null &&
              java.util.Arrays.equals(this.p10TrustedSignerCertificates, other.getP10TrustedSignerCertificates()))) &&
            ((this.p10CertStreamPolicy==null && other.getP10CertStreamPolicy()==null) || 
             (this.p10CertStreamPolicy!=null &&
              this.p10CertStreamPolicy.equals(other.getP10CertStreamPolicy()))) &&
            ((this.entrustSpecificInfo==null && other.getEntrustSpecificInfo()==null) || 
             (this.entrustSpecificInfo!=null &&
              this.entrustSpecificInfo.equals(other.getEntrustSpecificInfo()))) &&
            ((this.microsoftSpecificInfo==null && other.getMicrosoftSpecificInfo()==null) || 
             (this.microsoftSpecificInfo!=null &&
              this.microsoftSpecificInfo.equals(other.getMicrosoftSpecificInfo()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getDNFormat() != null) {
            _hashCode += getDNFormat().hashCode();
        }
        if (getSearchbase() != null) {
            _hashCode += getSearchbase().hashCode();
        }
        if (getManagedCA() != null) {
            _hashCode += getManagedCA().hashCode();
        }
        if (getCategory() != null) {
            _hashCode += getCategory().hashCode();
        }
        if (getSubjectAltNames() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSubjectAltNames());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSubjectAltNames(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getP10TrustedSignerCertificates() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getP10TrustedSignerCertificates());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getP10TrustedSignerCertificates(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getP10CertStreamPolicy() != null) {
            _hashCode += getP10CertStreamPolicy().hashCode();
        }
        if (getEntrustSpecificInfo() != null) {
            _hashCode += getEntrustSpecificInfo().hashCode();
        }
        if (getMicrosoftSpecificInfo() != null) {
            _hashCode += getMicrosoftSpecificInfo().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    @Override
    public String toString() {
        return "DigitalIdConfigInfo{" +
                "rolesGrantingAccess=" + Arrays.toString(rolesGrantingAccess) +
                ", p10CertStreamPolicy='" + p10CertStreamPolicy + '\'' +
                ", type=" + type +
                ", description='" + description + '\'' +
                ", category='" + category + '\'' +
                ", managedCA='" + managedCA + '\'' +
                ", searchbase='" + searchbase + '\'' +
                ", DNFormat='" + DNFormat + '\'' +
                ", name='" + name + '\'' +
                '}';
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdConfigInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("DNFormat");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DNFormat"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("searchbase");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Searchbase"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("managedCA");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ManagedCA"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("category");
        elemField.setXmlName(new javax.xml.namespace.QName("", "category"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("subjectAltNames");
        elemField.setXmlName(new javax.xml.namespace.QName("", "subjectAltNames"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SubjectAltName"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Type"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("p10TrustedSignerCertificates");
        elemField.setXmlName(new javax.xml.namespace.QName("", "p10TrustedSignerCertificates"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("p10CertStreamPolicy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "p10CertStreamPolicy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("entrustSpecificInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "EntrustSpecificInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigEntrustSpecificInfo"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("microsoftSpecificInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "MicrosoftSpecificInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigMicrosoftSpecificInfo"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
