/**
 * DigitalIdConfigMicrosoftSpecificParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the Microsoft specific paramaters that can be set when
 * creating or modifying a 
 *                         Microsoft Digital Id Config.
 */
public class DigitalIdConfigMicrosoftSpecificParms  implements java.io.Serializable {
    /* An optional list of Microsoft certificate templates configured
     * for use with the 
     *                                 digital identity. */
    private MicrosoftCertTemplate[] certTemplates;

    /* When used in a call to modify a digital identity configuration,
     * if mergeCertTemplates 
     *                                 is specified as true then the certificate
     * templates specified in the CertTemplates 
     *                                 attribute are merged with the existing
     * certificate templates instead of replacing them. */
    private Boolean mergeCertTemplates;

    /* When used in a call to modify a digital identity configuration,
     * if mergeCertTemplates 
     *                                 is not specified as true and the mergeCertTemplates
     * attribute is specified as true 
     *                                 then the certificate templates identified
     * by the CertTemplates attribute are removed 
     *                                 from the existing certificate templates. */
    private Boolean removeCertTemplates;

    public DigitalIdConfigMicrosoftSpecificParms() {
    }

    public DigitalIdConfigMicrosoftSpecificParms(
           MicrosoftCertTemplate[] certTemplates,
           Boolean mergeCertTemplates,
           Boolean removeCertTemplates) {
           this.certTemplates = certTemplates;
           this.mergeCertTemplates = mergeCertTemplates;
           this.removeCertTemplates = removeCertTemplates;
    }


    /**
     * Gets the certTemplates value for this DigitalIdConfigMicrosoftSpecificParms.
     * 
     * @return certTemplates   * An optional list of Microsoft certificate templates configured
     * for use with the 
     *                                 digital identity.
     */
    public MicrosoftCertTemplate[] getCertTemplates() {
        return certTemplates;
    }


    /**
     * Sets the certTemplates value for this DigitalIdConfigMicrosoftSpecificParms.
     * 
     * @param certTemplates   * An optional list of Microsoft certificate templates configured
     * for use with the 
     *                                 digital identity.
     */
    public void setCertTemplates(MicrosoftCertTemplate[] certTemplates) {
        this.certTemplates = certTemplates;
    }


    /**
     * Gets the mergeCertTemplates value for this DigitalIdConfigMicrosoftSpecificParms.
     * 
     * @return mergeCertTemplates   * When used in a call to modify a digital identity configuration,
     * if mergeCertTemplates 
     *                                 is specified as true then the certificate
     * templates specified in the CertTemplates 
     *                                 attribute are merged with the existing
     * certificate templates instead of replacing them.
     */
    public Boolean getMergeCertTemplates() {
        return mergeCertTemplates;
    }


    /**
     * Sets the mergeCertTemplates value for this DigitalIdConfigMicrosoftSpecificParms.
     * 
     * @param mergeCertTemplates   * When used in a call to modify a digital identity configuration,
     * if mergeCertTemplates 
     *                                 is specified as true then the certificate
     * templates specified in the CertTemplates 
     *                                 attribute are merged with the existing
     * certificate templates instead of replacing them.
     */
    public void setMergeCertTemplates(Boolean mergeCertTemplates) {
        this.mergeCertTemplates = mergeCertTemplates;
    }


    /**
     * Gets the removeCertTemplates value for this DigitalIdConfigMicrosoftSpecificParms.
     * 
     * @return removeCertTemplates   * When used in a call to modify a digital identity configuration,
     * if mergeCertTemplates 
     *                                 is not specified as true and the mergeCertTemplates
     * attribute is specified as true 
     *                                 then the certificate templates identified
     * by the CertTemplates attribute are removed 
     *                                 from the existing certificate templates.
     */
    public Boolean getRemoveCertTemplates() {
        return removeCertTemplates;
    }


    /**
     * Sets the removeCertTemplates value for this DigitalIdConfigMicrosoftSpecificParms.
     * 
     * @param removeCertTemplates   * When used in a call to modify a digital identity configuration,
     * if mergeCertTemplates 
     *                                 is not specified as true and the mergeCertTemplates
     * attribute is specified as true 
     *                                 then the certificate templates identified
     * by the CertTemplates attribute are removed 
     *                                 from the existing certificate templates.
     */
    public void setRemoveCertTemplates(Boolean removeCertTemplates) {
        this.removeCertTemplates = removeCertTemplates;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdConfigMicrosoftSpecificParms)) return false;
        DigitalIdConfigMicrosoftSpecificParms other = (DigitalIdConfigMicrosoftSpecificParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.certTemplates==null && other.getCertTemplates()==null) || 
             (this.certTemplates!=null &&
              java.util.Arrays.equals(this.certTemplates, other.getCertTemplates()))) &&
            ((this.mergeCertTemplates==null && other.getMergeCertTemplates()==null) || 
             (this.mergeCertTemplates!=null &&
              this.mergeCertTemplates.equals(other.getMergeCertTemplates()))) &&
            ((this.removeCertTemplates==null && other.getRemoveCertTemplates()==null) || 
             (this.removeCertTemplates!=null &&
              this.removeCertTemplates.equals(other.getRemoveCertTemplates())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCertTemplates() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCertTemplates());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCertTemplates(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMergeCertTemplates() != null) {
            _hashCode += getMergeCertTemplates().hashCode();
        }
        if (getRemoveCertTemplates() != null) {
            _hashCode += getRemoveCertTemplates().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdConfigMicrosoftSpecificParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigMicrosoftSpecificParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certTemplates");
        elemField.setXmlName(new javax.xml.namespace.QName("", "certTemplates"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "MicrosoftCertTemplate"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("mergeCertTemplates");
        elemField.setXmlName(new javax.xml.namespace.QName("", "mergeCertTemplates"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeCertTemplates");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeCertTemplates"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
