/**
 * DigitalIdConfigParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the paramaters that can be set when
 *                         creating or modifying a Digital Id Config.
 */
public class DigitalIdConfigParms  implements java.io.Serializable {
    /* When passed in a call to
     *                                 digitalIdConfigSet, this specifies
     * a new
     *                                 name for the Digital Id Config.  If
     * this
     *                                 is included in a call to
     *                                 digitalIdConfigCreate it is ignored. */
    private String name;

    /* The DNFormat specifies what the DN of
     *                                 Digital Ids for this Config will look
     * like.
     *                                 For example,
     *                                 "cn=<firstname> <lastname>" 
     *                                 or "cn=<uuid>" where <firstname>,
     *                                 <lastname> and <uuid> will
     *                                 be replaced by variable values when
     * the
     *                                 digital Id is created.
     *                                 The value is required for a call to
     * digitalIdConfigCreate and optional for a call
     *                                 to digitalIdConfigSet. */
    private String DNFormat;

    /* The searchbase for the Digital Id Config.
     *                                 The value must be a valid DN.  It
     * is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet. */
    private String searchbase;

    /* The Managed CA for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to digitalIdConfigSet. */
    private String managedCA;

    /* Optional category of the Digital Id Config.
     *                                 If an empty string is specified, the
     * existing
     *                                 category is removed. */
    private String category;

    /* For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is specified
     * as
     *                                 true then the subjectAltName values
     * 
     *                                 specified by the subjectAltNames attribute
     * are
     *                                 added to the existing values instead
     * of
     *                                 replacing the existing values. */
    private Boolean mergeSubjectAltNames;

    /* For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is not specified
     * as
     *                                 true and the removeSubjectAltNames
     * attribute
     *                                 is specified as true then the subjectAltName
     * values specified by the subjectAltNames
     *                                 attribute are removed from the existing
     * values. */
    private Boolean removeSubjectAltNames;

    /* If specified, the subjectAltNames of the
     *                                 Digital Id Config are set to the specified
     * value.  For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is specified
     * as
     *                                 true then the specified values are
     * added
     *                                 to the existing values instead of
     * replacing
     *                                 the existing values.  If mergeSubjectAltNames
     * is not specified as true and
     *                                 removeSubjectAltNames is specified
     * as true
     *                                 then the specified subjectAltNames
     * are
     *                                 removed from the existing values. */
    private SubjectAltName[] subjectAltNames;

    /* Optional description. */
    private String description;

    /* The optional list of P10 trusted signer 
     *                                 certificates to use with this Digital
     * Id 
     *                                 Config. */
    private byte[][] p10TrustedSignerCertificates;

    /* If set, the default P10 certificate stream 
     *                                 policy. During a create/recover operation
     * in 
     *                                 which P10 certificate requests are
     * provided 
     *                                 without explicitly specifying certificate
     * stream
     *                                 policy, this value (when present)
     * is used as the
     *                                 certificate stream policy for each
     * request.
     *                                 For an Entrust CA, this is a certificate
     * 
     *                                 definition name; for a Microsoft CA,
     * this is a 
     *                                 certificate template common name. */
    private String p10CertStreamPolicy;

    /* If set, indicates that these parameters are for an Entrust
     * digital identity 
     *                                 configuration and contains the Entrust
     * specific parameters. */
    private com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificParms entrustSpecificParams;

    /* If set, indicates that these parameters are for an Microsoft
     * digital identity 
     *                                 configuration and contains the Microsoft
     * specific parameters. */
    private com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificParms microsoftSpecificParams;

    public DigitalIdConfigParms() {
    }

    public DigitalIdConfigParms(
           String name,
           String DNFormat,
           String searchbase,
           String managedCA,
           String category,
           Boolean mergeSubjectAltNames,
           Boolean removeSubjectAltNames,
           SubjectAltName[] subjectAltNames,
           String description,
           byte[][] p10TrustedSignerCertificates,
           String p10CertStreamPolicy,
           com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificParms entrustSpecificParams,
           com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificParms microsoftSpecificParams) {
           this.name = name;
           this.DNFormat = DNFormat;
           this.searchbase = searchbase;
           this.managedCA = managedCA;
           this.category = category;
           this.mergeSubjectAltNames = mergeSubjectAltNames;
           this.removeSubjectAltNames = removeSubjectAltNames;
           this.subjectAltNames = subjectAltNames;
           this.description = description;
           this.p10TrustedSignerCertificates = p10TrustedSignerCertificates;
           this.p10CertStreamPolicy = p10CertStreamPolicy;
           this.entrustSpecificParams = entrustSpecificParams;
           this.microsoftSpecificParams = microsoftSpecificParams;
    }


    /**
     * Gets the name value for this DigitalIdConfigParms.
     * 
     * @return name   * When passed in a call to
     *                                 digitalIdConfigSet, this specifies
     * a new
     *                                 name for the Digital Id Config.  If
     * this
     *                                 is included in a call to
     *                                 digitalIdConfigCreate it is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this DigitalIdConfigParms.
     * 
     * @param name   * When passed in a call to
     *                                 digitalIdConfigSet, this specifies
     * a new
     *                                 name for the Digital Id Config.  If
     * this
     *                                 is included in a call to
     *                                 digitalIdConfigCreate it is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the DNFormat value for this DigitalIdConfigParms.
     * 
     * @return DNFormat   * The DNFormat specifies what the DN of
     *                                 Digital Ids for this Config will look
     * like.
     *                                 For example,
     *                                 "cn=<firstname> <lastname>" 
     *                                 or "cn=<uuid>" where <firstname>,
     *                                 <lastname> and <uuid> will
     *                                 be replaced by variable values when
     * the
     *                                 digital Id is created.
     *                                 The value is required for a call to
     * digitalIdConfigCreate and optional for a call
     *                                 to digitalIdConfigSet.
     */
    public String getDNFormat() {
        return DNFormat;
    }


    /**
     * Sets the DNFormat value for this DigitalIdConfigParms.
     * 
     * @param DNFormat   * The DNFormat specifies what the DN of
     *                                 Digital Ids for this Config will look
     * like.
     *                                 For example,
     *                                 "cn=<firstname> <lastname>" 
     *                                 or "cn=<uuid>" where <firstname>,
     *                                 <lastname> and <uuid> will
     *                                 be replaced by variable values when
     * the
     *                                 digital Id is created.
     *                                 The value is required for a call to
     * digitalIdConfigCreate and optional for a call
     *                                 to digitalIdConfigSet.
     */
    public void setDNFormat(String DNFormat) {
        this.DNFormat = DNFormat;
    }


    /**
     * Gets the searchbase value for this DigitalIdConfigParms.
     * 
     * @return searchbase   * The searchbase for the Digital Id Config.
     *                                 The value must be a valid DN.  It
     * is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public String getSearchbase() {
        return searchbase;
    }


    /**
     * Sets the searchbase value for this DigitalIdConfigParms.
     * 
     * @param searchbase   * The searchbase for the Digital Id Config.
     *                                 The value must be a valid DN.  It
     * is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to 
     *                                 digitalIdConfigSet.
     */
    public void setSearchbase(String searchbase) {
        this.searchbase = searchbase;
    }


    /**
     * Gets the managedCA value for this DigitalIdConfigParms.
     * 
     * @return managedCA   * The Managed CA for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to digitalIdConfigSet.
     */
    public String getManagedCA() {
        return managedCA;
    }


    /**
     * Sets the managedCA value for this DigitalIdConfigParms.
     * 
     * @param managedCA   * The Managed CA for the Digital Id Config.
     *                                 It is required
     *                                 for a call to digitalIdConfigCreate
     * and
     *                                 optional for a call to digitalIdConfigSet.
     */
    public void setManagedCA(String managedCA) {
        this.managedCA = managedCA;
    }


    /**
     * Gets the category value for this DigitalIdConfigParms.
     * 
     * @return category   * Optional category of the Digital Id Config.
     *                                 If an empty string is specified, the
     * existing
     *                                 category is removed.
     */
    public String getCategory() {
        return category;
    }


    /**
     * Sets the category value for this DigitalIdConfigParms.
     * 
     * @param category   * Optional category of the Digital Id Config.
     *                                 If an empty string is specified, the
     * existing
     *                                 category is removed.
     */
    public void setCategory(String category) {
        this.category = category;
    }


    /**
     * Gets the mergeSubjectAltNames value for this DigitalIdConfigParms.
     * 
     * @return mergeSubjectAltNames   * For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is specified
     * as
     *                                 true then the subjectAltName values
     * 
     *                                 specified by the subjectAltNames attribute
     * are
     *                                 added to the existing values instead
     * of
     *                                 replacing the existing values.
     */
    public Boolean getMergeSubjectAltNames() {
        return mergeSubjectAltNames;
    }


    /**
     * Sets the mergeSubjectAltNames value for this DigitalIdConfigParms.
     * 
     * @param mergeSubjectAltNames   * For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is specified
     * as
     *                                 true then the subjectAltName values
     * 
     *                                 specified by the subjectAltNames attribute
     * are
     *                                 added to the existing values instead
     * of
     *                                 replacing the existing values.
     */
    public void setMergeSubjectAltNames(Boolean mergeSubjectAltNames) {
        this.mergeSubjectAltNames = mergeSubjectAltNames;
    }


    /**
     * Gets the removeSubjectAltNames value for this DigitalIdConfigParms.
     * 
     * @return removeSubjectAltNames   * For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is not specified
     * as
     *                                 true and the removeSubjectAltNames
     * attribute
     *                                 is specified as true then the subjectAltName
     * values specified by the subjectAltNames
     *                                 attribute are removed from the existing
     * values.
     */
    public Boolean getRemoveSubjectAltNames() {
        return removeSubjectAltNames;
    }


    /**
     * Sets the removeSubjectAltNames value for this DigitalIdConfigParms.
     * 
     * @param removeSubjectAltNames   * For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is not specified
     * as
     *                                 true and the removeSubjectAltNames
     * attribute
     *                                 is specified as true then the subjectAltName
     * values specified by the subjectAltNames
     *                                 attribute are removed from the existing
     * values.
     */
    public void setRemoveSubjectAltNames(Boolean removeSubjectAltNames) {
        this.removeSubjectAltNames = removeSubjectAltNames;
    }


    /**
     * Gets the subjectAltNames value for this DigitalIdConfigParms.
     * 
     * @return subjectAltNames   * If specified, the subjectAltNames of the
     *                                 Digital Id Config are set to the specified
     * value.  For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is specified
     * as
     *                                 true then the specified values are
     * added
     *                                 to the existing values instead of
     * replacing
     *                                 the existing values.  If mergeSubjectAltNames
     * is not specified as true and
     *                                 removeSubjectAltNames is specified
     * as true
     *                                 then the specified subjectAltNames
     * are
     *                                 removed from the existing values.
     */
    public SubjectAltName[] getSubjectAltNames() {
        return subjectAltNames;
    }


    /**
     * Sets the subjectAltNames value for this DigitalIdConfigParms.
     * 
     * @param subjectAltNames   * If specified, the subjectAltNames of the
     *                                 Digital Id Config are set to the specified
     * value.  For the digitalIdConfigSet method,
     *                                 if mergeSubjectAltNames is specified
     * as
     *                                 true then the specified values are
     * added
     *                                 to the existing values instead of
     * replacing
     *                                 the existing values.  If mergeSubjectAltNames
     * is not specified as true and
     *                                 removeSubjectAltNames is specified
     * as true
     *                                 then the specified subjectAltNames
     * are
     *                                 removed from the existing values.
     */
    public void setSubjectAltNames(SubjectAltName[] subjectAltNames) {
        this.subjectAltNames = subjectAltNames;
    }


    /**
     * Gets the description value for this DigitalIdConfigParms.
     * 
     * @return description   * Optional description.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this DigitalIdConfigParms.
     * 
     * @param description   * Optional description.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the p10TrustedSignerCertificates value for this DigitalIdConfigParms.
     * 
     * @return p10TrustedSignerCertificates   * The optional list of P10 trusted signer 
     *                                 certificates to use with this Digital
     * Id 
     *                                 Config.
     */
    public byte[][] getP10TrustedSignerCertificates() {
        return p10TrustedSignerCertificates;
    }


    /**
     * Sets the p10TrustedSignerCertificates value for this DigitalIdConfigParms.
     * 
     * @param p10TrustedSignerCertificates   * The optional list of P10 trusted signer 
     *                                 certificates to use with this Digital
     * Id 
     *                                 Config.
     */
    public void setP10TrustedSignerCertificates(byte[][] p10TrustedSignerCertificates) {
        this.p10TrustedSignerCertificates = p10TrustedSignerCertificates;
    }


    /**
     * Gets the p10CertStreamPolicy value for this DigitalIdConfigParms.
     * 
     * @return p10CertStreamPolicy   * If set, the default P10 certificate stream 
     *                                 policy. During a create/recover operation
     * in 
     *                                 which P10 certificate requests are
     * provided 
     *                                 without explicitly specifying certificate
     * stream
     *                                 policy, this value (when present)
     * is used as the
     *                                 certificate stream policy for each
     * request.
     *                                 For an Entrust CA, this is a certificate
     * 
     *                                 definition name; for a Microsoft CA,
     * this is a 
     *                                 certificate template common name.
     */
    public String getP10CertStreamPolicy() {
        return p10CertStreamPolicy;
    }


    /**
     * Sets the p10CertStreamPolicy value for this DigitalIdConfigParms.
     * 
     * @param p10CertStreamPolicy   * If set, the default P10 certificate stream 
     *                                 policy. During a create/recover operation
     * in 
     *                                 which P10 certificate requests are
     * provided 
     *                                 without explicitly specifying certificate
     * stream
     *                                 policy, this value (when present)
     * is used as the
     *                                 certificate stream policy for each
     * request.
     *                                 For an Entrust CA, this is a certificate
     * 
     *                                 definition name; for a Microsoft CA,
     * this is a 
     *                                 certificate template common name.
     */
    public void setP10CertStreamPolicy(String p10CertStreamPolicy) {
        this.p10CertStreamPolicy = p10CertStreamPolicy;
    }


    /**
     * Gets the entrustSpecificParams value for this DigitalIdConfigParms.
     * 
     * @return entrustSpecificParams   * If set, indicates that these parameters are for an Entrust
     * digital identity 
     *                                 configuration and contains the Entrust
     * specific parameters.
     */
    public com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificParms getEntrustSpecificParams() {
        return entrustSpecificParams;
    }


    /**
     * Sets the entrustSpecificParams value for this DigitalIdConfigParms.
     * 
     * @param entrustSpecificParams   * If set, indicates that these parameters are for an Entrust
     * digital identity 
     *                                 configuration and contains the Entrust
     * specific parameters.
     */
    public void setEntrustSpecificParams(com.good.adapters.entrust.stubs.DigitalIdConfigEntrustSpecificParms entrustSpecificParams) {
        this.entrustSpecificParams = entrustSpecificParams;
    }


    /**
     * Gets the microsoftSpecificParams value for this DigitalIdConfigParms.
     * 
     * @return microsoftSpecificParams   * If set, indicates that these parameters are for an Microsoft
     * digital identity 
     *                                 configuration and contains the Microsoft
     * specific parameters.
     */
    public com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificParms getMicrosoftSpecificParams() {
        return microsoftSpecificParams;
    }


    /**
     * Sets the microsoftSpecificParams value for this DigitalIdConfigParms.
     * 
     * @param microsoftSpecificParams   * If set, indicates that these parameters are for an Microsoft
     * digital identity 
     *                                 configuration and contains the Microsoft
     * specific parameters.
     */
    public void setMicrosoftSpecificParams(com.good.adapters.entrust.stubs.DigitalIdConfigMicrosoftSpecificParms microsoftSpecificParams) {
        this.microsoftSpecificParams = microsoftSpecificParams;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof DigitalIdConfigParms)) return false;
        DigitalIdConfigParms other = (DigitalIdConfigParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.DNFormat==null && other.getDNFormat()==null) || 
             (this.DNFormat!=null &&
              this.DNFormat.equals(other.getDNFormat()))) &&
            ((this.searchbase==null && other.getSearchbase()==null) || 
             (this.searchbase!=null &&
              this.searchbase.equals(other.getSearchbase()))) &&
            ((this.managedCA==null && other.getManagedCA()==null) || 
             (this.managedCA!=null &&
              this.managedCA.equals(other.getManagedCA()))) &&
            ((this.category==null && other.getCategory()==null) || 
             (this.category!=null &&
              this.category.equals(other.getCategory()))) &&
            ((this.mergeSubjectAltNames==null && other.getMergeSubjectAltNames()==null) || 
             (this.mergeSubjectAltNames!=null &&
              this.mergeSubjectAltNames.equals(other.getMergeSubjectAltNames()))) &&
            ((this.removeSubjectAltNames==null && other.getRemoveSubjectAltNames()==null) || 
             (this.removeSubjectAltNames!=null &&
              this.removeSubjectAltNames.equals(other.getRemoveSubjectAltNames()))) &&
            ((this.subjectAltNames==null && other.getSubjectAltNames()==null) || 
             (this.subjectAltNames!=null &&
              java.util.Arrays.equals(this.subjectAltNames, other.getSubjectAltNames()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.p10TrustedSignerCertificates==null && other.getP10TrustedSignerCertificates()==null) || 
             (this.p10TrustedSignerCertificates!=null &&
              java.util.Arrays.equals(this.p10TrustedSignerCertificates, other.getP10TrustedSignerCertificates()))) &&
            ((this.p10CertStreamPolicy==null && other.getP10CertStreamPolicy()==null) || 
             (this.p10CertStreamPolicy!=null &&
              this.p10CertStreamPolicy.equals(other.getP10CertStreamPolicy()))) &&
            ((this.entrustSpecificParams==null && other.getEntrustSpecificParams()==null) || 
             (this.entrustSpecificParams!=null &&
              this.entrustSpecificParams.equals(other.getEntrustSpecificParams()))) &&
            ((this.microsoftSpecificParams==null && other.getMicrosoftSpecificParams()==null) || 
             (this.microsoftSpecificParams!=null &&
              this.microsoftSpecificParams.equals(other.getMicrosoftSpecificParams())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getDNFormat() != null) {
            _hashCode += getDNFormat().hashCode();
        }
        if (getSearchbase() != null) {
            _hashCode += getSearchbase().hashCode();
        }
        if (getManagedCA() != null) {
            _hashCode += getManagedCA().hashCode();
        }
        if (getCategory() != null) {
            _hashCode += getCategory().hashCode();
        }
        if (getMergeSubjectAltNames() != null) {
            _hashCode += getMergeSubjectAltNames().hashCode();
        }
        if (getRemoveSubjectAltNames() != null) {
            _hashCode += getRemoveSubjectAltNames().hashCode();
        }
        if (getSubjectAltNames() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSubjectAltNames());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSubjectAltNames(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getP10TrustedSignerCertificates() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getP10TrustedSignerCertificates());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getP10TrustedSignerCertificates(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getP10CertStreamPolicy() != null) {
            _hashCode += getP10CertStreamPolicy().hashCode();
        }
        if (getEntrustSpecificParams() != null) {
            _hashCode += getEntrustSpecificParams().hashCode();
        }
        if (getMicrosoftSpecificParams() != null) {
            _hashCode += getMicrosoftSpecificParams().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(DigitalIdConfigParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("DNFormat");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DNFormat"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("searchbase");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Searchbase"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("managedCA");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ManagedCA"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("category");
        elemField.setXmlName(new javax.xml.namespace.QName("", "category"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("mergeSubjectAltNames");
        elemField.setXmlName(new javax.xml.namespace.QName("", "mergeSubjectAltNames"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeSubjectAltNames");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeSubjectAltNames"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("subjectAltNames");
        elemField.setXmlName(new javax.xml.namespace.QName("", "subjectAltNames"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SubjectAltName"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("p10TrustedSignerCertificates");
        elemField.setXmlName(new javax.xml.namespace.QName("", "p10TrustedSignerCertificates"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("p10CertStreamPolicy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "p10CertStreamPolicy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("entrustSpecificParams");
        elemField.setXmlName(new javax.xml.namespace.QName("", "EntrustSpecificParams"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigEntrustSpecificParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("microsoftSpecificParams");
        elemField.setXmlName(new javax.xml.namespace.QName("", "MicrosoftSpecificParams"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdConfigMicrosoftSpecificParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
