/**
 * GroupInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a group.
 */
public class GroupInfo  implements java.io.Serializable {
    /* The name of the group. */
    private String name;

    /* If true, it means this group is the default,
     *                                 and is used in situations where no
     * group is
     *                                 specified but a group is required,
     * such as
     *                                 user creation. If false, this is not
     * the default
     *                                 group. */
    private boolean defaultGroup;

    /* The name of the policy associated with the group. */
    private String policy;

    /* The name of the partition associated with the
     *                                 group.  Users or cards created in
     * this group
     *                                 will be assigned user numbers or serial
     * numbers
     *                                 from this partition, as appropriate.
     * If this
     *                                 value is nil, users and cards are
     * assigned user
     *                                 numbers and card serial numbers from
     * the global
     *                                 system settings. */
    private String partition;

    /* The names of the repositories that users in
     *                                 this group may be stored in. If this
     * value is
     *                                 nil, it means that users in this group
     * will
     *                                 be stored in the repository flagged
     * as the
     *                                 default. */
    private String[] repository;

    /* The repository used to store pre-produced cards
     *                                 created in this group or added to
     * it. If this
     *                                 value is nil, pre-produced cards created
     * in or
     *                                 added to this group will be stored
     * in the
     *                                 default pre-produced card repository. */
    private String cardRepository;

    /* The repository used to store unassigned tokens
     *                                 loaded in this group or added to it.
     * If this
     *                                 value is nil, unassigned tokens loaded
     * in or
     *                                 added to this group will be stored
     * in the
     *                                 default unassigned token repository. */
    private String tokenRepository;

    /* The repository used to store unassigned smart credentials
     *                                 loaded in this group or added to it.
     * If this
     *                                 value is nil, unassigned smart credentials
     * loaded in or
     *                                 added to this group will be stored
     * in the
     *                                 default unassigned smart credential
     * repository. */
    private String smartCredentialRepository;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    /* Optional descriptive comments. */
    private String comment;

    public GroupInfo() {
    }

    public GroupInfo(
           String name,
           boolean defaultGroup,
           String policy,
           String partition,
           String[] repository,
           String cardRepository,
           String tokenRepository,
           String smartCredentialRepository,
           String[] rolesGrantingAccess,
           String comment) {
           this.name = name;
           this.defaultGroup = defaultGroup;
           this.policy = policy;
           this.partition = partition;
           this.repository = repository;
           this.cardRepository = cardRepository;
           this.tokenRepository = tokenRepository;
           this.smartCredentialRepository = smartCredentialRepository;
           this.rolesGrantingAccess = rolesGrantingAccess;
           this.comment = comment;
    }


    /**
     * Gets the name value for this GroupInfo.
     * 
     * @return name   * The name of the group.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this GroupInfo.
     * 
     * @param name   * The name of the group.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the defaultGroup value for this GroupInfo.
     * 
     * @return defaultGroup   * If true, it means this group is the default,
     *                                 and is used in situations where no
     * group is
     *                                 specified but a group is required,
     * such as
     *                                 user creation. If false, this is not
     * the default
     *                                 group.
     */
    public boolean isDefaultGroup() {
        return defaultGroup;
    }


    /**
     * Sets the defaultGroup value for this GroupInfo.
     * 
     * @param defaultGroup   * If true, it means this group is the default,
     *                                 and is used in situations where no
     * group is
     *                                 specified but a group is required,
     * such as
     *                                 user creation. If false, this is not
     * the default
     *                                 group.
     */
    public void setDefaultGroup(boolean defaultGroup) {
        this.defaultGroup = defaultGroup;
    }


    /**
     * Gets the policy value for this GroupInfo.
     * 
     * @return policy   * The name of the policy associated with the group.
     */
    public String getPolicy() {
        return policy;
    }


    /**
     * Sets the policy value for this GroupInfo.
     * 
     * @param policy   * The name of the policy associated with the group.
     */
    public void setPolicy(String policy) {
        this.policy = policy;
    }


    /**
     * Gets the partition value for this GroupInfo.
     * 
     * @return partition   * The name of the partition associated with the
     *                                 group.  Users or cards created in
     * this group
     *                                 will be assigned user numbers or serial
     * numbers
     *                                 from this partition, as appropriate.
     * If this
     *                                 value is nil, users and cards are
     * assigned user
     *                                 numbers and card serial numbers from
     * the global
     *                                 system settings.
     */
    public String getPartition() {
        return partition;
    }


    /**
     * Sets the partition value for this GroupInfo.
     * 
     * @param partition   * The name of the partition associated with the
     *                                 group.  Users or cards created in
     * this group
     *                                 will be assigned user numbers or serial
     * numbers
     *                                 from this partition, as appropriate.
     * If this
     *                                 value is nil, users and cards are
     * assigned user
     *                                 numbers and card serial numbers from
     * the global
     *                                 system settings.
     */
    public void setPartition(String partition) {
        this.partition = partition;
    }


    /**
     * Gets the repository value for this GroupInfo.
     * 
     * @return repository   * The names of the repositories that users in
     *                                 this group may be stored in. If this
     * value is
     *                                 nil, it means that users in this group
     * will
     *                                 be stored in the repository flagged
     * as the
     *                                 default.
     */
    public String[] getRepository() {
        return repository;
    }


    /**
     * Sets the repository value for this GroupInfo.
     * 
     * @param repository   * The names of the repositories that users in
     *                                 this group may be stored in. If this
     * value is
     *                                 nil, it means that users in this group
     * will
     *                                 be stored in the repository flagged
     * as the
     *                                 default.
     */
    public void setRepository(String[] repository) {
        this.repository = repository;
    }


    /**
     * Gets the cardRepository value for this GroupInfo.
     * 
     * @return cardRepository   * The repository used to store pre-produced cards
     *                                 created in this group or added to
     * it. If this
     *                                 value is nil, pre-produced cards created
     * in or
     *                                 added to this group will be stored
     * in the
     *                                 default pre-produced card repository.
     */
    public String getCardRepository() {
        return cardRepository;
    }


    /**
     * Sets the cardRepository value for this GroupInfo.
     * 
     * @param cardRepository   * The repository used to store pre-produced cards
     *                                 created in this group or added to
     * it. If this
     *                                 value is nil, pre-produced cards created
     * in or
     *                                 added to this group will be stored
     * in the
     *                                 default pre-produced card repository.
     */
    public void setCardRepository(String cardRepository) {
        this.cardRepository = cardRepository;
    }


    /**
     * Gets the tokenRepository value for this GroupInfo.
     * 
     * @return tokenRepository   * The repository used to store unassigned tokens
     *                                 loaded in this group or added to it.
     * If this
     *                                 value is nil, unassigned tokens loaded
     * in or
     *                                 added to this group will be stored
     * in the
     *                                 default unassigned token repository.
     */
    public String getTokenRepository() {
        return tokenRepository;
    }


    /**
     * Sets the tokenRepository value for this GroupInfo.
     * 
     * @param tokenRepository   * The repository used to store unassigned tokens
     *                                 loaded in this group or added to it.
     * If this
     *                                 value is nil, unassigned tokens loaded
     * in or
     *                                 added to this group will be stored
     * in the
     *                                 default unassigned token repository.
     */
    public void setTokenRepository(String tokenRepository) {
        this.tokenRepository = tokenRepository;
    }


    /**
     * Gets the smartCredentialRepository value for this GroupInfo.
     * 
     * @return smartCredentialRepository   * The repository used to store unassigned smart credentials
     *                                 loaded in this group or added to it.
     * If this
     *                                 value is nil, unassigned smart credentials
     * loaded in or
     *                                 added to this group will be stored
     * in the
     *                                 default unassigned smart credential
     * repository.
     */
    public String getSmartCredentialRepository() {
        return smartCredentialRepository;
    }


    /**
     * Sets the smartCredentialRepository value for this GroupInfo.
     * 
     * @param smartCredentialRepository   * The repository used to store unassigned smart credentials
     *                                 loaded in this group or added to it.
     * If this
     *                                 value is nil, unassigned smart credentials
     * loaded in or
     *                                 added to this group will be stored
     * in the
     *                                 default unassigned smart credential
     * repository.
     */
    public void setSmartCredentialRepository(String smartCredentialRepository) {
        this.smartCredentialRepository = smartCredentialRepository;
    }


    /**
     * Gets the rolesGrantingAccess value for this GroupInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this GroupInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the comment value for this GroupInfo.
     * 
     * @return comment   * Optional descriptive comments.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this GroupInfo.
     * 
     * @param comment   * Optional descriptive comments.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof GroupInfo)) return false;
        GroupInfo other = (GroupInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            this.defaultGroup == other.isDefaultGroup() &&
            ((this.policy==null && other.getPolicy()==null) || 
             (this.policy!=null &&
              this.policy.equals(other.getPolicy()))) &&
            ((this.partition==null && other.getPartition()==null) || 
             (this.partition!=null &&
              this.partition.equals(other.getPartition()))) &&
            ((this.repository==null && other.getRepository()==null) || 
             (this.repository!=null &&
              java.util.Arrays.equals(this.repository, other.getRepository()))) &&
            ((this.cardRepository==null && other.getCardRepository()==null) || 
             (this.cardRepository!=null &&
              this.cardRepository.equals(other.getCardRepository()))) &&
            ((this.tokenRepository==null && other.getTokenRepository()==null) || 
             (this.tokenRepository!=null &&
              this.tokenRepository.equals(other.getTokenRepository()))) &&
            ((this.smartCredentialRepository==null && other.getSmartCredentialRepository()==null) || 
             (this.smartCredentialRepository!=null &&
              this.smartCredentialRepository.equals(other.getSmartCredentialRepository()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        _hashCode += (isDefaultGroup() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getPolicy() != null) {
            _hashCode += getPolicy().hashCode();
        }
        if (getPartition() != null) {
            _hashCode += getPartition().hashCode();
        }
        if (getRepository() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRepository());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRepository(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCardRepository() != null) {
            _hashCode += getCardRepository().hashCode();
        }
        if (getTokenRepository() != null) {
            _hashCode += getTokenRepository().hashCode();
        }
        if (getSmartCredentialRepository() != null) {
            _hashCode += getSmartCredentialRepository().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(GroupInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "GroupInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("policy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "policy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("partition");
        elemField.setXmlName(new javax.xml.namespace.QName("", "partition"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("repository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "repository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cardRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "tokenRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "smartCredentialRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
