/**
 * GroupParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the group.
 */
public class GroupParms  implements java.io.Serializable {
    /* When passed in a call to groupSet, this
     *                                 specifies a new name for the group.
     * If this is
     *                                 included in a call to groupCreate
     * it is ignored. */
    private String name;

    /* If true, it means this group is the default,
     *                                 and is used in situations where no
     * group is
     *                                 specified. If false, this is not the
     * default
     *                                 group. There must always be exactly
     * one
     *                                 group flagged as being the default. */
    private Boolean defaultGroup;

    /* The name of the policy associated with the group. */
    private String policy;

    /* The name of the partition associated with the
     *                                 group.  Users or cards created in
     * this group
     *                                 will be assigned user numbers or serial
     * numbers
     *                                 from this partition, as appropriate. */
    private String partition;

    /* When updating a group, set this value to true
     *                                 to make the group not be assigned
     * any partition.
     *                                 This value is ignored during group
     * creation, if
     *                                 set to false, or if a partition is
     * specified. */
    private Boolean useNoPartition;

    /* The names of the repositories that users in
     *                                 this group may be stored in. */
    private String[] repositories;

    /* The repository used to store pre-produced cards
     *                                 created in this group or added to
     * it. Changing
     *                                 the repository for an existing group
     * will not
     *                                 move pre-produced cards already assigned
     * to this
     *                                 group to the new repository. */
    private String cardRepository;

    /* When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store pre-produced
     * cards,
     *                                 instead making it use the default
     * pre-produced
     *                                 card repository.
     *                                 This value is ignored during group
     * creation, if
     *                                 set to false, or if cardRepository
     * is specified. */
    private Boolean useNoCardRepository;

    /* The repository used to store unassigned tokens
     *                                 loaded in this group or added to it.
     * Changing
     *                                 the repository for an existing group
     * will not
     *                                 move unassigned token already assigned
     * to this
     *                                 group to the new repository. */
    private String tokenRepository;

    /* When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store unassigned
     * tokens,
     *                                 instead making it use the default
     * unassigned
     *                                 token repository.  This value is ignored
     * during
     *                                 group creation, if set to false, or
     * if
     *                                 tokenRepository is specified. */
    private Boolean useNoTokenRepository;

    /* The repository used to store unassigned smart credentials
     *                                 loaded in this group or added to it.
     * Changing
     *                                 the repository for an existing group
     * will not
     *                                 move unassigned smart credentials
     * already assigned to this
     *                                 group to the new repository. */
    private String smartCredentialRepository;

    /* When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store unassigned
     * smart credentials,
     *                                 instead making it use the default
     * unassigned
     *                                 smart credential repository.  This
     * value is ignored during
     *                                 group creation, if set to false, or
     * if
     *                                 smartCredentialRepository is specified. */
    private Boolean useNoSmartCredentialRepository;

    /* Optional descriptive comments. */
    private String comment;

    public GroupParms() {
    }

    public GroupParms(
           String name,
           Boolean defaultGroup,
           String policy,
           String partition,
           Boolean useNoPartition,
           String[] repositories,
           String cardRepository,
           Boolean useNoCardRepository,
           String tokenRepository,
           Boolean useNoTokenRepository,
           String smartCredentialRepository,
           Boolean useNoSmartCredentialRepository,
           String comment) {
           this.name = name;
           this.defaultGroup = defaultGroup;
           this.policy = policy;
           this.partition = partition;
           this.useNoPartition = useNoPartition;
           this.repositories = repositories;
           this.cardRepository = cardRepository;
           this.useNoCardRepository = useNoCardRepository;
           this.tokenRepository = tokenRepository;
           this.useNoTokenRepository = useNoTokenRepository;
           this.smartCredentialRepository = smartCredentialRepository;
           this.useNoSmartCredentialRepository = useNoSmartCredentialRepository;
           this.comment = comment;
    }


    /**
     * Gets the name value for this GroupParms.
     * 
     * @return name   * When passed in a call to groupSet, this
     *                                 specifies a new name for the group.
     * If this is
     *                                 included in a call to groupCreate
     * it is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this GroupParms.
     * 
     * @param name   * When passed in a call to groupSet, this
     *                                 specifies a new name for the group.
     * If this is
     *                                 included in a call to groupCreate
     * it is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the defaultGroup value for this GroupParms.
     * 
     * @return defaultGroup   * If true, it means this group is the default,
     *                                 and is used in situations where no
     * group is
     *                                 specified. If false, this is not the
     * default
     *                                 group. There must always be exactly
     * one
     *                                 group flagged as being the default.
     */
    public Boolean getDefaultGroup() {
        return defaultGroup;
    }


    /**
     * Sets the defaultGroup value for this GroupParms.
     * 
     * @param defaultGroup   * If true, it means this group is the default,
     *                                 and is used in situations where no
     * group is
     *                                 specified. If false, this is not the
     * default
     *                                 group. There must always be exactly
     * one
     *                                 group flagged as being the default.
     */
    public void setDefaultGroup(Boolean defaultGroup) {
        this.defaultGroup = defaultGroup;
    }


    /**
     * Gets the policy value for this GroupParms.
     * 
     * @return policy   * The name of the policy associated with the group.
     */
    public String getPolicy() {
        return policy;
    }


    /**
     * Sets the policy value for this GroupParms.
     * 
     * @param policy   * The name of the policy associated with the group.
     */
    public void setPolicy(String policy) {
        this.policy = policy;
    }


    /**
     * Gets the partition value for this GroupParms.
     * 
     * @return partition   * The name of the partition associated with the
     *                                 group.  Users or cards created in
     * this group
     *                                 will be assigned user numbers or serial
     * numbers
     *                                 from this partition, as appropriate.
     */
    public String getPartition() {
        return partition;
    }


    /**
     * Sets the partition value for this GroupParms.
     * 
     * @param partition   * The name of the partition associated with the
     *                                 group.  Users or cards created in
     * this group
     *                                 will be assigned user numbers or serial
     * numbers
     *                                 from this partition, as appropriate.
     */
    public void setPartition(String partition) {
        this.partition = partition;
    }


    /**
     * Gets the useNoPartition value for this GroupParms.
     * 
     * @return useNoPartition   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * any partition.
     *                                 This value is ignored during group
     * creation, if
     *                                 set to false, or if a partition is
     * specified.
     */
    public Boolean getUseNoPartition() {
        return useNoPartition;
    }


    /**
     * Sets the useNoPartition value for this GroupParms.
     * 
     * @param useNoPartition   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * any partition.
     *                                 This value is ignored during group
     * creation, if
     *                                 set to false, or if a partition is
     * specified.
     */
    public void setUseNoPartition(Boolean useNoPartition) {
        this.useNoPartition = useNoPartition;
    }


    /**
     * Gets the repositories value for this GroupParms.
     * 
     * @return repositories   * The names of the repositories that users in
     *                                 this group may be stored in.
     */
    public String[] getRepositories() {
        return repositories;
    }


    /**
     * Sets the repositories value for this GroupParms.
     * 
     * @param repositories   * The names of the repositories that users in
     *                                 this group may be stored in.
     */
    public void setRepositories(String[] repositories) {
        this.repositories = repositories;
    }


    /**
     * Gets the cardRepository value for this GroupParms.
     * 
     * @return cardRepository   * The repository used to store pre-produced cards
     *                                 created in this group or added to
     * it. Changing
     *                                 the repository for an existing group
     * will not
     *                                 move pre-produced cards already assigned
     * to this
     *                                 group to the new repository.
     */
    public String getCardRepository() {
        return cardRepository;
    }


    /**
     * Sets the cardRepository value for this GroupParms.
     * 
     * @param cardRepository   * The repository used to store pre-produced cards
     *                                 created in this group or added to
     * it. Changing
     *                                 the repository for an existing group
     * will not
     *                                 move pre-produced cards already assigned
     * to this
     *                                 group to the new repository.
     */
    public void setCardRepository(String cardRepository) {
        this.cardRepository = cardRepository;
    }


    /**
     * Gets the useNoCardRepository value for this GroupParms.
     * 
     * @return useNoCardRepository   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store pre-produced
     * cards,
     *                                 instead making it use the default
     * pre-produced
     *                                 card repository.
     *                                 This value is ignored during group
     * creation, if
     *                                 set to false, or if cardRepository
     * is specified.
     */
    public Boolean getUseNoCardRepository() {
        return useNoCardRepository;
    }


    /**
     * Sets the useNoCardRepository value for this GroupParms.
     * 
     * @param useNoCardRepository   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store pre-produced
     * cards,
     *                                 instead making it use the default
     * pre-produced
     *                                 card repository.
     *                                 This value is ignored during group
     * creation, if
     *                                 set to false, or if cardRepository
     * is specified.
     */
    public void setUseNoCardRepository(Boolean useNoCardRepository) {
        this.useNoCardRepository = useNoCardRepository;
    }


    /**
     * Gets the tokenRepository value for this GroupParms.
     * 
     * @return tokenRepository   * The repository used to store unassigned tokens
     *                                 loaded in this group or added to it.
     * Changing
     *                                 the repository for an existing group
     * will not
     *                                 move unassigned token already assigned
     * to this
     *                                 group to the new repository.
     */
    public String getTokenRepository() {
        return tokenRepository;
    }


    /**
     * Sets the tokenRepository value for this GroupParms.
     * 
     * @param tokenRepository   * The repository used to store unassigned tokens
     *                                 loaded in this group or added to it.
     * Changing
     *                                 the repository for an existing group
     * will not
     *                                 move unassigned token already assigned
     * to this
     *                                 group to the new repository.
     */
    public void setTokenRepository(String tokenRepository) {
        this.tokenRepository = tokenRepository;
    }


    /**
     * Gets the useNoTokenRepository value for this GroupParms.
     * 
     * @return useNoTokenRepository   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store unassigned
     * tokens,
     *                                 instead making it use the default
     * unassigned
     *                                 token repository.  This value is ignored
     * during
     *                                 group creation, if set to false, or
     * if
     *                                 tokenRepository is specified.
     */
    public Boolean getUseNoTokenRepository() {
        return useNoTokenRepository;
    }


    /**
     * Sets the useNoTokenRepository value for this GroupParms.
     * 
     * @param useNoTokenRepository   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store unassigned
     * tokens,
     *                                 instead making it use the default
     * unassigned
     *                                 token repository.  This value is ignored
     * during
     *                                 group creation, if set to false, or
     * if
     *                                 tokenRepository is specified.
     */
    public void setUseNoTokenRepository(Boolean useNoTokenRepository) {
        this.useNoTokenRepository = useNoTokenRepository;
    }


    /**
     * Gets the smartCredentialRepository value for this GroupParms.
     * 
     * @return smartCredentialRepository   * The repository used to store unassigned smart credentials
     *                                 loaded in this group or added to it.
     * Changing
     *                                 the repository for an existing group
     * will not
     *                                 move unassigned smart credentials
     * already assigned to this
     *                                 group to the new repository.
     */
    public String getSmartCredentialRepository() {
        return smartCredentialRepository;
    }


    /**
     * Sets the smartCredentialRepository value for this GroupParms.
     * 
     * @param smartCredentialRepository   * The repository used to store unassigned smart credentials
     *                                 loaded in this group or added to it.
     * Changing
     *                                 the repository for an existing group
     * will not
     *                                 move unassigned smart credentials
     * already assigned to this
     *                                 group to the new repository.
     */
    public void setSmartCredentialRepository(String smartCredentialRepository) {
        this.smartCredentialRepository = smartCredentialRepository;
    }


    /**
     * Gets the useNoSmartCredentialRepository value for this GroupParms.
     * 
     * @return useNoSmartCredentialRepository   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store unassigned
     * smart credentials,
     *                                 instead making it use the default
     * unassigned
     *                                 smart credential repository.  This
     * value is ignored during
     *                                 group creation, if set to false, or
     * if
     *                                 smartCredentialRepository is specified.
     */
    public Boolean getUseNoSmartCredentialRepository() {
        return useNoSmartCredentialRepository;
    }


    /**
     * Sets the useNoSmartCredentialRepository value for this GroupParms.
     * 
     * @param useNoSmartCredentialRepository   * When updating a group, set this value to true
     *                                 to make the group not be assigned
     * a particular
     *                                 repository in which to store unassigned
     * smart credentials,
     *                                 instead making it use the default
     * unassigned
     *                                 smart credential repository.  This
     * value is ignored during
     *                                 group creation, if set to false, or
     * if
     *                                 smartCredentialRepository is specified.
     */
    public void setUseNoSmartCredentialRepository(Boolean useNoSmartCredentialRepository) {
        this.useNoSmartCredentialRepository = useNoSmartCredentialRepository;
    }


    /**
     * Gets the comment value for this GroupParms.
     * 
     * @return comment   * Optional descriptive comments.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this GroupParms.
     * 
     * @param comment   * Optional descriptive comments.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof GroupParms)) return false;
        GroupParms other = (GroupParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.defaultGroup==null && other.getDefaultGroup()==null) || 
             (this.defaultGroup!=null &&
              this.defaultGroup.equals(other.getDefaultGroup()))) &&
            ((this.policy==null && other.getPolicy()==null) || 
             (this.policy!=null &&
              this.policy.equals(other.getPolicy()))) &&
            ((this.partition==null && other.getPartition()==null) || 
             (this.partition!=null &&
              this.partition.equals(other.getPartition()))) &&
            ((this.useNoPartition==null && other.getUseNoPartition()==null) || 
             (this.useNoPartition!=null &&
              this.useNoPartition.equals(other.getUseNoPartition()))) &&
            ((this.repositories==null && other.getRepositories()==null) || 
             (this.repositories!=null &&
              java.util.Arrays.equals(this.repositories, other.getRepositories()))) &&
            ((this.cardRepository==null && other.getCardRepository()==null) || 
             (this.cardRepository!=null &&
              this.cardRepository.equals(other.getCardRepository()))) &&
            ((this.useNoCardRepository==null && other.getUseNoCardRepository()==null) || 
             (this.useNoCardRepository!=null &&
              this.useNoCardRepository.equals(other.getUseNoCardRepository()))) &&
            ((this.tokenRepository==null && other.getTokenRepository()==null) || 
             (this.tokenRepository!=null &&
              this.tokenRepository.equals(other.getTokenRepository()))) &&
            ((this.useNoTokenRepository==null && other.getUseNoTokenRepository()==null) || 
             (this.useNoTokenRepository!=null &&
              this.useNoTokenRepository.equals(other.getUseNoTokenRepository()))) &&
            ((this.smartCredentialRepository==null && other.getSmartCredentialRepository()==null) || 
             (this.smartCredentialRepository!=null &&
              this.smartCredentialRepository.equals(other.getSmartCredentialRepository()))) &&
            ((this.useNoSmartCredentialRepository==null && other.getUseNoSmartCredentialRepository()==null) || 
             (this.useNoSmartCredentialRepository!=null &&
              this.useNoSmartCredentialRepository.equals(other.getUseNoSmartCredentialRepository()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getDefaultGroup() != null) {
            _hashCode += getDefaultGroup().hashCode();
        }
        if (getPolicy() != null) {
            _hashCode += getPolicy().hashCode();
        }
        if (getPartition() != null) {
            _hashCode += getPartition().hashCode();
        }
        if (getUseNoPartition() != null) {
            _hashCode += getUseNoPartition().hashCode();
        }
        if (getRepositories() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRepositories());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRepositories(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCardRepository() != null) {
            _hashCode += getCardRepository().hashCode();
        }
        if (getUseNoCardRepository() != null) {
            _hashCode += getUseNoCardRepository().hashCode();
        }
        if (getTokenRepository() != null) {
            _hashCode += getTokenRepository().hashCode();
        }
        if (getUseNoTokenRepository() != null) {
            _hashCode += getUseNoTokenRepository().hashCode();
        }
        if (getSmartCredentialRepository() != null) {
            _hashCode += getSmartCredentialRepository().hashCode();
        }
        if (getUseNoSmartCredentialRepository() != null) {
            _hashCode += getUseNoSmartCredentialRepository().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(GroupParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "GroupParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("policy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "policy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("partition");
        elemField.setXmlName(new javax.xml.namespace.QName("", "partition"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("useNoPartition");
        elemField.setXmlName(new javax.xml.namespace.QName("", "useNoPartition"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("repositories");
        elemField.setXmlName(new javax.xml.namespace.QName("", "repositories"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cardRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("useNoCardRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "useNoCardRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "tokenRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("useNoTokenRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "useNoTokenRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "smartCredentialRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("useNoSmartCredentialRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "useNoSmartCredentialRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
