/**
 * LicenseInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Information about the system license settings.
 */
public class LicenseInfo  implements java.io.Serializable {
    /* The current number of users in the system. */
    private java.math.BigInteger numUsers;

    /* The maximum number of users that can exist in
     *                                 the system. The system will not allow
     * more than
     *                                 this many users to be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of users in the system, or
     * the
     *                                 licenseCheck operation was called
     * to count users
     *                                 and did not provide installation and
     * activation
     *                                 keys. */
    private java.math.BigInteger maxUsers;

    /* The date at which the license expires. The
     *                                 system will cease functioning after
     * this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the
     *                                 licenseCheck operation was called
     * to count users
     *                                 and did not provide installation and
     * activation
     *                                 keys. */
    private java.util.Calendar expiryDate;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public LicenseInfo() {
    }

    public LicenseInfo(
           java.math.BigInteger numUsers,
           java.math.BigInteger maxUsers,
           java.util.Calendar expiryDate,
           String[] rolesGrantingAccess) {
           this.numUsers = numUsers;
           this.maxUsers = maxUsers;
           this.expiryDate = expiryDate;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the numUsers value for this LicenseInfo.
     * 
     * @return numUsers   * The current number of users in the system.
     */
    public java.math.BigInteger getNumUsers() {
        return numUsers;
    }


    /**
     * Sets the numUsers value for this LicenseInfo.
     * 
     * @param numUsers   * The current number of users in the system.
     */
    public void setNumUsers(java.math.BigInteger numUsers) {
        this.numUsers = numUsers;
    }


    /**
     * Gets the maxUsers value for this LicenseInfo.
     * 
     * @return maxUsers   * The maximum number of users that can exist in
     *                                 the system. The system will not allow
     * more than
     *                                 this many users to be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of users in the system, or
     * the
     *                                 licenseCheck operation was called
     * to count users
     *                                 and did not provide installation and
     * activation
     *                                 keys.
     */
    public java.math.BigInteger getMaxUsers() {
        return maxUsers;
    }


    /**
     * Sets the maxUsers value for this LicenseInfo.
     * 
     * @param maxUsers   * The maximum number of users that can exist in
     *                                 the system. The system will not allow
     * more than
     *                                 this many users to be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of users in the system, or
     * the
     *                                 licenseCheck operation was called
     * to count users
     *                                 and did not provide installation and
     * activation
     *                                 keys.
     */
    public void setMaxUsers(java.math.BigInteger maxUsers) {
        this.maxUsers = maxUsers;
    }


    /**
     * Gets the expiryDate value for this LicenseInfo.
     * 
     * @return expiryDate   * The date at which the license expires. The
     *                                 system will cease functioning after
     * this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the
     *                                 licenseCheck operation was called
     * to count users
     *                                 and did not provide installation and
     * activation
     *                                 keys.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this LicenseInfo.
     * 
     * @param expiryDate   * The date at which the license expires. The
     *                                 system will cease functioning after
     * this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the
     *                                 licenseCheck operation was called
     * to count users
     *                                 and did not provide installation and
     * activation
     *                                 keys.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the rolesGrantingAccess value for this LicenseInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this LicenseInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof LicenseInfo)) return false;
        LicenseInfo other = (LicenseInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.numUsers==null && other.getNumUsers()==null) || 
             (this.numUsers!=null &&
              this.numUsers.equals(other.getNumUsers()))) &&
            ((this.maxUsers==null && other.getMaxUsers()==null) || 
             (this.maxUsers!=null &&
              this.maxUsers.equals(other.getMaxUsers()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getNumUsers() != null) {
            _hashCode += getNumUsers().hashCode();
        }
        if (getMaxUsers() != null) {
            _hashCode += getMaxUsers().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(LicenseInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "LicenseInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numUsers");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numUsers"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxUsers");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxUsers"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
