/**
 * LoginParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information passed to a login or changePassword
 *                         request.
 */
public class LoginParms  implements java.io.Serializable {
    /* The user ID of the administrator logging in. */
    private String adminId;

    /* The password for the first phase of authentication.  
     *                                 When performing the second phase of
     * two-factor authentication,
     *                                 this value must be set to null. */
    private String password;

    /* The response to a GRID or TOKENCR challenge,
     *                                 or the value displayed on the token
     * for TOKENRO
     *                                 authentication, for the second phase
     * of authentication.
     *                                 When performing the second call to
     * login or
     *                                 changePassword when second-factor
     *                                 authentication is required, set this
     * value to
     *                                 the response and set the password
     * parameter to
     *                                 null. */
    private String[] response;

    /* Parameters passed to login. Currently the only
     *                                 supported parameter here is "locale",
     * used to
     *                                 provide the location of the administrator
     * logging
     *                                 in. This locale is an ISO language
     * code, optionally
     *                                 followed by an ISO country code, separated
     * by
     *                                 an underscore, for example "en_US"
     * for American English. */
    private NameValue[] parms;

    /* The user ID of the administrator logging in by delegation. */
    private String delegateId;

    /* The certificate chain from an SSL client. */
    private byte[][] clientCert;

    /* The kind of authenticator being provided for a delegation login. */
    private DelegationAuthType delegateAuth;

    public LoginParms() {
    }

    public LoginParms(
           String adminId,
           String password,
           String[] response,
           NameValue[] parms,
           String delegateId,
           byte[][] clientCert,
           DelegationAuthType delegateAuth) {
           this.adminId = adminId;
           this.password = password;
           this.response = response;
           this.parms = parms;
           this.delegateId = delegateId;
           this.clientCert = clientCert;
           this.delegateAuth = delegateAuth;
    }


    /**
     * Gets the adminId value for this LoginParms.
     * 
     * @return adminId   * The user ID of the administrator logging in.
     */
    public String getAdminId() {
        return adminId;
    }


    /**
     * Sets the adminId value for this LoginParms.
     * 
     * @param adminId   * The user ID of the administrator logging in.
     */
    public void setAdminId(String adminId) {
        this.adminId = adminId;
    }


    /**
     * Gets the password value for this LoginParms.
     * 
     * @return password   * The password for the first phase of authentication.  
     *                                 When performing the second phase of
     * two-factor authentication,
     *                                 this value must be set to null.
     */
    public String getPassword() {
        return password;
    }


    /**
     * Sets the password value for this LoginParms.
     * 
     * @param password   * The password for the first phase of authentication.  
     *                                 When performing the second phase of
     * two-factor authentication,
     *                                 this value must be set to null.
     */
    public void setPassword(String password) {
        this.password = password;
    }


    /**
     * Gets the response value for this LoginParms.
     * 
     * @return response   * The response to a GRID or TOKENCR challenge,
     *                                 or the value displayed on the token
     * for TOKENRO
     *                                 authentication, for the second phase
     * of authentication.
     *                                 When performing the second call to
     * login or
     *                                 changePassword when second-factor
     *                                 authentication is required, set this
     * value to
     *                                 the response and set the password
     * parameter to
     *                                 null.
     */
    public String[] getResponse() {
        return response;
    }


    /**
     * Sets the response value for this LoginParms.
     * 
     * @param response   * The response to a GRID or TOKENCR challenge,
     *                                 or the value displayed on the token
     * for TOKENRO
     *                                 authentication, for the second phase
     * of authentication.
     *                                 When performing the second call to
     * login or
     *                                 changePassword when second-factor
     *                                 authentication is required, set this
     * value to
     *                                 the response and set the password
     * parameter to
     *                                 null.
     */
    public void setResponse(String[] response) {
        this.response = response;
    }


    /**
     * Gets the parms value for this LoginParms.
     * 
     * @return parms   * Parameters passed to login. Currently the only
     *                                 supported parameter here is "locale",
     * used to
     *                                 provide the location of the administrator
     * logging
     *                                 in. This locale is an ISO language
     * code, optionally
     *                                 followed by an ISO country code, separated
     * by
     *                                 an underscore, for example "en_US"
     * for American English.
     */
    public NameValue[] getParms() {
        return parms;
    }


    /**
     * Sets the parms value for this LoginParms.
     * 
     * @param parms   * Parameters passed to login. Currently the only
     *                                 supported parameter here is "locale",
     * used to
     *                                 provide the location of the administrator
     * logging
     *                                 in. This locale is an ISO language
     * code, optionally
     *                                 followed by an ISO country code, separated
     * by
     *                                 an underscore, for example "en_US"
     * for American English.
     */
    public void setParms(NameValue[] parms) {
        this.parms = parms;
    }


    /**
     * Gets the delegateId value for this LoginParms.
     * 
     * @return delegateId   * The user ID of the administrator logging in by delegation.
     */
    public String getDelegateId() {
        return delegateId;
    }


    /**
     * Sets the delegateId value for this LoginParms.
     * 
     * @param delegateId   * The user ID of the administrator logging in by delegation.
     */
    public void setDelegateId(String delegateId) {
        this.delegateId = delegateId;
    }


    /**
     * Gets the clientCert value for this LoginParms.
     * 
     * @return clientCert   * The certificate chain from an SSL client.
     */
    public byte[][] getClientCert() {
        return clientCert;
    }


    /**
     * Sets the clientCert value for this LoginParms.
     * 
     * @param clientCert   * The certificate chain from an SSL client.
     */
    public void setClientCert(byte[][] clientCert) {
        this.clientCert = clientCert;
    }


    /**
     * Gets the delegateAuth value for this LoginParms.
     * 
     * @return delegateAuth   * The kind of authenticator being provided for a delegation login.
     */
    public DelegationAuthType getDelegateAuth() {
        return delegateAuth;
    }


    /**
     * Sets the delegateAuth value for this LoginParms.
     * 
     * @param delegateAuth   * The kind of authenticator being provided for a delegation login.
     */
    public void setDelegateAuth(DelegationAuthType delegateAuth) {
        this.delegateAuth = delegateAuth;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof LoginParms)) return false;
        LoginParms other = (LoginParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.adminId==null && other.getAdminId()==null) || 
             (this.adminId!=null &&
              this.adminId.equals(other.getAdminId()))) &&
            ((this.password==null && other.getPassword()==null) || 
             (this.password!=null &&
              this.password.equals(other.getPassword()))) &&
            ((this.response==null && other.getResponse()==null) || 
             (this.response!=null &&
              java.util.Arrays.equals(this.response, other.getResponse()))) &&
            ((this.parms==null && other.getParms()==null) || 
             (this.parms!=null &&
              java.util.Arrays.equals(this.parms, other.getParms()))) &&
            ((this.delegateId==null && other.getDelegateId()==null) || 
             (this.delegateId!=null &&
              this.delegateId.equals(other.getDelegateId()))) &&
            ((this.clientCert==null && other.getClientCert()==null) || 
             (this.clientCert!=null &&
              java.util.Arrays.equals(this.clientCert, other.getClientCert()))) &&
            ((this.delegateAuth==null && other.getDelegateAuth()==null) || 
             (this.delegateAuth!=null &&
              this.delegateAuth.equals(other.getDelegateAuth())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getAdminId() != null) {
            _hashCode += getAdminId().hashCode();
        }
        if (getPassword() != null) {
            _hashCode += getPassword().hashCode();
        }
        if (getResponse() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getResponse());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getResponse(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getParms() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getParms());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getParms(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDelegateId() != null) {
            _hashCode += getDelegateId().hashCode();
        }
        if (getClientCert() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getClientCert());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getClientCert(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDelegateAuth() != null) {
            _hashCode += getDelegateAuth().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(LoginParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "LoginParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("adminId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "adminId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("password");
        elemField.setXmlName(new javax.xml.namespace.QName("", "password"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("response");
        elemField.setXmlName(new javax.xml.namespace.QName("", "response"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("parms");
        elemField.setXmlName(new javax.xml.namespace.QName("", "parms"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "NameValue"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("delegateId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "delegateId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("clientCert");
        elemField.setXmlName(new javax.xml.namespace.QName("", "clientCert"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("delegateAuth");
        elemField.setXmlName(new javax.xml.namespace.QName("", "delegateAuth"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DelegationAuthType"));
        elemField.setMinOccurs(0);
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
