/**
 * LoginResult.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned from a login or
 *                         changePassword request.
 */
public class LoginResult  implements java.io.Serializable {
    /* The state of the login request. */
    private LoginState state;

    /* The group name of the administrator logging in.
     *                                 This value will only be set if the
     * administrator has completed logging in. */
    private String groupName;

    /* The user name of the administrator logging in.
     *                                 This value will only be set if the
     * administrator has completed logging in. */
    private String userName;

    /* The group name of the administrator logging in
     *                                 by delegation.  This value will only
     * be set if the
     *                                 delegation login completed successfully. */
    private String delegateGroupName;

    /* The user name of the administrator logging in
     *                                 by delegation.  This value will only
     * be set if the
     *                                 delegation login completed successfully. */
    private String delegateUserName;

    /* A challenge for second-factor authentication.
     *                                 This value will only be set if the
     * administrator has passed the first-phase
     *                                 password authentication and second-factor
     * authentication is required for the
     *                                 administrator. */
    private LoginChallenge loginChallenge;

    /* The date on which the user's password will
     *                                 expire.  A value of Date(0) means
     * the password
     *                                 will never expire.
     *                                 This value will be set if the administrator
     * is using an Entrust IdentityGuard password
     *                                 for first factor authentication and
     * the
     *                                 password has been authenticated.
     *                                 This value will not be set if the
     * administrator
     *                                 is using an external password for
     * first factor
     *                                 authentication. */
    private java.util.Calendar passwordExpiryDate;

    /* The date after which a password change will
     *                                 be allowed for the user, accounting
     * for the
     *                                 minimum lifetime policy.
     *                                 This value will be set if the administrator
     * is using an Entrust IdentityGuard password
     *                                 for first factor authentication and
     * the
     *                                 password has been authenticated.
     *                                 This value will not be set if the
     * administrator
     *                                 is using an external password for
     * first factor
     *                                 authentication. */
    private java.util.Calendar passwordAllowChangeAfterDate;

    /* The card used for second factor authentication.
     *                                 This value will be set if the administrator
     * has successfully used the card for second
     *                                 factor authentication. */
    private CardData card;

    /* The token used for second factor
     *                                 authentication.
     *                                 This value will be set if the administrator
     * has successfully used the token for second
     *                                 factor authentication. */
    private TokenData token;

    /* This value will be set if this structure
     *                                 is being returned for an invalid response. */
    private AdminServiceFault loginFault;

    public LoginResult() {
    }

    public LoginResult(
           LoginState state,
           String groupName,
           String userName,
           String delegateGroupName,
           String delegateUserName,
           LoginChallenge loginChallenge,
           java.util.Calendar passwordExpiryDate,
           java.util.Calendar passwordAllowChangeAfterDate,
           CardData card,
           TokenData token,
           AdminServiceFault loginFault) {
           this.state = state;
           this.groupName = groupName;
           this.userName = userName;
           this.delegateGroupName = delegateGroupName;
           this.delegateUserName = delegateUserName;
           this.loginChallenge = loginChallenge;
           this.passwordExpiryDate = passwordExpiryDate;
           this.passwordAllowChangeAfterDate = passwordAllowChangeAfterDate;
           this.card = card;
           this.token = token;
           this.loginFault = loginFault;
    }


    /**
     * Gets the state value for this LoginResult.
     * 
     * @return state   * The state of the login request.
     */
    public LoginState getState() {
        return state;
    }


    /**
     * Sets the state value for this LoginResult.
     * 
     * @param state   * The state of the login request.
     */
    public void setState(LoginState state) {
        this.state = state;
    }


    /**
     * Gets the groupName value for this LoginResult.
     * 
     * @return groupName   * The group name of the administrator logging in.
     *                                 This value will only be set if the
     * administrator has completed logging in.
     */
    public String getGroupName() {
        return groupName;
    }


    /**
     * Sets the groupName value for this LoginResult.
     * 
     * @param groupName   * The group name of the administrator logging in.
     *                                 This value will only be set if the
     * administrator has completed logging in.
     */
    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }


    /**
     * Gets the userName value for this LoginResult.
     * 
     * @return userName   * The user name of the administrator logging in.
     *                                 This value will only be set if the
     * administrator has completed logging in.
     */
    public String getUserName() {
        return userName;
    }


    /**
     * Sets the userName value for this LoginResult.
     * 
     * @param userName   * The user name of the administrator logging in.
     *                                 This value will only be set if the
     * administrator has completed logging in.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }


    /**
     * Gets the delegateGroupName value for this LoginResult.
     * 
     * @return delegateGroupName   * The group name of the administrator logging in
     *                                 by delegation.  This value will only
     * be set if the
     *                                 delegation login completed successfully.
     */
    public String getDelegateGroupName() {
        return delegateGroupName;
    }


    /**
     * Sets the delegateGroupName value for this LoginResult.
     * 
     * @param delegateGroupName   * The group name of the administrator logging in
     *                                 by delegation.  This value will only
     * be set if the
     *                                 delegation login completed successfully.
     */
    public void setDelegateGroupName(String delegateGroupName) {
        this.delegateGroupName = delegateGroupName;
    }


    /**
     * Gets the delegateUserName value for this LoginResult.
     * 
     * @return delegateUserName   * The user name of the administrator logging in
     *                                 by delegation.  This value will only
     * be set if the
     *                                 delegation login completed successfully.
     */
    public String getDelegateUserName() {
        return delegateUserName;
    }


    /**
     * Sets the delegateUserName value for this LoginResult.
     * 
     * @param delegateUserName   * The user name of the administrator logging in
     *                                 by delegation.  This value will only
     * be set if the
     *                                 delegation login completed successfully.
     */
    public void setDelegateUserName(String delegateUserName) {
        this.delegateUserName = delegateUserName;
    }


    /**
     * Gets the loginChallenge value for this LoginResult.
     * 
     * @return loginChallenge   * A challenge for second-factor authentication.
     *                                 This value will only be set if the
     * administrator has passed the first-phase
     *                                 password authentication and second-factor
     * authentication is required for the
     *                                 administrator.
     */
    public LoginChallenge getLoginChallenge() {
        return loginChallenge;
    }


    /**
     * Sets the loginChallenge value for this LoginResult.
     * 
     * @param loginChallenge   * A challenge for second-factor authentication.
     *                                 This value will only be set if the
     * administrator has passed the first-phase
     *                                 password authentication and second-factor
     * authentication is required for the
     *                                 administrator.
     */
    public void setLoginChallenge(LoginChallenge loginChallenge) {
        this.loginChallenge = loginChallenge;
    }


    /**
     * Gets the passwordExpiryDate value for this LoginResult.
     * 
     * @return passwordExpiryDate   * The date on which the user's password will
     *                                 expire.  A value of Date(0) means
     * the password
     *                                 will never expire.
     *                                 This value will be set if the administrator
     * is using an Entrust IdentityGuard password
     *                                 for first factor authentication and
     * the
     *                                 password has been authenticated.
     *                                 This value will not be set if the
     * administrator
     *                                 is using an external password for
     * first factor
     *                                 authentication.
     */
    public java.util.Calendar getPasswordExpiryDate() {
        return passwordExpiryDate;
    }


    /**
     * Sets the passwordExpiryDate value for this LoginResult.
     * 
     * @param passwordExpiryDate   * The date on which the user's password will
     *                                 expire.  A value of Date(0) means
     * the password
     *                                 will never expire.
     *                                 This value will be set if the administrator
     * is using an Entrust IdentityGuard password
     *                                 for first factor authentication and
     * the
     *                                 password has been authenticated.
     *                                 This value will not be set if the
     * administrator
     *                                 is using an external password for
     * first factor
     *                                 authentication.
     */
    public void setPasswordExpiryDate(java.util.Calendar passwordExpiryDate) {
        this.passwordExpiryDate = passwordExpiryDate;
    }


    /**
     * Gets the passwordAllowChangeAfterDate value for this LoginResult.
     * 
     * @return passwordAllowChangeAfterDate   * The date after which a password change will
     *                                 be allowed for the user, accounting
     * for the
     *                                 minimum lifetime policy.
     *                                 This value will be set if the administrator
     * is using an Entrust IdentityGuard password
     *                                 for first factor authentication and
     * the
     *                                 password has been authenticated.
     *                                 This value will not be set if the
     * administrator
     *                                 is using an external password for
     * first factor
     *                                 authentication.
     */
    public java.util.Calendar getPasswordAllowChangeAfterDate() {
        return passwordAllowChangeAfterDate;
    }


    /**
     * Sets the passwordAllowChangeAfterDate value for this LoginResult.
     * 
     * @param passwordAllowChangeAfterDate   * The date after which a password change will
     *                                 be allowed for the user, accounting
     * for the
     *                                 minimum lifetime policy.
     *                                 This value will be set if the administrator
     * is using an Entrust IdentityGuard password
     *                                 for first factor authentication and
     * the
     *                                 password has been authenticated.
     *                                 This value will not be set if the
     * administrator
     *                                 is using an external password for
     * first factor
     *                                 authentication.
     */
    public void setPasswordAllowChangeAfterDate(java.util.Calendar passwordAllowChangeAfterDate) {
        this.passwordAllowChangeAfterDate = passwordAllowChangeAfterDate;
    }


    /**
     * Gets the card value for this LoginResult.
     * 
     * @return card   * The card used for second factor authentication.
     *                                 This value will be set if the administrator
     * has successfully used the card for second
     *                                 factor authentication.
     */
    public CardData getCard() {
        return card;
    }


    /**
     * Sets the card value for this LoginResult.
     * 
     * @param card   * The card used for second factor authentication.
     *                                 This value will be set if the administrator
     * has successfully used the card for second
     *                                 factor authentication.
     */
    public void setCard(CardData card) {
        this.card = card;
    }


    /**
     * Gets the token value for this LoginResult.
     * 
     * @return token   * The token used for second factor
     *                                 authentication.
     *                                 This value will be set if the administrator
     * has successfully used the token for second
     *                                 factor authentication.
     */
    public TokenData getToken() {
        return token;
    }


    /**
     * Sets the token value for this LoginResult.
     * 
     * @param token   * The token used for second factor
     *                                 authentication.
     *                                 This value will be set if the administrator
     * has successfully used the token for second
     *                                 factor authentication.
     */
    public void setToken(TokenData token) {
        this.token = token;
    }


    /**
     * Gets the loginFault value for this LoginResult.
     * 
     * @return loginFault   * This value will be set if this structure
     *                                 is being returned for an invalid response.
     */
    public AdminServiceFault getLoginFault() {
        return loginFault;
    }


    /**
     * Sets the loginFault value for this LoginResult.
     * 
     * @param loginFault   * This value will be set if this structure
     *                                 is being returned for an invalid response.
     */
    public void setLoginFault(AdminServiceFault loginFault) {
        this.loginFault = loginFault;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof LoginResult)) return false;
        LoginResult other = (LoginResult) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              this.state.equals(other.getState()))) &&
            ((this.groupName==null && other.getGroupName()==null) || 
             (this.groupName!=null &&
              this.groupName.equals(other.getGroupName()))) &&
            ((this.userName==null && other.getUserName()==null) || 
             (this.userName!=null &&
              this.userName.equals(other.getUserName()))) &&
            ((this.delegateGroupName==null && other.getDelegateGroupName()==null) || 
             (this.delegateGroupName!=null &&
              this.delegateGroupName.equals(other.getDelegateGroupName()))) &&
            ((this.delegateUserName==null && other.getDelegateUserName()==null) || 
             (this.delegateUserName!=null &&
              this.delegateUserName.equals(other.getDelegateUserName()))) &&
            ((this.loginChallenge==null && other.getLoginChallenge()==null) || 
             (this.loginChallenge!=null &&
              this.loginChallenge.equals(other.getLoginChallenge()))) &&
            ((this.passwordExpiryDate==null && other.getPasswordExpiryDate()==null) || 
             (this.passwordExpiryDate!=null &&
              this.passwordExpiryDate.equals(other.getPasswordExpiryDate()))) &&
            ((this.passwordAllowChangeAfterDate==null && other.getPasswordAllowChangeAfterDate()==null) || 
             (this.passwordAllowChangeAfterDate!=null &&
              this.passwordAllowChangeAfterDate.equals(other.getPasswordAllowChangeAfterDate()))) &&
            ((this.card==null && other.getCard()==null) || 
             (this.card!=null &&
              this.card.equals(other.getCard()))) &&
            ((this.token==null && other.getToken()==null) || 
             (this.token!=null &&
              this.token.equals(other.getToken()))) &&
            ((this.loginFault==null && other.getLoginFault()==null) || 
             (this.loginFault!=null &&
              this.loginFault.equals(other.getLoginFault())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getState() != null) {
            _hashCode += getState().hashCode();
        }
        if (getGroupName() != null) {
            _hashCode += getGroupName().hashCode();
        }
        if (getUserName() != null) {
            _hashCode += getUserName().hashCode();
        }
        if (getDelegateGroupName() != null) {
            _hashCode += getDelegateGroupName().hashCode();
        }
        if (getDelegateUserName() != null) {
            _hashCode += getDelegateUserName().hashCode();
        }
        if (getLoginChallenge() != null) {
            _hashCode += getLoginChallenge().hashCode();
        }
        if (getPasswordExpiryDate() != null) {
            _hashCode += getPasswordExpiryDate().hashCode();
        }
        if (getPasswordAllowChangeAfterDate() != null) {
            _hashCode += getPasswordAllowChangeAfterDate().hashCode();
        }
        if (getCard() != null) {
            _hashCode += getCard().hashCode();
        }
        if (getToken() != null) {
            _hashCode += getToken().hashCode();
        }
        if (getLoginFault() != null) {
            _hashCode += getLoginFault().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(LoginResult.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "LoginResult"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "state"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "LoginState"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groupName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groupName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("delegateGroupName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "delegateGroupName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("delegateUserName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "delegateUserName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loginChallenge");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loginChallenge"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "LoginChallenge"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("passwordExpiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "passwordExpiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("passwordAllowChangeAfterDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "passwordAllowChangeAfterDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("card");
        elemField.setXmlName(new javax.xml.namespace.QName("", "card"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "CardData"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("token");
        elemField.setXmlName(new javax.xml.namespace.QName("", "token"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "TokenData"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loginFault");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loginFault"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AdminServiceFault"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
