/**
 * MachineSecretParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters used when creating or modifying
 *                         a machine secret.
 */
public class MachineSecretParms  implements java.io.Serializable {
    /* The machine label.  This value can be set
     *                                 during create or can be modified for
     * an existing machine secret. */
    private String machineLabel;

    /* The machine nonce.  If not specified when
     *                                 creating a machine secret, IdentityGuard
     * will generate a random value.  This value
     *                                 can not be modified for an existing
     * machine
     *                                 secret. */
    private String machineNonce;

    /* The application data. May be null or an
     *                                 empty array if the machine secret
     * doesn't
     *                                 have any application data. */
    private NameValue[] applicationData;

    public MachineSecretParms() {
    }

    public MachineSecretParms(
           String machineLabel,
           String machineNonce,
           NameValue[] applicationData) {
           this.machineLabel = machineLabel;
           this.machineNonce = machineNonce;
           this.applicationData = applicationData;
    }


    /**
     * Gets the machineLabel value for this MachineSecretParms.
     * 
     * @return machineLabel   * The machine label.  This value can be set
     *                                 during create or can be modified for
     * an existing machine secret.
     */
    public String getMachineLabel() {
        return machineLabel;
    }


    /**
     * Sets the machineLabel value for this MachineSecretParms.
     * 
     * @param machineLabel   * The machine label.  This value can be set
     *                                 during create or can be modified for
     * an existing machine secret.
     */
    public void setMachineLabel(String machineLabel) {
        this.machineLabel = machineLabel;
    }


    /**
     * Gets the machineNonce value for this MachineSecretParms.
     * 
     * @return machineNonce   * The machine nonce.  If not specified when
     *                                 creating a machine secret, IdentityGuard
     * will generate a random value.  This value
     *                                 can not be modified for an existing
     * machine
     *                                 secret.
     */
    public String getMachineNonce() {
        return machineNonce;
    }


    /**
     * Sets the machineNonce value for this MachineSecretParms.
     * 
     * @param machineNonce   * The machine nonce.  If not specified when
     *                                 creating a machine secret, IdentityGuard
     * will generate a random value.  This value
     *                                 can not be modified for an existing
     * machine
     *                                 secret.
     */
    public void setMachineNonce(String machineNonce) {
        this.machineNonce = machineNonce;
    }


    /**
     * Gets the applicationData value for this MachineSecretParms.
     * 
     * @return applicationData   * The application data. May be null or an
     *                                 empty array if the machine secret
     * doesn't
     *                                 have any application data.
     */
    public NameValue[] getApplicationData() {
        return applicationData;
    }


    /**
     * Sets the applicationData value for this MachineSecretParms.
     * 
     * @param applicationData   * The application data. May be null or an
     *                                 empty array if the machine secret
     * doesn't
     *                                 have any application data.
     */
    public void setApplicationData(NameValue[] applicationData) {
        this.applicationData = applicationData;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof MachineSecretParms)) return false;
        MachineSecretParms other = (MachineSecretParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.machineLabel==null && other.getMachineLabel()==null) || 
             (this.machineLabel!=null &&
              this.machineLabel.equals(other.getMachineLabel()))) &&
            ((this.machineNonce==null && other.getMachineNonce()==null) || 
             (this.machineNonce!=null &&
              this.machineNonce.equals(other.getMachineNonce()))) &&
            ((this.applicationData==null && other.getApplicationData()==null) || 
             (this.applicationData!=null &&
              java.util.Arrays.equals(this.applicationData, other.getApplicationData())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getMachineLabel() != null) {
            _hashCode += getMachineLabel().hashCode();
        }
        if (getMachineNonce() != null) {
            _hashCode += getMachineNonce().hashCode();
        }
        if (getApplicationData() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getApplicationData());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getApplicationData(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(MachineSecretParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "MachineSecretParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("machineLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "machineLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("machineNonce");
        elemField.setXmlName(new javax.xml.namespace.QName("", "machineNonce"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("applicationData");
        elemField.setXmlName(new javax.xml.namespace.QName("", "applicationData"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "NameValue"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
