/**
 * ManagedCaCredentialConfig.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a credential issued/used by a managed
 * CA; can be either a 
 *                         software-based or hardware-based managed CA
 * credential configuration.
 */
public class ManagedCaCredentialConfig  implements java.io.Serializable {
    /* Indicates the type of managed CA credential configuration.
     * If the type is 
     *                                 SOFTWARE_BASED, then the SoftwareBasedCredentialConfig
     * component will be non-null; if 
     *                                 the type is HARDWARD_BASED, then the
     * HardwareBasedCredentialConfig component will be 
     *                                 non-null. */
    private com.good.adapters.entrust.stubs.ManagedCaCredentialConfigType credentialConfigType;

    /* If set, indicates that this credential configuration is for
     * a software-based credential. */
    private com.good.adapters.entrust.stubs.ManagedCaCredentialConfigSoftwareBased softwareBasedCredentialConfig;

    /* If set, indicates that this credential configuration is for
     * a hardware-based credential. */
    private com.good.adapters.entrust.stubs.ManagedCaCredentialConfigHardwareBased hardwareBasedCredentialConfig;

    /* The distinguished name (DN) of the user from the credential.
     * This value is extracted 
     *                                 from the security store during the
     * create and set operations. */
    private String userDn;

    public ManagedCaCredentialConfig() {
    }

    public ManagedCaCredentialConfig(
           com.good.adapters.entrust.stubs.ManagedCaCredentialConfigType credentialConfigType,
           com.good.adapters.entrust.stubs.ManagedCaCredentialConfigSoftwareBased softwareBasedCredentialConfig,
           com.good.adapters.entrust.stubs.ManagedCaCredentialConfigHardwareBased hardwareBasedCredentialConfig,
           String userDn) {
           this.credentialConfigType = credentialConfigType;
           this.softwareBasedCredentialConfig = softwareBasedCredentialConfig;
           this.hardwareBasedCredentialConfig = hardwareBasedCredentialConfig;
           this.userDn = userDn;
    }


    /**
     * Gets the credentialConfigType value for this ManagedCaCredentialConfig.
     * 
     * @return credentialConfigType   * Indicates the type of managed CA credential configuration.
     * If the type is 
     *                                 SOFTWARE_BASED, then the SoftwareBasedCredentialConfig
     * component will be non-null; if 
     *                                 the type is HARDWARD_BASED, then the
     * HardwareBasedCredentialConfig component will be 
     *                                 non-null.
     */
    public com.good.adapters.entrust.stubs.ManagedCaCredentialConfigType getCredentialConfigType() {
        return credentialConfigType;
    }


    /**
     * Sets the credentialConfigType value for this ManagedCaCredentialConfig.
     * 
     * @param credentialConfigType   * Indicates the type of managed CA credential configuration.
     * If the type is 
     *                                 SOFTWARE_BASED, then the SoftwareBasedCredentialConfig
     * component will be non-null; if 
     *                                 the type is HARDWARD_BASED, then the
     * HardwareBasedCredentialConfig component will be 
     *                                 non-null.
     */
    public void setCredentialConfigType(com.good.adapters.entrust.stubs.ManagedCaCredentialConfigType credentialConfigType) {
        this.credentialConfigType = credentialConfigType;
    }


    /**
     * Gets the softwareBasedCredentialConfig value for this ManagedCaCredentialConfig.
     * 
     * @return softwareBasedCredentialConfig   * If set, indicates that this credential configuration is for
     * a software-based credential.
     */
    public com.good.adapters.entrust.stubs.ManagedCaCredentialConfigSoftwareBased getSoftwareBasedCredentialConfig() {
        return softwareBasedCredentialConfig;
    }


    /**
     * Sets the softwareBasedCredentialConfig value for this ManagedCaCredentialConfig.
     * 
     * @param softwareBasedCredentialConfig   * If set, indicates that this credential configuration is for
     * a software-based credential.
     */
    public void setSoftwareBasedCredentialConfig(com.good.adapters.entrust.stubs.ManagedCaCredentialConfigSoftwareBased softwareBasedCredentialConfig) {
        this.softwareBasedCredentialConfig = softwareBasedCredentialConfig;
    }


    /**
     * Gets the hardwareBasedCredentialConfig value for this ManagedCaCredentialConfig.
     * 
     * @return hardwareBasedCredentialConfig   * If set, indicates that this credential configuration is for
     * a hardware-based credential.
     */
    public com.good.adapters.entrust.stubs.ManagedCaCredentialConfigHardwareBased getHardwareBasedCredentialConfig() {
        return hardwareBasedCredentialConfig;
    }


    /**
     * Sets the hardwareBasedCredentialConfig value for this ManagedCaCredentialConfig.
     * 
     * @param hardwareBasedCredentialConfig   * If set, indicates that this credential configuration is for
     * a hardware-based credential.
     */
    public void setHardwareBasedCredentialConfig(com.good.adapters.entrust.stubs.ManagedCaCredentialConfigHardwareBased hardwareBasedCredentialConfig) {
        this.hardwareBasedCredentialConfig = hardwareBasedCredentialConfig;
    }


    /**
     * Gets the userDn value for this ManagedCaCredentialConfig.
     * 
     * @return userDn   * The distinguished name (DN) of the user from the credential.
     * This value is extracted 
     *                                 from the security store during the
     * create and set operations.
     */
    public String getUserDn() {
        return userDn;
    }


    /**
     * Sets the userDn value for this ManagedCaCredentialConfig.
     * 
     * @param userDn   * The distinguished name (DN) of the user from the credential.
     * This value is extracted 
     *                                 from the security store during the
     * create and set operations.
     */
    public void setUserDn(String userDn) {
        this.userDn = userDn;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ManagedCaCredentialConfig)) return false;
        ManagedCaCredentialConfig other = (ManagedCaCredentialConfig) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.credentialConfigType==null && other.getCredentialConfigType()==null) || 
             (this.credentialConfigType!=null &&
              this.credentialConfigType.equals(other.getCredentialConfigType()))) &&
            ((this.softwareBasedCredentialConfig==null && other.getSoftwareBasedCredentialConfig()==null) || 
             (this.softwareBasedCredentialConfig!=null &&
              this.softwareBasedCredentialConfig.equals(other.getSoftwareBasedCredentialConfig()))) &&
            ((this.hardwareBasedCredentialConfig==null && other.getHardwareBasedCredentialConfig()==null) || 
             (this.hardwareBasedCredentialConfig!=null &&
              this.hardwareBasedCredentialConfig.equals(other.getHardwareBasedCredentialConfig()))) &&
            ((this.userDn==null && other.getUserDn()==null) || 
             (this.userDn!=null &&
              this.userDn.equals(other.getUserDn())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCredentialConfigType() != null) {
            _hashCode += getCredentialConfigType().hashCode();
        }
        if (getSoftwareBasedCredentialConfig() != null) {
            _hashCode += getSoftwareBasedCredentialConfig().hashCode();
        }
        if (getHardwareBasedCredentialConfig() != null) {
            _hashCode += getHardwareBasedCredentialConfig().hashCode();
        }
        if (getUserDn() != null) {
            _hashCode += getUserDn().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ManagedCaCredentialConfig.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfig"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("credentialConfigType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CredentialConfigType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfigType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("softwareBasedCredentialConfig");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SoftwareBasedCredentialConfig"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfigSoftwareBased"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("hardwareBasedCredentialConfig");
        elemField.setXmlName(new javax.xml.namespace.QName("", "HardwareBasedCredentialConfig"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfigHardwareBased"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userDn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserDn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
