/**
 * ManagedCaMicrosoftSpecificParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the Microsoft specific paramaters that can be set when
 * creating or modifying a 
 *                         Microsoft managed CA.
 */
public class ManagedCaMicrosoftSpecificParms  implements java.io.Serializable {
    /* The common name of the CA (the value of the CN= component from
     * the CA DN). Mandatory 
     *                                 on 'create'; optional on 'set'. */
    private String caCommonName;

    /* The Enrollment Agent; required for key archival/backup support.
     * Optional on 'create'; 
     *                                 optional on 'set'. */
    private ManagedCaCredentialConfig enrollmentAgent;

    /* If set, indicates that the Enrollment Agent should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'. */
    private Boolean deleteEnrollmentAgent;

    /* The Key Recovery Agent; required for key archival/backup support.
     * Optional on 'create'; 
     *                                 optional on 'set'. */
    private ManagedCaCredentialConfig keyRecoveryAgent;

    /* If set, indicates that the Key Recovery Agent should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'. */
    private Boolean deleteKeyRecoveryAgent;

    public ManagedCaMicrosoftSpecificParms() {
    }

    public ManagedCaMicrosoftSpecificParms(
           String caCommonName,
           ManagedCaCredentialConfig enrollmentAgent,
           Boolean deleteEnrollmentAgent,
           ManagedCaCredentialConfig keyRecoveryAgent,
           Boolean deleteKeyRecoveryAgent) {
           this.caCommonName = caCommonName;
           this.enrollmentAgent = enrollmentAgent;
           this.deleteEnrollmentAgent = deleteEnrollmentAgent;
           this.keyRecoveryAgent = keyRecoveryAgent;
           this.deleteKeyRecoveryAgent = deleteKeyRecoveryAgent;
    }


    /**
     * Gets the caCommonName value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @return caCommonName   * The common name of the CA (the value of the CN= component from
     * the CA DN). Mandatory 
     *                                 on 'create'; optional on 'set'.
     */
    public String getCaCommonName() {
        return caCommonName;
    }


    /**
     * Sets the caCommonName value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @param caCommonName   * The common name of the CA (the value of the CN= component from
     * the CA DN). Mandatory 
     *                                 on 'create'; optional on 'set'.
     */
    public void setCaCommonName(String caCommonName) {
        this.caCommonName = caCommonName;
    }


    /**
     * Gets the enrollmentAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @return enrollmentAgent   * The Enrollment Agent; required for key archival/backup support.
     * Optional on 'create'; 
     *                                 optional on 'set'.
     */
    public ManagedCaCredentialConfig getEnrollmentAgent() {
        return enrollmentAgent;
    }


    /**
     * Sets the enrollmentAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @param enrollmentAgent   * The Enrollment Agent; required for key archival/backup support.
     * Optional on 'create'; 
     *                                 optional on 'set'.
     */
    public void setEnrollmentAgent(ManagedCaCredentialConfig enrollmentAgent) {
        this.enrollmentAgent = enrollmentAgent;
    }


    /**
     * Gets the deleteEnrollmentAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @return deleteEnrollmentAgent   * If set, indicates that the Enrollment Agent should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'.
     */
    public Boolean getDeleteEnrollmentAgent() {
        return deleteEnrollmentAgent;
    }


    /**
     * Sets the deleteEnrollmentAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @param deleteEnrollmentAgent   * If set, indicates that the Enrollment Agent should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'.
     */
    public void setDeleteEnrollmentAgent(Boolean deleteEnrollmentAgent) {
        this.deleteEnrollmentAgent = deleteEnrollmentAgent;
    }


    /**
     * Gets the keyRecoveryAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @return keyRecoveryAgent   * The Key Recovery Agent; required for key archival/backup support.
     * Optional on 'create'; 
     *                                 optional on 'set'.
     */
    public ManagedCaCredentialConfig getKeyRecoveryAgent() {
        return keyRecoveryAgent;
    }


    /**
     * Sets the keyRecoveryAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @param keyRecoveryAgent   * The Key Recovery Agent; required for key archival/backup support.
     * Optional on 'create'; 
     *                                 optional on 'set'.
     */
    public void setKeyRecoveryAgent(ManagedCaCredentialConfig keyRecoveryAgent) {
        this.keyRecoveryAgent = keyRecoveryAgent;
    }


    /**
     * Gets the deleteKeyRecoveryAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @return deleteKeyRecoveryAgent   * If set, indicates that the Key Recovery Agent should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'.
     */
    public Boolean getDeleteKeyRecoveryAgent() {
        return deleteKeyRecoveryAgent;
    }


    /**
     * Sets the deleteKeyRecoveryAgent value for this ManagedCaMicrosoftSpecificParms.
     * 
     * @param deleteKeyRecoveryAgent   * If set, indicates that the Key Recovery Agent should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'.
     */
    public void setDeleteKeyRecoveryAgent(Boolean deleteKeyRecoveryAgent) {
        this.deleteKeyRecoveryAgent = deleteKeyRecoveryAgent;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ManagedCaMicrosoftSpecificParms)) return false;
        ManagedCaMicrosoftSpecificParms other = (ManagedCaMicrosoftSpecificParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.caCommonName==null && other.getCaCommonName()==null) || 
             (this.caCommonName!=null &&
              this.caCommonName.equals(other.getCaCommonName()))) &&
            ((this.enrollmentAgent==null && other.getEnrollmentAgent()==null) || 
             (this.enrollmentAgent!=null &&
              this.enrollmentAgent.equals(other.getEnrollmentAgent()))) &&
            ((this.deleteEnrollmentAgent==null && other.getDeleteEnrollmentAgent()==null) || 
             (this.deleteEnrollmentAgent!=null &&
              this.deleteEnrollmentAgent.equals(other.getDeleteEnrollmentAgent()))) &&
            ((this.keyRecoveryAgent==null && other.getKeyRecoveryAgent()==null) || 
             (this.keyRecoveryAgent!=null &&
              this.keyRecoveryAgent.equals(other.getKeyRecoveryAgent()))) &&
            ((this.deleteKeyRecoveryAgent==null && other.getDeleteKeyRecoveryAgent()==null) || 
             (this.deleteKeyRecoveryAgent!=null &&
              this.deleteKeyRecoveryAgent.equals(other.getDeleteKeyRecoveryAgent())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCaCommonName() != null) {
            _hashCode += getCaCommonName().hashCode();
        }
        if (getEnrollmentAgent() != null) {
            _hashCode += getEnrollmentAgent().hashCode();
        }
        if (getDeleteEnrollmentAgent() != null) {
            _hashCode += getDeleteEnrollmentAgent().hashCode();
        }
        if (getKeyRecoveryAgent() != null) {
            _hashCode += getKeyRecoveryAgent().hashCode();
        }
        if (getDeleteKeyRecoveryAgent() != null) {
            _hashCode += getDeleteKeyRecoveryAgent().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ManagedCaMicrosoftSpecificParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaMicrosoftSpecificParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("caCommonName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CaCommonName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("enrollmentAgent");
        elemField.setXmlName(new javax.xml.namespace.QName("", "EnrollmentAgent"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfig"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deleteEnrollmentAgent");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DeleteEnrollmentAgent"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("keyRecoveryAgent");
        elemField.setXmlName(new javax.xml.namespace.QName("", "KeyRecoveryAgent"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfig"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deleteKeyRecoveryAgent");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DeleteKeyRecoveryAgent"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
