/**
 * ManagedCaParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the paramaters that can be set when creating or modifying
 * a managed CA; can be either 
 *                         an Entrust managed CA or a Microsoft managed
 * CA.
 */
public class ManagedCaParms  implements java.io.Serializable {
    /* A name for the managed CA (a friendly name, can be different
     * than the CA DN). Ignored 
     *                                 on 'create'; optional on 'set'. */
    private String name;

    /* The host the CA is running on. Mandatory on 'create'; optional
     * on 'set'. */
    private String host;

    /* The proxy used to communicate with the CA. Optional on 'create';
     * optional on 'set'. */
    private String proxy;

    /* The host the Directory used by the CA is running on. Mandatory
     * on 'create'; optional 
     *                                 on 'set'. */
    private String dirHost;

    /* The port of the LDAP service provided by the Directory. Mandatory
     * on 'create'; 
     *                                 optional on 'set'. */
    private Integer dirLdapPort;

    /* The PIV content signer. Optional on 'create'; optional on 'set'. */
    private ContentSigner pivContentSigner;

    /* If set, indicates that the PIV content signer should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'. */
    private Boolean deletePivContentSigner;

    /* The SCEP RA. Optional on 'create'; optional on 'set'. */
    private com.good.adapters.entrust.stubs.ManagedCaCredentialConfig scepRa;

    /* If set, indicates that the SCEP RA should be deleted. Ignored
     * on 'create'; optional on 
     *                                 'set'. */
    private Boolean deleteScepRa;

    /* A flag indicating of the CA should publish CRLs after IdentityGuard
     * revokes 
     *                                 certificates. Mandatory on 'create';
     * optional on 'set'. */
    private Boolean publishCRLAfterRevocation;

    /* This attribute specifies the revocation cache
     *                                 timeout in minutes.  A value of 0
     * means
     *                                 revocation information is not cached. */
    private Integer revocationCacheTimeout;

    /* If specified this value defines a URL that
     *                                 is called when a certificate is issued. */
    private String certificateIssuanceCallback;

    /* If set, indicates that these parameters are for a Entrust CA
     * and contains the 
     *                                 Entrust specific parameters. Conditionally
     * optional on 'create' (mandatory when 
     *                                 MicrosoftSpecificParams is missing);
     * optional on 'set'. */
    private com.good.adapters.entrust.stubs.ManagedCaEntrustSpecificParms entrustSpecificParams;

    /* If set, indicates that these parameters are for a Microsoft
     * CA and contains the 
     *                                 Microsoft specific parameters. Conditionally
     * optional on 'create' (mandatory when 
     *                                 EntrustSpecificParams is missing);
     * optional on 'set'. */
    private com.good.adapters.entrust.stubs.ManagedCaMicrosoftSpecificParms microsoftSpecificParams;

    public ManagedCaParms() {
    }

    public ManagedCaParms(
           String name,
           String host,
           String proxy,
           String dirHost,
           Integer dirLdapPort,
           ContentSigner pivContentSigner,
           Boolean deletePivContentSigner,
           com.good.adapters.entrust.stubs.ManagedCaCredentialConfig scepRa,
           Boolean deleteScepRa,
           Boolean publishCRLAfterRevocation,
           Integer revocationCacheTimeout,
           String certificateIssuanceCallback,
           com.good.adapters.entrust.stubs.ManagedCaEntrustSpecificParms entrustSpecificParams,
           com.good.adapters.entrust.stubs.ManagedCaMicrosoftSpecificParms microsoftSpecificParams) {
           this.name = name;
           this.host = host;
           this.proxy = proxy;
           this.dirHost = dirHost;
           this.dirLdapPort = dirLdapPort;
           this.pivContentSigner = pivContentSigner;
           this.deletePivContentSigner = deletePivContentSigner;
           this.scepRa = scepRa;
           this.deleteScepRa = deleteScepRa;
           this.publishCRLAfterRevocation = publishCRLAfterRevocation;
           this.revocationCacheTimeout = revocationCacheTimeout;
           this.certificateIssuanceCallback = certificateIssuanceCallback;
           this.entrustSpecificParams = entrustSpecificParams;
           this.microsoftSpecificParams = microsoftSpecificParams;
    }


    /**
     * Gets the name value for this ManagedCaParms.
     * 
     * @return name   * A name for the managed CA (a friendly name, can be different
     * than the CA DN). Ignored 
     *                                 on 'create'; optional on 'set'.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this ManagedCaParms.
     * 
     * @param name   * A name for the managed CA (a friendly name, can be different
     * than the CA DN). Ignored 
     *                                 on 'create'; optional on 'set'.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the host value for this ManagedCaParms.
     * 
     * @return host   * The host the CA is running on. Mandatory on 'create'; optional
     * on 'set'.
     */
    public String getHost() {
        return host;
    }


    /**
     * Sets the host value for this ManagedCaParms.
     * 
     * @param host   * The host the CA is running on. Mandatory on 'create'; optional
     * on 'set'.
     */
    public void setHost(String host) {
        this.host = host;
    }


    /**
     * Gets the proxy value for this ManagedCaParms.
     * 
     * @return proxy   * The proxy used to communicate with the CA. Optional on 'create';
     * optional on 'set'.
     */
    public String getProxy() {
        return proxy;
    }


    /**
     * Sets the proxy value for this ManagedCaParms.
     * 
     * @param proxy   * The proxy used to communicate with the CA. Optional on 'create';
     * optional on 'set'.
     */
    public void setProxy(String proxy) {
        this.proxy = proxy;
    }


    /**
     * Gets the dirHost value for this ManagedCaParms.
     * 
     * @return dirHost   * The host the Directory used by the CA is running on. Mandatory
     * on 'create'; optional 
     *                                 on 'set'.
     */
    public String getDirHost() {
        return dirHost;
    }


    /**
     * Sets the dirHost value for this ManagedCaParms.
     * 
     * @param dirHost   * The host the Directory used by the CA is running on. Mandatory
     * on 'create'; optional 
     *                                 on 'set'.
     */
    public void setDirHost(String dirHost) {
        this.dirHost = dirHost;
    }


    /**
     * Gets the dirLdapPort value for this ManagedCaParms.
     * 
     * @return dirLdapPort   * The port of the LDAP service provided by the Directory. Mandatory
     * on 'create'; 
     *                                 optional on 'set'.
     */
    public Integer getDirLdapPort() {
        return dirLdapPort;
    }


    /**
     * Sets the dirLdapPort value for this ManagedCaParms.
     * 
     * @param dirLdapPort   * The port of the LDAP service provided by the Directory. Mandatory
     * on 'create'; 
     *                                 optional on 'set'.
     */
    public void setDirLdapPort(Integer dirLdapPort) {
        this.dirLdapPort = dirLdapPort;
    }


    /**
     * Gets the pivContentSigner value for this ManagedCaParms.
     * 
     * @return pivContentSigner   * The PIV content signer. Optional on 'create'; optional on 'set'.
     */
    public ContentSigner getPivContentSigner() {
        return pivContentSigner;
    }


    /**
     * Sets the pivContentSigner value for this ManagedCaParms.
     * 
     * @param pivContentSigner   * The PIV content signer. Optional on 'create'; optional on 'set'.
     */
    public void setPivContentSigner(ContentSigner pivContentSigner) {
        this.pivContentSigner = pivContentSigner;
    }


    /**
     * Gets the deletePivContentSigner value for this ManagedCaParms.
     * 
     * @return deletePivContentSigner   * If set, indicates that the PIV content signer should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'.
     */
    public Boolean getDeletePivContentSigner() {
        return deletePivContentSigner;
    }


    /**
     * Sets the deletePivContentSigner value for this ManagedCaParms.
     * 
     * @param deletePivContentSigner   * If set, indicates that the PIV content signer should be deleted.
     * Ignored on 'create'; 
     *                                 optional on 'set'.
     */
    public void setDeletePivContentSigner(Boolean deletePivContentSigner) {
        this.deletePivContentSigner = deletePivContentSigner;
    }


    /**
     * Gets the scepRa value for this ManagedCaParms.
     * 
     * @return scepRa   * The SCEP RA. Optional on 'create'; optional on 'set'.
     */
    public com.good.adapters.entrust.stubs.ManagedCaCredentialConfig getScepRa() {
        return scepRa;
    }


    /**
     * Sets the scepRa value for this ManagedCaParms.
     * 
     * @param scepRa   * The SCEP RA. Optional on 'create'; optional on 'set'.
     */
    public void setScepRa(com.good.adapters.entrust.stubs.ManagedCaCredentialConfig scepRa) {
        this.scepRa = scepRa;
    }


    /**
     * Gets the deleteScepRa value for this ManagedCaParms.
     * 
     * @return deleteScepRa   * If set, indicates that the SCEP RA should be deleted. Ignored
     * on 'create'; optional on 
     *                                 'set'.
     */
    public Boolean getDeleteScepRa() {
        return deleteScepRa;
    }


    /**
     * Sets the deleteScepRa value for this ManagedCaParms.
     * 
     * @param deleteScepRa   * If set, indicates that the SCEP RA should be deleted. Ignored
     * on 'create'; optional on 
     *                                 'set'.
     */
    public void setDeleteScepRa(Boolean deleteScepRa) {
        this.deleteScepRa = deleteScepRa;
    }


    /**
     * Gets the publishCRLAfterRevocation value for this ManagedCaParms.
     * 
     * @return publishCRLAfterRevocation   * A flag indicating of the CA should publish CRLs after IdentityGuard
     * revokes 
     *                                 certificates. Mandatory on 'create';
     * optional on 'set'.
     */
    public Boolean getPublishCRLAfterRevocation() {
        return publishCRLAfterRevocation;
    }


    /**
     * Sets the publishCRLAfterRevocation value for this ManagedCaParms.
     * 
     * @param publishCRLAfterRevocation   * A flag indicating of the CA should publish CRLs after IdentityGuard
     * revokes 
     *                                 certificates. Mandatory on 'create';
     * optional on 'set'.
     */
    public void setPublishCRLAfterRevocation(Boolean publishCRLAfterRevocation) {
        this.publishCRLAfterRevocation = publishCRLAfterRevocation;
    }


    /**
     * Gets the revocationCacheTimeout value for this ManagedCaParms.
     * 
     * @return revocationCacheTimeout   * This attribute specifies the revocation cache
     *                                 timeout in minutes.  A value of 0
     * means
     *                                 revocation information is not cached.
     */
    public Integer getRevocationCacheTimeout() {
        return revocationCacheTimeout;
    }


    /**
     * Sets the revocationCacheTimeout value for this ManagedCaParms.
     * 
     * @param revocationCacheTimeout   * This attribute specifies the revocation cache
     *                                 timeout in minutes.  A value of 0
     * means
     *                                 revocation information is not cached.
     */
    public void setRevocationCacheTimeout(Integer revocationCacheTimeout) {
        this.revocationCacheTimeout = revocationCacheTimeout;
    }


    /**
     * Gets the certificateIssuanceCallback value for this ManagedCaParms.
     * 
     * @return certificateIssuanceCallback   * If specified this value defines a URL that
     *                                 is called when a certificate is issued.
     */
    public String getCertificateIssuanceCallback() {
        return certificateIssuanceCallback;
    }


    /**
     * Sets the certificateIssuanceCallback value for this ManagedCaParms.
     * 
     * @param certificateIssuanceCallback   * If specified this value defines a URL that
     *                                 is called when a certificate is issued.
     */
    public void setCertificateIssuanceCallback(String certificateIssuanceCallback) {
        this.certificateIssuanceCallback = certificateIssuanceCallback;
    }


    /**
     * Gets the entrustSpecificParams value for this ManagedCaParms.
     * 
     * @return entrustSpecificParams   * If set, indicates that these parameters are for a Entrust CA
     * and contains the 
     *                                 Entrust specific parameters. Conditionally
     * optional on 'create' (mandatory when 
     *                                 MicrosoftSpecificParams is missing);
     * optional on 'set'.
     */
    public com.good.adapters.entrust.stubs.ManagedCaEntrustSpecificParms getEntrustSpecificParams() {
        return entrustSpecificParams;
    }


    /**
     * Sets the entrustSpecificParams value for this ManagedCaParms.
     * 
     * @param entrustSpecificParams   * If set, indicates that these parameters are for a Entrust CA
     * and contains the 
     *                                 Entrust specific parameters. Conditionally
     * optional on 'create' (mandatory when 
     *                                 MicrosoftSpecificParams is missing);
     * optional on 'set'.
     */
    public void setEntrustSpecificParams(com.good.adapters.entrust.stubs.ManagedCaEntrustSpecificParms entrustSpecificParams) {
        this.entrustSpecificParams = entrustSpecificParams;
    }


    /**
     * Gets the microsoftSpecificParams value for this ManagedCaParms.
     * 
     * @return microsoftSpecificParams   * If set, indicates that these parameters are for a Microsoft
     * CA and contains the 
     *                                 Microsoft specific parameters. Conditionally
     * optional on 'create' (mandatory when 
     *                                 EntrustSpecificParams is missing);
     * optional on 'set'.
     */
    public com.good.adapters.entrust.stubs.ManagedCaMicrosoftSpecificParms getMicrosoftSpecificParams() {
        return microsoftSpecificParams;
    }


    /**
     * Sets the microsoftSpecificParams value for this ManagedCaParms.
     * 
     * @param microsoftSpecificParams   * If set, indicates that these parameters are for a Microsoft
     * CA and contains the 
     *                                 Microsoft specific parameters. Conditionally
     * optional on 'create' (mandatory when 
     *                                 EntrustSpecificParams is missing);
     * optional on 'set'.
     */
    public void setMicrosoftSpecificParams(com.good.adapters.entrust.stubs.ManagedCaMicrosoftSpecificParms microsoftSpecificParams) {
        this.microsoftSpecificParams = microsoftSpecificParams;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ManagedCaParms)) return false;
        ManagedCaParms other = (ManagedCaParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.host==null && other.getHost()==null) || 
             (this.host!=null &&
              this.host.equals(other.getHost()))) &&
            ((this.proxy==null && other.getProxy()==null) || 
             (this.proxy!=null &&
              this.proxy.equals(other.getProxy()))) &&
            ((this.dirHost==null && other.getDirHost()==null) || 
             (this.dirHost!=null &&
              this.dirHost.equals(other.getDirHost()))) &&
            ((this.dirLdapPort==null && other.getDirLdapPort()==null) || 
             (this.dirLdapPort!=null &&
              this.dirLdapPort.equals(other.getDirLdapPort()))) &&
            ((this.pivContentSigner==null && other.getPivContentSigner()==null) || 
             (this.pivContentSigner!=null &&
              this.pivContentSigner.equals(other.getPivContentSigner()))) &&
            ((this.deletePivContentSigner==null && other.getDeletePivContentSigner()==null) || 
             (this.deletePivContentSigner!=null &&
              this.deletePivContentSigner.equals(other.getDeletePivContentSigner()))) &&
            ((this.scepRa==null && other.getScepRa()==null) || 
             (this.scepRa!=null &&
              this.scepRa.equals(other.getScepRa()))) &&
            ((this.deleteScepRa==null && other.getDeleteScepRa()==null) || 
             (this.deleteScepRa!=null &&
              this.deleteScepRa.equals(other.getDeleteScepRa()))) &&
            ((this.publishCRLAfterRevocation==null && other.getPublishCRLAfterRevocation()==null) || 
             (this.publishCRLAfterRevocation!=null &&
              this.publishCRLAfterRevocation.equals(other.getPublishCRLAfterRevocation()))) &&
            ((this.revocationCacheTimeout==null && other.getRevocationCacheTimeout()==null) || 
             (this.revocationCacheTimeout!=null &&
              this.revocationCacheTimeout.equals(other.getRevocationCacheTimeout()))) &&
            ((this.certificateIssuanceCallback==null && other.getCertificateIssuanceCallback()==null) || 
             (this.certificateIssuanceCallback!=null &&
              this.certificateIssuanceCallback.equals(other.getCertificateIssuanceCallback()))) &&
            ((this.entrustSpecificParams==null && other.getEntrustSpecificParams()==null) || 
             (this.entrustSpecificParams!=null &&
              this.entrustSpecificParams.equals(other.getEntrustSpecificParams()))) &&
            ((this.microsoftSpecificParams==null && other.getMicrosoftSpecificParams()==null) || 
             (this.microsoftSpecificParams!=null &&
              this.microsoftSpecificParams.equals(other.getMicrosoftSpecificParams())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getHost() != null) {
            _hashCode += getHost().hashCode();
        }
        if (getProxy() != null) {
            _hashCode += getProxy().hashCode();
        }
        if (getDirHost() != null) {
            _hashCode += getDirHost().hashCode();
        }
        if (getDirLdapPort() != null) {
            _hashCode += getDirLdapPort().hashCode();
        }
        if (getPivContentSigner() != null) {
            _hashCode += getPivContentSigner().hashCode();
        }
        if (getDeletePivContentSigner() != null) {
            _hashCode += getDeletePivContentSigner().hashCode();
        }
        if (getScepRa() != null) {
            _hashCode += getScepRa().hashCode();
        }
        if (getDeleteScepRa() != null) {
            _hashCode += getDeleteScepRa().hashCode();
        }
        if (getPublishCRLAfterRevocation() != null) {
            _hashCode += getPublishCRLAfterRevocation().hashCode();
        }
        if (getRevocationCacheTimeout() != null) {
            _hashCode += getRevocationCacheTimeout().hashCode();
        }
        if (getCertificateIssuanceCallback() != null) {
            _hashCode += getCertificateIssuanceCallback().hashCode();
        }
        if (getEntrustSpecificParams() != null) {
            _hashCode += getEntrustSpecificParams().hashCode();
        }
        if (getMicrosoftSpecificParams() != null) {
            _hashCode += getMicrosoftSpecificParams().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ManagedCaParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("host");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Host"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("proxy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Proxy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dirHost");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DirHost"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dirLdapPort");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DirLdapPort"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("pivContentSigner");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PivContentSigner"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ContentSigner"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deletePivContentSigner");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DeletePivContentSigner"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("scepRa");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ScepRa"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaCredentialConfig"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deleteScepRa");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DeleteScepRa"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("publishCRLAfterRevocation");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PublishCRLAfterRevocation"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("revocationCacheTimeout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RevocationCacheTimeout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certificateIssuanceCallback");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CertificateIssuanceCallback"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("entrustSpecificParams");
        elemField.setXmlName(new javax.xml.namespace.QName("", "EntrustSpecificParams"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaEntrustSpecificParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("microsoftSpecificParams");
        elemField.setXmlName(new javax.xml.namespace.QName("", "MicrosoftSpecificParams"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ManagedCaMicrosoftSpecificParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
