/**
 * PACSParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the paramaters that can be set when
 *                         creating or modifying a PACS.
 */
public class PACSParms  implements java.io.Serializable {
    /* When passed in a call to
     *                                 pacsSet, this
     *                                 specifies a new name for the PACS.
     * If this is included in a call to
     *                                 pacsCreate it is ignored. */
    private String name;

    /* The url of the PACS.
     *                                 This value is required for calls to
     * pacsCreate. */
    private String URL;

    /* The profile used to authenticate to the
     *                                 PACS. This value is required for calls
     * to
     *                                 pacsCreate. */
    private byte[] profile;

    /* The password used to authenticate to the
     *                                 PACS. This value is required for calls
     * to
     *                                 pacsCreate. */
    private String password;

    /* The name of the proxy used to communicate with
     *                                 this PACS.  Specify an empty string
     * to remove
     *                                 the existing value. */
    private String proxy;

    /* The connection timeout (in msec) used when
     *                                 when connecting to this PACS.  A value
     * of
     *                                 0 means infinite timeout. */
    private Integer connectionTimeout;

    /* A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * PACS. */
    private Boolean disableSSLHostnameValidation;

    /* This attribute specifies types of applets
     *                                 that will be published to this PACS.
     * An 
     *                                 empty list specifies that all applet
     * types
     *                                 that support PACS (PIV, PROXIMITY
     * and DESFIRE)
     *                                 will be published. */
    private String[] applets;

    /* If specified as true, the specified applets
     *                                 are added to the existing values. */
    private Boolean addApplets;

    /* If specified as true, the specified applets
     *                                 are removed from the existing values.
     * This
     *                                 attribute is ignored for the pacsCreate
     * operation or if the addApplets attribute
     *                                 is specified as true. */
    private Boolean removeApplets;

    /* Optional description. */
    private String description;

    /* The default access rights sent to the PACS
     *                                 when registering a smart credential.
     * If an
     *                                 empty string value is specified, the
     * existing
     *                                 value is removed. */
    private String defaultAccessRights;

    public PACSParms() {
    }

    public PACSParms(
           String name,
           String URL,
           byte[] profile,
           String password,
           String proxy,
           Integer connectionTimeout,
           Boolean disableSSLHostnameValidation,
           String[] applets,
           Boolean addApplets,
           Boolean removeApplets,
           String description,
           String defaultAccessRights) {
           this.name = name;
           this.URL = URL;
           this.profile = profile;
           this.password = password;
           this.proxy = proxy;
           this.connectionTimeout = connectionTimeout;
           this.disableSSLHostnameValidation = disableSSLHostnameValidation;
           this.applets = applets;
           this.addApplets = addApplets;
           this.removeApplets = removeApplets;
           this.description = description;
           this.defaultAccessRights = defaultAccessRights;
    }


    /**
     * Gets the name value for this PACSParms.
     * 
     * @return name   * When passed in a call to
     *                                 pacsSet, this
     *                                 specifies a new name for the PACS.
     * If this is included in a call to
     *                                 pacsCreate it is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this PACSParms.
     * 
     * @param name   * When passed in a call to
     *                                 pacsSet, this
     *                                 specifies a new name for the PACS.
     * If this is included in a call to
     *                                 pacsCreate it is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the URL value for this PACSParms.
     * 
     * @return URL   * The url of the PACS.
     *                                 This value is required for calls to
     * pacsCreate.
     */
    public String getURL() {
        return URL;
    }


    /**
     * Sets the URL value for this PACSParms.
     * 
     * @param URL   * The url of the PACS.
     *                                 This value is required for calls to
     * pacsCreate.
     */
    public void setURL(String URL) {
        this.URL = URL;
    }


    /**
     * Gets the profile value for this PACSParms.
     * 
     * @return profile   * The profile used to authenticate to the
     *                                 PACS. This value is required for calls
     * to
     *                                 pacsCreate.
     */
    public byte[] getProfile() {
        return profile;
    }


    /**
     * Sets the profile value for this PACSParms.
     * 
     * @param profile   * The profile used to authenticate to the
     *                                 PACS. This value is required for calls
     * to
     *                                 pacsCreate.
     */
    public void setProfile(byte[] profile) {
        this.profile = profile;
    }


    /**
     * Gets the password value for this PACSParms.
     * 
     * @return password   * The password used to authenticate to the
     *                                 PACS. This value is required for calls
     * to
     *                                 pacsCreate.
     */
    public String getPassword() {
        return password;
    }


    /**
     * Sets the password value for this PACSParms.
     * 
     * @param password   * The password used to authenticate to the
     *                                 PACS. This value is required for calls
     * to
     *                                 pacsCreate.
     */
    public void setPassword(String password) {
        this.password = password;
    }


    /**
     * Gets the proxy value for this PACSParms.
     * 
     * @return proxy   * The name of the proxy used to communicate with
     *                                 this PACS.  Specify an empty string
     * to remove
     *                                 the existing value.
     */
    public String getProxy() {
        return proxy;
    }


    /**
     * Sets the proxy value for this PACSParms.
     * 
     * @param proxy   * The name of the proxy used to communicate with
     *                                 this PACS.  Specify an empty string
     * to remove
     *                                 the existing value.
     */
    public void setProxy(String proxy) {
        this.proxy = proxy;
    }


    /**
     * Gets the connectionTimeout value for this PACSParms.
     * 
     * @return connectionTimeout   * The connection timeout (in msec) used when
     *                                 when connecting to this PACS.  A value
     * of
     *                                 0 means infinite timeout.
     */
    public Integer getConnectionTimeout() {
        return connectionTimeout;
    }


    /**
     * Sets the connectionTimeout value for this PACSParms.
     * 
     * @param connectionTimeout   * The connection timeout (in msec) used when
     *                                 when connecting to this PACS.  A value
     * of
     *                                 0 means infinite timeout.
     */
    public void setConnectionTimeout(Integer connectionTimeout) {
        this.connectionTimeout = connectionTimeout;
    }


    /**
     * Gets the disableSSLHostnameValidation value for this PACSParms.
     * 
     * @return disableSSLHostnameValidation   * A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * PACS.
     */
    public Boolean getDisableSSLHostnameValidation() {
        return disableSSLHostnameValidation;
    }


    /**
     * Sets the disableSSLHostnameValidation value for this PACSParms.
     * 
     * @param disableSSLHostnameValidation   * A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * PACS.
     */
    public void setDisableSSLHostnameValidation(Boolean disableSSLHostnameValidation) {
        this.disableSSLHostnameValidation = disableSSLHostnameValidation;
    }


    /**
     * Gets the applets value for this PACSParms.
     * 
     * @return applets   * This attribute specifies types of applets
     *                                 that will be published to this PACS.
     * An 
     *                                 empty list specifies that all applet
     * types
     *                                 that support PACS (PIV, PROXIMITY
     * and DESFIRE)
     *                                 will be published.
     */
    public String[] getApplets() {
        return applets;
    }


    /**
     * Sets the applets value for this PACSParms.
     * 
     * @param applets   * This attribute specifies types of applets
     *                                 that will be published to this PACS.
     * An 
     *                                 empty list specifies that all applet
     * types
     *                                 that support PACS (PIV, PROXIMITY
     * and DESFIRE)
     *                                 will be published.
     */
    public void setApplets(String[] applets) {
        this.applets = applets;
    }


    /**
     * Gets the addApplets value for this PACSParms.
     * 
     * @return addApplets   * If specified as true, the specified applets
     *                                 are added to the existing values.
     */
    public Boolean getAddApplets() {
        return addApplets;
    }


    /**
     * Sets the addApplets value for this PACSParms.
     * 
     * @param addApplets   * If specified as true, the specified applets
     *                                 are added to the existing values.
     */
    public void setAddApplets(Boolean addApplets) {
        this.addApplets = addApplets;
    }


    /**
     * Gets the removeApplets value for this PACSParms.
     * 
     * @return removeApplets   * If specified as true, the specified applets
     *                                 are removed from the existing values.
     * This
     *                                 attribute is ignored for the pacsCreate
     * operation or if the addApplets attribute
     *                                 is specified as true.
     */
    public Boolean getRemoveApplets() {
        return removeApplets;
    }


    /**
     * Sets the removeApplets value for this PACSParms.
     * 
     * @param removeApplets   * If specified as true, the specified applets
     *                                 are removed from the existing values.
     * This
     *                                 attribute is ignored for the pacsCreate
     * operation or if the addApplets attribute
     *                                 is specified as true.
     */
    public void setRemoveApplets(Boolean removeApplets) {
        this.removeApplets = removeApplets;
    }


    /**
     * Gets the description value for this PACSParms.
     * 
     * @return description   * Optional description.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this PACSParms.
     * 
     * @param description   * Optional description.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the defaultAccessRights value for this PACSParms.
     * 
     * @return defaultAccessRights   * The default access rights sent to the PACS
     *                                 when registering a smart credential.
     * If an
     *                                 empty string value is specified, the
     * existing
     *                                 value is removed.
     */
    public String getDefaultAccessRights() {
        return defaultAccessRights;
    }


    /**
     * Sets the defaultAccessRights value for this PACSParms.
     * 
     * @param defaultAccessRights   * The default access rights sent to the PACS
     *                                 when registering a smart credential.
     * If an
     *                                 empty string value is specified, the
     * existing
     *                                 value is removed.
     */
    public void setDefaultAccessRights(String defaultAccessRights) {
        this.defaultAccessRights = defaultAccessRights;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PACSParms)) return false;
        PACSParms other = (PACSParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.URL==null && other.getURL()==null) || 
             (this.URL!=null &&
              this.URL.equals(other.getURL()))) &&
            ((this.profile==null && other.getProfile()==null) || 
             (this.profile!=null &&
              java.util.Arrays.equals(this.profile, other.getProfile()))) &&
            ((this.password==null && other.getPassword()==null) || 
             (this.password!=null &&
              this.password.equals(other.getPassword()))) &&
            ((this.proxy==null && other.getProxy()==null) || 
             (this.proxy!=null &&
              this.proxy.equals(other.getProxy()))) &&
            ((this.connectionTimeout==null && other.getConnectionTimeout()==null) || 
             (this.connectionTimeout!=null &&
              this.connectionTimeout.equals(other.getConnectionTimeout()))) &&
            ((this.disableSSLHostnameValidation==null && other.getDisableSSLHostnameValidation()==null) || 
             (this.disableSSLHostnameValidation!=null &&
              this.disableSSLHostnameValidation.equals(other.getDisableSSLHostnameValidation()))) &&
            ((this.applets==null && other.getApplets()==null) || 
             (this.applets!=null &&
              java.util.Arrays.equals(this.applets, other.getApplets()))) &&
            ((this.addApplets==null && other.getAddApplets()==null) || 
             (this.addApplets!=null &&
              this.addApplets.equals(other.getAddApplets()))) &&
            ((this.removeApplets==null && other.getRemoveApplets()==null) || 
             (this.removeApplets!=null &&
              this.removeApplets.equals(other.getRemoveApplets()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.defaultAccessRights==null && other.getDefaultAccessRights()==null) || 
             (this.defaultAccessRights!=null &&
              this.defaultAccessRights.equals(other.getDefaultAccessRights())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getURL() != null) {
            _hashCode += getURL().hashCode();
        }
        if (getProfile() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getProfile());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getProfile(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getPassword() != null) {
            _hashCode += getPassword().hashCode();
        }
        if (getProxy() != null) {
            _hashCode += getProxy().hashCode();
        }
        if (getConnectionTimeout() != null) {
            _hashCode += getConnectionTimeout().hashCode();
        }
        if (getDisableSSLHostnameValidation() != null) {
            _hashCode += getDisableSSLHostnameValidation().hashCode();
        }
        if (getApplets() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getApplets());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getApplets(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAddApplets() != null) {
            _hashCode += getAddApplets().hashCode();
        }
        if (getRemoveApplets() != null) {
            _hashCode += getRemoveApplets().hashCode();
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getDefaultAccessRights() != null) {
            _hashCode += getDefaultAccessRights().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PACSParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PACSParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("URL");
        elemField.setXmlName(new javax.xml.namespace.QName("", "URL"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("profile");
        elemField.setXmlName(new javax.xml.namespace.QName("", "profile"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("password");
        elemField.setXmlName(new javax.xml.namespace.QName("", "password"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("proxy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "proxy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("connectionTimeout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "connectionTimeout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("disableSSLHostnameValidation");
        elemField.setXmlName(new javax.xml.namespace.QName("", "disableSSLHostnameValidation"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("applets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "applets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addApplets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "addApplets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeApplets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeApplets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultAccessRights");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultAccessRights"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
