/**
 * PINSpecParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Parameters used to modify a temporary PIN specification policy.
 * All parameters are optional.
 */
public class PINSpecParms  implements java.io.Serializable {
    /* The number of characters in each cell. */
    private Integer cellSize;

    /* The characters that can appear in a cell. */
    private String[] cellAlphabet;

    /* A list of characters that are replaced
     *                             in a challenge response before it is validated. */
    private CellReplacement[] cellReplacements;

    /* The number of cells in a temporary PIN. */
    private Integer challengeSize;

    /* The lifetime in hours of a temporary PIN.
     *                             This value must be at least 0 and at most
     * 876000.
     *                             A value of 0 indicates that the pin has
     * infinite lifetime. */
    private Long lifetime;

    /* The number of times a temporary PIN can be used for authentication.
     * A value
     *                             of 0 means the pin can be used an unlimited
     * number
     *                             of times. */
    private Integer maxUses;

    /* If true, a user's temporary PIN is automatically deleted when
     * a
     *                             card is used to authenticate a challenge. */
    private Boolean autoDelete;

    /* Optional descriptive comments. */
    private String comment;

    public PINSpecParms() {
    }

    public PINSpecParms(
           Integer cellSize,
           String[] cellAlphabet,
           CellReplacement[] cellReplacements,
           Integer challengeSize,
           Long lifetime,
           Integer maxUses,
           Boolean autoDelete,
           String comment) {
           this.cellSize = cellSize;
           this.cellAlphabet = cellAlphabet;
           this.cellReplacements = cellReplacements;
           this.challengeSize = challengeSize;
           this.lifetime = lifetime;
           this.maxUses = maxUses;
           this.autoDelete = autoDelete;
           this.comment = comment;
    }


    /**
     * Gets the cellSize value for this PINSpecParms.
     * 
     * @return cellSize   * The number of characters in each cell.
     */
    public Integer getCellSize() {
        return cellSize;
    }


    /**
     * Sets the cellSize value for this PINSpecParms.
     * 
     * @param cellSize   * The number of characters in each cell.
     */
    public void setCellSize(Integer cellSize) {
        this.cellSize = cellSize;
    }


    /**
     * Gets the cellAlphabet value for this PINSpecParms.
     * 
     * @return cellAlphabet   * The characters that can appear in a cell.
     */
    public String[] getCellAlphabet() {
        return cellAlphabet;
    }


    /**
     * Sets the cellAlphabet value for this PINSpecParms.
     * 
     * @param cellAlphabet   * The characters that can appear in a cell.
     */
    public void setCellAlphabet(String[] cellAlphabet) {
        this.cellAlphabet = cellAlphabet;
    }


    /**
     * Gets the cellReplacements value for this PINSpecParms.
     * 
     * @return cellReplacements   * A list of characters that are replaced
     *                             in a challenge response before it is validated.
     */
    public CellReplacement[] getCellReplacements() {
        return cellReplacements;
    }


    /**
     * Sets the cellReplacements value for this PINSpecParms.
     * 
     * @param cellReplacements   * A list of characters that are replaced
     *                             in a challenge response before it is validated.
     */
    public void setCellReplacements(CellReplacement[] cellReplacements) {
        this.cellReplacements = cellReplacements;
    }


    /**
     * Gets the challengeSize value for this PINSpecParms.
     * 
     * @return challengeSize   * The number of cells in a temporary PIN.
     */
    public Integer getChallengeSize() {
        return challengeSize;
    }


    /**
     * Sets the challengeSize value for this PINSpecParms.
     * 
     * @param challengeSize   * The number of cells in a temporary PIN.
     */
    public void setChallengeSize(Integer challengeSize) {
        this.challengeSize = challengeSize;
    }


    /**
     * Gets the lifetime value for this PINSpecParms.
     * 
     * @return lifetime   * The lifetime in hours of a temporary PIN.
     *                             This value must be at least 0 and at most
     * 876000.
     *                             A value of 0 indicates that the pin has
     * infinite lifetime.
     */
    public Long getLifetime() {
        return lifetime;
    }


    /**
     * Sets the lifetime value for this PINSpecParms.
     * 
     * @param lifetime   * The lifetime in hours of a temporary PIN.
     *                             This value must be at least 0 and at most
     * 876000.
     *                             A value of 0 indicates that the pin has
     * infinite lifetime.
     */
    public void setLifetime(Long lifetime) {
        this.lifetime = lifetime;
    }


    /**
     * Gets the maxUses value for this PINSpecParms.
     * 
     * @return maxUses   * The number of times a temporary PIN can be used for authentication.
     * A value
     *                             of 0 means the pin can be used an unlimited
     * number
     *                             of times.
     */
    public Integer getMaxUses() {
        return maxUses;
    }


    /**
     * Sets the maxUses value for this PINSpecParms.
     * 
     * @param maxUses   * The number of times a temporary PIN can be used for authentication.
     * A value
     *                             of 0 means the pin can be used an unlimited
     * number
     *                             of times.
     */
    public void setMaxUses(Integer maxUses) {
        this.maxUses = maxUses;
    }


    /**
     * Gets the autoDelete value for this PINSpecParms.
     * 
     * @return autoDelete   * If true, a user's temporary PIN is automatically deleted when
     * a
     *                             card is used to authenticate a challenge.
     */
    public Boolean getAutoDelete() {
        return autoDelete;
    }


    /**
     * Sets the autoDelete value for this PINSpecParms.
     * 
     * @param autoDelete   * If true, a user's temporary PIN is automatically deleted when
     * a
     *                             card is used to authenticate a challenge.
     */
    public void setAutoDelete(Boolean autoDelete) {
        this.autoDelete = autoDelete;
    }


    /**
     * Gets the comment value for this PINSpecParms.
     * 
     * @return comment   * Optional descriptive comments.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this PINSpecParms.
     * 
     * @param comment   * Optional descriptive comments.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PINSpecParms)) return false;
        PINSpecParms other = (PINSpecParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.cellSize==null && other.getCellSize()==null) || 
             (this.cellSize!=null &&
              this.cellSize.equals(other.getCellSize()))) &&
            ((this.cellAlphabet==null && other.getCellAlphabet()==null) || 
             (this.cellAlphabet!=null &&
              java.util.Arrays.equals(this.cellAlphabet, other.getCellAlphabet()))) &&
            ((this.cellReplacements==null && other.getCellReplacements()==null) || 
             (this.cellReplacements!=null &&
              java.util.Arrays.equals(this.cellReplacements, other.getCellReplacements()))) &&
            ((this.challengeSize==null && other.getChallengeSize()==null) || 
             (this.challengeSize!=null &&
              this.challengeSize.equals(other.getChallengeSize()))) &&
            ((this.lifetime==null && other.getLifetime()==null) || 
             (this.lifetime!=null &&
              this.lifetime.equals(other.getLifetime()))) &&
            ((this.maxUses==null && other.getMaxUses()==null) || 
             (this.maxUses!=null &&
              this.maxUses.equals(other.getMaxUses()))) &&
            ((this.autoDelete==null && other.getAutoDelete()==null) || 
             (this.autoDelete!=null &&
              this.autoDelete.equals(other.getAutoDelete()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCellSize() != null) {
            _hashCode += getCellSize().hashCode();
        }
        if (getCellAlphabet() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCellAlphabet());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCellAlphabet(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCellReplacements() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCellReplacements());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCellReplacements(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getChallengeSize() != null) {
            _hashCode += getChallengeSize().hashCode();
        }
        if (getLifetime() != null) {
            _hashCode += getLifetime().hashCode();
        }
        if (getMaxUses() != null) {
            _hashCode += getMaxUses().hashCode();
        }
        if (getAutoDelete() != null) {
            _hashCode += getAutoDelete().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PINSpecParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PINSpecParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cellSize");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cellSize"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cellAlphabet");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cellAlphabet"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cellReplacements");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cellReplacements"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "CellReplacement"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("challengeSize");
        elemField.setXmlName(new javax.xml.namespace.QName("", "challengeSize"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("lifetime");
        elemField.setXmlName(new javax.xml.namespace.QName("", "lifetime"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxUses");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxUses"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("autoDelete");
        elemField.setXmlName(new javax.xml.namespace.QName("", "autoDelete"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
