/**
 * PartitionParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Parameters that can be applied when creating or
 *                         modifying a partition.
 */
public class PartitionParms  implements java.io.Serializable {
    /* When modifying a partition, this element is the new
     *                                 name of the partition. When creating
     * a partition, this
     *                                 value is ignored. */
    private String name;

    /* When modifying a partition, set this to
     *                                 true to remove a range of user numbers
     * instead
     *                                 of adding a range of user numbers.
     * When creating
     *                                 a partition, or if no user number
     * range is
     *                                 specified, this value is ignored. */
    private Boolean removeUserNumbers;

    /* When creating or modifying a partition,
     *                                 this is the range of user numbers
     * to add to the
     *                                 partition. To remove a range of user
     * numbers,
     *                                 supply this range and set removeUserNumbers
     * to
     *                                 true. When adding a range of user
     * numbers, the
     *                                 minimum value in the range must be
     * at least as
     *                                 large as the next user number to be
     * assigned to 
     *                                 a user not created in any partition;
     * this value
     *                                 is available in the SystemInfo structure
     * returned by systemInfoGet. */
    private Range userNumberRange;

    /* When modifying a partition, set this to
     *                                 true to remove a range of card serial
     * numbers instead
     *                                 of adding a range of card serial numbers.
     * When creating
     *                                 a partition, or if no card serial
     * number range is
     *                                 specified, this value is ignored. */
    private Boolean removeCardSerialNumbers;

    /* When creating or modifying a partition,
     *                                 this is the range of card serial numbers
     * to add to the
     *                                 partition. To remove a range of card
     * serial numbers,
     *                                 supply this range and set removeCardSerialNumbers
     * to
     *                                 true. When adding a range of card
     * serial numbers, the
     *                                 minimum value in the range must be
     * at least as
     *                                 large as the next serial number to
     * be assigned to
     *                                 a card not created in any partition;
     * this value
     *                                 is available in the
     *                                 SystemInfo structure returned by systemInfoGet. */
    private Range cardSerialNumberRange;

    /* Descriptive comments about this partition
     *                                  that could be used to provide a full
     * description of this partition's intended purpose. */
    private String comment;

    public PartitionParms() {
    }

    public PartitionParms(
           String name,
           Boolean removeUserNumbers,
           Range userNumberRange,
           Boolean removeCardSerialNumbers,
           Range cardSerialNumberRange,
           String comment) {
           this.name = name;
           this.removeUserNumbers = removeUserNumbers;
           this.userNumberRange = userNumberRange;
           this.removeCardSerialNumbers = removeCardSerialNumbers;
           this.cardSerialNumberRange = cardSerialNumberRange;
           this.comment = comment;
    }


    /**
     * Gets the name value for this PartitionParms.
     * 
     * @return name   * When modifying a partition, this element is the new
     *                                 name of the partition. When creating
     * a partition, this
     *                                 value is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this PartitionParms.
     * 
     * @param name   * When modifying a partition, this element is the new
     *                                 name of the partition. When creating
     * a partition, this
     *                                 value is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the removeUserNumbers value for this PartitionParms.
     * 
     * @return removeUserNumbers   * When modifying a partition, set this to
     *                                 true to remove a range of user numbers
     * instead
     *                                 of adding a range of user numbers.
     * When creating
     *                                 a partition, or if no user number
     * range is
     *                                 specified, this value is ignored.
     */
    public Boolean getRemoveUserNumbers() {
        return removeUserNumbers;
    }


    /**
     * Sets the removeUserNumbers value for this PartitionParms.
     * 
     * @param removeUserNumbers   * When modifying a partition, set this to
     *                                 true to remove a range of user numbers
     * instead
     *                                 of adding a range of user numbers.
     * When creating
     *                                 a partition, or if no user number
     * range is
     *                                 specified, this value is ignored.
     */
    public void setRemoveUserNumbers(Boolean removeUserNumbers) {
        this.removeUserNumbers = removeUserNumbers;
    }


    /**
     * Gets the userNumberRange value for this PartitionParms.
     * 
     * @return userNumberRange   * When creating or modifying a partition,
     *                                 this is the range of user numbers
     * to add to the
     *                                 partition. To remove a range of user
     * numbers,
     *                                 supply this range and set removeUserNumbers
     * to
     *                                 true. When adding a range of user
     * numbers, the
     *                                 minimum value in the range must be
     * at least as
     *                                 large as the next user number to be
     * assigned to 
     *                                 a user not created in any partition;
     * this value
     *                                 is available in the SystemInfo structure
     * returned by systemInfoGet.
     */
    public Range getUserNumberRange() {
        return userNumberRange;
    }


    /**
     * Sets the userNumberRange value for this PartitionParms.
     * 
     * @param userNumberRange   * When creating or modifying a partition,
     *                                 this is the range of user numbers
     * to add to the
     *                                 partition. To remove a range of user
     * numbers,
     *                                 supply this range and set removeUserNumbers
     * to
     *                                 true. When adding a range of user
     * numbers, the
     *                                 minimum value in the range must be
     * at least as
     *                                 large as the next user number to be
     * assigned to 
     *                                 a user not created in any partition;
     * this value
     *                                 is available in the SystemInfo structure
     * returned by systemInfoGet.
     */
    public void setUserNumberRange(Range userNumberRange) {
        this.userNumberRange = userNumberRange;
    }


    /**
     * Gets the removeCardSerialNumbers value for this PartitionParms.
     * 
     * @return removeCardSerialNumbers   * When modifying a partition, set this to
     *                                 true to remove a range of card serial
     * numbers instead
     *                                 of adding a range of card serial numbers.
     * When creating
     *                                 a partition, or if no card serial
     * number range is
     *                                 specified, this value is ignored.
     */
    public Boolean getRemoveCardSerialNumbers() {
        return removeCardSerialNumbers;
    }


    /**
     * Sets the removeCardSerialNumbers value for this PartitionParms.
     * 
     * @param removeCardSerialNumbers   * When modifying a partition, set this to
     *                                 true to remove a range of card serial
     * numbers instead
     *                                 of adding a range of card serial numbers.
     * When creating
     *                                 a partition, or if no card serial
     * number range is
     *                                 specified, this value is ignored.
     */
    public void setRemoveCardSerialNumbers(Boolean removeCardSerialNumbers) {
        this.removeCardSerialNumbers = removeCardSerialNumbers;
    }


    /**
     * Gets the cardSerialNumberRange value for this PartitionParms.
     * 
     * @return cardSerialNumberRange   * When creating or modifying a partition,
     *                                 this is the range of card serial numbers
     * to add to the
     *                                 partition. To remove a range of card
     * serial numbers,
     *                                 supply this range and set removeCardSerialNumbers
     * to
     *                                 true. When adding a range of card
     * serial numbers, the
     *                                 minimum value in the range must be
     * at least as
     *                                 large as the next serial number to
     * be assigned to
     *                                 a card not created in any partition;
     * this value
     *                                 is available in the
     *                                 SystemInfo structure returned by systemInfoGet.
     */
    public Range getCardSerialNumberRange() {
        return cardSerialNumberRange;
    }


    /**
     * Sets the cardSerialNumberRange value for this PartitionParms.
     * 
     * @param cardSerialNumberRange   * When creating or modifying a partition,
     *                                 this is the range of card serial numbers
     * to add to the
     *                                 partition. To remove a range of card
     * serial numbers,
     *                                 supply this range and set removeCardSerialNumbers
     * to
     *                                 true. When adding a range of card
     * serial numbers, the
     *                                 minimum value in the range must be
     * at least as
     *                                 large as the next serial number to
     * be assigned to
     *                                 a card not created in any partition;
     * this value
     *                                 is available in the
     *                                 SystemInfo structure returned by systemInfoGet.
     */
    public void setCardSerialNumberRange(Range cardSerialNumberRange) {
        this.cardSerialNumberRange = cardSerialNumberRange;
    }


    /**
     * Gets the comment value for this PartitionParms.
     * 
     * @return comment   * Descriptive comments about this partition
     *                                  that could be used to provide a full
     * description of this partition's intended purpose.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this PartitionParms.
     * 
     * @param comment   * Descriptive comments about this partition
     *                                  that could be used to provide a full
     * description of this partition's intended purpose.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PartitionParms)) return false;
        PartitionParms other = (PartitionParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.removeUserNumbers==null && other.getRemoveUserNumbers()==null) || 
             (this.removeUserNumbers!=null &&
              this.removeUserNumbers.equals(other.getRemoveUserNumbers()))) &&
            ((this.userNumberRange==null && other.getUserNumberRange()==null) || 
             (this.userNumberRange!=null &&
              this.userNumberRange.equals(other.getUserNumberRange()))) &&
            ((this.removeCardSerialNumbers==null && other.getRemoveCardSerialNumbers()==null) || 
             (this.removeCardSerialNumbers!=null &&
              this.removeCardSerialNumbers.equals(other.getRemoveCardSerialNumbers()))) &&
            ((this.cardSerialNumberRange==null && other.getCardSerialNumberRange()==null) || 
             (this.cardSerialNumberRange!=null &&
              this.cardSerialNumberRange.equals(other.getCardSerialNumberRange()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getRemoveUserNumbers() != null) {
            _hashCode += getRemoveUserNumbers().hashCode();
        }
        if (getUserNumberRange() != null) {
            _hashCode += getUserNumberRange().hashCode();
        }
        if (getRemoveCardSerialNumbers() != null) {
            _hashCode += getRemoveCardSerialNumbers().hashCode();
        }
        if (getCardSerialNumberRange() != null) {
            _hashCode += getCardSerialNumberRange().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PartitionParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PartitionParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeUserNumbers");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeUserNumbers"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userNumberRange");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userNumberRange"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "Range"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeCardSerialNumbers");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeCardSerialNumbers"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardSerialNumberRange");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cardSerialNumberRange"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "Range"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
