/**
 * PivSignContentCallParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Parameters for the PIV content signing' operation.
 */
public class PivSignContentCallParms  implements java.io.Serializable {
    /* The name of the managed CA whose PIV content 
     *                                 signer will be used to perform the
     * signing 
     *                                 operation. */
    private String managedCaName;

    /* The type of PIV content signiner operation
     *                                 that is being performed; this effects
     * how the 
     *                                 input is validated and how the signing
     * is done. */
    private com.good.adapters.entrust.stubs.PivContentSigningOperationType operationType;

    /* The data over which the signature is being
     *                                 calculated. For example, when performing
     * a
     *                                 CHUID signing operation, this will
     * contain the 
     *                                 encoded CHUID. The format of this
     * data is 
     *                                 validated. Ignored when the operationType
     * is
     *                                 NO_OP. */
    private byte[] dataToSign;

    /* The UUID of the user for which this signing
     *                                 operation is being performed; the
     * resulting
     *                                 signature will will be incorperated
     * into a
     *                                 PIV data object that is part of this
     * user's
     *                                 PIV smart credential. When present,
     * the UUID
     *                                 is included as a signed attribute
     * in the 
     *                                 resulting signature; otherwise the
     * UUID is
     *                                 not included as a signed attribute
     * in the
     *                                 resulting signature. */
    private String uuid;

    /* The FASCN of the user for which this signing
     *                                 operation is being performed; the
     * resulting
     *                                 signature will will be incorperated
     * into a
     *                                 PIV data object that is part of this
     * user's
     *                                 PIV smart credential. When present,
     * the FASCN
     *                                 is included as a signed attribute
     * in the 
     *                                 resulting signature; otherwise the
     * FASCN is 
     *                                 not included as a signed attribute
     * in the
     *                                 resulting signature. */
    private byte[] fascn;

    public PivSignContentCallParms() {
    }

    public PivSignContentCallParms(
           String managedCaName,
           com.good.adapters.entrust.stubs.PivContentSigningOperationType operationType,
           byte[] dataToSign,
           String uuid,
           byte[] fascn) {
           this.managedCaName = managedCaName;
           this.operationType = operationType;
           this.dataToSign = dataToSign;
           this.uuid = uuid;
           this.fascn = fascn;
    }


    /**
     * Gets the managedCaName value for this PivSignContentCallParms.
     * 
     * @return managedCaName   * The name of the managed CA whose PIV content 
     *                                 signer will be used to perform the
     * signing 
     *                                 operation.
     */
    public String getManagedCaName() {
        return managedCaName;
    }


    /**
     * Sets the managedCaName value for this PivSignContentCallParms.
     * 
     * @param managedCaName   * The name of the managed CA whose PIV content 
     *                                 signer will be used to perform the
     * signing 
     *                                 operation.
     */
    public void setManagedCaName(String managedCaName) {
        this.managedCaName = managedCaName;
    }


    /**
     * Gets the operationType value for this PivSignContentCallParms.
     * 
     * @return operationType   * The type of PIV content signiner operation
     *                                 that is being performed; this effects
     * how the 
     *                                 input is validated and how the signing
     * is done.
     */
    public com.good.adapters.entrust.stubs.PivContentSigningOperationType getOperationType() {
        return operationType;
    }


    /**
     * Sets the operationType value for this PivSignContentCallParms.
     * 
     * @param operationType   * The type of PIV content signiner operation
     *                                 that is being performed; this effects
     * how the 
     *                                 input is validated and how the signing
     * is done.
     */
    public void setOperationType(com.good.adapters.entrust.stubs.PivContentSigningOperationType operationType) {
        this.operationType = operationType;
    }


    /**
     * Gets the dataToSign value for this PivSignContentCallParms.
     * 
     * @return dataToSign   * The data over which the signature is being
     *                                 calculated. For example, when performing
     * a
     *                                 CHUID signing operation, this will
     * contain the 
     *                                 encoded CHUID. The format of this
     * data is 
     *                                 validated. Ignored when the operationType
     * is
     *                                 NO_OP.
     */
    public byte[] getDataToSign() {
        return dataToSign;
    }


    /**
     * Sets the dataToSign value for this PivSignContentCallParms.
     * 
     * @param dataToSign   * The data over which the signature is being
     *                                 calculated. For example, when performing
     * a
     *                                 CHUID signing operation, this will
     * contain the 
     *                                 encoded CHUID. The format of this
     * data is 
     *                                 validated. Ignored when the operationType
     * is
     *                                 NO_OP.
     */
    public void setDataToSign(byte[] dataToSign) {
        this.dataToSign = dataToSign;
    }


    /**
     * Gets the uuid value for this PivSignContentCallParms.
     * 
     * @return uuid   * The UUID of the user for which this signing
     *                                 operation is being performed; the
     * resulting
     *                                 signature will will be incorperated
     * into a
     *                                 PIV data object that is part of this
     * user's
     *                                 PIV smart credential. When present,
     * the UUID
     *                                 is included as a signed attribute
     * in the 
     *                                 resulting signature; otherwise the
     * UUID is
     *                                 not included as a signed attribute
     * in the
     *                                 resulting signature.
     */
    public String getUuid() {
        return uuid;
    }


    /**
     * Sets the uuid value for this PivSignContentCallParms.
     * 
     * @param uuid   * The UUID of the user for which this signing
     *                                 operation is being performed; the
     * resulting
     *                                 signature will will be incorperated
     * into a
     *                                 PIV data object that is part of this
     * user's
     *                                 PIV smart credential. When present,
     * the UUID
     *                                 is included as a signed attribute
     * in the 
     *                                 resulting signature; otherwise the
     * UUID is
     *                                 not included as a signed attribute
     * in the
     *                                 resulting signature.
     */
    public void setUuid(String uuid) {
        this.uuid = uuid;
    }


    /**
     * Gets the fascn value for this PivSignContentCallParms.
     * 
     * @return fascn   * The FASCN of the user for which this signing
     *                                 operation is being performed; the
     * resulting
     *                                 signature will will be incorperated
     * into a
     *                                 PIV data object that is part of this
     * user's
     *                                 PIV smart credential. When present,
     * the FASCN
     *                                 is included as a signed attribute
     * in the 
     *                                 resulting signature; otherwise the
     * FASCN is 
     *                                 not included as a signed attribute
     * in the
     *                                 resulting signature.
     */
    public byte[] getFascn() {
        return fascn;
    }


    /**
     * Sets the fascn value for this PivSignContentCallParms.
     * 
     * @param fascn   * The FASCN of the user for which this signing
     *                                 operation is being performed; the
     * resulting
     *                                 signature will will be incorperated
     * into a
     *                                 PIV data object that is part of this
     * user's
     *                                 PIV smart credential. When present,
     * the FASCN
     *                                 is included as a signed attribute
     * in the 
     *                                 resulting signature; otherwise the
     * FASCN is 
     *                                 not included as a signed attribute
     * in the
     *                                 resulting signature.
     */
    public void setFascn(byte[] fascn) {
        this.fascn = fascn;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PivSignContentCallParms)) return false;
        PivSignContentCallParms other = (PivSignContentCallParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.managedCaName==null && other.getManagedCaName()==null) || 
             (this.managedCaName!=null &&
              this.managedCaName.equals(other.getManagedCaName()))) &&
            ((this.operationType==null && other.getOperationType()==null) || 
             (this.operationType!=null &&
              this.operationType.equals(other.getOperationType()))) &&
            ((this.dataToSign==null && other.getDataToSign()==null) || 
             (this.dataToSign!=null &&
              java.util.Arrays.equals(this.dataToSign, other.getDataToSign()))) &&
            ((this.uuid==null && other.getUuid()==null) || 
             (this.uuid!=null &&
              this.uuid.equals(other.getUuid()))) &&
            ((this.fascn==null && other.getFascn()==null) || 
             (this.fascn!=null &&
              java.util.Arrays.equals(this.fascn, other.getFascn())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getManagedCaName() != null) {
            _hashCode += getManagedCaName().hashCode();
        }
        if (getOperationType() != null) {
            _hashCode += getOperationType().hashCode();
        }
        if (getDataToSign() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getDataToSign());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getDataToSign(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getUuid() != null) {
            _hashCode += getUuid().hashCode();
        }
        if (getFascn() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getFascn());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getFascn(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PivSignContentCallParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PivSignContentCallParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("managedCaName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "managedCaName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("operationType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "operationType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PivContentSigningOperationType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dataToSign");
        elemField.setXmlName(new javax.xml.namespace.QName("", "dataToSign"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("uuid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "uuid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("fascn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "fascn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
