/**
 * PolicyParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Parameters that can be applied when creating or modifying
 *                         a policy.
 */
public class PolicyParms  implements java.io.Serializable {
    /* When modifying a policy, this element is the new
     *                                 name of the policy. When creating
     * a policy, this
     *                                 value is ignored. */
    private String name;

    /* If true, make this policy the default. Whichever
     *                                  policy is currently flagged as the
     * default will
     *                                  be updated so that it is no longer
     * the default. */
    private Boolean defaultPolicy;

    /* Parameters to apply to the user specification
     *                                 for this policy. */
    private UserSpecParms userSpec;

    /* Parameters to apply to the card specification
     *                                 for this policy. */
    private CardSpecParms cardSpec;

    /* Parameters to apply to the PIN specification for
     *                                 this policy. */
    private PINSpecParms pinSpec;

    /* Parameters to apply to the default password
     *                                 rules for this policy. */
    private PasswordRulesParms passwordRules;

    /* If specified as true, any named passwords
     *                                 specified in the namedPasswordRules
     * parameter are created.  If the named password
     *                                 already exists, an error is returned.
     * This attribute only applies to the policySet
     *                                 operation. */
    private Boolean createNamedPasswordRulesOnly;

    /* If specified as true, any named passwords
     *                                 specified in the namedPasswordRules
     * parameter are created.  If the named password
     *                                 already exists, an error is returned.
     * This attribute only applies to the policySet
     *                                 operation. */
    private Boolean updateNamedPasswordRulesOnly;

    /* If specified as true, any named passwords
     *                                 not specified in the namedPasswordRules
     * parameter are removed.  This attribute only
     *                                 applies to the policySet operation. */
    private Boolean replaceNamedPasswordRules;

    /* Parameters to apply to the named password
     *                                 rules for this policy.  If the named
     * password
     *                                 rules already exist, they are modified.
     * If the name dpassword rules don't exist, they
     *                                 are added. */
    private PasswordRulesParms[] namedPasswordRules;

    /* A list of named password rules to be removed
     *                                 from this policy. */
    private String[] removeNamedPasswordRules;

    /* Descriptive comments about this policy that could
     *                                  be used to provide a full description
     * of this
     *                                  policy's intended purpose. */
    private String comment;

    public PolicyParms() {
    }

    public PolicyParms(
           String name,
           Boolean defaultPolicy,
           UserSpecParms userSpec,
           CardSpecParms cardSpec,
           PINSpecParms pinSpec,
           PasswordRulesParms passwordRules,
           Boolean createNamedPasswordRulesOnly,
           Boolean updateNamedPasswordRulesOnly,
           Boolean replaceNamedPasswordRules,
           PasswordRulesParms[] namedPasswordRules,
           String[] removeNamedPasswordRules,
           String comment) {
           this.name = name;
           this.defaultPolicy = defaultPolicy;
           this.userSpec = userSpec;
           this.cardSpec = cardSpec;
           this.pinSpec = pinSpec;
           this.passwordRules = passwordRules;
           this.createNamedPasswordRulesOnly = createNamedPasswordRulesOnly;
           this.updateNamedPasswordRulesOnly = updateNamedPasswordRulesOnly;
           this.replaceNamedPasswordRules = replaceNamedPasswordRules;
           this.namedPasswordRules = namedPasswordRules;
           this.removeNamedPasswordRules = removeNamedPasswordRules;
           this.comment = comment;
    }


    /**
     * Gets the name value for this PolicyParms.
     * 
     * @return name   * When modifying a policy, this element is the new
     *                                 name of the policy. When creating
     * a policy, this
     *                                 value is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this PolicyParms.
     * 
     * @param name   * When modifying a policy, this element is the new
     *                                 name of the policy. When creating
     * a policy, this
     *                                 value is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the defaultPolicy value for this PolicyParms.
     * 
     * @return defaultPolicy   * If true, make this policy the default. Whichever
     *                                  policy is currently flagged as the
     * default will
     *                                  be updated so that it is no longer
     * the default.
     */
    public Boolean getDefaultPolicy() {
        return defaultPolicy;
    }


    /**
     * Sets the defaultPolicy value for this PolicyParms.
     * 
     * @param defaultPolicy   * If true, make this policy the default. Whichever
     *                                  policy is currently flagged as the
     * default will
     *                                  be updated so that it is no longer
     * the default.
     */
    public void setDefaultPolicy(Boolean defaultPolicy) {
        this.defaultPolicy = defaultPolicy;
    }


    /**
     * Gets the userSpec value for this PolicyParms.
     * 
     * @return userSpec   * Parameters to apply to the user specification
     *                                 for this policy.
     */
    public UserSpecParms getUserSpec() {
        return userSpec;
    }


    /**
     * Sets the userSpec value for this PolicyParms.
     * 
     * @param userSpec   * Parameters to apply to the user specification
     *                                 for this policy.
     */
    public void setUserSpec(UserSpecParms userSpec) {
        this.userSpec = userSpec;
    }


    /**
     * Gets the cardSpec value for this PolicyParms.
     * 
     * @return cardSpec   * Parameters to apply to the card specification
     *                                 for this policy.
     */
    public CardSpecParms getCardSpec() {
        return cardSpec;
    }


    /**
     * Sets the cardSpec value for this PolicyParms.
     * 
     * @param cardSpec   * Parameters to apply to the card specification
     *                                 for this policy.
     */
    public void setCardSpec(CardSpecParms cardSpec) {
        this.cardSpec = cardSpec;
    }


    /**
     * Gets the pinSpec value for this PolicyParms.
     * 
     * @return pinSpec   * Parameters to apply to the PIN specification for
     *                                 this policy.
     */
    public PINSpecParms getPinSpec() {
        return pinSpec;
    }


    /**
     * Sets the pinSpec value for this PolicyParms.
     * 
     * @param pinSpec   * Parameters to apply to the PIN specification for
     *                                 this policy.
     */
    public void setPinSpec(PINSpecParms pinSpec) {
        this.pinSpec = pinSpec;
    }


    /**
     * Gets the passwordRules value for this PolicyParms.
     * 
     * @return passwordRules   * Parameters to apply to the default password
     *                                 rules for this policy.
     */
    public PasswordRulesParms getPasswordRules() {
        return passwordRules;
    }


    /**
     * Sets the passwordRules value for this PolicyParms.
     * 
     * @param passwordRules   * Parameters to apply to the default password
     *                                 rules for this policy.
     */
    public void setPasswordRules(PasswordRulesParms passwordRules) {
        this.passwordRules = passwordRules;
    }


    /**
     * Gets the createNamedPasswordRulesOnly value for this PolicyParms.
     * 
     * @return createNamedPasswordRulesOnly   * If specified as true, any named passwords
     *                                 specified in the namedPasswordRules
     * parameter are created.  If the named password
     *                                 already exists, an error is returned.
     * This attribute only applies to the policySet
     *                                 operation.
     */
    public Boolean getCreateNamedPasswordRulesOnly() {
        return createNamedPasswordRulesOnly;
    }


    /**
     * Sets the createNamedPasswordRulesOnly value for this PolicyParms.
     * 
     * @param createNamedPasswordRulesOnly   * If specified as true, any named passwords
     *                                 specified in the namedPasswordRules
     * parameter are created.  If the named password
     *                                 already exists, an error is returned.
     * This attribute only applies to the policySet
     *                                 operation.
     */
    public void setCreateNamedPasswordRulesOnly(Boolean createNamedPasswordRulesOnly) {
        this.createNamedPasswordRulesOnly = createNamedPasswordRulesOnly;
    }


    /**
     * Gets the updateNamedPasswordRulesOnly value for this PolicyParms.
     * 
     * @return updateNamedPasswordRulesOnly   * If specified as true, any named passwords
     *                                 specified in the namedPasswordRules
     * parameter are created.  If the named password
     *                                 already exists, an error is returned.
     * This attribute only applies to the policySet
     *                                 operation.
     */
    public Boolean getUpdateNamedPasswordRulesOnly() {
        return updateNamedPasswordRulesOnly;
    }


    /**
     * Sets the updateNamedPasswordRulesOnly value for this PolicyParms.
     * 
     * @param updateNamedPasswordRulesOnly   * If specified as true, any named passwords
     *                                 specified in the namedPasswordRules
     * parameter are created.  If the named password
     *                                 already exists, an error is returned.
     * This attribute only applies to the policySet
     *                                 operation.
     */
    public void setUpdateNamedPasswordRulesOnly(Boolean updateNamedPasswordRulesOnly) {
        this.updateNamedPasswordRulesOnly = updateNamedPasswordRulesOnly;
    }


    /**
     * Gets the replaceNamedPasswordRules value for this PolicyParms.
     * 
     * @return replaceNamedPasswordRules   * If specified as true, any named passwords
     *                                 not specified in the namedPasswordRules
     * parameter are removed.  This attribute only
     *                                 applies to the policySet operation.
     */
    public Boolean getReplaceNamedPasswordRules() {
        return replaceNamedPasswordRules;
    }


    /**
     * Sets the replaceNamedPasswordRules value for this PolicyParms.
     * 
     * @param replaceNamedPasswordRules   * If specified as true, any named passwords
     *                                 not specified in the namedPasswordRules
     * parameter are removed.  This attribute only
     *                                 applies to the policySet operation.
     */
    public void setReplaceNamedPasswordRules(Boolean replaceNamedPasswordRules) {
        this.replaceNamedPasswordRules = replaceNamedPasswordRules;
    }


    /**
     * Gets the namedPasswordRules value for this PolicyParms.
     * 
     * @return namedPasswordRules   * Parameters to apply to the named password
     *                                 rules for this policy.  If the named
     * password
     *                                 rules already exist, they are modified.
     * If the name dpassword rules don't exist, they
     *                                 are added.
     */
    public PasswordRulesParms[] getNamedPasswordRules() {
        return namedPasswordRules;
    }


    /**
     * Sets the namedPasswordRules value for this PolicyParms.
     * 
     * @param namedPasswordRules   * Parameters to apply to the named password
     *                                 rules for this policy.  If the named
     * password
     *                                 rules already exist, they are modified.
     * If the name dpassword rules don't exist, they
     *                                 are added.
     */
    public void setNamedPasswordRules(PasswordRulesParms[] namedPasswordRules) {
        this.namedPasswordRules = namedPasswordRules;
    }


    /**
     * Gets the removeNamedPasswordRules value for this PolicyParms.
     * 
     * @return removeNamedPasswordRules   * A list of named password rules to be removed
     *                                 from this policy.
     */
    public String[] getRemoveNamedPasswordRules() {
        return removeNamedPasswordRules;
    }


    /**
     * Sets the removeNamedPasswordRules value for this PolicyParms.
     * 
     * @param removeNamedPasswordRules   * A list of named password rules to be removed
     *                                 from this policy.
     */
    public void setRemoveNamedPasswordRules(String[] removeNamedPasswordRules) {
        this.removeNamedPasswordRules = removeNamedPasswordRules;
    }


    /**
     * Gets the comment value for this PolicyParms.
     * 
     * @return comment   * Descriptive comments about this policy that could
     *                                  be used to provide a full description
     * of this
     *                                  policy's intended purpose.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this PolicyParms.
     * 
     * @param comment   * Descriptive comments about this policy that could
     *                                  be used to provide a full description
     * of this
     *                                  policy's intended purpose.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PolicyParms)) return false;
        PolicyParms other = (PolicyParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.defaultPolicy==null && other.getDefaultPolicy()==null) || 
             (this.defaultPolicy!=null &&
              this.defaultPolicy.equals(other.getDefaultPolicy()))) &&
            ((this.userSpec==null && other.getUserSpec()==null) || 
             (this.userSpec!=null &&
              this.userSpec.equals(other.getUserSpec()))) &&
            ((this.cardSpec==null && other.getCardSpec()==null) || 
             (this.cardSpec!=null &&
              this.cardSpec.equals(other.getCardSpec()))) &&
            ((this.pinSpec==null && other.getPinSpec()==null) || 
             (this.pinSpec!=null &&
              this.pinSpec.equals(other.getPinSpec()))) &&
            ((this.passwordRules==null && other.getPasswordRules()==null) || 
             (this.passwordRules!=null &&
              this.passwordRules.equals(other.getPasswordRules()))) &&
            ((this.createNamedPasswordRulesOnly==null && other.getCreateNamedPasswordRulesOnly()==null) || 
             (this.createNamedPasswordRulesOnly!=null &&
              this.createNamedPasswordRulesOnly.equals(other.getCreateNamedPasswordRulesOnly()))) &&
            ((this.updateNamedPasswordRulesOnly==null && other.getUpdateNamedPasswordRulesOnly()==null) || 
             (this.updateNamedPasswordRulesOnly!=null &&
              this.updateNamedPasswordRulesOnly.equals(other.getUpdateNamedPasswordRulesOnly()))) &&
            ((this.replaceNamedPasswordRules==null && other.getReplaceNamedPasswordRules()==null) || 
             (this.replaceNamedPasswordRules!=null &&
              this.replaceNamedPasswordRules.equals(other.getReplaceNamedPasswordRules()))) &&
            ((this.namedPasswordRules==null && other.getNamedPasswordRules()==null) || 
             (this.namedPasswordRules!=null &&
              java.util.Arrays.equals(this.namedPasswordRules, other.getNamedPasswordRules()))) &&
            ((this.removeNamedPasswordRules==null && other.getRemoveNamedPasswordRules()==null) || 
             (this.removeNamedPasswordRules!=null &&
              java.util.Arrays.equals(this.removeNamedPasswordRules, other.getRemoveNamedPasswordRules()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getDefaultPolicy() != null) {
            _hashCode += getDefaultPolicy().hashCode();
        }
        if (getUserSpec() != null) {
            _hashCode += getUserSpec().hashCode();
        }
        if (getCardSpec() != null) {
            _hashCode += getCardSpec().hashCode();
        }
        if (getPinSpec() != null) {
            _hashCode += getPinSpec().hashCode();
        }
        if (getPasswordRules() != null) {
            _hashCode += getPasswordRules().hashCode();
        }
        if (getCreateNamedPasswordRulesOnly() != null) {
            _hashCode += getCreateNamedPasswordRulesOnly().hashCode();
        }
        if (getUpdateNamedPasswordRulesOnly() != null) {
            _hashCode += getUpdateNamedPasswordRulesOnly().hashCode();
        }
        if (getReplaceNamedPasswordRules() != null) {
            _hashCode += getReplaceNamedPasswordRules().hashCode();
        }
        if (getNamedPasswordRules() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getNamedPasswordRules());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getNamedPasswordRules(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRemoveNamedPasswordRules() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRemoveNamedPasswordRules());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRemoveNamedPasswordRules(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PolicyParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PolicyParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultPolicy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultPolicy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userSpec");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userSpec"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserSpecParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardSpec");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cardSpec"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "CardSpecParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("pinSpec");
        elemField.setXmlName(new javax.xml.namespace.QName("", "pinSpec"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PINSpecParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("passwordRules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "passwordRules"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PasswordRulesParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createNamedPasswordRulesOnly");
        elemField.setXmlName(new javax.xml.namespace.QName("", "createNamedPasswordRulesOnly"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("updateNamedPasswordRulesOnly");
        elemField.setXmlName(new javax.xml.namespace.QName("", "updateNamedPasswordRulesOnly"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("replaceNamedPasswordRules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "replaceNamedPasswordRules"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("namedPasswordRules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "namedPasswordRules"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PasswordRulesParms"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeNamedPasswordRules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeNamedPasswordRules"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
