/**
 * PreproducedCardFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the filter to limit which preproduced cards are
 *                         to be returned from the preproducedCardList
 * operation.
 */
public class PreproducedCardFilter  implements java.io.Serializable {
    /* If specified, only cards with this serial
     *                                 number or serial numbers matching
     * the
     *                                 serialNumbers or serialNumberRanges
     * arguments
     *                                 will be returned. */
    private String serialNumber;

    /* If specified, only cards with one of these
     *                                 serial numbers or serial numbers matching
     * the
     *                                 serialNumber or serialNumberRanges
     * arguments
     *                                 will be returned. */
    private String[] serialNumbers;

    /* If specified, only cards with serial numbers
     *                                 in these ranges or serial numbers
     * matching the
     *                                 serialNumber or serialNumberRanges
     * arguments
     *                                 will be returned. */
    private SerialNumberRange[] serialNumberRanges;

    /* If specified, returns only cards whose creation date
     *                                 is after the given date. */
    private java.util.Calendar createStartDate;

    /* If specified, returns only cards whose creation date
     *                                 is before the given date. */
    private java.util.Calendar createEndDate;

    /* If specified, provides a list of group names and
     *                                 returns only cards in the specified
     * groups. */
    private String[] groups;

    /* The number of cards to return.  If not specified,
     *                                 or the value is 0 or less, it defaults
     * to 100. */
    private Integer maxReturn;

    /* The serial number of the next card to be returned. If
     *                                 specified, indicates that searching
     * should start at
     *                                 the given card. This value is used
     * to get the next
     *                                 set of cards following a previous
     * search. The value
     *                                 can be found in the PreproducedCardListResult
     * from the
     *                                 previous search. */
    private String nextCard;

    public PreproducedCardFilter() {
    }

    public PreproducedCardFilter(
           String serialNumber,
           String[] serialNumbers,
           SerialNumberRange[] serialNumberRanges,
           java.util.Calendar createStartDate,
           java.util.Calendar createEndDate,
           String[] groups,
           Integer maxReturn,
           String nextCard) {
           this.serialNumber = serialNumber;
           this.serialNumbers = serialNumbers;
           this.serialNumberRanges = serialNumberRanges;
           this.createStartDate = createStartDate;
           this.createEndDate = createEndDate;
           this.groups = groups;
           this.maxReturn = maxReturn;
           this.nextCard = nextCard;
    }


    /**
     * Gets the serialNumber value for this PreproducedCardFilter.
     * 
     * @return serialNumber   * If specified, only cards with this serial
     *                                 number or serial numbers matching
     * the
     *                                 serialNumbers or serialNumberRanges
     * arguments
     *                                 will be returned.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this PreproducedCardFilter.
     * 
     * @param serialNumber   * If specified, only cards with this serial
     *                                 number or serial numbers matching
     * the
     *                                 serialNumbers or serialNumberRanges
     * arguments
     *                                 will be returned.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the serialNumbers value for this PreproducedCardFilter.
     * 
     * @return serialNumbers   * If specified, only cards with one of these
     *                                 serial numbers or serial numbers matching
     * the
     *                                 serialNumber or serialNumberRanges
     * arguments
     *                                 will be returned.
     */
    public String[] getSerialNumbers() {
        return serialNumbers;
    }


    /**
     * Sets the serialNumbers value for this PreproducedCardFilter.
     * 
     * @param serialNumbers   * If specified, only cards with one of these
     *                                 serial numbers or serial numbers matching
     * the
     *                                 serialNumber or serialNumberRanges
     * arguments
     *                                 will be returned.
     */
    public void setSerialNumbers(String[] serialNumbers) {
        this.serialNumbers = serialNumbers;
    }


    /**
     * Gets the serialNumberRanges value for this PreproducedCardFilter.
     * 
     * @return serialNumberRanges   * If specified, only cards with serial numbers
     *                                 in these ranges or serial numbers
     * matching the
     *                                 serialNumber or serialNumberRanges
     * arguments
     *                                 will be returned.
     */
    public SerialNumberRange[] getSerialNumberRanges() {
        return serialNumberRanges;
    }


    /**
     * Sets the serialNumberRanges value for this PreproducedCardFilter.
     * 
     * @param serialNumberRanges   * If specified, only cards with serial numbers
     *                                 in these ranges or serial numbers
     * matching the
     *                                 serialNumber or serialNumberRanges
     * arguments
     *                                 will be returned.
     */
    public void setSerialNumberRanges(SerialNumberRange[] serialNumberRanges) {
        this.serialNumberRanges = serialNumberRanges;
    }


    /**
     * Gets the createStartDate value for this PreproducedCardFilter.
     * 
     * @return createStartDate   * If specified, returns only cards whose creation date
     *                                 is after the given date.
     */
    public java.util.Calendar getCreateStartDate() {
        return createStartDate;
    }


    /**
     * Sets the createStartDate value for this PreproducedCardFilter.
     * 
     * @param createStartDate   * If specified, returns only cards whose creation date
     *                                 is after the given date.
     */
    public void setCreateStartDate(java.util.Calendar createStartDate) {
        this.createStartDate = createStartDate;
    }


    /**
     * Gets the createEndDate value for this PreproducedCardFilter.
     * 
     * @return createEndDate   * If specified, returns only cards whose creation date
     *                                 is before the given date.
     */
    public java.util.Calendar getCreateEndDate() {
        return createEndDate;
    }


    /**
     * Sets the createEndDate value for this PreproducedCardFilter.
     * 
     * @param createEndDate   * If specified, returns only cards whose creation date
     *                                 is before the given date.
     */
    public void setCreateEndDate(java.util.Calendar createEndDate) {
        this.createEndDate = createEndDate;
    }


    /**
     * Gets the groups value for this PreproducedCardFilter.
     * 
     * @return groups   * If specified, provides a list of group names and
     *                                 returns only cards in the specified
     * groups.
     */
    public String[] getGroups() {
        return groups;
    }


    /**
     * Sets the groups value for this PreproducedCardFilter.
     * 
     * @param groups   * If specified, provides a list of group names and
     *                                 returns only cards in the specified
     * groups.
     */
    public void setGroups(String[] groups) {
        this.groups = groups;
    }


    /**
     * Gets the maxReturn value for this PreproducedCardFilter.
     * 
     * @return maxReturn   * The number of cards to return.  If not specified,
     *                                 or the value is 0 or less, it defaults
     * to 100.
     */
    public Integer getMaxReturn() {
        return maxReturn;
    }


    /**
     * Sets the maxReturn value for this PreproducedCardFilter.
     * 
     * @param maxReturn   * The number of cards to return.  If not specified,
     *                                 or the value is 0 or less, it defaults
     * to 100.
     */
    public void setMaxReturn(Integer maxReturn) {
        this.maxReturn = maxReturn;
    }


    /**
     * Gets the nextCard value for this PreproducedCardFilter.
     * 
     * @return nextCard   * The serial number of the next card to be returned. If
     *                                 specified, indicates that searching
     * should start at
     *                                 the given card. This value is used
     * to get the next
     *                                 set of cards following a previous
     * search. The value
     *                                 can be found in the PreproducedCardListResult
     * from the
     *                                 previous search.
     */
    public String getNextCard() {
        return nextCard;
    }


    /**
     * Sets the nextCard value for this PreproducedCardFilter.
     * 
     * @param nextCard   * The serial number of the next card to be returned. If
     *                                 specified, indicates that searching
     * should start at
     *                                 the given card. This value is used
     * to get the next
     *                                 set of cards following a previous
     * search. The value
     *                                 can be found in the PreproducedCardListResult
     * from the
     *                                 previous search.
     */
    public void setNextCard(String nextCard) {
        this.nextCard = nextCard;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PreproducedCardFilter)) return false;
        PreproducedCardFilter other = (PreproducedCardFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.serialNumbers==null && other.getSerialNumbers()==null) || 
             (this.serialNumbers!=null &&
              java.util.Arrays.equals(this.serialNumbers, other.getSerialNumbers()))) &&
            ((this.serialNumberRanges==null && other.getSerialNumberRanges()==null) || 
             (this.serialNumberRanges!=null &&
              java.util.Arrays.equals(this.serialNumberRanges, other.getSerialNumberRanges()))) &&
            ((this.createStartDate==null && other.getCreateStartDate()==null) || 
             (this.createStartDate!=null &&
              this.createStartDate.equals(other.getCreateStartDate()))) &&
            ((this.createEndDate==null && other.getCreateEndDate()==null) || 
             (this.createEndDate!=null &&
              this.createEndDate.equals(other.getCreateEndDate()))) &&
            ((this.groups==null && other.getGroups()==null) || 
             (this.groups!=null &&
              java.util.Arrays.equals(this.groups, other.getGroups()))) &&
            ((this.maxReturn==null && other.getMaxReturn()==null) || 
             (this.maxReturn!=null &&
              this.maxReturn.equals(other.getMaxReturn()))) &&
            ((this.nextCard==null && other.getNextCard()==null) || 
             (this.nextCard!=null &&
              this.nextCard.equals(other.getNextCard())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getSerialNumbers() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSerialNumbers());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSerialNumbers(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getSerialNumberRanges() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSerialNumberRanges());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSerialNumberRanges(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCreateStartDate() != null) {
            _hashCode += getCreateStartDate().hashCode();
        }
        if (getCreateEndDate() != null) {
            _hashCode += getCreateEndDate().hashCode();
        }
        if (getGroups() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroups());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroups(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMaxReturn() != null) {
            _hashCode += getMaxReturn().hashCode();
        }
        if (getNextCard() != null) {
            _hashCode += getNextCard().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PreproducedCardFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PreproducedCardFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumbers");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumbers"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumberRanges");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumberRanges"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SerialNumberRange"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createStartDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "createStartDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createEndDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "createEndDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxReturn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxReturn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("nextCard");
        elemField.setXmlName(new javax.xml.namespace.QName("", "nextCard"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
