/**
 * PreproducedCardParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when creating or modifying
 *                         a preproduced card. All values can be null
 * indicating
 *                         that the default is used for create or the
 * value is not
 *                         changed for modify.
 */
public class PreproducedCardParms  implements java.io.Serializable {
    /* During card creation, this value will define
     *                                 how many preproduced cards are to
     * be created.
     *                                 If not set, one card will be created.
     * This
     *                                 parameter is ignored by preproduced
     * card modify. */
    private Integer numCards;

    /* The group this preproduced card belongs to. If null
     *                                 during create, the card will belong
     * to the group
     *                                 flagged as the default. */
    private String group;

    /* The card comment. Defaults to an empty string when
     *                                 creating new preproduced cards. */
    private String comment;

    public PreproducedCardParms() {
    }

    public PreproducedCardParms(
           Integer numCards,
           String group,
           String comment) {
           this.numCards = numCards;
           this.group = group;
           this.comment = comment;
    }


    /**
     * Gets the numCards value for this PreproducedCardParms.
     * 
     * @return numCards   * During card creation, this value will define
     *                                 how many preproduced cards are to
     * be created.
     *                                 If not set, one card will be created.
     * This
     *                                 parameter is ignored by preproduced
     * card modify.
     */
    public Integer getNumCards() {
        return numCards;
    }


    /**
     * Sets the numCards value for this PreproducedCardParms.
     * 
     * @param numCards   * During card creation, this value will define
     *                                 how many preproduced cards are to
     * be created.
     *                                 If not set, one card will be created.
     * This
     *                                 parameter is ignored by preproduced
     * card modify.
     */
    public void setNumCards(Integer numCards) {
        this.numCards = numCards;
    }


    /**
     * Gets the group value for this PreproducedCardParms.
     * 
     * @return group   * The group this preproduced card belongs to. If null
     *                                 during create, the card will belong
     * to the group
     *                                 flagged as the default.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this PreproducedCardParms.
     * 
     * @param group   * The group this preproduced card belongs to. If null
     *                                 during create, the card will belong
     * to the group
     *                                 flagged as the default.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the comment value for this PreproducedCardParms.
     * 
     * @return comment   * The card comment. Defaults to an empty string when
     *                                 creating new preproduced cards.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this PreproducedCardParms.
     * 
     * @param comment   * The card comment. Defaults to an empty string when
     *                                 creating new preproduced cards.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof PreproducedCardParms)) return false;
        PreproducedCardParms other = (PreproducedCardParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.numCards==null && other.getNumCards()==null) || 
             (this.numCards!=null &&
              this.numCards.equals(other.getNumCards()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getNumCards() != null) {
            _hashCode += getNumCards().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(PreproducedCardParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PreproducedCardParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numCards");
        elemField.setXmlName(new javax.xml.namespace.QName("", "NumCards"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
