/**
 * ReportCreateFilters.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the set of filters for creating a report. At least one
 * of the filters  must not be null.
 */
public class ReportCreateFilters  implements java.io.Serializable {
    /* The search filter, specifying which users, cards, tokens, smart
     * credentials and certificates should be returned for the report. */
    private UserFilter userFilter;

    /* The search filter, specifying which preproduced cards should
     * be returned for the report. */
    private PreproducedCardFilter preproducedCardFilter;

    /* The search filter, specifying which unassigned tokens should
     * be returned for the report. */
    private TokenFilter tokenFilter;

    /* The search filter, specifying which unassigned smart credentials
     * should be returned for the report. */
    private SmartCredentialFilter smartCredentialFilter;

    /* The search filter, specifying which audits should be returned
     * for the report. */
    private AuditFilter auditFilter;

    public ReportCreateFilters() {
    }

    public ReportCreateFilters(
           UserFilter userFilter,
           PreproducedCardFilter preproducedCardFilter,
           TokenFilter tokenFilter,
           SmartCredentialFilter smartCredentialFilter,
           AuditFilter auditFilter) {
           this.userFilter = userFilter;
           this.preproducedCardFilter = preproducedCardFilter;
           this.tokenFilter = tokenFilter;
           this.smartCredentialFilter = smartCredentialFilter;
           this.auditFilter = auditFilter;
    }


    /**
     * Gets the userFilter value for this ReportCreateFilters.
     * 
     * @return userFilter   * The search filter, specifying which users, cards, tokens, smart
     * credentials and certificates should be returned for the report.
     */
    public UserFilter getUserFilter() {
        return userFilter;
    }


    /**
     * Sets the userFilter value for this ReportCreateFilters.
     * 
     * @param userFilter   * The search filter, specifying which users, cards, tokens, smart
     * credentials and certificates should be returned for the report.
     */
    public void setUserFilter(UserFilter userFilter) {
        this.userFilter = userFilter;
    }


    /**
     * Gets the preproducedCardFilter value for this ReportCreateFilters.
     * 
     * @return preproducedCardFilter   * The search filter, specifying which preproduced cards should
     * be returned for the report.
     */
    public PreproducedCardFilter getPreproducedCardFilter() {
        return preproducedCardFilter;
    }


    /**
     * Sets the preproducedCardFilter value for this ReportCreateFilters.
     * 
     * @param preproducedCardFilter   * The search filter, specifying which preproduced cards should
     * be returned for the report.
     */
    public void setPreproducedCardFilter(PreproducedCardFilter preproducedCardFilter) {
        this.preproducedCardFilter = preproducedCardFilter;
    }


    /**
     * Gets the tokenFilter value for this ReportCreateFilters.
     * 
     * @return tokenFilter   * The search filter, specifying which unassigned tokens should
     * be returned for the report.
     */
    public TokenFilter getTokenFilter() {
        return tokenFilter;
    }


    /**
     * Sets the tokenFilter value for this ReportCreateFilters.
     * 
     * @param tokenFilter   * The search filter, specifying which unassigned tokens should
     * be returned for the report.
     */
    public void setTokenFilter(TokenFilter tokenFilter) {
        this.tokenFilter = tokenFilter;
    }


    /**
     * Gets the smartCredentialFilter value for this ReportCreateFilters.
     * 
     * @return smartCredentialFilter   * The search filter, specifying which unassigned smart credentials
     * should be returned for the report.
     */
    public SmartCredentialFilter getSmartCredentialFilter() {
        return smartCredentialFilter;
    }


    /**
     * Sets the smartCredentialFilter value for this ReportCreateFilters.
     * 
     * @param smartCredentialFilter   * The search filter, specifying which unassigned smart credentials
     * should be returned for the report.
     */
    public void setSmartCredentialFilter(SmartCredentialFilter smartCredentialFilter) {
        this.smartCredentialFilter = smartCredentialFilter;
    }


    /**
     * Gets the auditFilter value for this ReportCreateFilters.
     * 
     * @return auditFilter   * The search filter, specifying which audits should be returned
     * for the report.
     */
    public AuditFilter getAuditFilter() {
        return auditFilter;
    }


    /**
     * Sets the auditFilter value for this ReportCreateFilters.
     * 
     * @param auditFilter   * The search filter, specifying which audits should be returned
     * for the report.
     */
    public void setAuditFilter(AuditFilter auditFilter) {
        this.auditFilter = auditFilter;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ReportCreateFilters)) return false;
        ReportCreateFilters other = (ReportCreateFilters) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userFilter==null && other.getUserFilter()==null) || 
             (this.userFilter!=null &&
              this.userFilter.equals(other.getUserFilter()))) &&
            ((this.preproducedCardFilter==null && other.getPreproducedCardFilter()==null) || 
             (this.preproducedCardFilter!=null &&
              this.preproducedCardFilter.equals(other.getPreproducedCardFilter()))) &&
            ((this.tokenFilter==null && other.getTokenFilter()==null) || 
             (this.tokenFilter!=null &&
              this.tokenFilter.equals(other.getTokenFilter()))) &&
            ((this.smartCredentialFilter==null && other.getSmartCredentialFilter()==null) || 
             (this.smartCredentialFilter!=null &&
              this.smartCredentialFilter.equals(other.getSmartCredentialFilter()))) &&
            ((this.auditFilter==null && other.getAuditFilter()==null) || 
             (this.auditFilter!=null &&
              this.auditFilter.equals(other.getAuditFilter())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserFilter() != null) {
            _hashCode += getUserFilter().hashCode();
        }
        if (getPreproducedCardFilter() != null) {
            _hashCode += getPreproducedCardFilter().hashCode();
        }
        if (getTokenFilter() != null) {
            _hashCode += getTokenFilter().hashCode();
        }
        if (getSmartCredentialFilter() != null) {
            _hashCode += getSmartCredentialFilter().hashCode();
        }
        if (getAuditFilter() != null) {
            _hashCode += getAuditFilter().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ReportCreateFilters.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportCreateFilters"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userFilter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserFilter"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserFilter"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("preproducedCardFilter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PreproducedCardFilter"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PreproducedCardFilter"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenFilter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenFilter"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenFilter"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialFilter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SmartCredentialFilter"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialFilter"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("auditFilter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AuditFilter"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuditFilter"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
