/**
 * ReportDefinitionInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure provides information about the reports that can
 * be generated.
 */
public class ReportDefinitionInfo  implements java.io.Serializable {
    /* The name of the report. This value cannot be null. */
    private String name;

    /* The display name of the report. This value cannot be null. */
    private String displayName;

    /* The help message of the report. */
    private String helpMessage;

    /* The data source of the report. This value cannot be null. */
    private ReportDataSourceType dataSource;

    /* The list of supported report formats allowed. This value cannot
     * be null and must have at least one entry. For example, PDF or CSV. */
    private String[] formats;

    /* When this structure is returned by an admin service operation,
     * this is the list of the names of the roles that granted access to
     * this structure. */
    private String[] rolesGrantingAccess;

    public ReportDefinitionInfo() {
    }

    public ReportDefinitionInfo(
           String name,
           String displayName,
           String helpMessage,
           ReportDataSourceType dataSource,
           String[] formats,
           String[] rolesGrantingAccess) {
           this.name = name;
           this.displayName = displayName;
           this.helpMessage = helpMessage;
           this.dataSource = dataSource;
           this.formats = formats;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the name value for this ReportDefinitionInfo.
     * 
     * @return name   * The name of the report. This value cannot be null.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this ReportDefinitionInfo.
     * 
     * @param name   * The name of the report. This value cannot be null.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the displayName value for this ReportDefinitionInfo.
     * 
     * @return displayName   * The display name of the report. This value cannot be null.
     */
    public String getDisplayName() {
        return displayName;
    }


    /**
     * Sets the displayName value for this ReportDefinitionInfo.
     * 
     * @param displayName   * The display name of the report. This value cannot be null.
     */
    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }


    /**
     * Gets the helpMessage value for this ReportDefinitionInfo.
     * 
     * @return helpMessage   * The help message of the report.
     */
    public String getHelpMessage() {
        return helpMessage;
    }


    /**
     * Sets the helpMessage value for this ReportDefinitionInfo.
     * 
     * @param helpMessage   * The help message of the report.
     */
    public void setHelpMessage(String helpMessage) {
        this.helpMessage = helpMessage;
    }


    /**
     * Gets the dataSource value for this ReportDefinitionInfo.
     * 
     * @return dataSource   * The data source of the report. This value cannot be null.
     */
    public ReportDataSourceType getDataSource() {
        return dataSource;
    }


    /**
     * Sets the dataSource value for this ReportDefinitionInfo.
     * 
     * @param dataSource   * The data source of the report. This value cannot be null.
     */
    public void setDataSource(ReportDataSourceType dataSource) {
        this.dataSource = dataSource;
    }


    /**
     * Gets the formats value for this ReportDefinitionInfo.
     * 
     * @return formats   * The list of supported report formats allowed. This value cannot
     * be null and must have at least one entry. For example, PDF or CSV.
     */
    public String[] getFormats() {
        return formats;
    }


    /**
     * Sets the formats value for this ReportDefinitionInfo.
     * 
     * @param formats   * The list of supported report formats allowed. This value cannot
     * be null and must have at least one entry. For example, PDF or CSV.
     */
    public void setFormats(String[] formats) {
        this.formats = formats;
    }


    /**
     * Gets the rolesGrantingAccess value for this ReportDefinitionInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin service operation,
     * this is the list of the names of the roles that granted access to
     * this structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this ReportDefinitionInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin service operation,
     * this is the list of the names of the roles that granted access to
     * this structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ReportDefinitionInfo)) return false;
        ReportDefinitionInfo other = (ReportDefinitionInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.displayName==null && other.getDisplayName()==null) || 
             (this.displayName!=null &&
              this.displayName.equals(other.getDisplayName()))) &&
            ((this.helpMessage==null && other.getHelpMessage()==null) || 
             (this.helpMessage!=null &&
              this.helpMessage.equals(other.getHelpMessage()))) &&
            ((this.dataSource==null && other.getDataSource()==null) || 
             (this.dataSource!=null &&
              this.dataSource.equals(other.getDataSource()))) &&
            ((this.formats==null && other.getFormats()==null) || 
             (this.formats!=null &&
              java.util.Arrays.equals(this.formats, other.getFormats()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getDisplayName() != null) {
            _hashCode += getDisplayName().hashCode();
        }
        if (getHelpMessage() != null) {
            _hashCode += getHelpMessage().hashCode();
        }
        if (getDataSource() != null) {
            _hashCode += getDataSource().hashCode();
        }
        if (getFormats() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getFormats());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getFormats(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ReportDefinitionInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportDefinitionInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("displayName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DisplayName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("helpMessage");
        elemField.setXmlName(new javax.xml.namespace.QName("", "HelpMessage"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dataSource");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DataSource"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportDataSourceType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("formats");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Formats"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
