/**
 * ReportInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure provides information about reports. One of these
 * is always not null and two of them are null: QueueInfo, SuccessInfo,
 * FailureInfo.
 */
public class ReportInfo  implements java.io.Serializable {
    /* The Id of the report. This value cannot be null. */
    private String id;

    /* The name of the report. This value cannot be null. */
    private String name;

    /* The display name of the report. This value cannot be null. */
    private String displayName;

    /* The description of the report. This value cannot be null. */
    private String description;

    /* The data source of the report. This value cannot be null. */
    private ReportDataSourceType dataSource;

    /* The service type that originated this report. */
    private String serviceType;

    /* The userid of the creator that generated this report. This
     * value cannot be null. */
    private String creatorUserid;

    /* The user name of the creator that generated this report. This
     * value cannot be null. */
    private String creatorUserName;

    /* The group of the creator that generated this report. This value
     * can be null when a Master user generates the report. */
    private String creatorGroup;

    /* The date this report was requested (added to the reporting
     * queue). This value cannot be null. */
    private java.util.Calendar requestDate;

    /* The date this report started being generated. This value is
     * irrelevant if the report has not yet started being generated. */
    private java.util.Calendar startDate;

    /* An indicator for whether this report can be deleted. A report
     * is removable if the user retrieving this structure has the required
     * permission to delete reports. Reports that have not completed generation
     * cannot be removed. */
    private boolean removable;

    /* The approximate number of records processed thus far. This
     * value cannot be null. */
    private int records;

    /* Information about reports that have not completed generation. */
    private ReportQueueInfo queueInfo;

    /* Information about reports that have completed successfully. */
    private ReportSuccessInfo successInfo;

    /* Information about reports that have not completed successfully. */
    private ReportFailureInfo failureInfo;

    /* When this structure is returned by an admin service operation,
     * this is the list of the names of the roles that granted access to
     * this structure. */
    private String[] rolesGrantingAccess;

    public ReportInfo() {
    }

    public ReportInfo(
           String id,
           String name,
           String displayName,
           String description,
           ReportDataSourceType dataSource,
           String serviceType,
           String creatorUserid,
           String creatorUserName,
           String creatorGroup,
           java.util.Calendar requestDate,
           java.util.Calendar startDate,
           boolean removable,
           int records,
           ReportQueueInfo queueInfo,
           ReportSuccessInfo successInfo,
           ReportFailureInfo failureInfo,
           String[] rolesGrantingAccess) {
           this.id = id;
           this.name = name;
           this.displayName = displayName;
           this.description = description;
           this.dataSource = dataSource;
           this.serviceType = serviceType;
           this.creatorUserid = creatorUserid;
           this.creatorUserName = creatorUserName;
           this.creatorGroup = creatorGroup;
           this.requestDate = requestDate;
           this.startDate = startDate;
           this.removable = removable;
           this.records = records;
           this.queueInfo = queueInfo;
           this.successInfo = successInfo;
           this.failureInfo = failureInfo;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the id value for this ReportInfo.
     * 
     * @return id   * The Id of the report. This value cannot be null.
     */
    public String getId() {
        return id;
    }


    /**
     * Sets the id value for this ReportInfo.
     * 
     * @param id   * The Id of the report. This value cannot be null.
     */
    public void setId(String id) {
        this.id = id;
    }


    /**
     * Gets the name value for this ReportInfo.
     * 
     * @return name   * The name of the report. This value cannot be null.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this ReportInfo.
     * 
     * @param name   * The name of the report. This value cannot be null.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the displayName value for this ReportInfo.
     * 
     * @return displayName   * The display name of the report. This value cannot be null.
     */
    public String getDisplayName() {
        return displayName;
    }


    /**
     * Sets the displayName value for this ReportInfo.
     * 
     * @param displayName   * The display name of the report. This value cannot be null.
     */
    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }


    /**
     * Gets the description value for this ReportInfo.
     * 
     * @return description   * The description of the report. This value cannot be null.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this ReportInfo.
     * 
     * @param description   * The description of the report. This value cannot be null.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the dataSource value for this ReportInfo.
     * 
     * @return dataSource   * The data source of the report. This value cannot be null.
     */
    public ReportDataSourceType getDataSource() {
        return dataSource;
    }


    /**
     * Sets the dataSource value for this ReportInfo.
     * 
     * @param dataSource   * The data source of the report. This value cannot be null.
     */
    public void setDataSource(ReportDataSourceType dataSource) {
        this.dataSource = dataSource;
    }


    /**
     * Gets the serviceType value for this ReportInfo.
     * 
     * @return serviceType   * The service type that originated this report.
     */
    public String getServiceType() {
        return serviceType;
    }


    /**
     * Sets the serviceType value for this ReportInfo.
     * 
     * @param serviceType   * The service type that originated this report.
     */
    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }


    /**
     * Gets the creatorUserid value for this ReportInfo.
     * 
     * @return creatorUserid   * The userid of the creator that generated this report. This
     * value cannot be null.
     */
    public String getCreatorUserid() {
        return creatorUserid;
    }


    /**
     * Sets the creatorUserid value for this ReportInfo.
     * 
     * @param creatorUserid   * The userid of the creator that generated this report. This
     * value cannot be null.
     */
    public void setCreatorUserid(String creatorUserid) {
        this.creatorUserid = creatorUserid;
    }


    /**
     * Gets the creatorUserName value for this ReportInfo.
     * 
     * @return creatorUserName   * The user name of the creator that generated this report. This
     * value cannot be null.
     */
    public String getCreatorUserName() {
        return creatorUserName;
    }


    /**
     * Sets the creatorUserName value for this ReportInfo.
     * 
     * @param creatorUserName   * The user name of the creator that generated this report. This
     * value cannot be null.
     */
    public void setCreatorUserName(String creatorUserName) {
        this.creatorUserName = creatorUserName;
    }


    /**
     * Gets the creatorGroup value for this ReportInfo.
     * 
     * @return creatorGroup   * The group of the creator that generated this report. This value
     * can be null when a Master user generates the report.
     */
    public String getCreatorGroup() {
        return creatorGroup;
    }


    /**
     * Sets the creatorGroup value for this ReportInfo.
     * 
     * @param creatorGroup   * The group of the creator that generated this report. This value
     * can be null when a Master user generates the report.
     */
    public void setCreatorGroup(String creatorGroup) {
        this.creatorGroup = creatorGroup;
    }


    /**
     * Gets the requestDate value for this ReportInfo.
     * 
     * @return requestDate   * The date this report was requested (added to the reporting
     * queue). This value cannot be null.
     */
    public java.util.Calendar getRequestDate() {
        return requestDate;
    }


    /**
     * Sets the requestDate value for this ReportInfo.
     * 
     * @param requestDate   * The date this report was requested (added to the reporting
     * queue). This value cannot be null.
     */
    public void setRequestDate(java.util.Calendar requestDate) {
        this.requestDate = requestDate;
    }


    /**
     * Gets the startDate value for this ReportInfo.
     * 
     * @return startDate   * The date this report started being generated. This value is
     * irrelevant if the report has not yet started being generated.
     */
    public java.util.Calendar getStartDate() {
        return startDate;
    }


    /**
     * Sets the startDate value for this ReportInfo.
     * 
     * @param startDate   * The date this report started being generated. This value is
     * irrelevant if the report has not yet started being generated.
     */
    public void setStartDate(java.util.Calendar startDate) {
        this.startDate = startDate;
    }


    /**
     * Gets the removable value for this ReportInfo.
     * 
     * @return removable   * An indicator for whether this report can be deleted. A report
     * is removable if the user retrieving this structure has the required
     * permission to delete reports. Reports that have not completed generation
     * cannot be removed.
     */
    public boolean isRemovable() {
        return removable;
    }


    /**
     * Sets the removable value for this ReportInfo.
     * 
     * @param removable   * An indicator for whether this report can be deleted. A report
     * is removable if the user retrieving this structure has the required
     * permission to delete reports. Reports that have not completed generation
     * cannot be removed.
     */
    public void setRemovable(boolean removable) {
        this.removable = removable;
    }


    /**
     * Gets the records value for this ReportInfo.
     * 
     * @return records   * The approximate number of records processed thus far. This
     * value cannot be null.
     */
    public int getRecords() {
        return records;
    }


    /**
     * Sets the records value for this ReportInfo.
     * 
     * @param records   * The approximate number of records processed thus far. This
     * value cannot be null.
     */
    public void setRecords(int records) {
        this.records = records;
    }


    /**
     * Gets the queueInfo value for this ReportInfo.
     * 
     * @return queueInfo   * Information about reports that have not completed generation.
     */
    public ReportQueueInfo getQueueInfo() {
        return queueInfo;
    }


    /**
     * Sets the queueInfo value for this ReportInfo.
     * 
     * @param queueInfo   * Information about reports that have not completed generation.
     */
    public void setQueueInfo(ReportQueueInfo queueInfo) {
        this.queueInfo = queueInfo;
    }


    /**
     * Gets the successInfo value for this ReportInfo.
     * 
     * @return successInfo   * Information about reports that have completed successfully.
     */
    public ReportSuccessInfo getSuccessInfo() {
        return successInfo;
    }


    /**
     * Sets the successInfo value for this ReportInfo.
     * 
     * @param successInfo   * Information about reports that have completed successfully.
     */
    public void setSuccessInfo(ReportSuccessInfo successInfo) {
        this.successInfo = successInfo;
    }


    /**
     * Gets the failureInfo value for this ReportInfo.
     * 
     * @return failureInfo   * Information about reports that have not completed successfully.
     */
    public ReportFailureInfo getFailureInfo() {
        return failureInfo;
    }


    /**
     * Sets the failureInfo value for this ReportInfo.
     * 
     * @param failureInfo   * Information about reports that have not completed successfully.
     */
    public void setFailureInfo(ReportFailureInfo failureInfo) {
        this.failureInfo = failureInfo;
    }


    /**
     * Gets the rolesGrantingAccess value for this ReportInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin service operation,
     * this is the list of the names of the roles that granted access to
     * this structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this ReportInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin service operation,
     * this is the list of the names of the roles that granted access to
     * this structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof ReportInfo)) return false;
        ReportInfo other = (ReportInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.id==null && other.getId()==null) || 
             (this.id!=null &&
              this.id.equals(other.getId()))) &&
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.displayName==null && other.getDisplayName()==null) || 
             (this.displayName!=null &&
              this.displayName.equals(other.getDisplayName()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.dataSource==null && other.getDataSource()==null) || 
             (this.dataSource!=null &&
              this.dataSource.equals(other.getDataSource()))) &&
            ((this.serviceType==null && other.getServiceType()==null) || 
             (this.serviceType!=null &&
              this.serviceType.equals(other.getServiceType()))) &&
            ((this.creatorUserid==null && other.getCreatorUserid()==null) || 
             (this.creatorUserid!=null &&
              this.creatorUserid.equals(other.getCreatorUserid()))) &&
            ((this.creatorUserName==null && other.getCreatorUserName()==null) || 
             (this.creatorUserName!=null &&
              this.creatorUserName.equals(other.getCreatorUserName()))) &&
            ((this.creatorGroup==null && other.getCreatorGroup()==null) || 
             (this.creatorGroup!=null &&
              this.creatorGroup.equals(other.getCreatorGroup()))) &&
            ((this.requestDate==null && other.getRequestDate()==null) || 
             (this.requestDate!=null &&
              this.requestDate.equals(other.getRequestDate()))) &&
            ((this.startDate==null && other.getStartDate()==null) || 
             (this.startDate!=null &&
              this.startDate.equals(other.getStartDate()))) &&
            this.removable == other.isRemovable() &&
            this.records == other.getRecords() &&
            ((this.queueInfo==null && other.getQueueInfo()==null) || 
             (this.queueInfo!=null &&
              this.queueInfo.equals(other.getQueueInfo()))) &&
            ((this.successInfo==null && other.getSuccessInfo()==null) || 
             (this.successInfo!=null &&
              this.successInfo.equals(other.getSuccessInfo()))) &&
            ((this.failureInfo==null && other.getFailureInfo()==null) || 
             (this.failureInfo!=null &&
              this.failureInfo.equals(other.getFailureInfo()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getId() != null) {
            _hashCode += getId().hashCode();
        }
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getDisplayName() != null) {
            _hashCode += getDisplayName().hashCode();
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getDataSource() != null) {
            _hashCode += getDataSource().hashCode();
        }
        if (getServiceType() != null) {
            _hashCode += getServiceType().hashCode();
        }
        if (getCreatorUserid() != null) {
            _hashCode += getCreatorUserid().hashCode();
        }
        if (getCreatorUserName() != null) {
            _hashCode += getCreatorUserName().hashCode();
        }
        if (getCreatorGroup() != null) {
            _hashCode += getCreatorGroup().hashCode();
        }
        if (getRequestDate() != null) {
            _hashCode += getRequestDate().hashCode();
        }
        if (getStartDate() != null) {
            _hashCode += getStartDate().hashCode();
        }
        _hashCode += (isRemovable() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += getRecords();
        if (getQueueInfo() != null) {
            _hashCode += getQueueInfo().hashCode();
        }
        if (getSuccessInfo() != null) {
            _hashCode += getSuccessInfo().hashCode();
        }
        if (getFailureInfo() != null) {
            _hashCode += getFailureInfo().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(ReportInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("id");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Id"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("displayName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DisplayName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dataSource");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DataSource"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportDataSourceType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serviceType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ServiceType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("creatorUserid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreatorUserid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("creatorUserName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreatorUserName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("creatorGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreatorGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("requestDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RequestDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("startDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "StartDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Removable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("records");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Records"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("queueInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "QueueInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportQueueInfo"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("successInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SuccessInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportSuccessInfo"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("failureInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "FailureInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "ReportFailureInfo"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
