/**
 * RepositoryInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Information about a repository where Entrust IdentityGuard
 *                         will store data.
 */
public class RepositoryInfo  implements java.io.Serializable {
    /* The name of the repository. */
    private String name;

    /* The type of the repository. */
    private RepositoryType type;

    /* If true, it means this repository is the default
     *                                 repository used to store user information.
     * This
     *                                 is used when creating a new group
     * and no
     *                                 repositories are specifically assigned
     * to the group. */
    private boolean defaultRepository;

    /* If true, it means this repository can contain
     *                                 user information, and can be
     *                                 assigned to a group's list of repositories
     * that
     *                                 are used to store user information.
     * This flag will not always be true.  For example,
     *                                 it will be false in the case of file-based
     * repositories used to store pre-produced cards. */
    private boolean canContainUsers;

    /* If true, it means this repository is the default
     *                                 repository where policy, group, and
     * role
     *                                 definitions will be stored. */
    private boolean defaultPolicyRepository;

    /* If true, it means this repository can contain
     *                                 policy, group, and role definitions. */
    private boolean canContainPolicies;

    /* If true, it means this repository is the default
     *                                 repository used to store pre-produced
     * card
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 pre-produced cards created in that
     * group to be
     *                                 placed in. */
    private boolean defaultCardRepository;

    /* If true, it means this repository can contain
     *                                 pre-produced card information, and
     * can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store pre-produced cards. */
    private boolean canContainCards;

    /* If true, it means this repository is the default
     *                                 repository used to store unassigned
     * token
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 unassigned tokens loaded in that group
     * to be
     *                                 placed in. */
    private boolean defaultTokenRepository;

    /* If true, it means this repository can contain
     *                                 unassigned token information, and
     * can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store unassigned tokens. */
    private boolean canContainTokens;

    /* If true, it means this repository is the default
     *                                 repository used to store unassigned
     * smart credential
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 unassigned smart credentials loaded
     * in that group to be
     *                                 placed in. */
    private boolean defaultSmartCredentialRepository;

    /* If true, it means this repository can contain
     *                                 unassigned smart credential information,
     * and can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store unassigned smart credentials. */
    private boolean canContainSmartCredentials;

    /* A description of the repository. */
    private String description;

    /* If true, it means this repository is an LDAP 
     *                                 repository that contains users who
     * are not yet
     *                                 Entrust IdentityGuard users. */
    private boolean userEnrollmentEnabled;

    public RepositoryInfo() {
    }

    public RepositoryInfo(
           String name,
           RepositoryType type,
           boolean defaultRepository,
           boolean canContainUsers,
           boolean defaultPolicyRepository,
           boolean canContainPolicies,
           boolean defaultCardRepository,
           boolean canContainCards,
           boolean defaultTokenRepository,
           boolean canContainTokens,
           boolean defaultSmartCredentialRepository,
           boolean canContainSmartCredentials,
           String description,
           boolean userEnrollmentEnabled) {
           this.name = name;
           this.type = type;
           this.defaultRepository = defaultRepository;
           this.canContainUsers = canContainUsers;
           this.defaultPolicyRepository = defaultPolicyRepository;
           this.canContainPolicies = canContainPolicies;
           this.defaultCardRepository = defaultCardRepository;
           this.canContainCards = canContainCards;
           this.defaultTokenRepository = defaultTokenRepository;
           this.canContainTokens = canContainTokens;
           this.defaultSmartCredentialRepository = defaultSmartCredentialRepository;
           this.canContainSmartCredentials = canContainSmartCredentials;
           this.description = description;
           this.userEnrollmentEnabled = userEnrollmentEnabled;
    }


    /**
     * Gets the name value for this RepositoryInfo.
     * 
     * @return name   * The name of the repository.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this RepositoryInfo.
     * 
     * @param name   * The name of the repository.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the type value for this RepositoryInfo.
     * 
     * @return type   * The type of the repository.
     */
    public RepositoryType getType() {
        return type;
    }


    /**
     * Sets the type value for this RepositoryInfo.
     * 
     * @param type   * The type of the repository.
     */
    public void setType(RepositoryType type) {
        this.type = type;
    }


    /**
     * Gets the defaultRepository value for this RepositoryInfo.
     * 
     * @return defaultRepository   * If true, it means this repository is the default
     *                                 repository used to store user information.
     * This
     *                                 is used when creating a new group
     * and no
     *                                 repositories are specifically assigned
     * to the group.
     */
    public boolean isDefaultRepository() {
        return defaultRepository;
    }


    /**
     * Sets the defaultRepository value for this RepositoryInfo.
     * 
     * @param defaultRepository   * If true, it means this repository is the default
     *                                 repository used to store user information.
     * This
     *                                 is used when creating a new group
     * and no
     *                                 repositories are specifically assigned
     * to the group.
     */
    public void setDefaultRepository(boolean defaultRepository) {
        this.defaultRepository = defaultRepository;
    }


    /**
     * Gets the canContainUsers value for this RepositoryInfo.
     * 
     * @return canContainUsers   * If true, it means this repository can contain
     *                                 user information, and can be
     *                                 assigned to a group's list of repositories
     * that
     *                                 are used to store user information.
     * This flag will not always be true.  For example,
     *                                 it will be false in the case of file-based
     * repositories used to store pre-produced cards.
     */
    public boolean isCanContainUsers() {
        return canContainUsers;
    }


    /**
     * Sets the canContainUsers value for this RepositoryInfo.
     * 
     * @param canContainUsers   * If true, it means this repository can contain
     *                                 user information, and can be
     *                                 assigned to a group's list of repositories
     * that
     *                                 are used to store user information.
     * This flag will not always be true.  For example,
     *                                 it will be false in the case of file-based
     * repositories used to store pre-produced cards.
     */
    public void setCanContainUsers(boolean canContainUsers) {
        this.canContainUsers = canContainUsers;
    }


    /**
     * Gets the defaultPolicyRepository value for this RepositoryInfo.
     * 
     * @return defaultPolicyRepository   * If true, it means this repository is the default
     *                                 repository where policy, group, and
     * role
     *                                 definitions will be stored.
     */
    public boolean isDefaultPolicyRepository() {
        return defaultPolicyRepository;
    }


    /**
     * Sets the defaultPolicyRepository value for this RepositoryInfo.
     * 
     * @param defaultPolicyRepository   * If true, it means this repository is the default
     *                                 repository where policy, group, and
     * role
     *                                 definitions will be stored.
     */
    public void setDefaultPolicyRepository(boolean defaultPolicyRepository) {
        this.defaultPolicyRepository = defaultPolicyRepository;
    }


    /**
     * Gets the canContainPolicies value for this RepositoryInfo.
     * 
     * @return canContainPolicies   * If true, it means this repository can contain
     *                                 policy, group, and role definitions.
     */
    public boolean isCanContainPolicies() {
        return canContainPolicies;
    }


    /**
     * Sets the canContainPolicies value for this RepositoryInfo.
     * 
     * @param canContainPolicies   * If true, it means this repository can contain
     *                                 policy, group, and role definitions.
     */
    public void setCanContainPolicies(boolean canContainPolicies) {
        this.canContainPolicies = canContainPolicies;
    }


    /**
     * Gets the defaultCardRepository value for this RepositoryInfo.
     * 
     * @return defaultCardRepository   * If true, it means this repository is the default
     *                                 repository used to store pre-produced
     * card
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 pre-produced cards created in that
     * group to be
     *                                 placed in.
     */
    public boolean isDefaultCardRepository() {
        return defaultCardRepository;
    }


    /**
     * Sets the defaultCardRepository value for this RepositoryInfo.
     * 
     * @param defaultCardRepository   * If true, it means this repository is the default
     *                                 repository used to store pre-produced
     * card
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 pre-produced cards created in that
     * group to be
     *                                 placed in.
     */
    public void setDefaultCardRepository(boolean defaultCardRepository) {
        this.defaultCardRepository = defaultCardRepository;
    }


    /**
     * Gets the canContainCards value for this RepositoryInfo.
     * 
     * @return canContainCards   * If true, it means this repository can contain
     *                                 pre-produced card information, and
     * can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store pre-produced cards.
     */
    public boolean isCanContainCards() {
        return canContainCards;
    }


    /**
     * Sets the canContainCards value for this RepositoryInfo.
     * 
     * @param canContainCards   * If true, it means this repository can contain
     *                                 pre-produced card information, and
     * can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store pre-produced cards.
     */
    public void setCanContainCards(boolean canContainCards) {
        this.canContainCards = canContainCards;
    }


    /**
     * Gets the defaultTokenRepository value for this RepositoryInfo.
     * 
     * @return defaultTokenRepository   * If true, it means this repository is the default
     *                                 repository used to store unassigned
     * token
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 unassigned tokens loaded in that group
     * to be
     *                                 placed in.
     */
    public boolean isDefaultTokenRepository() {
        return defaultTokenRepository;
    }


    /**
     * Sets the defaultTokenRepository value for this RepositoryInfo.
     * 
     * @param defaultTokenRepository   * If true, it means this repository is the default
     *                                 repository used to store unassigned
     * token
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 unassigned tokens loaded in that group
     * to be
     *                                 placed in.
     */
    public void setDefaultTokenRepository(boolean defaultTokenRepository) {
        this.defaultTokenRepository = defaultTokenRepository;
    }


    /**
     * Gets the canContainTokens value for this RepositoryInfo.
     * 
     * @return canContainTokens   * If true, it means this repository can contain
     *                                 unassigned token information, and
     * can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store unassigned tokens.
     */
    public boolean isCanContainTokens() {
        return canContainTokens;
    }


    /**
     * Sets the canContainTokens value for this RepositoryInfo.
     * 
     * @param canContainTokens   * If true, it means this repository can contain
     *                                 unassigned token information, and
     * can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store unassigned tokens.
     */
    public void setCanContainTokens(boolean canContainTokens) {
        this.canContainTokens = canContainTokens;
    }


    /**
     * Gets the defaultSmartCredentialRepository value for this RepositoryInfo.
     * 
     * @return defaultSmartCredentialRepository   * If true, it means this repository is the default
     *                                 repository used to store unassigned
     * smart credential
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 unassigned smart credentials loaded
     * in that group to be
     *                                 placed in.
     */
    public boolean isDefaultSmartCredentialRepository() {
        return defaultSmartCredentialRepository;
    }


    /**
     * Sets the defaultSmartCredentialRepository value for this RepositoryInfo.
     * 
     * @param defaultSmartCredentialRepository   * If true, it means this repository is the default
     *                                 repository used to store unassigned
     * smart credential
     *                                 information. This is used when a group
     * does
     *                                 not specify an explicit repository
     * for
     *                                 unassigned smart credentials loaded
     * in that group to be
     *                                 placed in.
     */
    public void setDefaultSmartCredentialRepository(boolean defaultSmartCredentialRepository) {
        this.defaultSmartCredentialRepository = defaultSmartCredentialRepository;
    }


    /**
     * Gets the canContainSmartCredentials value for this RepositoryInfo.
     * 
     * @return canContainSmartCredentials   * If true, it means this repository can contain
     *                                 unassigned smart credential information,
     * and can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store unassigned smart credentials.
     */
    public boolean isCanContainSmartCredentials() {
        return canContainSmartCredentials;
    }


    /**
     * Sets the canContainSmartCredentials value for this RepositoryInfo.
     * 
     * @param canContainSmartCredentials   * If true, it means this repository can contain
     *                                 unassigned smart credential information,
     * and can be
     *                                 assigned as a group's repository in
     * which to
     *                                 store unassigned smart credentials.
     */
    public void setCanContainSmartCredentials(boolean canContainSmartCredentials) {
        this.canContainSmartCredentials = canContainSmartCredentials;
    }


    /**
     * Gets the description value for this RepositoryInfo.
     * 
     * @return description   * A description of the repository.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this RepositoryInfo.
     * 
     * @param description   * A description of the repository.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the userEnrollmentEnabled value for this RepositoryInfo.
     * 
     * @return userEnrollmentEnabled   * If true, it means this repository is an LDAP 
     *                                 repository that contains users who
     * are not yet
     *                                 Entrust IdentityGuard users.
     */
    public boolean isUserEnrollmentEnabled() {
        return userEnrollmentEnabled;
    }


    /**
     * Sets the userEnrollmentEnabled value for this RepositoryInfo.
     * 
     * @param userEnrollmentEnabled   * If true, it means this repository is an LDAP 
     *                                 repository that contains users who
     * are not yet
     *                                 Entrust IdentityGuard users.
     */
    public void setUserEnrollmentEnabled(boolean userEnrollmentEnabled) {
        this.userEnrollmentEnabled = userEnrollmentEnabled;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof RepositoryInfo)) return false;
        RepositoryInfo other = (RepositoryInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            this.defaultRepository == other.isDefaultRepository() &&
            this.canContainUsers == other.isCanContainUsers() &&
            this.defaultPolicyRepository == other.isDefaultPolicyRepository() &&
            this.canContainPolicies == other.isCanContainPolicies() &&
            this.defaultCardRepository == other.isDefaultCardRepository() &&
            this.canContainCards == other.isCanContainCards() &&
            this.defaultTokenRepository == other.isDefaultTokenRepository() &&
            this.canContainTokens == other.isCanContainTokens() &&
            this.defaultSmartCredentialRepository == other.isDefaultSmartCredentialRepository() &&
            this.canContainSmartCredentials == other.isCanContainSmartCredentials() &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            this.userEnrollmentEnabled == other.isUserEnrollmentEnabled();
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        _hashCode += (isDefaultRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isCanContainUsers() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isDefaultPolicyRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isCanContainPolicies() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isDefaultCardRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isCanContainCards() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isDefaultTokenRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isCanContainTokens() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isDefaultSmartCredentialRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isCanContainSmartCredentials() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        _hashCode += (isUserEnrollmentEnabled() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(RepositoryInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "RepositoryInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "RepositoryType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("canContainUsers");
        elemField.setXmlName(new javax.xml.namespace.QName("", "canContainUsers"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultPolicyRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultPolicyRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("canContainPolicies");
        elemField.setXmlName(new javax.xml.namespace.QName("", "canContainPolicies"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultCardRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultCardRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("canContainCards");
        elemField.setXmlName(new javax.xml.namespace.QName("", "canContainCards"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultTokenRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultTokenRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("canContainTokens");
        elemField.setXmlName(new javax.xml.namespace.QName("", "canContainTokens"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultSmartCredentialRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultSmartCredentialRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("canContainSmartCredentials");
        elemField.setXmlName(new javax.xml.namespace.QName("", "canContainSmartCredentials"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userEnrollmentEnabled");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userEnrollmentEnabled"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
