/**
 * RoleFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the filter to limit which roles are to be
 *                         returned from the roleList operation.
 */
public class RoleFilter  implements java.io.Serializable {
    /* If true, only the built-in system roles will
     *                                 be returned. If false, only roles
     * that have
     *                                 been created since the system was
     * installed will
     *                                 be returned. */
    private Boolean systemRole;

    /* If specified, provides a list of permission
     *                                 names and returns only roles where
     * one of
     *                                 these names is explicitly included
     * in the role's
     *                                 permission list. */
    private String[] permissions;

    /* If true, only roles where the permission list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the permission
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * permissions
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned. */
    private Boolean allPermissions;

    /* If specified, provides a list of policy names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * policy list. */
    private String[] policies;

    /* If true, only roles where the policy list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the policy
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * policies
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned. */
    private Boolean allPolicies;

    /* If specified, provides a list of group names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * group list. */
    private String[] groups;

    /* If true, only roles where the group list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the group
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * groups
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned. */
    private Boolean allGroups;

    /* If true, only roles where the group list
     *                                 is the special "own" list will be
     * returned. If
     *                                 false, only roles where the group
     * list
     *                                 is not the special "own" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * groups
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned. */
    private Boolean ownGroup;

    /* If specified, provides a list of role names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * role list. */
    private String[] roles;

    /* If true, only roles where the role list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the role list
     * is not the special "all" list will be returned.
     *                                 Specifying both a non-empty list for
     * roles
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned. */
    private Boolean allRoles;

    /* If specified, provides a list of Smart Credential Definition
     * names and returns only roles where one of these
     *                                 names is explicitly included in the
     * role's
     *                                 Smart Credential Definition list. */
    private String[] smartCredentialDefinitions;

    /* If true, only roles where the Smart Credential Definition
     *                                 list is the special "all" list will
     * be
     *                                 returned. If false, only roles where
     * the
     *                                 Smart Credential Definition list is
     * not the special "all"
     *                                 list will be returned.
     *                                 Specifying both a non-empty list for
     * SmartCredentialDefinitions and setting this value to true
     *                                 is invalid and will result in no roles
     * being
     *                                 returned. */
    private Boolean allSmartCredentialDefinitions;

    /* If specified, provides a list of Smart Credential Print Module
     * names and returns only roles where one of these
     *                                 names is explicitly included in the
     * role's
     *                                 Smart Credential Print Module list. */
    private String[] smartCredentialPrintModules;

    /* If true, only roles where the Smart Credential Print Module
     * list is the special "all" list will be
     *                                 returned. If false, only roles where
     * the
     *                                 Smart Credential Print Module list
     * is not the special "all"
     *                                 list will be returned.
     *                                 Specifying both a non-empty list for
     * SmartCredentialPrintModules and setting this value to true
     *                                 is invalid and will result in no roles
     * being
     *                                 returned. */
    private Boolean allSmartCredentialPrintModules;

    public RoleFilter() {
    }

    public RoleFilter(
           Boolean systemRole,
           String[] permissions,
           Boolean allPermissions,
           String[] policies,
           Boolean allPolicies,
           String[] groups,
           Boolean allGroups,
           Boolean ownGroup,
           String[] roles,
           Boolean allRoles,
           String[] smartCredentialDefinitions,
           Boolean allSmartCredentialDefinitions,
           String[] smartCredentialPrintModules,
           Boolean allSmartCredentialPrintModules) {
           this.systemRole = systemRole;
           this.permissions = permissions;
           this.allPermissions = allPermissions;
           this.policies = policies;
           this.allPolicies = allPolicies;
           this.groups = groups;
           this.allGroups = allGroups;
           this.ownGroup = ownGroup;
           this.roles = roles;
           this.allRoles = allRoles;
           this.smartCredentialDefinitions = smartCredentialDefinitions;
           this.allSmartCredentialDefinitions = allSmartCredentialDefinitions;
           this.smartCredentialPrintModules = smartCredentialPrintModules;
           this.allSmartCredentialPrintModules = allSmartCredentialPrintModules;
    }


    /**
     * Gets the systemRole value for this RoleFilter.
     * 
     * @return systemRole   * If true, only the built-in system roles will
     *                                 be returned. If false, only roles
     * that have
     *                                 been created since the system was
     * installed will
     *                                 be returned.
     */
    public Boolean getSystemRole() {
        return systemRole;
    }


    /**
     * Sets the systemRole value for this RoleFilter.
     * 
     * @param systemRole   * If true, only the built-in system roles will
     *                                 be returned. If false, only roles
     * that have
     *                                 been created since the system was
     * installed will
     *                                 be returned.
     */
    public void setSystemRole(Boolean systemRole) {
        this.systemRole = systemRole;
    }


    /**
     * Gets the permissions value for this RoleFilter.
     * 
     * @return permissions   * If specified, provides a list of permission
     *                                 names and returns only roles where
     * one of
     *                                 these names is explicitly included
     * in the role's
     *                                 permission list.
     */
    public String[] getPermissions() {
        return permissions;
    }


    /**
     * Sets the permissions value for this RoleFilter.
     * 
     * @param permissions   * If specified, provides a list of permission
     *                                 names and returns only roles where
     * one of
     *                                 these names is explicitly included
     * in the role's
     *                                 permission list.
     */
    public void setPermissions(String[] permissions) {
        this.permissions = permissions;
    }


    /**
     * Gets the allPermissions value for this RoleFilter.
     * 
     * @return allPermissions   * If true, only roles where the permission list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the permission
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * permissions
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public Boolean getAllPermissions() {
        return allPermissions;
    }


    /**
     * Sets the allPermissions value for this RoleFilter.
     * 
     * @param allPermissions   * If true, only roles where the permission list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the permission
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * permissions
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public void setAllPermissions(Boolean allPermissions) {
        this.allPermissions = allPermissions;
    }


    /**
     * Gets the policies value for this RoleFilter.
     * 
     * @return policies   * If specified, provides a list of policy names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * policy list.
     */
    public String[] getPolicies() {
        return policies;
    }


    /**
     * Sets the policies value for this RoleFilter.
     * 
     * @param policies   * If specified, provides a list of policy names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * policy list.
     */
    public void setPolicies(String[] policies) {
        this.policies = policies;
    }


    /**
     * Gets the allPolicies value for this RoleFilter.
     * 
     * @return allPolicies   * If true, only roles where the policy list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the policy
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * policies
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public Boolean getAllPolicies() {
        return allPolicies;
    }


    /**
     * Sets the allPolicies value for this RoleFilter.
     * 
     * @param allPolicies   * If true, only roles where the policy list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the policy
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * policies
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public void setAllPolicies(Boolean allPolicies) {
        this.allPolicies = allPolicies;
    }


    /**
     * Gets the groups value for this RoleFilter.
     * 
     * @return groups   * If specified, provides a list of group names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * group list.
     */
    public String[] getGroups() {
        return groups;
    }


    /**
     * Sets the groups value for this RoleFilter.
     * 
     * @param groups   * If specified, provides a list of group names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * group list.
     */
    public void setGroups(String[] groups) {
        this.groups = groups;
    }


    /**
     * Gets the allGroups value for this RoleFilter.
     * 
     * @return allGroups   * If true, only roles where the group list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the group
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * groups
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public Boolean getAllGroups() {
        return allGroups;
    }


    /**
     * Sets the allGroups value for this RoleFilter.
     * 
     * @param allGroups   * If true, only roles where the group list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the group
     * list
     *                                 is not the special "all" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * groups
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public void setAllGroups(Boolean allGroups) {
        this.allGroups = allGroups;
    }


    /**
     * Gets the ownGroup value for this RoleFilter.
     * 
     * @return ownGroup   * If true, only roles where the group list
     *                                 is the special "own" list will be
     * returned. If
     *                                 false, only roles where the group
     * list
     *                                 is not the special "own" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * groups
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public Boolean getOwnGroup() {
        return ownGroup;
    }


    /**
     * Sets the ownGroup value for this RoleFilter.
     * 
     * @param ownGroup   * If true, only roles where the group list
     *                                 is the special "own" list will be
     * returned. If
     *                                 false, only roles where the group
     * list
     *                                 is not the special "own" list will
     * be returned.
     *                                 Specifying both a non-empty list for
     * groups
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public void setOwnGroup(Boolean ownGroup) {
        this.ownGroup = ownGroup;
    }


    /**
     * Gets the roles value for this RoleFilter.
     * 
     * @return roles   * If specified, provides a list of role names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * role list.
     */
    public String[] getRoles() {
        return roles;
    }


    /**
     * Sets the roles value for this RoleFilter.
     * 
     * @param roles   * If specified, provides a list of role names and
     *                                 returns only roles where one of these
     * names is
     *                                 explicitly included in the role's
     * role list.
     */
    public void setRoles(String[] roles) {
        this.roles = roles;
    }


    /**
     * Gets the allRoles value for this RoleFilter.
     * 
     * @return allRoles   * If true, only roles where the role list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the role list
     * is not the special "all" list will be returned.
     *                                 Specifying both a non-empty list for
     * roles
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public Boolean getAllRoles() {
        return allRoles;
    }


    /**
     * Sets the allRoles value for this RoleFilter.
     * 
     * @param allRoles   * If true, only roles where the role list
     *                                 is the special "all" list will be
     * returned. If
     *                                 false, only roles where the role list
     * is not the special "all" list will be returned.
     *                                 Specifying both a non-empty list for
     * roles
     *                                 and setting this value to true is
     * invalid and will
     *                                 result in no roles being returned.
     */
    public void setAllRoles(Boolean allRoles) {
        this.allRoles = allRoles;
    }


    /**
     * Gets the smartCredentialDefinitions value for this RoleFilter.
     * 
     * @return smartCredentialDefinitions   * If specified, provides a list of Smart Credential Definition
     * names and returns only roles where one of these
     *                                 names is explicitly included in the
     * role's
     *                                 Smart Credential Definition list.
     */
    public String[] getSmartCredentialDefinitions() {
        return smartCredentialDefinitions;
    }


    /**
     * Sets the smartCredentialDefinitions value for this RoleFilter.
     * 
     * @param smartCredentialDefinitions   * If specified, provides a list of Smart Credential Definition
     * names and returns only roles where one of these
     *                                 names is explicitly included in the
     * role's
     *                                 Smart Credential Definition list.
     */
    public void setSmartCredentialDefinitions(String[] smartCredentialDefinitions) {
        this.smartCredentialDefinitions = smartCredentialDefinitions;
    }


    /**
     * Gets the allSmartCredentialDefinitions value for this RoleFilter.
     * 
     * @return allSmartCredentialDefinitions   * If true, only roles where the Smart Credential Definition
     *                                 list is the special "all" list will
     * be
     *                                 returned. If false, only roles where
     * the
     *                                 Smart Credential Definition list is
     * not the special "all"
     *                                 list will be returned.
     *                                 Specifying both a non-empty list for
     * SmartCredentialDefinitions and setting this value to true
     *                                 is invalid and will result in no roles
     * being
     *                                 returned.
     */
    public Boolean getAllSmartCredentialDefinitions() {
        return allSmartCredentialDefinitions;
    }


    /**
     * Sets the allSmartCredentialDefinitions value for this RoleFilter.
     * 
     * @param allSmartCredentialDefinitions   * If true, only roles where the Smart Credential Definition
     *                                 list is the special "all" list will
     * be
     *                                 returned. If false, only roles where
     * the
     *                                 Smart Credential Definition list is
     * not the special "all"
     *                                 list will be returned.
     *                                 Specifying both a non-empty list for
     * SmartCredentialDefinitions and setting this value to true
     *                                 is invalid and will result in no roles
     * being
     *                                 returned.
     */
    public void setAllSmartCredentialDefinitions(Boolean allSmartCredentialDefinitions) {
        this.allSmartCredentialDefinitions = allSmartCredentialDefinitions;
    }


    /**
     * Gets the smartCredentialPrintModules value for this RoleFilter.
     * 
     * @return smartCredentialPrintModules   * If specified, provides a list of Smart Credential Print Module
     * names and returns only roles where one of these
     *                                 names is explicitly included in the
     * role's
     *                                 Smart Credential Print Module list.
     */
    public String[] getSmartCredentialPrintModules() {
        return smartCredentialPrintModules;
    }


    /**
     * Sets the smartCredentialPrintModules value for this RoleFilter.
     * 
     * @param smartCredentialPrintModules   * If specified, provides a list of Smart Credential Print Module
     * names and returns only roles where one of these
     *                                 names is explicitly included in the
     * role's
     *                                 Smart Credential Print Module list.
     */
    public void setSmartCredentialPrintModules(String[] smartCredentialPrintModules) {
        this.smartCredentialPrintModules = smartCredentialPrintModules;
    }


    /**
     * Gets the allSmartCredentialPrintModules value for this RoleFilter.
     * 
     * @return allSmartCredentialPrintModules   * If true, only roles where the Smart Credential Print Module
     * list is the special "all" list will be
     *                                 returned. If false, only roles where
     * the
     *                                 Smart Credential Print Module list
     * is not the special "all"
     *                                 list will be returned.
     *                                 Specifying both a non-empty list for
     * SmartCredentialPrintModules and setting this value to true
     *                                 is invalid and will result in no roles
     * being
     *                                 returned.
     */
    public Boolean getAllSmartCredentialPrintModules() {
        return allSmartCredentialPrintModules;
    }


    /**
     * Sets the allSmartCredentialPrintModules value for this RoleFilter.
     * 
     * @param allSmartCredentialPrintModules   * If true, only roles where the Smart Credential Print Module
     * list is the special "all" list will be
     *                                 returned. If false, only roles where
     * the
     *                                 Smart Credential Print Module list
     * is not the special "all"
     *                                 list will be returned.
     *                                 Specifying both a non-empty list for
     * SmartCredentialPrintModules and setting this value to true
     *                                 is invalid and will result in no roles
     * being
     *                                 returned.
     */
    public void setAllSmartCredentialPrintModules(Boolean allSmartCredentialPrintModules) {
        this.allSmartCredentialPrintModules = allSmartCredentialPrintModules;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof RoleFilter)) return false;
        RoleFilter other = (RoleFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.systemRole==null && other.getSystemRole()==null) || 
             (this.systemRole!=null &&
              this.systemRole.equals(other.getSystemRole()))) &&
            ((this.permissions==null && other.getPermissions()==null) || 
             (this.permissions!=null &&
              java.util.Arrays.equals(this.permissions, other.getPermissions()))) &&
            ((this.allPermissions==null && other.getAllPermissions()==null) || 
             (this.allPermissions!=null &&
              this.allPermissions.equals(other.getAllPermissions()))) &&
            ((this.policies==null && other.getPolicies()==null) || 
             (this.policies!=null &&
              java.util.Arrays.equals(this.policies, other.getPolicies()))) &&
            ((this.allPolicies==null && other.getAllPolicies()==null) || 
             (this.allPolicies!=null &&
              this.allPolicies.equals(other.getAllPolicies()))) &&
            ((this.groups==null && other.getGroups()==null) || 
             (this.groups!=null &&
              java.util.Arrays.equals(this.groups, other.getGroups()))) &&
            ((this.allGroups==null && other.getAllGroups()==null) || 
             (this.allGroups!=null &&
              this.allGroups.equals(other.getAllGroups()))) &&
            ((this.ownGroup==null && other.getOwnGroup()==null) || 
             (this.ownGroup!=null &&
              this.ownGroup.equals(other.getOwnGroup()))) &&
            ((this.roles==null && other.getRoles()==null) || 
             (this.roles!=null &&
              java.util.Arrays.equals(this.roles, other.getRoles()))) &&
            ((this.allRoles==null && other.getAllRoles()==null) || 
             (this.allRoles!=null &&
              this.allRoles.equals(other.getAllRoles()))) &&
            ((this.smartCredentialDefinitions==null && other.getSmartCredentialDefinitions()==null) || 
             (this.smartCredentialDefinitions!=null &&
              java.util.Arrays.equals(this.smartCredentialDefinitions, other.getSmartCredentialDefinitions()))) &&
            ((this.allSmartCredentialDefinitions==null && other.getAllSmartCredentialDefinitions()==null) || 
             (this.allSmartCredentialDefinitions!=null &&
              this.allSmartCredentialDefinitions.equals(other.getAllSmartCredentialDefinitions()))) &&
            ((this.smartCredentialPrintModules==null && other.getSmartCredentialPrintModules()==null) || 
             (this.smartCredentialPrintModules!=null &&
              java.util.Arrays.equals(this.smartCredentialPrintModules, other.getSmartCredentialPrintModules()))) &&
            ((this.allSmartCredentialPrintModules==null && other.getAllSmartCredentialPrintModules()==null) || 
             (this.allSmartCredentialPrintModules!=null &&
              this.allSmartCredentialPrintModules.equals(other.getAllSmartCredentialPrintModules())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getSystemRole() != null) {
            _hashCode += getSystemRole().hashCode();
        }
        if (getPermissions() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPermissions());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPermissions(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllPermissions() != null) {
            _hashCode += getAllPermissions().hashCode();
        }
        if (getPolicies() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPolicies());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPolicies(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllPolicies() != null) {
            _hashCode += getAllPolicies().hashCode();
        }
        if (getGroups() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroups());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroups(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllGroups() != null) {
            _hashCode += getAllGroups().hashCode();
        }
        if (getOwnGroup() != null) {
            _hashCode += getOwnGroup().hashCode();
        }
        if (getRoles() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRoles());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRoles(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllRoles() != null) {
            _hashCode += getAllRoles().hashCode();
        }
        if (getSmartCredentialDefinitions() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSmartCredentialDefinitions());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSmartCredentialDefinitions(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllSmartCredentialDefinitions() != null) {
            _hashCode += getAllSmartCredentialDefinitions().hashCode();
        }
        if (getSmartCredentialPrintModules() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSmartCredentialPrintModules());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSmartCredentialPrintModules(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllSmartCredentialPrintModules() != null) {
            _hashCode += getAllSmartCredentialPrintModules().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(RoleFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "RoleFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("systemRole");
        elemField.setXmlName(new javax.xml.namespace.QName("", "systemRole"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("permissions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "permissions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allPermissions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allPermissions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("policies");
        elemField.setXmlName(new javax.xml.namespace.QName("", "policies"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allPolicies");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allPolicies"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allGroups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allGroups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("ownGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ownGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("roles");
        elemField.setXmlName(new javax.xml.namespace.QName("", "roles"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allRoles");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allRoles"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialDefinitions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SmartCredentialDefinitions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allSmartCredentialDefinitions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allSmartCredentialDefinitions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialPrintModules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SmartCredentialPrintModules"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allSmartCredentialPrintModules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allSmartCredentialPrintModules"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
