/**
 * RoleParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a role when creating or
 *                         modifying a role.
 */
public class RoleParms  implements java.io.Serializable {
    /* When specified in a call to roleSet, this is
     *                                 the new name for the role. It is ignored
     * if
     *                                 specified in a call to roleCreate. */
    private String name;

    /* If true, it means this role grants all permissions. */
    private Boolean allPermissions;

    /* The list of the names of the permissions that
     *                                 this role grants. If allPermissions
     * is true,
     *                                 this list must be empty or nil. */
    private String[] permissions;

    /* If true, it means this role grants access to
     *                                 all policies. */
    private Boolean allPolicies;

    /* The list of the names of policies that this role
     *                                 grants access to. If allPolicies is
     * true,
     *                                 this list must be empty or nil. */
    private String[] policyList;

    /* If true, it means this role grants access to
     *                                 all groups. */
    private Boolean allGroups;

    /* If true, when assigned to an administrator,
     *                                 this role grants access to users who
     * belong to
     *                                 the same group as the administrator.
     * At most one
     *                                 of allGroups and ownGroup can be true. */
    private Boolean ownGroup;

    /* The list of the names of the groups that this role grants access
     * to. If either allGroups or ownGroup is true, this
     *                                 list must be empty or nil. */
    private String[] groupList;

    /* If true, it means this role grants access to
     *                                 all roles. */
    private Boolean allRoles;

    /* The list of the names of the roles that this role grants access
     * to. If allRoles is true, this list must be empty or nil. */
    private String[] roleList;

    /* If true, it means this role grants access to
     *                                 all Smart Credential Definitions. */
    private Boolean allSmartCredentialDefinitions;

    /* The list of the names of Smart Credential Definitions that
     *                                 this role grants access to. If
     *                                 allSmartCredentialDefinitions is true,
     * this list must be empty or nil. */
    private String[] smartCredentialDefinitionList;

    /* If true, it means this role grants access to
     *                                 all Smart Credential Print Modules. */
    private Boolean allSmartCredentialPrintModules;

    /* The list of the names of Smart Credential Print Modules that
     * this role grants access to. If
     *                                 allSmartCredentialPrintModules is
     * true,
     *                                 this list must be empty or nil. */
    private String[] smartCredentialPrintModuleList;

    /* If the skipSecondAuth flag is set to true
     *                                 for a role, administrators in this
     * role
     *                                 will skip second factor authentication
     * when
     *                                 logging into the Entrust IdentityGuard
     * Administration Interface or Service even
     *                                 when policy dictates that second factor
     * authentication is required.
     *                                 This flag should be set to true for
     * administration identities that require
     *                                 unattended login such as those used
     * for
     *                                 services. */
    private Boolean skipSecondAuth;

    /* Descriptive comments about this role, that could
     *                                 be used to provide a full description
     * of this
     *                                 role's intended purpose. */
    private String comment;

    public RoleParms() {
    }

    public RoleParms(
           String name,
           Boolean allPermissions,
           String[] permissions,
           Boolean allPolicies,
           String[] policyList,
           Boolean allGroups,
           Boolean ownGroup,
           String[] groupList,
           Boolean allRoles,
           String[] roleList,
           Boolean allSmartCredentialDefinitions,
           String[] smartCredentialDefinitionList,
           Boolean allSmartCredentialPrintModules,
           String[] smartCredentialPrintModuleList,
           Boolean skipSecondAuth,
           String comment) {
           this.name = name;
           this.allPermissions = allPermissions;
           this.permissions = permissions;
           this.allPolicies = allPolicies;
           this.policyList = policyList;
           this.allGroups = allGroups;
           this.ownGroup = ownGroup;
           this.groupList = groupList;
           this.allRoles = allRoles;
           this.roleList = roleList;
           this.allSmartCredentialDefinitions = allSmartCredentialDefinitions;
           this.smartCredentialDefinitionList = smartCredentialDefinitionList;
           this.allSmartCredentialPrintModules = allSmartCredentialPrintModules;
           this.smartCredentialPrintModuleList = smartCredentialPrintModuleList;
           this.skipSecondAuth = skipSecondAuth;
           this.comment = comment;
    }


    /**
     * Gets the name value for this RoleParms.
     * 
     * @return name   * When specified in a call to roleSet, this is
     *                                 the new name for the role. It is ignored
     * if
     *                                 specified in a call to roleCreate.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this RoleParms.
     * 
     * @param name   * When specified in a call to roleSet, this is
     *                                 the new name for the role. It is ignored
     * if
     *                                 specified in a call to roleCreate.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the allPermissions value for this RoleParms.
     * 
     * @return allPermissions   * If true, it means this role grants all permissions.
     */
    public Boolean getAllPermissions() {
        return allPermissions;
    }


    /**
     * Sets the allPermissions value for this RoleParms.
     * 
     * @param allPermissions   * If true, it means this role grants all permissions.
     */
    public void setAllPermissions(Boolean allPermissions) {
        this.allPermissions = allPermissions;
    }


    /**
     * Gets the permissions value for this RoleParms.
     * 
     * @return permissions   * The list of the names of the permissions that
     *                                 this role grants. If allPermissions
     * is true,
     *                                 this list must be empty or nil.
     */
    public String[] getPermissions() {
        return permissions;
    }


    /**
     * Sets the permissions value for this RoleParms.
     * 
     * @param permissions   * The list of the names of the permissions that
     *                                 this role grants. If allPermissions
     * is true,
     *                                 this list must be empty or nil.
     */
    public void setPermissions(String[] permissions) {
        this.permissions = permissions;
    }


    /**
     * Gets the allPolicies value for this RoleParms.
     * 
     * @return allPolicies   * If true, it means this role grants access to
     *                                 all policies.
     */
    public Boolean getAllPolicies() {
        return allPolicies;
    }


    /**
     * Sets the allPolicies value for this RoleParms.
     * 
     * @param allPolicies   * If true, it means this role grants access to
     *                                 all policies.
     */
    public void setAllPolicies(Boolean allPolicies) {
        this.allPolicies = allPolicies;
    }


    /**
     * Gets the policyList value for this RoleParms.
     * 
     * @return policyList   * The list of the names of policies that this role
     *                                 grants access to. If allPolicies is
     * true,
     *                                 this list must be empty or nil.
     */
    public String[] getPolicyList() {
        return policyList;
    }


    /**
     * Sets the policyList value for this RoleParms.
     * 
     * @param policyList   * The list of the names of policies that this role
     *                                 grants access to. If allPolicies is
     * true,
     *                                 this list must be empty or nil.
     */
    public void setPolicyList(String[] policyList) {
        this.policyList = policyList;
    }


    /**
     * Gets the allGroups value for this RoleParms.
     * 
     * @return allGroups   * If true, it means this role grants access to
     *                                 all groups.
     */
    public Boolean getAllGroups() {
        return allGroups;
    }


    /**
     * Sets the allGroups value for this RoleParms.
     * 
     * @param allGroups   * If true, it means this role grants access to
     *                                 all groups.
     */
    public void setAllGroups(Boolean allGroups) {
        this.allGroups = allGroups;
    }


    /**
     * Gets the ownGroup value for this RoleParms.
     * 
     * @return ownGroup   * If true, when assigned to an administrator,
     *                                 this role grants access to users who
     * belong to
     *                                 the same group as the administrator.
     * At most one
     *                                 of allGroups and ownGroup can be true.
     */
    public Boolean getOwnGroup() {
        return ownGroup;
    }


    /**
     * Sets the ownGroup value for this RoleParms.
     * 
     * @param ownGroup   * If true, when assigned to an administrator,
     *                                 this role grants access to users who
     * belong to
     *                                 the same group as the administrator.
     * At most one
     *                                 of allGroups and ownGroup can be true.
     */
    public void setOwnGroup(Boolean ownGroup) {
        this.ownGroup = ownGroup;
    }


    /**
     * Gets the groupList value for this RoleParms.
     * 
     * @return groupList   * The list of the names of the groups that this role grants access
     * to. If either allGroups or ownGroup is true, this
     *                                 list must be empty or nil.
     */
    public String[] getGroupList() {
        return groupList;
    }


    /**
     * Sets the groupList value for this RoleParms.
     * 
     * @param groupList   * The list of the names of the groups that this role grants access
     * to. If either allGroups or ownGroup is true, this
     *                                 list must be empty or nil.
     */
    public void setGroupList(String[] groupList) {
        this.groupList = groupList;
    }


    /**
     * Gets the allRoles value for this RoleParms.
     * 
     * @return allRoles   * If true, it means this role grants access to
     *                                 all roles.
     */
    public Boolean getAllRoles() {
        return allRoles;
    }


    /**
     * Sets the allRoles value for this RoleParms.
     * 
     * @param allRoles   * If true, it means this role grants access to
     *                                 all roles.
     */
    public void setAllRoles(Boolean allRoles) {
        this.allRoles = allRoles;
    }


    /**
     * Gets the roleList value for this RoleParms.
     * 
     * @return roleList   * The list of the names of the roles that this role grants access
     * to. If allRoles is true, this list must be empty or nil.
     */
    public String[] getRoleList() {
        return roleList;
    }


    /**
     * Sets the roleList value for this RoleParms.
     * 
     * @param roleList   * The list of the names of the roles that this role grants access
     * to. If allRoles is true, this list must be empty or nil.
     */
    public void setRoleList(String[] roleList) {
        this.roleList = roleList;
    }


    /**
     * Gets the allSmartCredentialDefinitions value for this RoleParms.
     * 
     * @return allSmartCredentialDefinitions   * If true, it means this role grants access to
     *                                 all Smart Credential Definitions.
     */
    public Boolean getAllSmartCredentialDefinitions() {
        return allSmartCredentialDefinitions;
    }


    /**
     * Sets the allSmartCredentialDefinitions value for this RoleParms.
     * 
     * @param allSmartCredentialDefinitions   * If true, it means this role grants access to
     *                                 all Smart Credential Definitions.
     */
    public void setAllSmartCredentialDefinitions(Boolean allSmartCredentialDefinitions) {
        this.allSmartCredentialDefinitions = allSmartCredentialDefinitions;
    }


    /**
     * Gets the smartCredentialDefinitionList value for this RoleParms.
     * 
     * @return smartCredentialDefinitionList   * The list of the names of Smart Credential Definitions that
     *                                 this role grants access to. If
     *                                 allSmartCredentialDefinitions is true,
     * this list must be empty or nil.
     */
    public String[] getSmartCredentialDefinitionList() {
        return smartCredentialDefinitionList;
    }


    /**
     * Sets the smartCredentialDefinitionList value for this RoleParms.
     * 
     * @param smartCredentialDefinitionList   * The list of the names of Smart Credential Definitions that
     *                                 this role grants access to. If
     *                                 allSmartCredentialDefinitions is true,
     * this list must be empty or nil.
     */
    public void setSmartCredentialDefinitionList(String[] smartCredentialDefinitionList) {
        this.smartCredentialDefinitionList = smartCredentialDefinitionList;
    }


    /**
     * Gets the allSmartCredentialPrintModules value for this RoleParms.
     * 
     * @return allSmartCredentialPrintModules   * If true, it means this role grants access to
     *                                 all Smart Credential Print Modules.
     */
    public Boolean getAllSmartCredentialPrintModules() {
        return allSmartCredentialPrintModules;
    }


    /**
     * Sets the allSmartCredentialPrintModules value for this RoleParms.
     * 
     * @param allSmartCredentialPrintModules   * If true, it means this role grants access to
     *                                 all Smart Credential Print Modules.
     */
    public void setAllSmartCredentialPrintModules(Boolean allSmartCredentialPrintModules) {
        this.allSmartCredentialPrintModules = allSmartCredentialPrintModules;
    }


    /**
     * Gets the smartCredentialPrintModuleList value for this RoleParms.
     * 
     * @return smartCredentialPrintModuleList   * The list of the names of Smart Credential Print Modules that
     * this role grants access to. If
     *                                 allSmartCredentialPrintModules is
     * true,
     *                                 this list must be empty or nil.
     */
    public String[] getSmartCredentialPrintModuleList() {
        return smartCredentialPrintModuleList;
    }


    /**
     * Sets the smartCredentialPrintModuleList value for this RoleParms.
     * 
     * @param smartCredentialPrintModuleList   * The list of the names of Smart Credential Print Modules that
     * this role grants access to. If
     *                                 allSmartCredentialPrintModules is
     * true,
     *                                 this list must be empty or nil.
     */
    public void setSmartCredentialPrintModuleList(String[] smartCredentialPrintModuleList) {
        this.smartCredentialPrintModuleList = smartCredentialPrintModuleList;
    }


    /**
     * Gets the skipSecondAuth value for this RoleParms.
     * 
     * @return skipSecondAuth   * If the skipSecondAuth flag is set to true
     *                                 for a role, administrators in this
     * role
     *                                 will skip second factor authentication
     * when
     *                                 logging into the Entrust IdentityGuard
     * Administration Interface or Service even
     *                                 when policy dictates that second factor
     * authentication is required.
     *                                 This flag should be set to true for
     * administration identities that require
     *                                 unattended login such as those used
     * for
     *                                 services.
     */
    public Boolean getSkipSecondAuth() {
        return skipSecondAuth;
    }


    /**
     * Sets the skipSecondAuth value for this RoleParms.
     * 
     * @param skipSecondAuth   * If the skipSecondAuth flag is set to true
     *                                 for a role, administrators in this
     * role
     *                                 will skip second factor authentication
     * when
     *                                 logging into the Entrust IdentityGuard
     * Administration Interface or Service even
     *                                 when policy dictates that second factor
     * authentication is required.
     *                                 This flag should be set to true for
     * administration identities that require
     *                                 unattended login such as those used
     * for
     *                                 services.
     */
    public void setSkipSecondAuth(Boolean skipSecondAuth) {
        this.skipSecondAuth = skipSecondAuth;
    }


    /**
     * Gets the comment value for this RoleParms.
     * 
     * @return comment   * Descriptive comments about this role, that could
     *                                 be used to provide a full description
     * of this
     *                                 role's intended purpose.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this RoleParms.
     * 
     * @param comment   * Descriptive comments about this role, that could
     *                                 be used to provide a full description
     * of this
     *                                 role's intended purpose.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof RoleParms)) return false;
        RoleParms other = (RoleParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.allPermissions==null && other.getAllPermissions()==null) || 
             (this.allPermissions!=null &&
              this.allPermissions.equals(other.getAllPermissions()))) &&
            ((this.permissions==null && other.getPermissions()==null) || 
             (this.permissions!=null &&
              java.util.Arrays.equals(this.permissions, other.getPermissions()))) &&
            ((this.allPolicies==null && other.getAllPolicies()==null) || 
             (this.allPolicies!=null &&
              this.allPolicies.equals(other.getAllPolicies()))) &&
            ((this.policyList==null && other.getPolicyList()==null) || 
             (this.policyList!=null &&
              java.util.Arrays.equals(this.policyList, other.getPolicyList()))) &&
            ((this.allGroups==null && other.getAllGroups()==null) || 
             (this.allGroups!=null &&
              this.allGroups.equals(other.getAllGroups()))) &&
            ((this.ownGroup==null && other.getOwnGroup()==null) || 
             (this.ownGroup!=null &&
              this.ownGroup.equals(other.getOwnGroup()))) &&
            ((this.groupList==null && other.getGroupList()==null) || 
             (this.groupList!=null &&
              java.util.Arrays.equals(this.groupList, other.getGroupList()))) &&
            ((this.allRoles==null && other.getAllRoles()==null) || 
             (this.allRoles!=null &&
              this.allRoles.equals(other.getAllRoles()))) &&
            ((this.roleList==null && other.getRoleList()==null) || 
             (this.roleList!=null &&
              java.util.Arrays.equals(this.roleList, other.getRoleList()))) &&
            ((this.allSmartCredentialDefinitions==null && other.getAllSmartCredentialDefinitions()==null) || 
             (this.allSmartCredentialDefinitions!=null &&
              this.allSmartCredentialDefinitions.equals(other.getAllSmartCredentialDefinitions()))) &&
            ((this.smartCredentialDefinitionList==null && other.getSmartCredentialDefinitionList()==null) || 
             (this.smartCredentialDefinitionList!=null &&
              java.util.Arrays.equals(this.smartCredentialDefinitionList, other.getSmartCredentialDefinitionList()))) &&
            ((this.allSmartCredentialPrintModules==null && other.getAllSmartCredentialPrintModules()==null) || 
             (this.allSmartCredentialPrintModules!=null &&
              this.allSmartCredentialPrintModules.equals(other.getAllSmartCredentialPrintModules()))) &&
            ((this.smartCredentialPrintModuleList==null && other.getSmartCredentialPrintModuleList()==null) || 
             (this.smartCredentialPrintModuleList!=null &&
              java.util.Arrays.equals(this.smartCredentialPrintModuleList, other.getSmartCredentialPrintModuleList()))) &&
            ((this.skipSecondAuth==null && other.getSkipSecondAuth()==null) || 
             (this.skipSecondAuth!=null &&
              this.skipSecondAuth.equals(other.getSkipSecondAuth()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getAllPermissions() != null) {
            _hashCode += getAllPermissions().hashCode();
        }
        if (getPermissions() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPermissions());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPermissions(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllPolicies() != null) {
            _hashCode += getAllPolicies().hashCode();
        }
        if (getPolicyList() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPolicyList());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPolicyList(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllGroups() != null) {
            _hashCode += getAllGroups().hashCode();
        }
        if (getOwnGroup() != null) {
            _hashCode += getOwnGroup().hashCode();
        }
        if (getGroupList() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroupList());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroupList(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllRoles() != null) {
            _hashCode += getAllRoles().hashCode();
        }
        if (getRoleList() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRoleList());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRoleList(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllSmartCredentialDefinitions() != null) {
            _hashCode += getAllSmartCredentialDefinitions().hashCode();
        }
        if (getSmartCredentialDefinitionList() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSmartCredentialDefinitionList());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSmartCredentialDefinitionList(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllSmartCredentialPrintModules() != null) {
            _hashCode += getAllSmartCredentialPrintModules().hashCode();
        }
        if (getSmartCredentialPrintModuleList() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSmartCredentialPrintModuleList());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSmartCredentialPrintModuleList(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getSkipSecondAuth() != null) {
            _hashCode += getSkipSecondAuth().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(RoleParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "RoleParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allPermissions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allPermissions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("permissions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "permissions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allPolicies");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allPolicies"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("policyList");
        elemField.setXmlName(new javax.xml.namespace.QName("", "policyList"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allGroups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allGroups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("ownGroup");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ownGroup"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groupList");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groupList"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allRoles");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allRoles"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("roleList");
        elemField.setXmlName(new javax.xml.namespace.QName("", "roleList"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allSmartCredentialDefinitions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allSmartCredentialDefinitions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialDefinitionList");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SmartCredentialDefinitionList"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allSmartCredentialPrintModules");
        elemField.setXmlName(new javax.xml.namespace.QName("", "allSmartCredentialPrintModules"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("smartCredentialPrintModuleList");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SmartCredentialPrintModuleList"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("skipSecondAuth");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SkipSecondAuth"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
