/**
 * SmartCredentialAppletParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the paramaters that can be set when
 *                         creating or modifying a Smart Credential Applet.
 */
public class SmartCredentialAppletParms  implements java.io.Serializable {
    /* When passed in a call to
     *                                 smartCredentialAppletSet, this
     *                                 specifies a new name for the Smart
     * Credential
     *                                 applet.  If this is included in a
     * call to
     *                                 smartCredentialAppletCreate it is
     * ignored. */
    private String name;

    /* The type of the smart credential applet.
     *                                 This value is required for calls to
     * smartCredentialAppletCreate. */
    private String type;

    /* The binary data that defines this applet. */
    private byte[] data;

    /* The master key used for DESFIRE applets.
     *                                 This value must be specified for type
     * DESFIRE and must not be specified for other
     *                                 types. */
    private byte[] masterKey;

    /* The optional password used to access the master
     *                                 key.  This value can only be specified
     * if a
     *                                 master key is specified.  Specify
     * an empty
     *                                 string to remove the current value. */
    private String masterKeyPassword;

    /* The optional type used to describe the master
     *                                 key.  This value can only be specified
     * if a
     *                                 master key is specified.  Specify
     * an empty
     *                                 string to remove the current value. */
    private String masterKeyType;

    /* If set to true, the values specified in 
     *                                 configSettings are added to the existing
     * value.  Otherwise the existing values are
     *                                 replaced.  This property is ignored
     * for
     *                                 the userSmartCredentialAppletCreate
     * operation. */
    private Boolean addConfigSettings;

    /* Configuration settings for this applet. */
    private NameValue[] configSettings;

    /* If specified, this value specifies a list
     *                                 of config setting values to be removed.
     * This setting is ignored for the
     *                                 userSmartCredentialAppletCreate operation. */
    private String[] removeConfigSettings;

    /* If set to true, the values specified in 
     *                                 fileSettings are added to the existing
     * value.  Otherwise the existing values are
     *                                 replaced.  This property is ignored
     * for
     *                                 the userSmartCredentialAppletCreate
     * operaiton. */
    private Boolean addFileSettings;

    /* File settings for this applet. */
    private FileSetting[] fileSettings;

    /* If specified, this value specifies a list
     *                                 of file setting values to be removed.
     * This setting is ignored for the
     *                                 userSmartCredentialAppletCreate operation. */
    private String[] removeFileSettings;

    /* Optional description. */
    private String description;

    public SmartCredentialAppletParms() {
    }

    public SmartCredentialAppletParms(
           String name,
           String type,
           byte[] data,
           byte[] masterKey,
           String masterKeyPassword,
           String masterKeyType,
           Boolean addConfigSettings,
           NameValue[] configSettings,
           String[] removeConfigSettings,
           Boolean addFileSettings,
           FileSetting[] fileSettings,
           String[] removeFileSettings,
           String description) {
           this.name = name;
           this.type = type;
           this.data = data;
           this.masterKey = masterKey;
           this.masterKeyPassword = masterKeyPassword;
           this.masterKeyType = masterKeyType;
           this.addConfigSettings = addConfigSettings;
           this.configSettings = configSettings;
           this.removeConfigSettings = removeConfigSettings;
           this.addFileSettings = addFileSettings;
           this.fileSettings = fileSettings;
           this.removeFileSettings = removeFileSettings;
           this.description = description;
    }


    /**
     * Gets the name value for this SmartCredentialAppletParms.
     * 
     * @return name   * When passed in a call to
     *                                 smartCredentialAppletSet, this
     *                                 specifies a new name for the Smart
     * Credential
     *                                 applet.  If this is included in a
     * call to
     *                                 smartCredentialAppletCreate it is
     * ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialAppletParms.
     * 
     * @param name   * When passed in a call to
     *                                 smartCredentialAppletSet, this
     *                                 specifies a new name for the Smart
     * Credential
     *                                 applet.  If this is included in a
     * call to
     *                                 smartCredentialAppletCreate it is
     * ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the type value for this SmartCredentialAppletParms.
     * 
     * @return type   * The type of the smart credential applet.
     *                                 This value is required for calls to
     * smartCredentialAppletCreate.
     */
    public String getType() {
        return type;
    }


    /**
     * Sets the type value for this SmartCredentialAppletParms.
     * 
     * @param type   * The type of the smart credential applet.
     *                                 This value is required for calls to
     * smartCredentialAppletCreate.
     */
    public void setType(String type) {
        this.type = type;
    }


    /**
     * Gets the data value for this SmartCredentialAppletParms.
     * 
     * @return data   * The binary data that defines this applet.
     */
    public byte[] getData() {
        return data;
    }


    /**
     * Sets the data value for this SmartCredentialAppletParms.
     * 
     * @param data   * The binary data that defines this applet.
     */
    public void setData(byte[] data) {
        this.data = data;
    }


    /**
     * Gets the masterKey value for this SmartCredentialAppletParms.
     * 
     * @return masterKey   * The master key used for DESFIRE applets.
     *                                 This value must be specified for type
     * DESFIRE and must not be specified for other
     *                                 types.
     */
    public byte[] getMasterKey() {
        return masterKey;
    }


    /**
     * Sets the masterKey value for this SmartCredentialAppletParms.
     * 
     * @param masterKey   * The master key used for DESFIRE applets.
     *                                 This value must be specified for type
     * DESFIRE and must not be specified for other
     *                                 types.
     */
    public void setMasterKey(byte[] masterKey) {
        this.masterKey = masterKey;
    }


    /**
     * Gets the masterKeyPassword value for this SmartCredentialAppletParms.
     * 
     * @return masterKeyPassword   * The optional password used to access the master
     *                                 key.  This value can only be specified
     * if a
     *                                 master key is specified.  Specify
     * an empty
     *                                 string to remove the current value.
     */
    public String getMasterKeyPassword() {
        return masterKeyPassword;
    }


    /**
     * Sets the masterKeyPassword value for this SmartCredentialAppletParms.
     * 
     * @param masterKeyPassword   * The optional password used to access the master
     *                                 key.  This value can only be specified
     * if a
     *                                 master key is specified.  Specify
     * an empty
     *                                 string to remove the current value.
     */
    public void setMasterKeyPassword(String masterKeyPassword) {
        this.masterKeyPassword = masterKeyPassword;
    }


    /**
     * Gets the masterKeyType value for this SmartCredentialAppletParms.
     * 
     * @return masterKeyType   * The optional type used to describe the master
     *                                 key.  This value can only be specified
     * if a
     *                                 master key is specified.  Specify
     * an empty
     *                                 string to remove the current value.
     */
    public String getMasterKeyType() {
        return masterKeyType;
    }


    /**
     * Sets the masterKeyType value for this SmartCredentialAppletParms.
     * 
     * @param masterKeyType   * The optional type used to describe the master
     *                                 key.  This value can only be specified
     * if a
     *                                 master key is specified.  Specify
     * an empty
     *                                 string to remove the current value.
     */
    public void setMasterKeyType(String masterKeyType) {
        this.masterKeyType = masterKeyType;
    }


    /**
     * Gets the addConfigSettings value for this SmartCredentialAppletParms.
     * 
     * @return addConfigSettings   * If set to true, the values specified in 
     *                                 configSettings are added to the existing
     * value.  Otherwise the existing values are
     *                                 replaced.  This property is ignored
     * for
     *                                 the userSmartCredentialAppletCreate
     * operation.
     */
    public Boolean getAddConfigSettings() {
        return addConfigSettings;
    }


    /**
     * Sets the addConfigSettings value for this SmartCredentialAppletParms.
     * 
     * @param addConfigSettings   * If set to true, the values specified in 
     *                                 configSettings are added to the existing
     * value.  Otherwise the existing values are
     *                                 replaced.  This property is ignored
     * for
     *                                 the userSmartCredentialAppletCreate
     * operation.
     */
    public void setAddConfigSettings(Boolean addConfigSettings) {
        this.addConfigSettings = addConfigSettings;
    }


    /**
     * Gets the configSettings value for this SmartCredentialAppletParms.
     * 
     * @return configSettings   * Configuration settings for this applet.
     */
    public NameValue[] getConfigSettings() {
        return configSettings;
    }


    /**
     * Sets the configSettings value for this SmartCredentialAppletParms.
     * 
     * @param configSettings   * Configuration settings for this applet.
     */
    public void setConfigSettings(NameValue[] configSettings) {
        this.configSettings = configSettings;
    }


    /**
     * Gets the removeConfigSettings value for this SmartCredentialAppletParms.
     * 
     * @return removeConfigSettings   * If specified, this value specifies a list
     *                                 of config setting values to be removed.
     * This setting is ignored for the
     *                                 userSmartCredentialAppletCreate operation.
     */
    public String[] getRemoveConfigSettings() {
        return removeConfigSettings;
    }


    /**
     * Sets the removeConfigSettings value for this SmartCredentialAppletParms.
     * 
     * @param removeConfigSettings   * If specified, this value specifies a list
     *                                 of config setting values to be removed.
     * This setting is ignored for the
     *                                 userSmartCredentialAppletCreate operation.
     */
    public void setRemoveConfigSettings(String[] removeConfigSettings) {
        this.removeConfigSettings = removeConfigSettings;
    }


    /**
     * Gets the addFileSettings value for this SmartCredentialAppletParms.
     * 
     * @return addFileSettings   * If set to true, the values specified in 
     *                                 fileSettings are added to the existing
     * value.  Otherwise the existing values are
     *                                 replaced.  This property is ignored
     * for
     *                                 the userSmartCredentialAppletCreate
     * operaiton.
     */
    public Boolean getAddFileSettings() {
        return addFileSettings;
    }


    /**
     * Sets the addFileSettings value for this SmartCredentialAppletParms.
     * 
     * @param addFileSettings   * If set to true, the values specified in 
     *                                 fileSettings are added to the existing
     * value.  Otherwise the existing values are
     *                                 replaced.  This property is ignored
     * for
     *                                 the userSmartCredentialAppletCreate
     * operaiton.
     */
    public void setAddFileSettings(Boolean addFileSettings) {
        this.addFileSettings = addFileSettings;
    }


    /**
     * Gets the fileSettings value for this SmartCredentialAppletParms.
     * 
     * @return fileSettings   * File settings for this applet.
     */
    public FileSetting[] getFileSettings() {
        return fileSettings;
    }


    /**
     * Sets the fileSettings value for this SmartCredentialAppletParms.
     * 
     * @param fileSettings   * File settings for this applet.
     */
    public void setFileSettings(FileSetting[] fileSettings) {
        this.fileSettings = fileSettings;
    }


    /**
     * Gets the removeFileSettings value for this SmartCredentialAppletParms.
     * 
     * @return removeFileSettings   * If specified, this value specifies a list
     *                                 of file setting values to be removed.
     * This setting is ignored for the
     *                                 userSmartCredentialAppletCreate operation.
     */
    public String[] getRemoveFileSettings() {
        return removeFileSettings;
    }


    /**
     * Sets the removeFileSettings value for this SmartCredentialAppletParms.
     * 
     * @param removeFileSettings   * If specified, this value specifies a list
     *                                 of file setting values to be removed.
     * This setting is ignored for the
     *                                 userSmartCredentialAppletCreate operation.
     */
    public void setRemoveFileSettings(String[] removeFileSettings) {
        this.removeFileSettings = removeFileSettings;
    }


    /**
     * Gets the description value for this SmartCredentialAppletParms.
     * 
     * @return description   * Optional description.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this SmartCredentialAppletParms.
     * 
     * @param description   * Optional description.
     */
    public void setDescription(String description) {
        this.description = description;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialAppletParms)) return false;
        SmartCredentialAppletParms other = (SmartCredentialAppletParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.data==null && other.getData()==null) || 
             (this.data!=null &&
              java.util.Arrays.equals(this.data, other.getData()))) &&
            ((this.masterKey==null && other.getMasterKey()==null) || 
             (this.masterKey!=null &&
              java.util.Arrays.equals(this.masterKey, other.getMasterKey()))) &&
            ((this.masterKeyPassword==null && other.getMasterKeyPassword()==null) || 
             (this.masterKeyPassword!=null &&
              this.masterKeyPassword.equals(other.getMasterKeyPassword()))) &&
            ((this.masterKeyType==null && other.getMasterKeyType()==null) || 
             (this.masterKeyType!=null &&
              this.masterKeyType.equals(other.getMasterKeyType()))) &&
            ((this.addConfigSettings==null && other.getAddConfigSettings()==null) || 
             (this.addConfigSettings!=null &&
              this.addConfigSettings.equals(other.getAddConfigSettings()))) &&
            ((this.configSettings==null && other.getConfigSettings()==null) || 
             (this.configSettings!=null &&
              java.util.Arrays.equals(this.configSettings, other.getConfigSettings()))) &&
            ((this.removeConfigSettings==null && other.getRemoveConfigSettings()==null) || 
             (this.removeConfigSettings!=null &&
              java.util.Arrays.equals(this.removeConfigSettings, other.getRemoveConfigSettings()))) &&
            ((this.addFileSettings==null && other.getAddFileSettings()==null) || 
             (this.addFileSettings!=null &&
              this.addFileSettings.equals(other.getAddFileSettings()))) &&
            ((this.fileSettings==null && other.getFileSettings()==null) || 
             (this.fileSettings!=null &&
              java.util.Arrays.equals(this.fileSettings, other.getFileSettings()))) &&
            ((this.removeFileSettings==null && other.getRemoveFileSettings()==null) || 
             (this.removeFileSettings!=null &&
              java.util.Arrays.equals(this.removeFileSettings, other.getRemoveFileSettings()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getData() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getData());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getData(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMasterKey() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getMasterKey());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getMasterKey(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMasterKeyPassword() != null) {
            _hashCode += getMasterKeyPassword().hashCode();
        }
        if (getMasterKeyType() != null) {
            _hashCode += getMasterKeyType().hashCode();
        }
        if (getAddConfigSettings() != null) {
            _hashCode += getAddConfigSettings().hashCode();
        }
        if (getConfigSettings() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getConfigSettings());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getConfigSettings(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRemoveConfigSettings() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRemoveConfigSettings());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRemoveConfigSettings(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAddFileSettings() != null) {
            _hashCode += getAddFileSettings().hashCode();
        }
        if (getFileSettings() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getFileSettings());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getFileSettings(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRemoveFileSettings() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRemoveFileSettings());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRemoveFileSettings(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialAppletParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialAppletParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("data");
        elemField.setXmlName(new javax.xml.namespace.QName("", "data"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("masterKey");
        elemField.setXmlName(new javax.xml.namespace.QName("", "masterKey"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("masterKeyPassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "masterKeyPassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("masterKeyType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "masterKeyType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addConfigSettings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "addConfigSettings"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("configSettings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "configSettings"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "NameValue"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeConfigSettings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeConfigSettings"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addFileSettings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "addFileSettings"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("fileSettings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "fileSettings"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "FileSetting"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeFileSettings");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeFileSettings"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
