/**
 * SmartCredentialDefinitionInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a Smart Credential Definition
 */
public class SmartCredentialDefinitionInfo  implements java.io.Serializable {
    /* The name of the Smart Credential Definition. */
    private String name;

    /* An XML document that describes the values
     *                                 that need to be collected during enrollment. */
    private String valueDefinition;

    /* A list of locales defined for smart credential
     *                                 variables. */
    private SmartCredentialLocaleInfo[] variableLocales;

    /* A list of variables defined for this smart
     *                                 credential definition. */
    private SmartCredentialVariableInfo[] variables;

    /* A flag indicating if Smart Credentials need
     *                                 to be approved before they can be
     * printed. */
    private Boolean approvalRequired;

    /* The name of the Smart Credential Layout
     *                                 assigned to the Smart Credential Definition.
     * If the value is null no Smart Credential
     *                                 Layout is assigned to this Smart Credential
     * Definition. */
    private String layout;

    /* A list of Smart Credential Applet names
     *                                 assigned to the Smart Credential Definition. */
    private String[] applets;

    /* A list of PACS names
     *                                 assigned to the Smart Credential Definition. */
    private String[] PACS;

    /* A list of Smart Credential Deliveries that
     *                                 can be used as a parameter to the
     *                                 userSmartCredentialDelivery and
     *                                 userSmartCredentialUnblock  operations
     * with
     *                                 smart credentials using this definition. */
    private SmartCredentialDeliveryInfo[] allowedDeliveries;

    /* A description of the Smart Credential Definition. */
    private String description;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public SmartCredentialDefinitionInfo() {
    }

    public SmartCredentialDefinitionInfo(
           String name,
           String valueDefinition,
           SmartCredentialLocaleInfo[] variableLocales,
           SmartCredentialVariableInfo[] variables,
           Boolean approvalRequired,
           String layout,
           String[] applets,
           String[] PACS,
           SmartCredentialDeliveryInfo[] allowedDeliveries,
           String description,
           String[] rolesGrantingAccess) {
           this.name = name;
           this.valueDefinition = valueDefinition;
           this.variableLocales = variableLocales;
           this.variables = variables;
           this.approvalRequired = approvalRequired;
           this.layout = layout;
           this.applets = applets;
           this.PACS = PACS;
           this.allowedDeliveries = allowedDeliveries;
           this.description = description;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the name value for this SmartCredentialDefinitionInfo.
     * 
     * @return name   * The name of the Smart Credential Definition.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialDefinitionInfo.
     * 
     * @param name   * The name of the Smart Credential Definition.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the valueDefinition value for this SmartCredentialDefinitionInfo.
     * 
     * @return valueDefinition   * An XML document that describes the values
     *                                 that need to be collected during enrollment.
     */
    public String getValueDefinition() {
        return valueDefinition;
    }


    /**
     * Sets the valueDefinition value for this SmartCredentialDefinitionInfo.
     * 
     * @param valueDefinition   * An XML document that describes the values
     *                                 that need to be collected during enrollment.
     */
    public void setValueDefinition(String valueDefinition) {
        this.valueDefinition = valueDefinition;
    }


    /**
     * Gets the variableLocales value for this SmartCredentialDefinitionInfo.
     * 
     * @return variableLocales   * A list of locales defined for smart credential
     *                                 variables.
     */
    public SmartCredentialLocaleInfo[] getVariableLocales() {
        return variableLocales;
    }


    /**
     * Sets the variableLocales value for this SmartCredentialDefinitionInfo.
     * 
     * @param variableLocales   * A list of locales defined for smart credential
     *                                 variables.
     */
    public void setVariableLocales(SmartCredentialLocaleInfo[] variableLocales) {
        this.variableLocales = variableLocales;
    }


    /**
     * Gets the variables value for this SmartCredentialDefinitionInfo.
     * 
     * @return variables   * A list of variables defined for this smart
     *                                 credential definition.
     */
    public SmartCredentialVariableInfo[] getVariables() {
        return variables;
    }


    /**
     * Sets the variables value for this SmartCredentialDefinitionInfo.
     * 
     * @param variables   * A list of variables defined for this smart
     *                                 credential definition.
     */
    public void setVariables(SmartCredentialVariableInfo[] variables) {
        this.variables = variables;
    }


    /**
     * Gets the approvalRequired value for this SmartCredentialDefinitionInfo.
     * 
     * @return approvalRequired   * A flag indicating if Smart Credentials need
     *                                 to be approved before they can be
     * printed.
     */
    public Boolean getApprovalRequired() {
        return approvalRequired;
    }


    /**
     * Sets the approvalRequired value for this SmartCredentialDefinitionInfo.
     * 
     * @param approvalRequired   * A flag indicating if Smart Credentials need
     *                                 to be approved before they can be
     * printed.
     */
    public void setApprovalRequired(Boolean approvalRequired) {
        this.approvalRequired = approvalRequired;
    }


    /**
     * Gets the layout value for this SmartCredentialDefinitionInfo.
     * 
     * @return layout   * The name of the Smart Credential Layout
     *                                 assigned to the Smart Credential Definition.
     * If the value is null no Smart Credential
     *                                 Layout is assigned to this Smart Credential
     * Definition.
     */
    public String getLayout() {
        return layout;
    }


    /**
     * Sets the layout value for this SmartCredentialDefinitionInfo.
     * 
     * @param layout   * The name of the Smart Credential Layout
     *                                 assigned to the Smart Credential Definition.
     * If the value is null no Smart Credential
     *                                 Layout is assigned to this Smart Credential
     * Definition.
     */
    public void setLayout(String layout) {
        this.layout = layout;
    }


    /**
     * Gets the applets value for this SmartCredentialDefinitionInfo.
     * 
     * @return applets   * A list of Smart Credential Applet names
     *                                 assigned to the Smart Credential Definition.
     */
    public String[] getApplets() {
        return applets;
    }


    /**
     * Sets the applets value for this SmartCredentialDefinitionInfo.
     * 
     * @param applets   * A list of Smart Credential Applet names
     *                                 assigned to the Smart Credential Definition.
     */
    public void setApplets(String[] applets) {
        this.applets = applets;
    }


    /**
     * Gets the PACS value for this SmartCredentialDefinitionInfo.
     * 
     * @return PACS   * A list of PACS names
     *                                 assigned to the Smart Credential Definition.
     */
    public String[] getPACS() {
        return PACS;
    }


    /**
     * Sets the PACS value for this SmartCredentialDefinitionInfo.
     * 
     * @param PACS   * A list of PACS names
     *                                 assigned to the Smart Credential Definition.
     */
    public void setPACS(String[] PACS) {
        this.PACS = PACS;
    }


    /**
     * Gets the allowedDeliveries value for this SmartCredentialDefinitionInfo.
     * 
     * @return allowedDeliveries   * A list of Smart Credential Deliveries that
     *                                 can be used as a parameter to the
     *                                 userSmartCredentialDelivery and
     *                                 userSmartCredentialUnblock  operations
     * with
     *                                 smart credentials using this definition.
     */
    public SmartCredentialDeliveryInfo[] getAllowedDeliveries() {
        return allowedDeliveries;
    }


    /**
     * Sets the allowedDeliveries value for this SmartCredentialDefinitionInfo.
     * 
     * @param allowedDeliveries   * A list of Smart Credential Deliveries that
     *                                 can be used as a parameter to the
     *                                 userSmartCredentialDelivery and
     *                                 userSmartCredentialUnblock  operations
     * with
     *                                 smart credentials using this definition.
     */
    public void setAllowedDeliveries(SmartCredentialDeliveryInfo[] allowedDeliveries) {
        this.allowedDeliveries = allowedDeliveries;
    }


    /**
     * Gets the description value for this SmartCredentialDefinitionInfo.
     * 
     * @return description   * A description of the Smart Credential Definition.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this SmartCredentialDefinitionInfo.
     * 
     * @param description   * A description of the Smart Credential Definition.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the rolesGrantingAccess value for this SmartCredentialDefinitionInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this SmartCredentialDefinitionInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialDefinitionInfo)) return false;
        SmartCredentialDefinitionInfo other = (SmartCredentialDefinitionInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.valueDefinition==null && other.getValueDefinition()==null) || 
             (this.valueDefinition!=null &&
              this.valueDefinition.equals(other.getValueDefinition()))) &&
            ((this.variableLocales==null && other.getVariableLocales()==null) || 
             (this.variableLocales!=null &&
              java.util.Arrays.equals(this.variableLocales, other.getVariableLocales()))) &&
            ((this.variables==null && other.getVariables()==null) || 
             (this.variables!=null &&
              java.util.Arrays.equals(this.variables, other.getVariables()))) &&
            ((this.approvalRequired==null && other.getApprovalRequired()==null) || 
             (this.approvalRequired!=null &&
              this.approvalRequired.equals(other.getApprovalRequired()))) &&
            ((this.layout==null && other.getLayout()==null) || 
             (this.layout!=null &&
              this.layout.equals(other.getLayout()))) &&
            ((this.applets==null && other.getApplets()==null) || 
             (this.applets!=null &&
              java.util.Arrays.equals(this.applets, other.getApplets()))) &&
            ((this.PACS==null && other.getPACS()==null) || 
             (this.PACS!=null &&
              java.util.Arrays.equals(this.PACS, other.getPACS()))) &&
            ((this.allowedDeliveries==null && other.getAllowedDeliveries()==null) || 
             (this.allowedDeliveries!=null &&
              java.util.Arrays.equals(this.allowedDeliveries, other.getAllowedDeliveries()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getValueDefinition() != null) {
            _hashCode += getValueDefinition().hashCode();
        }
        if (getVariableLocales() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getVariableLocales());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getVariableLocales(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getVariables() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getVariables());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getVariables(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getApprovalRequired() != null) {
            _hashCode += getApprovalRequired().hashCode();
        }
        if (getLayout() != null) {
            _hashCode += getLayout().hashCode();
        }
        if (getApplets() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getApplets());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getApplets(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getPACS() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPACS());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPACS(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAllowedDeliveries() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getAllowedDeliveries());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getAllowedDeliveries(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialDefinitionInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialDefinitionInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("valueDefinition");
        elemField.setXmlName(new javax.xml.namespace.QName("", "valueDefinition"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("variableLocales");
        elemField.setXmlName(new javax.xml.namespace.QName("", "variableLocales"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialLocaleInfo"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("variables");
        elemField.setXmlName(new javax.xml.namespace.QName("", "variables"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableInfo"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("approvalRequired");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ApprovalRequired"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("layout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Layout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("applets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Applets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("PACS");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PACS"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allowedDeliveries");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AllowedDeliveries"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialDeliveryInfo"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
