/**
 * SmartCredentialDefinitionParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the paramaters that can be set when
 *                         creating or modifying a Smart Credential Definition.
 */
public class SmartCredentialDefinitionParms  implements java.io.Serializable {
    /* When passed in a call to smartCredentialDefinitionSet, this
     * specifies a new name for the Smart Credential Definition.
     *                                 If this is included in a call to
     *                                 smartCredentialDefinitionCreate it
     * is ignored. */
    private String name;

    /* An XML document that defines the values
     *                                 to be collected during enrollment. */
    private String valueDefinition;

    /* A flag indicating if Smart Credentials need
     *                                 to be approved before they can be
     * printed. */
    private Boolean approvalRequired;

    /* If this value is set it specifies the name
     *                                 of the Smart Credential Layout to
     * be assigned to this
     *                                 Smart Credential Definition.  If the
     * value is an empty
     *                                 string, the current Smart Credential
     * Layout is
     *                                 removed from the Smart Credential
     * Definition. */
    private String layout;

    /* If this value is set to true, the values
     *                                 specified in the Applets
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false. */
    private Boolean addApplets;

    /* If this value is set to true, the values
     *                                 specified in the Applets
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation. */
    private Boolean removeApplets;

    /* A list of Smart Credential Applet names to be set, added
     *                                 or removed from a Smart Credential
     * Definition. */
    private String[] applets;

    /* If this value is set to true, the values
     *                                 specified in the PACS
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false. */
    private Boolean addPACS;

    /* If this value is set to true, the values
     *                                 specified in the PACS
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation. */
    private Boolean removePACS;

    /* A list of PACS names to be set, added
     *                                 or removed from a Smart Credential
     * Definition. */
    private String[] PACS;

    /* If this value is set to true, the values
     *                                 specified in the AllowedDeliveries
     * parameter are added to the existing values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false. */
    private Boolean addAllowedDeliveries;

    /* If this value is set to true, the values
     *                                 specified in the AllowedDeliveries
     * parameter are removed from the existing values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation. */
    private Boolean removeAllowedDeliveries;

    /* A list of Smart Credential Delivery names to be
     *                                 set, added or removed from the allowed
     * Smart Credential Deliveries list of a
     *                                 Smart Credential Definition. */
    private String[] allowedDeliveries;

    /* If this value is set to true, the values
     *                                 specified in the Locales
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false. */
    private Boolean addLocales;

    /* If this value is set to true, the values
     *                                 specified in the Locales
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute is ignored for the
     *                                 smartCredentialDefinitionCreate operation. */
    private Boolean removeLocales;

    /* A list of locale names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     *                                 This argument is ignored if the
     *                                 valueDefinitions parameter is specified. */
    private String[] locales;

    /* The name of the locale to be made the default
     *                                 locale. If not specified for the
     *                                 smartCredentialDefinitionCreate  operation
     * and a list of locales is specified the first
     *                                 locale in the locales list is made
     * the default. */
    private String defaultLocale;

    /* Optional description. */
    private String description;

    public SmartCredentialDefinitionParms() {
    }

    public SmartCredentialDefinitionParms(
           String name,
           String valueDefinition,
           Boolean approvalRequired,
           String layout,
           Boolean addApplets,
           Boolean removeApplets,
           String[] applets,
           Boolean addPACS,
           Boolean removePACS,
           String[] PACS,
           Boolean addAllowedDeliveries,
           Boolean removeAllowedDeliveries,
           String[] allowedDeliveries,
           Boolean addLocales,
           Boolean removeLocales,
           String[] locales,
           String defaultLocale,
           String description) {
           this.name = name;
           this.valueDefinition = valueDefinition;
           this.approvalRequired = approvalRequired;
           this.layout = layout;
           this.addApplets = addApplets;
           this.removeApplets = removeApplets;
           this.applets = applets;
           this.addPACS = addPACS;
           this.removePACS = removePACS;
           this.PACS = PACS;
           this.addAllowedDeliveries = addAllowedDeliveries;
           this.removeAllowedDeliveries = removeAllowedDeliveries;
           this.allowedDeliveries = allowedDeliveries;
           this.addLocales = addLocales;
           this.removeLocales = removeLocales;
           this.locales = locales;
           this.defaultLocale = defaultLocale;
           this.description = description;
    }


    /**
     * Gets the name value for this SmartCredentialDefinitionParms.
     * 
     * @return name   * When passed in a call to smartCredentialDefinitionSet, this
     * specifies a new name for the Smart Credential Definition.
     *                                 If this is included in a call to
     *                                 smartCredentialDefinitionCreate it
     * is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialDefinitionParms.
     * 
     * @param name   * When passed in a call to smartCredentialDefinitionSet, this
     * specifies a new name for the Smart Credential Definition.
     *                                 If this is included in a call to
     *                                 smartCredentialDefinitionCreate it
     * is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the valueDefinition value for this SmartCredentialDefinitionParms.
     * 
     * @return valueDefinition   * An XML document that defines the values
     *                                 to be collected during enrollment.
     */
    public String getValueDefinition() {
        return valueDefinition;
    }


    /**
     * Sets the valueDefinition value for this SmartCredentialDefinitionParms.
     * 
     * @param valueDefinition   * An XML document that defines the values
     *                                 to be collected during enrollment.
     */
    public void setValueDefinition(String valueDefinition) {
        this.valueDefinition = valueDefinition;
    }


    /**
     * Gets the approvalRequired value for this SmartCredentialDefinitionParms.
     * 
     * @return approvalRequired   * A flag indicating if Smart Credentials need
     *                                 to be approved before they can be
     * printed.
     */
    public Boolean getApprovalRequired() {
        return approvalRequired;
    }


    /**
     * Sets the approvalRequired value for this SmartCredentialDefinitionParms.
     * 
     * @param approvalRequired   * A flag indicating if Smart Credentials need
     *                                 to be approved before they can be
     * printed.
     */
    public void setApprovalRequired(Boolean approvalRequired) {
        this.approvalRequired = approvalRequired;
    }


    /**
     * Gets the layout value for this SmartCredentialDefinitionParms.
     * 
     * @return layout   * If this value is set it specifies the name
     *                                 of the Smart Credential Layout to
     * be assigned to this
     *                                 Smart Credential Definition.  If the
     * value is an empty
     *                                 string, the current Smart Credential
     * Layout is
     *                                 removed from the Smart Credential
     * Definition.
     */
    public String getLayout() {
        return layout;
    }


    /**
     * Sets the layout value for this SmartCredentialDefinitionParms.
     * 
     * @param layout   * If this value is set it specifies the name
     *                                 of the Smart Credential Layout to
     * be assigned to this
     *                                 Smart Credential Definition.  If the
     * value is an empty
     *                                 string, the current Smart Credential
     * Layout is
     *                                 removed from the Smart Credential
     * Definition.
     */
    public void setLayout(String layout) {
        this.layout = layout;
    }


    /**
     * Gets the addApplets value for this SmartCredentialDefinitionParms.
     * 
     * @return addApplets   * If this value is set to true, the values
     *                                 specified in the Applets
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public Boolean getAddApplets() {
        return addApplets;
    }


    /**
     * Sets the addApplets value for this SmartCredentialDefinitionParms.
     * 
     * @param addApplets   * If this value is set to true, the values
     *                                 specified in the Applets
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public void setAddApplets(Boolean addApplets) {
        this.addApplets = addApplets;
    }


    /**
     * Gets the removeApplets value for this SmartCredentialDefinitionParms.
     * 
     * @return removeApplets   * If this value is set to true, the values
     *                                 specified in the Applets
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation.
     */
    public Boolean getRemoveApplets() {
        return removeApplets;
    }


    /**
     * Sets the removeApplets value for this SmartCredentialDefinitionParms.
     * 
     * @param removeApplets   * If this value is set to true, the values
     *                                 specified in the Applets
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation.
     */
    public void setRemoveApplets(Boolean removeApplets) {
        this.removeApplets = removeApplets;
    }


    /**
     * Gets the applets value for this SmartCredentialDefinitionParms.
     * 
     * @return applets   * A list of Smart Credential Applet names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     */
    public String[] getApplets() {
        return applets;
    }


    /**
     * Sets the applets value for this SmartCredentialDefinitionParms.
     * 
     * @param applets   * A list of Smart Credential Applet names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     */
    public void setApplets(String[] applets) {
        this.applets = applets;
    }


    /**
     * Gets the addPACS value for this SmartCredentialDefinitionParms.
     * 
     * @return addPACS   * If this value is set to true, the values
     *                                 specified in the PACS
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public Boolean getAddPACS() {
        return addPACS;
    }


    /**
     * Sets the addPACS value for this SmartCredentialDefinitionParms.
     * 
     * @param addPACS   * If this value is set to true, the values
     *                                 specified in the PACS
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public void setAddPACS(Boolean addPACS) {
        this.addPACS = addPACS;
    }


    /**
     * Gets the removePACS value for this SmartCredentialDefinitionParms.
     * 
     * @return removePACS   * If this value is set to true, the values
     *                                 specified in the PACS
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation.
     */
    public Boolean getRemovePACS() {
        return removePACS;
    }


    /**
     * Sets the removePACS value for this SmartCredentialDefinitionParms.
     * 
     * @param removePACS   * If this value is set to true, the values
     *                                 specified in the PACS
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation.
     */
    public void setRemovePACS(Boolean removePACS) {
        this.removePACS = removePACS;
    }


    /**
     * Gets the PACS value for this SmartCredentialDefinitionParms.
     * 
     * @return PACS   * A list of PACS names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     */
    public String[] getPACS() {
        return PACS;
    }


    /**
     * Sets the PACS value for this SmartCredentialDefinitionParms.
     * 
     * @param PACS   * A list of PACS names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     */
    public void setPACS(String[] PACS) {
        this.PACS = PACS;
    }


    /**
     * Gets the addAllowedDeliveries value for this SmartCredentialDefinitionParms.
     * 
     * @return addAllowedDeliveries   * If this value is set to true, the values
     *                                 specified in the AllowedDeliveries
     * parameter are added to the existing values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public Boolean getAddAllowedDeliveries() {
        return addAllowedDeliveries;
    }


    /**
     * Sets the addAllowedDeliveries value for this SmartCredentialDefinitionParms.
     * 
     * @param addAllowedDeliveries   * If this value is set to true, the values
     *                                 specified in the AllowedDeliveries
     * parameter are added to the existing values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public void setAddAllowedDeliveries(Boolean addAllowedDeliveries) {
        this.addAllowedDeliveries = addAllowedDeliveries;
    }


    /**
     * Gets the removeAllowedDeliveries value for this SmartCredentialDefinitionParms.
     * 
     * @return removeAllowedDeliveries   * If this value is set to true, the values
     *                                 specified in the AllowedDeliveries
     * parameter are removed from the existing values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation.
     */
    public Boolean getRemoveAllowedDeliveries() {
        return removeAllowedDeliveries;
    }


    /**
     * Sets the removeAllowedDeliveries value for this SmartCredentialDefinitionParms.
     * 
     * @param removeAllowedDeliveries   * If this value is set to true, the values
     *                                 specified in the AllowedDeliveries
     * parameter are removed from the existing values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute can not be specified
     * as true
     *                                 for the smartCredentialDefinitionCreate
     * operation.
     */
    public void setRemoveAllowedDeliveries(Boolean removeAllowedDeliveries) {
        this.removeAllowedDeliveries = removeAllowedDeliveries;
    }


    /**
     * Gets the allowedDeliveries value for this SmartCredentialDefinitionParms.
     * 
     * @return allowedDeliveries   * A list of Smart Credential Delivery names to be
     *                                 set, added or removed from the allowed
     * Smart Credential Deliveries list of a
     *                                 Smart Credential Definition.
     */
    public String[] getAllowedDeliveries() {
        return allowedDeliveries;
    }


    /**
     * Sets the allowedDeliveries value for this SmartCredentialDefinitionParms.
     * 
     * @param allowedDeliveries   * A list of Smart Credential Delivery names to be
     *                                 set, added or removed from the allowed
     * Smart Credential Deliveries list of a
     *                                 Smart Credential Definition.
     */
    public void setAllowedDeliveries(String[] allowedDeliveries) {
        this.allowedDeliveries = allowedDeliveries;
    }


    /**
     * Gets the addLocales value for this SmartCredentialDefinitionParms.
     * 
     * @return addLocales   * If this value is set to true, the values
     *                                 specified in the Locales
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public Boolean getAddLocales() {
        return addLocales;
    }


    /**
     * Sets the addLocales value for this SmartCredentialDefinitionParms.
     * 
     * @param addLocales   * If this value is set to true, the values
     *                                 specified in the Locales
     *                                 parameter are added to the existing
     * values
     *                                 instead of overwriting them.
     *                                 If not specified, this attribute defaults
     * to
     *                                 false.
     */
    public void setAddLocales(Boolean addLocales) {
        this.addLocales = addLocales;
    }


    /**
     * Gets the removeLocales value for this SmartCredentialDefinitionParms.
     * 
     * @return removeLocales   * If this value is set to true, the values
     *                                 specified in the Locales
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute is ignored for the
     *                                 smartCredentialDefinitionCreate operation.
     */
    public Boolean getRemoveLocales() {
        return removeLocales;
    }


    /**
     * Sets the removeLocales value for this SmartCredentialDefinitionParms.
     * 
     * @param removeLocales   * If this value is set to true, the values
     *                                 specified in the Locales
     *                                 parameter are removed from the existing
     * values.
     *                                 If not specified, this attribute defaults
     * to false.
     *                                 This attribute is ignored for the
     *                                 smartCredentialDefinitionCreate operation.
     */
    public void setRemoveLocales(Boolean removeLocales) {
        this.removeLocales = removeLocales;
    }


    /**
     * Gets the locales value for this SmartCredentialDefinitionParms.
     * 
     * @return locales   * A list of locale names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     *                                 This argument is ignored if the
     *                                 valueDefinitions parameter is specified.
     */
    public String[] getLocales() {
        return locales;
    }


    /**
     * Sets the locales value for this SmartCredentialDefinitionParms.
     * 
     * @param locales   * A list of locale names to be set, added
     *                                 or removed from a Smart Credential
     * Definition.
     *                                 This argument is ignored if the
     *                                 valueDefinitions parameter is specified.
     */
    public void setLocales(String[] locales) {
        this.locales = locales;
    }


    /**
     * Gets the defaultLocale value for this SmartCredentialDefinitionParms.
     * 
     * @return defaultLocale   * The name of the locale to be made the default
     *                                 locale. If not specified for the
     *                                 smartCredentialDefinitionCreate  operation
     * and a list of locales is specified the first
     *                                 locale in the locales list is made
     * the default.
     */
    public String getDefaultLocale() {
        return defaultLocale;
    }


    /**
     * Sets the defaultLocale value for this SmartCredentialDefinitionParms.
     * 
     * @param defaultLocale   * The name of the locale to be made the default
     *                                 locale. If not specified for the
     *                                 smartCredentialDefinitionCreate  operation
     * and a list of locales is specified the first
     *                                 locale in the locales list is made
     * the default.
     */
    public void setDefaultLocale(String defaultLocale) {
        this.defaultLocale = defaultLocale;
    }


    /**
     * Gets the description value for this SmartCredentialDefinitionParms.
     * 
     * @return description   * Optional description.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this SmartCredentialDefinitionParms.
     * 
     * @param description   * Optional description.
     */
    public void setDescription(String description) {
        this.description = description;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialDefinitionParms)) return false;
        SmartCredentialDefinitionParms other = (SmartCredentialDefinitionParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.valueDefinition==null && other.getValueDefinition()==null) || 
             (this.valueDefinition!=null &&
              this.valueDefinition.equals(other.getValueDefinition()))) &&
            ((this.approvalRequired==null && other.getApprovalRequired()==null) || 
             (this.approvalRequired!=null &&
              this.approvalRequired.equals(other.getApprovalRequired()))) &&
            ((this.layout==null && other.getLayout()==null) || 
             (this.layout!=null &&
              this.layout.equals(other.getLayout()))) &&
            ((this.addApplets==null && other.getAddApplets()==null) || 
             (this.addApplets!=null &&
              this.addApplets.equals(other.getAddApplets()))) &&
            ((this.removeApplets==null && other.getRemoveApplets()==null) || 
             (this.removeApplets!=null &&
              this.removeApplets.equals(other.getRemoveApplets()))) &&
            ((this.applets==null && other.getApplets()==null) || 
             (this.applets!=null &&
              java.util.Arrays.equals(this.applets, other.getApplets()))) &&
            ((this.addPACS==null && other.getAddPACS()==null) || 
             (this.addPACS!=null &&
              this.addPACS.equals(other.getAddPACS()))) &&
            ((this.removePACS==null && other.getRemovePACS()==null) || 
             (this.removePACS!=null &&
              this.removePACS.equals(other.getRemovePACS()))) &&
            ((this.PACS==null && other.getPACS()==null) || 
             (this.PACS!=null &&
              java.util.Arrays.equals(this.PACS, other.getPACS()))) &&
            ((this.addAllowedDeliveries==null && other.getAddAllowedDeliveries()==null) || 
             (this.addAllowedDeliveries!=null &&
              this.addAllowedDeliveries.equals(other.getAddAllowedDeliveries()))) &&
            ((this.removeAllowedDeliveries==null && other.getRemoveAllowedDeliveries()==null) || 
             (this.removeAllowedDeliveries!=null &&
              this.removeAllowedDeliveries.equals(other.getRemoveAllowedDeliveries()))) &&
            ((this.allowedDeliveries==null && other.getAllowedDeliveries()==null) || 
             (this.allowedDeliveries!=null &&
              java.util.Arrays.equals(this.allowedDeliveries, other.getAllowedDeliveries()))) &&
            ((this.addLocales==null && other.getAddLocales()==null) || 
             (this.addLocales!=null &&
              this.addLocales.equals(other.getAddLocales()))) &&
            ((this.removeLocales==null && other.getRemoveLocales()==null) || 
             (this.removeLocales!=null &&
              this.removeLocales.equals(other.getRemoveLocales()))) &&
            ((this.locales==null && other.getLocales()==null) || 
             (this.locales!=null &&
              java.util.Arrays.equals(this.locales, other.getLocales()))) &&
            ((this.defaultLocale==null && other.getDefaultLocale()==null) || 
             (this.defaultLocale!=null &&
              this.defaultLocale.equals(other.getDefaultLocale()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getValueDefinition() != null) {
            _hashCode += getValueDefinition().hashCode();
        }
        if (getApprovalRequired() != null) {
            _hashCode += getApprovalRequired().hashCode();
        }
        if (getLayout() != null) {
            _hashCode += getLayout().hashCode();
        }
        if (getAddApplets() != null) {
            _hashCode += getAddApplets().hashCode();
        }
        if (getRemoveApplets() != null) {
            _hashCode += getRemoveApplets().hashCode();
        }
        if (getApplets() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getApplets());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getApplets(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAddPACS() != null) {
            _hashCode += getAddPACS().hashCode();
        }
        if (getRemovePACS() != null) {
            _hashCode += getRemovePACS().hashCode();
        }
        if (getPACS() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPACS());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPACS(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAddAllowedDeliveries() != null) {
            _hashCode += getAddAllowedDeliveries().hashCode();
        }
        if (getRemoveAllowedDeliveries() != null) {
            _hashCode += getRemoveAllowedDeliveries().hashCode();
        }
        if (getAllowedDeliveries() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getAllowedDeliveries());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getAllowedDeliveries(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAddLocales() != null) {
            _hashCode += getAddLocales().hashCode();
        }
        if (getRemoveLocales() != null) {
            _hashCode += getRemoveLocales().hashCode();
        }
        if (getLocales() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getLocales());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getLocales(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDefaultLocale() != null) {
            _hashCode += getDefaultLocale().hashCode();
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialDefinitionParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialDefinitionParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("valueDefinition");
        elemField.setXmlName(new javax.xml.namespace.QName("", "valueDefinition"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("approvalRequired");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ApprovalRequired"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("layout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Layout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addApplets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AddApplets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeApplets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RemoveApplets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("applets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Applets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addPACS");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AddPACS"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removePACS");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RemovePACS"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("PACS");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PACS"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addAllowedDeliveries");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AddAllowedDeliveries"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeAllowedDeliveries");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RemoveAllowedDeliveries"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("allowedDeliveries");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AllowedDeliveries"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("addLocales");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AddLocales"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeLocales");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RemoveLocales"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("locales");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Locales"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultLocale");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DefaultLocale"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
