/**
 * SmartCredentialDeliveryInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a Smart Credential Delivery
 */
public class SmartCredentialDeliveryInfo  implements java.io.Serializable {
    /* The label of the Smart Credential Delivery. */
    private String label;

    /* The name of the Smart Credential Delivery. */
    private String name;

    /* A string indicating the type of the
     *                                 Smart Credential Delivery.  Deliveries
     * with
     *                                 the type UNBLOCK can be used with
     * the
     *                                 userSmartCredentialUnblock operation.
     * Deliveries with other types can be used
     *                                 with the userSmartCredentialDeliver
     * operation.
     *                                 Defined types include PIN, UNBLOCK
     * and MISC 
     *                                 although the type can be any value. */
    private String type;

    /* A list of enrollment variables required
     *                                 for this delivery mechanism. */
    private String[] requiredVariables;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public SmartCredentialDeliveryInfo() {
    }

    public SmartCredentialDeliveryInfo(
           String label,
           String name,
           String type,
           String[] requiredVariables,
           String[] rolesGrantingAccess) {
           this.label = label;
           this.name = name;
           this.type = type;
           this.requiredVariables = requiredVariables;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the label value for this SmartCredentialDeliveryInfo.
     * 
     * @return label   * The label of the Smart Credential Delivery.
     */
    public String getLabel() {
        return label;
    }


    /**
     * Sets the label value for this SmartCredentialDeliveryInfo.
     * 
     * @param label   * The label of the Smart Credential Delivery.
     */
    public void setLabel(String label) {
        this.label = label;
    }


    /**
     * Gets the name value for this SmartCredentialDeliveryInfo.
     * 
     * @return name   * The name of the Smart Credential Delivery.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialDeliveryInfo.
     * 
     * @param name   * The name of the Smart Credential Delivery.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the type value for this SmartCredentialDeliveryInfo.
     * 
     * @return type   * A string indicating the type of the
     *                                 Smart Credential Delivery.  Deliveries
     * with
     *                                 the type UNBLOCK can be used with
     * the
     *                                 userSmartCredentialUnblock operation.
     * Deliveries with other types can be used
     *                                 with the userSmartCredentialDeliver
     * operation.
     *                                 Defined types include PIN, UNBLOCK
     * and MISC 
     *                                 although the type can be any value.
     */
    public String getType() {
        return type;
    }


    /**
     * Sets the type value for this SmartCredentialDeliveryInfo.
     * 
     * @param type   * A string indicating the type of the
     *                                 Smart Credential Delivery.  Deliveries
     * with
     *                                 the type UNBLOCK can be used with
     * the
     *                                 userSmartCredentialUnblock operation.
     * Deliveries with other types can be used
     *                                 with the userSmartCredentialDeliver
     * operation.
     *                                 Defined types include PIN, UNBLOCK
     * and MISC 
     *                                 although the type can be any value.
     */
    public void setType(String type) {
        this.type = type;
    }


    /**
     * Gets the requiredVariables value for this SmartCredentialDeliveryInfo.
     * 
     * @return requiredVariables   * A list of enrollment variables required
     *                                 for this delivery mechanism.
     */
    public String[] getRequiredVariables() {
        return requiredVariables;
    }


    /**
     * Sets the requiredVariables value for this SmartCredentialDeliveryInfo.
     * 
     * @param requiredVariables   * A list of enrollment variables required
     *                                 for this delivery mechanism.
     */
    public void setRequiredVariables(String[] requiredVariables) {
        this.requiredVariables = requiredVariables;
    }


    /**
     * Gets the rolesGrantingAccess value for this SmartCredentialDeliveryInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this SmartCredentialDeliveryInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialDeliveryInfo)) return false;
        SmartCredentialDeliveryInfo other = (SmartCredentialDeliveryInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.label==null && other.getLabel()==null) || 
             (this.label!=null &&
              this.label.equals(other.getLabel()))) &&
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.requiredVariables==null && other.getRequiredVariables()==null) || 
             (this.requiredVariables!=null &&
              java.util.Arrays.equals(this.requiredVariables, other.getRequiredVariables()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getLabel() != null) {
            _hashCode += getLabel().hashCode();
        }
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getRequiredVariables() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRequiredVariables());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRequiredVariables(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialDeliveryInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialDeliveryInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("label");
        elemField.setXmlName(new javax.xml.namespace.QName("", "label"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("requiredVariables");
        elemField.setXmlName(new javax.xml.namespace.QName("", "requiredVariables"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
