/**
 * SmartCredentialFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the filter to limit which unassigned smart
 *                         credentials are to be returned from the
 *                         smartCredentialList operation.
 */
public class SmartCredentialFilter  implements java.io.Serializable {
    /* If specified, only smart credentials whose
     *                                 serial numbers match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String serialNumber;

    /* If specified, returns Smart Credentials that
     *                                 have a card UID that matches the
     *                                 given value. */
    private String cardUID;

    /* If specified, returns only smart credentials
     *                                 whose load date is after the given
     * date. */
    private java.util.Calendar loadStartDate;

    /* If specified, returns only smart credentials
     *                                 whose load date is before the given
     * date. */
    private java.util.Calendar loadEndDate;

    /* If specified, provides a list of group names
     *                                 and returns only smart credentials
     * in the
     *                                 specified groups. */
    private String[] groups;

    /* If specified, provides a list of smart
     *                                 credential states
     *                                 and returns only smart credentials
     * with one 
     *                                 of the specified states. */
    private SmartCredentialState[] states;

    /* If specified, provides a list of smart
     *                                 credential states
     *                                 and returns only smart credentials
     * not in one 
     *                                 of the specified states. */
    private SmartCredentialState[] absentStates;

    /* The number of smart credentials to return. If
     *                                 not specified or the value is 0 or
     * less, it
     *                                 defaults to 100. */
    private Integer maxReturn;

    /* The serialNumber of the next smart credential
     *                                 to be returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * smart
     *                                 credential. This value is used to
     * get the next
     *                                 set of smart credentials following
     * a previous
     *                                 search. The value can be found in
     * the
     *                                 SmartCredentialListResult from the
     * previous search. */
    private String nextSmartCredentialSerialNumber;

    public SmartCredentialFilter() {
    }

    public SmartCredentialFilter(
           String serialNumber,
           String cardUID,
           java.util.Calendar loadStartDate,
           java.util.Calendar loadEndDate,
           String[] groups,
           SmartCredentialState[] states,
           SmartCredentialState[] absentStates,
           Integer maxReturn,
           String nextSmartCredentialSerialNumber) {
           this.serialNumber = serialNumber;
           this.cardUID = cardUID;
           this.loadStartDate = loadStartDate;
           this.loadEndDate = loadEndDate;
           this.groups = groups;
           this.states = states;
           this.absentStates = absentStates;
           this.maxReturn = maxReturn;
           this.nextSmartCredentialSerialNumber = nextSmartCredentialSerialNumber;
    }


    /**
     * Gets the serialNumber value for this SmartCredentialFilter.
     * 
     * @return serialNumber   * If specified, only smart credentials whose
     *                                 serial numbers match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this SmartCredentialFilter.
     * 
     * @param serialNumber   * If specified, only smart credentials whose
     *                                 serial numbers match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the cardUID value for this SmartCredentialFilter.
     * 
     * @return cardUID   * If specified, returns Smart Credentials that
     *                                 have a card UID that matches the
     *                                 given value.
     */
    public String getCardUID() {
        return cardUID;
    }


    /**
     * Sets the cardUID value for this SmartCredentialFilter.
     * 
     * @param cardUID   * If specified, returns Smart Credentials that
     *                                 have a card UID that matches the
     *                                 given value.
     */
    public void setCardUID(String cardUID) {
        this.cardUID = cardUID;
    }


    /**
     * Gets the loadStartDate value for this SmartCredentialFilter.
     * 
     * @return loadStartDate   * If specified, returns only smart credentials
     *                                 whose load date is after the given
     * date.
     */
    public java.util.Calendar getLoadStartDate() {
        return loadStartDate;
    }


    /**
     * Sets the loadStartDate value for this SmartCredentialFilter.
     * 
     * @param loadStartDate   * If specified, returns only smart credentials
     *                                 whose load date is after the given
     * date.
     */
    public void setLoadStartDate(java.util.Calendar loadStartDate) {
        this.loadStartDate = loadStartDate;
    }


    /**
     * Gets the loadEndDate value for this SmartCredentialFilter.
     * 
     * @return loadEndDate   * If specified, returns only smart credentials
     *                                 whose load date is before the given
     * date.
     */
    public java.util.Calendar getLoadEndDate() {
        return loadEndDate;
    }


    /**
     * Sets the loadEndDate value for this SmartCredentialFilter.
     * 
     * @param loadEndDate   * If specified, returns only smart credentials
     *                                 whose load date is before the given
     * date.
     */
    public void setLoadEndDate(java.util.Calendar loadEndDate) {
        this.loadEndDate = loadEndDate;
    }


    /**
     * Gets the groups value for this SmartCredentialFilter.
     * 
     * @return groups   * If specified, provides a list of group names
     *                                 and returns only smart credentials
     * in the
     *                                 specified groups.
     */
    public String[] getGroups() {
        return groups;
    }


    /**
     * Sets the groups value for this SmartCredentialFilter.
     * 
     * @param groups   * If specified, provides a list of group names
     *                                 and returns only smart credentials
     * in the
     *                                 specified groups.
     */
    public void setGroups(String[] groups) {
        this.groups = groups;
    }


    /**
     * Gets the states value for this SmartCredentialFilter.
     * 
     * @return states   * If specified, provides a list of smart
     *                                 credential states
     *                                 and returns only smart credentials
     * with one 
     *                                 of the specified states.
     */
    public SmartCredentialState[] getStates() {
        return states;
    }


    /**
     * Sets the states value for this SmartCredentialFilter.
     * 
     * @param states   * If specified, provides a list of smart
     *                                 credential states
     *                                 and returns only smart credentials
     * with one 
     *                                 of the specified states.
     */
    public void setStates(SmartCredentialState[] states) {
        this.states = states;
    }


    /**
     * Gets the absentStates value for this SmartCredentialFilter.
     * 
     * @return absentStates   * If specified, provides a list of smart
     *                                 credential states
     *                                 and returns only smart credentials
     * not in one 
     *                                 of the specified states.
     */
    public SmartCredentialState[] getAbsentStates() {
        return absentStates;
    }


    /**
     * Sets the absentStates value for this SmartCredentialFilter.
     * 
     * @param absentStates   * If specified, provides a list of smart
     *                                 credential states
     *                                 and returns only smart credentials
     * not in one 
     *                                 of the specified states.
     */
    public void setAbsentStates(SmartCredentialState[] absentStates) {
        this.absentStates = absentStates;
    }


    /**
     * Gets the maxReturn value for this SmartCredentialFilter.
     * 
     * @return maxReturn   * The number of smart credentials to return. If
     *                                 not specified or the value is 0 or
     * less, it
     *                                 defaults to 100.
     */
    public Integer getMaxReturn() {
        return maxReturn;
    }


    /**
     * Sets the maxReturn value for this SmartCredentialFilter.
     * 
     * @param maxReturn   * The number of smart credentials to return. If
     *                                 not specified or the value is 0 or
     * less, it
     *                                 defaults to 100.
     */
    public void setMaxReturn(Integer maxReturn) {
        this.maxReturn = maxReturn;
    }


    /**
     * Gets the nextSmartCredentialSerialNumber value for this SmartCredentialFilter.
     * 
     * @return nextSmartCredentialSerialNumber   * The serialNumber of the next smart credential
     *                                 to be returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * smart
     *                                 credential. This value is used to
     * get the next
     *                                 set of smart credentials following
     * a previous
     *                                 search. The value can be found in
     * the
     *                                 SmartCredentialListResult from the
     * previous search.
     */
    public String getNextSmartCredentialSerialNumber() {
        return nextSmartCredentialSerialNumber;
    }


    /**
     * Sets the nextSmartCredentialSerialNumber value for this SmartCredentialFilter.
     * 
     * @param nextSmartCredentialSerialNumber   * The serialNumber of the next smart credential
     *                                 to be returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * smart
     *                                 credential. This value is used to
     * get the next
     *                                 set of smart credentials following
     * a previous
     *                                 search. The value can be found in
     * the
     *                                 SmartCredentialListResult from the
     * previous search.
     */
    public void setNextSmartCredentialSerialNumber(String nextSmartCredentialSerialNumber) {
        this.nextSmartCredentialSerialNumber = nextSmartCredentialSerialNumber;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialFilter)) return false;
        SmartCredentialFilter other = (SmartCredentialFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.cardUID==null && other.getCardUID()==null) || 
             (this.cardUID!=null &&
              this.cardUID.equals(other.getCardUID()))) &&
            ((this.loadStartDate==null && other.getLoadStartDate()==null) || 
             (this.loadStartDate!=null &&
              this.loadStartDate.equals(other.getLoadStartDate()))) &&
            ((this.loadEndDate==null && other.getLoadEndDate()==null) || 
             (this.loadEndDate!=null &&
              this.loadEndDate.equals(other.getLoadEndDate()))) &&
            ((this.groups==null && other.getGroups()==null) || 
             (this.groups!=null &&
              java.util.Arrays.equals(this.groups, other.getGroups()))) &&
            ((this.states==null && other.getStates()==null) || 
             (this.states!=null &&
              java.util.Arrays.equals(this.states, other.getStates()))) &&
            ((this.absentStates==null && other.getAbsentStates()==null) || 
             (this.absentStates!=null &&
              java.util.Arrays.equals(this.absentStates, other.getAbsentStates()))) &&
            ((this.maxReturn==null && other.getMaxReturn()==null) || 
             (this.maxReturn!=null &&
              this.maxReturn.equals(other.getMaxReturn()))) &&
            ((this.nextSmartCredentialSerialNumber==null && other.getNextSmartCredentialSerialNumber()==null) || 
             (this.nextSmartCredentialSerialNumber!=null &&
              this.nextSmartCredentialSerialNumber.equals(other.getNextSmartCredentialSerialNumber())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getCardUID() != null) {
            _hashCode += getCardUID().hashCode();
        }
        if (getLoadStartDate() != null) {
            _hashCode += getLoadStartDate().hashCode();
        }
        if (getLoadEndDate() != null) {
            _hashCode += getLoadEndDate().hashCode();
        }
        if (getGroups() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroups());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroups(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getStates() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getStates());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getStates(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getAbsentStates() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getAbsentStates());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getAbsentStates(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMaxReturn() != null) {
            _hashCode += getMaxReturn().hashCode();
        }
        if (getNextSmartCredentialSerialNumber() != null) {
            _hashCode += getNextSmartCredentialSerialNumber().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardUID");
        elemField.setXmlName(new javax.xml.namespace.QName("", "cardUID"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadStartDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loadStartDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadEndDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loadEndDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("states");
        elemField.setXmlName(new javax.xml.namespace.QName("", "states"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialState"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("absentStates");
        elemField.setXmlName(new javax.xml.namespace.QName("", "absentStates"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialState"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxReturn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxReturn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("nextSmartCredentialSerialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "nextSmartCredentialSerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
