/**
 * SmartCredentialInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned about an unassigned
 *                         smart credential.
 */
public class SmartCredentialInfo  implements java.io.Serializable {
    /* The serial number of the smart credential. */
    private String serialNumber;

    /* The optional UID of the card. */
    private String cardUID;

    /* The card manager keys of this smart
     *                                 credential.  If the admininstrator
     * does
     *                                 not have permission to view the card
     * manager keys, this value will be null. */
    private byte[][] cardManagerKeys;

    /* The version of the card manager keys of this
     *                                 smart credential.  If the admininstrator
     * does
     *                                 not have permission to view the card
     * manager keys, this value will be null. */
    private Integer cardManagerKeyVersion;

    /* The state of the smart credential. */
    private SmartCredentialState state;

    /* The load date of the smart credential. */
    private java.util.Calendar loadDate;

    /* The group this smart credential belongs to. */
    private String group;

    /* A list of values provided for the smart
     *                                 credential when loaded from the data
     * file. */
    private NameValue[] enrollmentValues;

    /* The type of card this smart credential
     *                                 represents. */
    private String cardType;

    /* The smart credential comment. */
    private String comment;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public SmartCredentialInfo() {
    }

    public SmartCredentialInfo(
           String serialNumber,
           String cardUID,
           byte[][] cardManagerKeys,
           Integer cardManagerKeyVersion,
           SmartCredentialState state,
           java.util.Calendar loadDate,
           String group,
           NameValue[] enrollmentValues,
           String cardType,
           String comment,
           String[] rolesGrantingAccess) {
           this.serialNumber = serialNumber;
           this.cardUID = cardUID;
           this.cardManagerKeys = cardManagerKeys;
           this.cardManagerKeyVersion = cardManagerKeyVersion;
           this.state = state;
           this.loadDate = loadDate;
           this.group = group;
           this.enrollmentValues = enrollmentValues;
           this.cardType = cardType;
           this.comment = comment;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the serialNumber value for this SmartCredentialInfo.
     * 
     * @return serialNumber   * The serial number of the smart credential.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this SmartCredentialInfo.
     * 
     * @param serialNumber   * The serial number of the smart credential.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the cardUID value for this SmartCredentialInfo.
     * 
     * @return cardUID   * The optional UID of the card.
     */
    public String getCardUID() {
        return cardUID;
    }


    /**
     * Sets the cardUID value for this SmartCredentialInfo.
     * 
     * @param cardUID   * The optional UID of the card.
     */
    public void setCardUID(String cardUID) {
        this.cardUID = cardUID;
    }


    /**
     * Gets the cardManagerKeys value for this SmartCredentialInfo.
     * 
     * @return cardManagerKeys   * The card manager keys of this smart
     *                                 credential.  If the admininstrator
     * does
     *                                 not have permission to view the card
     * manager keys, this value will be null.
     */
    public byte[][] getCardManagerKeys() {
        return cardManagerKeys;
    }


    /**
     * Sets the cardManagerKeys value for this SmartCredentialInfo.
     * 
     * @param cardManagerKeys   * The card manager keys of this smart
     *                                 credential.  If the admininstrator
     * does
     *                                 not have permission to view the card
     * manager keys, this value will be null.
     */
    public void setCardManagerKeys(byte[][] cardManagerKeys) {
        this.cardManagerKeys = cardManagerKeys;
    }


    /**
     * Gets the cardManagerKeyVersion value for this SmartCredentialInfo.
     * 
     * @return cardManagerKeyVersion   * The version of the card manager keys of this
     *                                 smart credential.  If the admininstrator
     * does
     *                                 not have permission to view the card
     * manager keys, this value will be null.
     */
    public Integer getCardManagerKeyVersion() {
        return cardManagerKeyVersion;
    }


    /**
     * Sets the cardManagerKeyVersion value for this SmartCredentialInfo.
     * 
     * @param cardManagerKeyVersion   * The version of the card manager keys of this
     *                                 smart credential.  If the admininstrator
     * does
     *                                 not have permission to view the card
     * manager keys, this value will be null.
     */
    public void setCardManagerKeyVersion(Integer cardManagerKeyVersion) {
        this.cardManagerKeyVersion = cardManagerKeyVersion;
    }


    /**
     * Gets the state value for this SmartCredentialInfo.
     * 
     * @return state   * The state of the smart credential.
     */
    public SmartCredentialState getState() {
        return state;
    }


    /**
     * Sets the state value for this SmartCredentialInfo.
     * 
     * @param state   * The state of the smart credential.
     */
    public void setState(SmartCredentialState state) {
        this.state = state;
    }


    /**
     * Gets the loadDate value for this SmartCredentialInfo.
     * 
     * @return loadDate   * The load date of the smart credential.
     */
    public java.util.Calendar getLoadDate() {
        return loadDate;
    }


    /**
     * Sets the loadDate value for this SmartCredentialInfo.
     * 
     * @param loadDate   * The load date of the smart credential.
     */
    public void setLoadDate(java.util.Calendar loadDate) {
        this.loadDate = loadDate;
    }


    /**
     * Gets the group value for this SmartCredentialInfo.
     * 
     * @return group   * The group this smart credential belongs to.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this SmartCredentialInfo.
     * 
     * @param group   * The group this smart credential belongs to.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the enrollmentValues value for this SmartCredentialInfo.
     * 
     * @return enrollmentValues   * A list of values provided for the smart
     *                                 credential when loaded from the data
     * file.
     */
    public NameValue[] getEnrollmentValues() {
        return enrollmentValues;
    }


    /**
     * Sets the enrollmentValues value for this SmartCredentialInfo.
     * 
     * @param enrollmentValues   * A list of values provided for the smart
     *                                 credential when loaded from the data
     * file.
     */
    public void setEnrollmentValues(NameValue[] enrollmentValues) {
        this.enrollmentValues = enrollmentValues;
    }


    /**
     * Gets the cardType value for this SmartCredentialInfo.
     * 
     * @return cardType   * The type of card this smart credential
     *                                 represents.
     */
    public String getCardType() {
        return cardType;
    }


    /**
     * Sets the cardType value for this SmartCredentialInfo.
     * 
     * @param cardType   * The type of card this smart credential
     *                                 represents.
     */
    public void setCardType(String cardType) {
        this.cardType = cardType;
    }


    /**
     * Gets the comment value for this SmartCredentialInfo.
     * 
     * @return comment   * The smart credential comment.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this SmartCredentialInfo.
     * 
     * @param comment   * The smart credential comment.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }


    /**
     * Gets the rolesGrantingAccess value for this SmartCredentialInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this SmartCredentialInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialInfo)) return false;
        SmartCredentialInfo other = (SmartCredentialInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.cardUID==null && other.getCardUID()==null) || 
             (this.cardUID!=null &&
              this.cardUID.equals(other.getCardUID()))) &&
            ((this.cardManagerKeys==null && other.getCardManagerKeys()==null) || 
             (this.cardManagerKeys!=null &&
              java.util.Arrays.equals(this.cardManagerKeys, other.getCardManagerKeys()))) &&
            ((this.cardManagerKeyVersion==null && other.getCardManagerKeyVersion()==null) || 
             (this.cardManagerKeyVersion!=null &&
              this.cardManagerKeyVersion.equals(other.getCardManagerKeyVersion()))) &&
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              this.state.equals(other.getState()))) &&
            ((this.loadDate==null && other.getLoadDate()==null) || 
             (this.loadDate!=null &&
              this.loadDate.equals(other.getLoadDate()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.enrollmentValues==null && other.getEnrollmentValues()==null) || 
             (this.enrollmentValues!=null &&
              java.util.Arrays.equals(this.enrollmentValues, other.getEnrollmentValues()))) &&
            ((this.cardType==null && other.getCardType()==null) || 
             (this.cardType!=null &&
              this.cardType.equals(other.getCardType()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getCardUID() != null) {
            _hashCode += getCardUID().hashCode();
        }
        if (getCardManagerKeys() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCardManagerKeys());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCardManagerKeys(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCardManagerKeyVersion() != null) {
            _hashCode += getCardManagerKeyVersion().hashCode();
        }
        if (getState() != null) {
            _hashCode += getState().hashCode();
        }
        if (getLoadDate() != null) {
            _hashCode += getLoadDate().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getEnrollmentValues() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getEnrollmentValues());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getEnrollmentValues(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getCardType() != null) {
            _hashCode += getCardType().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardUID");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CardUID"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardManagerKeys");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CardManagerKeys"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardManagerKeyVersion");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CardManagerKeyVersion"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "State"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialState"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "LoadDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("enrollmentValues");
        elemField.setXmlName(new javax.xml.namespace.QName("", "EnrollmentValues"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "NameValue"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CardType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
