/**
 * SmartCredentialLicenseInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Information about the system's smart credential license settings.
 */
public class SmartCredentialLicenseInfo  implements java.io.Serializable {
    /* The current number of licensed smart credentials in the system. */
    private java.math.BigInteger numSmartCredentials;

    /* The maximum number of licensed smart credentials that can
     *                                 exist in the system. The system will
     * not allow
     *                                 more than this many smart credentials
     * to be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of smart credentials in the
     * system, or the
     *                                 licenseCheck operation was called
     * to count
     *                                 licensed smart credentials and did
     * not provide installation
     *                                 and activation keys. */
    private java.math.BigInteger maxSmartCredentials;

    /* The date at which the smart credential license expires. The
     * system will stop allowing smart credentials
     *                                 to be created after this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the licenseCheck operation
     * was
     *                                 called to count licensed smart credentials
     * and did not
     *                                 provide installation and activation
     * keys. */
    private java.util.Calendar expiryDate;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public SmartCredentialLicenseInfo() {
    }

    public SmartCredentialLicenseInfo(
           java.math.BigInteger numSmartCredentials,
           java.math.BigInteger maxSmartCredentials,
           java.util.Calendar expiryDate,
           String[] rolesGrantingAccess) {
           this.numSmartCredentials = numSmartCredentials;
           this.maxSmartCredentials = maxSmartCredentials;
           this.expiryDate = expiryDate;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the numSmartCredentials value for this SmartCredentialLicenseInfo.
     * 
     * @return numSmartCredentials   * The current number of licensed smart credentials in the system.
     */
    public java.math.BigInteger getNumSmartCredentials() {
        return numSmartCredentials;
    }


    /**
     * Sets the numSmartCredentials value for this SmartCredentialLicenseInfo.
     * 
     * @param numSmartCredentials   * The current number of licensed smart credentials in the system.
     */
    public void setNumSmartCredentials(java.math.BigInteger numSmartCredentials) {
        this.numSmartCredentials = numSmartCredentials;
    }


    /**
     * Gets the maxSmartCredentials value for this SmartCredentialLicenseInfo.
     * 
     * @return maxSmartCredentials   * The maximum number of licensed smart credentials that can
     *                                 exist in the system. The system will
     * not allow
     *                                 more than this many smart credentials
     * to be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of smart credentials in the
     * system, or the
     *                                 licenseCheck operation was called
     * to count
     *                                 licensed smart credentials and did
     * not provide installation
     *                                 and activation keys.
     */
    public java.math.BigInteger getMaxSmartCredentials() {
        return maxSmartCredentials;
    }


    /**
     * Sets the maxSmartCredentials value for this SmartCredentialLicenseInfo.
     * 
     * @param maxSmartCredentials   * The maximum number of licensed smart credentials that can
     *                                 exist in the system. The system will
     * not allow
     *                                 more than this many smart credentials
     * to be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of smart credentials in the
     * system, or the
     *                                 licenseCheck operation was called
     * to count
     *                                 licensed smart credentials and did
     * not provide installation
     *                                 and activation keys.
     */
    public void setMaxSmartCredentials(java.math.BigInteger maxSmartCredentials) {
        this.maxSmartCredentials = maxSmartCredentials;
    }


    /**
     * Gets the expiryDate value for this SmartCredentialLicenseInfo.
     * 
     * @return expiryDate   * The date at which the smart credential license expires. The
     * system will stop allowing smart credentials
     *                                 to be created after this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the licenseCheck operation
     * was
     *                                 called to count licensed smart credentials
     * and did not
     *                                 provide installation and activation
     * keys.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this SmartCredentialLicenseInfo.
     * 
     * @param expiryDate   * The date at which the smart credential license expires. The
     * system will stop allowing smart credentials
     *                                 to be created after this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the licenseCheck operation
     * was
     *                                 called to count licensed smart credentials
     * and did not
     *                                 provide installation and activation
     * keys.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the rolesGrantingAccess value for this SmartCredentialLicenseInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this SmartCredentialLicenseInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialLicenseInfo)) return false;
        SmartCredentialLicenseInfo other = (SmartCredentialLicenseInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.numSmartCredentials==null && other.getNumSmartCredentials()==null) || 
             (this.numSmartCredentials!=null &&
              this.numSmartCredentials.equals(other.getNumSmartCredentials()))) &&
            ((this.maxSmartCredentials==null && other.getMaxSmartCredentials()==null) || 
             (this.maxSmartCredentials!=null &&
              this.maxSmartCredentials.equals(other.getMaxSmartCredentials()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getNumSmartCredentials() != null) {
            _hashCode += getNumSmartCredentials().hashCode();
        }
        if (getMaxSmartCredentials() != null) {
            _hashCode += getMaxSmartCredentials().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialLicenseInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialLicenseInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numSmartCredentials");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numSmartCredentials"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxSmartCredentials");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxSmartCredentials"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
