/**
 * SmartCredentialParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when loading or modifying
 *                      unassigned smart credentials. All values can
 * be null
 *                      indicating that the default is used when loading
 * or the
 *                      value is not changed for modify.
 */
public class SmartCredentialParms  implements java.io.Serializable {
    /* The group this smart credential belongs to. If null
     *                            during load, the smart credential will
     * belong to the
     *                            default group. */
    private String group;

    /* The state of this smart credential.
     *                            during load, the state will default to
     * ACTIVE. */
    private SmartCredentialState state;

    /* The smart credential data to load for the
     *                            smartCredentialLoad operation.
     *                            Ignored when modifying smart credentials. */
    private byte[] data;

    /* The key used to unlock the smart credential data in
     *                            the smartCredentialLoad operation.
     *                            Ignored when modifying smart credentials. */
    private String key;

    /* The smart credential comment. Defaults to an empty
     *                            string if not specified during a smartCredentialLoad
     * operation. */
    private String comment;

    public SmartCredentialParms() {
    }

    public SmartCredentialParms(
           String group,
           SmartCredentialState state,
           byte[] data,
           String key,
           String comment) {
           this.group = group;
           this.state = state;
           this.data = data;
           this.key = key;
           this.comment = comment;
    }


    /**
     * Gets the group value for this SmartCredentialParms.
     * 
     * @return group   * The group this smart credential belongs to. If null
     *                            during load, the smart credential will
     * belong to the
     *                            default group.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this SmartCredentialParms.
     * 
     * @param group   * The group this smart credential belongs to. If null
     *                            during load, the smart credential will
     * belong to the
     *                            default group.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the state value for this SmartCredentialParms.
     * 
     * @return state   * The state of this smart credential.
     *                            during load, the state will default to
     * ACTIVE.
     */
    public SmartCredentialState getState() {
        return state;
    }


    /**
     * Sets the state value for this SmartCredentialParms.
     * 
     * @param state   * The state of this smart credential.
     *                            during load, the state will default to
     * ACTIVE.
     */
    public void setState(SmartCredentialState state) {
        this.state = state;
    }


    /**
     * Gets the data value for this SmartCredentialParms.
     * 
     * @return data   * The smart credential data to load for the
     *                            smartCredentialLoad operation.
     *                            Ignored when modifying smart credentials.
     */
    public byte[] getData() {
        return data;
    }


    /**
     * Sets the data value for this SmartCredentialParms.
     * 
     * @param data   * The smart credential data to load for the
     *                            smartCredentialLoad operation.
     *                            Ignored when modifying smart credentials.
     */
    public void setData(byte[] data) {
        this.data = data;
    }


    /**
     * Gets the key value for this SmartCredentialParms.
     * 
     * @return key   * The key used to unlock the smart credential data in
     *                            the smartCredentialLoad operation.
     *                            Ignored when modifying smart credentials.
     */
    public String getKey() {
        return key;
    }


    /**
     * Sets the key value for this SmartCredentialParms.
     * 
     * @param key   * The key used to unlock the smart credential data in
     *                            the smartCredentialLoad operation.
     *                            Ignored when modifying smart credentials.
     */
    public void setKey(String key) {
        this.key = key;
    }


    /**
     * Gets the comment value for this SmartCredentialParms.
     * 
     * @return comment   * The smart credential comment. Defaults to an empty
     *                            string if not specified during a smartCredentialLoad
     * operation.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this SmartCredentialParms.
     * 
     * @param comment   * The smart credential comment. Defaults to an empty
     *                            string if not specified during a smartCredentialLoad
     * operation.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialParms)) return false;
        SmartCredentialParms other = (SmartCredentialParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              this.state.equals(other.getState()))) &&
            ((this.data==null && other.getData()==null) || 
             (this.data!=null &&
              java.util.Arrays.equals(this.data, other.getData()))) &&
            ((this.key==null && other.getKey()==null) || 
             (this.key!=null &&
              this.key.equals(other.getKey()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getState() != null) {
            _hashCode += getState().hashCode();
        }
        if (getData() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getData());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getData(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getKey() != null) {
            _hashCode += getKey().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "State"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialState"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("data");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Data"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("key");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Key"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
