/**
 * SmartCredentialPrintModuleInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a SmartCredential Print Module
 */
public class SmartCredentialPrintModuleInfo  implements java.io.Serializable {
    /* The name of the Smart Credential Print Module. */
    private String name;

    /* A URL of the Smart Credential Print Module. */
    private String URL;

    /* A flag indicating if this Print Module has
     *                                 a shared key. */
    private boolean sharedKey;

    /* The connection timeout (in msec) used when
     *                                 when connecting to this Print Module.
     * A value of
     *                                 0 means infinite timeout. */
    private int connectionTimeout;

    /* A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * Print Module. */
    private boolean disableSSLHostnameValidation;

    /* A flag indicating if this print module
     *                                 supports printing a Smart Credential */
    private boolean supportsPrint;

    /* A flag indicating if this print module supports
     *                                 encoding a Smart Credential using
     * the
     *                                 Print Module's card reader.
     *                                 operation. */
    private boolean supportsPrinterEncode;

    /* A flag indicating if this Print Module supports
     *                                 encoding a Smart Credential using
     * an
     *                                 external card reader. */
    private boolean supportsExternalEncode;

    /* A flag indicating if this Print Module supports
     *                                 encoding physical access information
     * onto
     *                                 a Smart Credential */
    private boolean supportsProximity;

    /* A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * card 
     *                                 reader of the Print Module printer. */
    private boolean supportsPrinterWipe;

    /* A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * external card 
     *                                 reader of the Print Module. */
    private boolean supportsExternalWipe;

    /* The state of the current or last wipe
     *                                 operation performed against this Print
     * Module. */
    private SmartCredentialWipeState wipeState;

    /* The date of the current or last wipe operation
     *                                 performed against this Print Module. */
    private java.util.Calendar wipeDate;

    /* Status information of the current or last wipe
     *                                 operation performed against this Print
     * Module. */
    private String wipeInfo;

    /* A count of the number of cards wiped
     *                                 during the current or last wipe operation
     * performed against this Print Module. */
    private Integer wipeCount;

    /* The name of the proxy used to communicate with
     *                                 this print module.  If not set, a
     * proxy
     *                                 is not used. */
    private String proxy;

    /* A description of the Smart Credential Print Module. */
    private String description;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public SmartCredentialPrintModuleInfo() {
    }

    public SmartCredentialPrintModuleInfo(
           String name,
           String URL,
           boolean sharedKey,
           int connectionTimeout,
           boolean disableSSLHostnameValidation,
           boolean supportsPrint,
           boolean supportsPrinterEncode,
           boolean supportsExternalEncode,
           boolean supportsProximity,
           boolean supportsPrinterWipe,
           boolean supportsExternalWipe,
           SmartCredentialWipeState wipeState,
           java.util.Calendar wipeDate,
           String wipeInfo,
           Integer wipeCount,
           String proxy,
           String description,
           String[] rolesGrantingAccess) {
           this.name = name;
           this.URL = URL;
           this.sharedKey = sharedKey;
           this.connectionTimeout = connectionTimeout;
           this.disableSSLHostnameValidation = disableSSLHostnameValidation;
           this.supportsPrint = supportsPrint;
           this.supportsPrinterEncode = supportsPrinterEncode;
           this.supportsExternalEncode = supportsExternalEncode;
           this.supportsProximity = supportsProximity;
           this.supportsPrinterWipe = supportsPrinterWipe;
           this.supportsExternalWipe = supportsExternalWipe;
           this.wipeState = wipeState;
           this.wipeDate = wipeDate;
           this.wipeInfo = wipeInfo;
           this.wipeCount = wipeCount;
           this.proxy = proxy;
           this.description = description;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the name value for this SmartCredentialPrintModuleInfo.
     * 
     * @return name   * The name of the Smart Credential Print Module.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialPrintModuleInfo.
     * 
     * @param name   * The name of the Smart Credential Print Module.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the URL value for this SmartCredentialPrintModuleInfo.
     * 
     * @return URL   * A URL of the Smart Credential Print Module.
     */
    public String getURL() {
        return URL;
    }


    /**
     * Sets the URL value for this SmartCredentialPrintModuleInfo.
     * 
     * @param URL   * A URL of the Smart Credential Print Module.
     */
    public void setURL(String URL) {
        this.URL = URL;
    }


    /**
     * Gets the sharedKey value for this SmartCredentialPrintModuleInfo.
     * 
     * @return sharedKey   * A flag indicating if this Print Module has
     *                                 a shared key.
     */
    public boolean isSharedKey() {
        return sharedKey;
    }


    /**
     * Sets the sharedKey value for this SmartCredentialPrintModuleInfo.
     * 
     * @param sharedKey   * A flag indicating if this Print Module has
     *                                 a shared key.
     */
    public void setSharedKey(boolean sharedKey) {
        this.sharedKey = sharedKey;
    }


    /**
     * Gets the connectionTimeout value for this SmartCredentialPrintModuleInfo.
     * 
     * @return connectionTimeout   * The connection timeout (in msec) used when
     *                                 when connecting to this Print Module.
     * A value of
     *                                 0 means infinite timeout.
     */
    public int getConnectionTimeout() {
        return connectionTimeout;
    }


    /**
     * Sets the connectionTimeout value for this SmartCredentialPrintModuleInfo.
     * 
     * @param connectionTimeout   * The connection timeout (in msec) used when
     *                                 when connecting to this Print Module.
     * A value of
     *                                 0 means infinite timeout.
     */
    public void setConnectionTimeout(int connectionTimeout) {
        this.connectionTimeout = connectionTimeout;
    }


    /**
     * Gets the disableSSLHostnameValidation value for this SmartCredentialPrintModuleInfo.
     * 
     * @return disableSSLHostnameValidation   * A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * Print Module.
     */
    public boolean isDisableSSLHostnameValidation() {
        return disableSSLHostnameValidation;
    }


    /**
     * Sets the disableSSLHostnameValidation value for this SmartCredentialPrintModuleInfo.
     * 
     * @param disableSSLHostnameValidation   * A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * Print Module.
     */
    public void setDisableSSLHostnameValidation(boolean disableSSLHostnameValidation) {
        this.disableSSLHostnameValidation = disableSSLHostnameValidation;
    }


    /**
     * Gets the supportsPrint value for this SmartCredentialPrintModuleInfo.
     * 
     * @return supportsPrint   * A flag indicating if this print module
     *                                 supports printing a Smart Credential
     */
    public boolean isSupportsPrint() {
        return supportsPrint;
    }


    /**
     * Sets the supportsPrint value for this SmartCredentialPrintModuleInfo.
     * 
     * @param supportsPrint   * A flag indicating if this print module
     *                                 supports printing a Smart Credential
     */
    public void setSupportsPrint(boolean supportsPrint) {
        this.supportsPrint = supportsPrint;
    }


    /**
     * Gets the supportsPrinterEncode value for this SmartCredentialPrintModuleInfo.
     * 
     * @return supportsPrinterEncode   * A flag indicating if this print module supports
     *                                 encoding a Smart Credential using
     * the
     *                                 Print Module's card reader.
     *                                 operation.
     */
    public boolean isSupportsPrinterEncode() {
        return supportsPrinterEncode;
    }


    /**
     * Sets the supportsPrinterEncode value for this SmartCredentialPrintModuleInfo.
     * 
     * @param supportsPrinterEncode   * A flag indicating if this print module supports
     *                                 encoding a Smart Credential using
     * the
     *                                 Print Module's card reader.
     *                                 operation.
     */
    public void setSupportsPrinterEncode(boolean supportsPrinterEncode) {
        this.supportsPrinterEncode = supportsPrinterEncode;
    }


    /**
     * Gets the supportsExternalEncode value for this SmartCredentialPrintModuleInfo.
     * 
     * @return supportsExternalEncode   * A flag indicating if this Print Module supports
     *                                 encoding a Smart Credential using
     * an
     *                                 external card reader.
     */
    public boolean isSupportsExternalEncode() {
        return supportsExternalEncode;
    }


    /**
     * Sets the supportsExternalEncode value for this SmartCredentialPrintModuleInfo.
     * 
     * @param supportsExternalEncode   * A flag indicating if this Print Module supports
     *                                 encoding a Smart Credential using
     * an
     *                                 external card reader.
     */
    public void setSupportsExternalEncode(boolean supportsExternalEncode) {
        this.supportsExternalEncode = supportsExternalEncode;
    }


    /**
     * Gets the supportsProximity value for this SmartCredentialPrintModuleInfo.
     * 
     * @return supportsProximity   * A flag indicating if this Print Module supports
     *                                 encoding physical access information
     * onto
     *                                 a Smart Credential
     */
    public boolean isSupportsProximity() {
        return supportsProximity;
    }


    /**
     * Sets the supportsProximity value for this SmartCredentialPrintModuleInfo.
     * 
     * @param supportsProximity   * A flag indicating if this Print Module supports
     *                                 encoding physical access information
     * onto
     *                                 a Smart Credential
     */
    public void setSupportsProximity(boolean supportsProximity) {
        this.supportsProximity = supportsProximity;
    }


    /**
     * Gets the supportsPrinterWipe value for this SmartCredentialPrintModuleInfo.
     * 
     * @return supportsPrinterWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * card 
     *                                 reader of the Print Module printer.
     */
    public boolean isSupportsPrinterWipe() {
        return supportsPrinterWipe;
    }


    /**
     * Sets the supportsPrinterWipe value for this SmartCredentialPrintModuleInfo.
     * 
     * @param supportsPrinterWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * card 
     *                                 reader of the Print Module printer.
     */
    public void setSupportsPrinterWipe(boolean supportsPrinterWipe) {
        this.supportsPrinterWipe = supportsPrinterWipe;
    }


    /**
     * Gets the supportsExternalWipe value for this SmartCredentialPrintModuleInfo.
     * 
     * @return supportsExternalWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * external card 
     *                                 reader of the Print Module.
     */
    public boolean isSupportsExternalWipe() {
        return supportsExternalWipe;
    }


    /**
     * Sets the supportsExternalWipe value for this SmartCredentialPrintModuleInfo.
     * 
     * @param supportsExternalWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * external card 
     *                                 reader of the Print Module.
     */
    public void setSupportsExternalWipe(boolean supportsExternalWipe) {
        this.supportsExternalWipe = supportsExternalWipe;
    }


    /**
     * Gets the wipeState value for this SmartCredentialPrintModuleInfo.
     * 
     * @return wipeState   * The state of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public SmartCredentialWipeState getWipeState() {
        return wipeState;
    }


    /**
     * Sets the wipeState value for this SmartCredentialPrintModuleInfo.
     * 
     * @param wipeState   * The state of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public void setWipeState(SmartCredentialWipeState wipeState) {
        this.wipeState = wipeState;
    }


    /**
     * Gets the wipeDate value for this SmartCredentialPrintModuleInfo.
     * 
     * @return wipeDate   * The date of the current or last wipe operation
     *                                 performed against this Print Module.
     */
    public java.util.Calendar getWipeDate() {
        return wipeDate;
    }


    /**
     * Sets the wipeDate value for this SmartCredentialPrintModuleInfo.
     * 
     * @param wipeDate   * The date of the current or last wipe operation
     *                                 performed against this Print Module.
     */
    public void setWipeDate(java.util.Calendar wipeDate) {
        this.wipeDate = wipeDate;
    }


    /**
     * Gets the wipeInfo value for this SmartCredentialPrintModuleInfo.
     * 
     * @return wipeInfo   * Status information of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public String getWipeInfo() {
        return wipeInfo;
    }


    /**
     * Sets the wipeInfo value for this SmartCredentialPrintModuleInfo.
     * 
     * @param wipeInfo   * Status information of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public void setWipeInfo(String wipeInfo) {
        this.wipeInfo = wipeInfo;
    }


    /**
     * Gets the wipeCount value for this SmartCredentialPrintModuleInfo.
     * 
     * @return wipeCount   * A count of the number of cards wiped
     *                                 during the current or last wipe operation
     * performed against this Print Module.
     */
    public Integer getWipeCount() {
        return wipeCount;
    }


    /**
     * Sets the wipeCount value for this SmartCredentialPrintModuleInfo.
     * 
     * @param wipeCount   * A count of the number of cards wiped
     *                                 during the current or last wipe operation
     * performed against this Print Module.
     */
    public void setWipeCount(Integer wipeCount) {
        this.wipeCount = wipeCount;
    }


    /**
     * Gets the proxy value for this SmartCredentialPrintModuleInfo.
     * 
     * @return proxy   * The name of the proxy used to communicate with
     *                                 this print module.  If not set, a
     * proxy
     *                                 is not used.
     */
    public String getProxy() {
        return proxy;
    }


    /**
     * Sets the proxy value for this SmartCredentialPrintModuleInfo.
     * 
     * @param proxy   * The name of the proxy used to communicate with
     *                                 this print module.  If not set, a
     * proxy
     *                                 is not used.
     */
    public void setProxy(String proxy) {
        this.proxy = proxy;
    }


    /**
     * Gets the description value for this SmartCredentialPrintModuleInfo.
     * 
     * @return description   * A description of the Smart Credential Print Module.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this SmartCredentialPrintModuleInfo.
     * 
     * @param description   * A description of the Smart Credential Print Module.
     */
    public void setDescription(String description) {
        this.description = description;
    }


    /**
     * Gets the rolesGrantingAccess value for this SmartCredentialPrintModuleInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this SmartCredentialPrintModuleInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialPrintModuleInfo)) return false;
        SmartCredentialPrintModuleInfo other = (SmartCredentialPrintModuleInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.URL==null && other.getURL()==null) || 
             (this.URL!=null &&
              this.URL.equals(other.getURL()))) &&
            this.sharedKey == other.isSharedKey() &&
            this.connectionTimeout == other.getConnectionTimeout() &&
            this.disableSSLHostnameValidation == other.isDisableSSLHostnameValidation() &&
            this.supportsPrint == other.isSupportsPrint() &&
            this.supportsPrinterEncode == other.isSupportsPrinterEncode() &&
            this.supportsExternalEncode == other.isSupportsExternalEncode() &&
            this.supportsProximity == other.isSupportsProximity() &&
            this.supportsPrinterWipe == other.isSupportsPrinterWipe() &&
            this.supportsExternalWipe == other.isSupportsExternalWipe() &&
            ((this.wipeState==null && other.getWipeState()==null) || 
             (this.wipeState!=null &&
              this.wipeState.equals(other.getWipeState()))) &&
            ((this.wipeDate==null && other.getWipeDate()==null) || 
             (this.wipeDate!=null &&
              this.wipeDate.equals(other.getWipeDate()))) &&
            ((this.wipeInfo==null && other.getWipeInfo()==null) || 
             (this.wipeInfo!=null &&
              this.wipeInfo.equals(other.getWipeInfo()))) &&
            ((this.wipeCount==null && other.getWipeCount()==null) || 
             (this.wipeCount!=null &&
              this.wipeCount.equals(other.getWipeCount()))) &&
            ((this.proxy==null && other.getProxy()==null) || 
             (this.proxy!=null &&
              this.proxy.equals(other.getProxy()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getURL() != null) {
            _hashCode += getURL().hashCode();
        }
        _hashCode += (isSharedKey() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += getConnectionTimeout();
        _hashCode += (isDisableSSLHostnameValidation() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsPrint() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsPrinterEncode() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsExternalEncode() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsProximity() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsPrinterWipe() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsExternalWipe() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getWipeState() != null) {
            _hashCode += getWipeState().hashCode();
        }
        if (getWipeDate() != null) {
            _hashCode += getWipeDate().hashCode();
        }
        if (getWipeInfo() != null) {
            _hashCode += getWipeInfo().hashCode();
        }
        if (getWipeCount() != null) {
            _hashCode += getWipeCount().hashCode();
        }
        if (getProxy() != null) {
            _hashCode += getProxy().hashCode();
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialPrintModuleInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialPrintModuleInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("URL");
        elemField.setXmlName(new javax.xml.namespace.QName("", "URL"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("sharedKey");
        elemField.setXmlName(new javax.xml.namespace.QName("", "sharedKey"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("connectionTimeout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "connectionTimeout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("disableSSLHostnameValidation");
        elemField.setXmlName(new javax.xml.namespace.QName("", "disableSSLHostnameValidation"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsPrint");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsPrint"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsPrinterEncode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsPrinterEncode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsExternalEncode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsExternalEncode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsProximity");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsProximity"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsPrinterWipe");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsPrinterWipe"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsExternalWipe");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsExternalWipe"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeState");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeState"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialWipeState"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeCount");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeCount"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("proxy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "proxy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
