/**
 * SmartCredentialPrintModuleParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the paramaters that can be set when
 *                         creating or modifying a Smart Credential Print
 * Module.
 */
public class SmartCredentialPrintModuleParms  implements java.io.Serializable {
    /* When passed in a call to smartCredentialPrintModuleSet, this
     * specifies a new name for the Smart Credential Definition.
     *                                 If this is included in a call to
     *                                 smartCredentialPrintModuleCreate it
     * is ignored. */
    private String name;

    /* The URL of the Smart Credential Print Module.  This value
     *                                 is required for the smartCredentialPrintModuleCreate
     * operation and is optional for the smartCredentialPrintModuleSet
     *                                 operation. */
    private String URL;

    /* The shared key used to authenticate when
     *                                 sending requests to this Smart Credential
     * Print Module. */
    private String sharedKey;

    /* The connection timeout (in msec) used when
     *                                 when connecting to this Print Module.
     * A value of
     *                                 0 means infinite timeout. */
    private Integer connectionTimeout;

    /* A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * Print Module. */
    private Boolean disableSSLHostnameValidation;

    /* A flag indicating if this Print Module supports
     *                                 printing a Smart Credential.  If not
     * specified
     *                                 this value defaults to false when
     * creating a
     *                                 Smart Credential Print Module. */
    private Boolean supportsPrint;

    /* A flag indicating if this print module supports
     *                                 encoding a Smart Credential using
     * the
     *                                 Print Module's card reader.  If
     *                                 supportsPrinterEncode is true,
     *                                 supportsExternalEncode must be false. */
    private Boolean supportsPrinterEncode;

    /* A flag indicating if this Print Module supports
     *                                 encoding a Smart Credential using
     * an
     *                                 external card reader.
     *                                 If suppportsExternalEncode is true,
     * 
     *                                 supportsPrinterEncode must be false. */
    private Boolean supportsExternalEncode;

    /* A flag indicating if this print module supports
     *                                 encoding physical access information
     * onto
     *                                 a Smart Credential. */
    private Boolean supportsProximity;

    /* A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * card 
     *                                 reader of the Print Module printer. */
    private Boolean supportsPrinterWipe;

    /* A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * external card 
     *                                 reader of the Print Module. */
    private Boolean supportsExternalWipe;

    /* The state of the current or last wipe
     *                                 operation performed against this Print
     * Module. */
    private SmartCredentialWipeState wipeState;

    /* This argument is used by the print module.
     *                                 If specified as true, the wipe date
     * of
     *                                 this print module is updated to the
     * current date. */
    private Boolean wipeDate;

    /* Status information of the current or last wipe
     *                                 operation performed against this Print
     * Module. */
    private String wipeInfo;

    /* A count of the number of cards wiped
     *                                 during the current or last wipe operation
     * performed against this Print Module. */
    private Integer wipeCount;

    /* The name of the proxy used to communicate
     *                                 with this print module.  Set the value
     * to
     *                                 an empty string to remove the existing
     * proxy value. */
    private String proxy;

    /* Optional description. */
    private String description;

    public SmartCredentialPrintModuleParms() {
    }

    public SmartCredentialPrintModuleParms(
           String name,
           String URL,
           String sharedKey,
           Integer connectionTimeout,
           Boolean disableSSLHostnameValidation,
           Boolean supportsPrint,
           Boolean supportsPrinterEncode,
           Boolean supportsExternalEncode,
           Boolean supportsProximity,
           Boolean supportsPrinterWipe,
           Boolean supportsExternalWipe,
           SmartCredentialWipeState wipeState,
           Boolean wipeDate,
           String wipeInfo,
           Integer wipeCount,
           String proxy,
           String description) {
           this.name = name;
           this.URL = URL;
           this.sharedKey = sharedKey;
           this.connectionTimeout = connectionTimeout;
           this.disableSSLHostnameValidation = disableSSLHostnameValidation;
           this.supportsPrint = supportsPrint;
           this.supportsPrinterEncode = supportsPrinterEncode;
           this.supportsExternalEncode = supportsExternalEncode;
           this.supportsProximity = supportsProximity;
           this.supportsPrinterWipe = supportsPrinterWipe;
           this.supportsExternalWipe = supportsExternalWipe;
           this.wipeState = wipeState;
           this.wipeDate = wipeDate;
           this.wipeInfo = wipeInfo;
           this.wipeCount = wipeCount;
           this.proxy = proxy;
           this.description = description;
    }


    /**
     * Gets the name value for this SmartCredentialPrintModuleParms.
     * 
     * @return name   * When passed in a call to smartCredentialPrintModuleSet, this
     * specifies a new name for the Smart Credential Definition.
     *                                 If this is included in a call to
     *                                 smartCredentialPrintModuleCreate it
     * is ignored.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialPrintModuleParms.
     * 
     * @param name   * When passed in a call to smartCredentialPrintModuleSet, this
     * specifies a new name for the Smart Credential Definition.
     *                                 If this is included in a call to
     *                                 smartCredentialPrintModuleCreate it
     * is ignored.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the URL value for this SmartCredentialPrintModuleParms.
     * 
     * @return URL   * The URL of the Smart Credential Print Module.  This value
     *                                 is required for the smartCredentialPrintModuleCreate
     * operation and is optional for the smartCredentialPrintModuleSet
     *                                 operation.
     */
    public String getURL() {
        return URL;
    }


    /**
     * Sets the URL value for this SmartCredentialPrintModuleParms.
     * 
     * @param URL   * The URL of the Smart Credential Print Module.  This value
     *                                 is required for the smartCredentialPrintModuleCreate
     * operation and is optional for the smartCredentialPrintModuleSet
     *                                 operation.
     */
    public void setURL(String URL) {
        this.URL = URL;
    }


    /**
     * Gets the sharedKey value for this SmartCredentialPrintModuleParms.
     * 
     * @return sharedKey   * The shared key used to authenticate when
     *                                 sending requests to this Smart Credential
     * Print Module.
     */
    public String getSharedKey() {
        return sharedKey;
    }


    /**
     * Sets the sharedKey value for this SmartCredentialPrintModuleParms.
     * 
     * @param sharedKey   * The shared key used to authenticate when
     *                                 sending requests to this Smart Credential
     * Print Module.
     */
    public void setSharedKey(String sharedKey) {
        this.sharedKey = sharedKey;
    }


    /**
     * Gets the connectionTimeout value for this SmartCredentialPrintModuleParms.
     * 
     * @return connectionTimeout   * The connection timeout (in msec) used when
     *                                 when connecting to this Print Module.
     * A value of
     *                                 0 means infinite timeout.
     */
    public Integer getConnectionTimeout() {
        return connectionTimeout;
    }


    /**
     * Sets the connectionTimeout value for this SmartCredentialPrintModuleParms.
     * 
     * @param connectionTimeout   * The connection timeout (in msec) used when
     *                                 when connecting to this Print Module.
     * A value of
     *                                 0 means infinite timeout.
     */
    public void setConnectionTimeout(Integer connectionTimeout) {
        this.connectionTimeout = connectionTimeout;
    }


    /**
     * Gets the disableSSLHostnameValidation value for this SmartCredentialPrintModuleParms.
     * 
     * @return disableSSLHostnameValidation   * A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * Print Module.
     */
    public Boolean getDisableSSLHostnameValidation() {
        return disableSSLHostnameValidation;
    }


    /**
     * Sets the disableSSLHostnameValidation value for this SmartCredentialPrintModuleParms.
     * 
     * @param disableSSLHostnameValidation   * A flag indicating if SSL Hostname Validation
     *                                 is disabled when connecting to this
     * Print Module.
     */
    public void setDisableSSLHostnameValidation(Boolean disableSSLHostnameValidation) {
        this.disableSSLHostnameValidation = disableSSLHostnameValidation;
    }


    /**
     * Gets the supportsPrint value for this SmartCredentialPrintModuleParms.
     * 
     * @return supportsPrint   * A flag indicating if this Print Module supports
     *                                 printing a Smart Credential.  If not
     * specified
     *                                 this value defaults to false when
     * creating a
     *                                 Smart Credential Print Module.
     */
    public Boolean getSupportsPrint() {
        return supportsPrint;
    }


    /**
     * Sets the supportsPrint value for this SmartCredentialPrintModuleParms.
     * 
     * @param supportsPrint   * A flag indicating if this Print Module supports
     *                                 printing a Smart Credential.  If not
     * specified
     *                                 this value defaults to false when
     * creating a
     *                                 Smart Credential Print Module.
     */
    public void setSupportsPrint(Boolean supportsPrint) {
        this.supportsPrint = supportsPrint;
    }


    /**
     * Gets the supportsPrinterEncode value for this SmartCredentialPrintModuleParms.
     * 
     * @return supportsPrinterEncode   * A flag indicating if this print module supports
     *                                 encoding a Smart Credential using
     * the
     *                                 Print Module's card reader.  If
     *                                 supportsPrinterEncode is true,
     *                                 supportsExternalEncode must be false.
     */
    public Boolean getSupportsPrinterEncode() {
        return supportsPrinterEncode;
    }


    /**
     * Sets the supportsPrinterEncode value for this SmartCredentialPrintModuleParms.
     * 
     * @param supportsPrinterEncode   * A flag indicating if this print module supports
     *                                 encoding a Smart Credential using
     * the
     *                                 Print Module's card reader.  If
     *                                 supportsPrinterEncode is true,
     *                                 supportsExternalEncode must be false.
     */
    public void setSupportsPrinterEncode(Boolean supportsPrinterEncode) {
        this.supportsPrinterEncode = supportsPrinterEncode;
    }


    /**
     * Gets the supportsExternalEncode value for this SmartCredentialPrintModuleParms.
     * 
     * @return supportsExternalEncode   * A flag indicating if this Print Module supports
     *                                 encoding a Smart Credential using
     * an
     *                                 external card reader.
     *                                 If suppportsExternalEncode is true,
     * 
     *                                 supportsPrinterEncode must be false.
     */
    public Boolean getSupportsExternalEncode() {
        return supportsExternalEncode;
    }


    /**
     * Sets the supportsExternalEncode value for this SmartCredentialPrintModuleParms.
     * 
     * @param supportsExternalEncode   * A flag indicating if this Print Module supports
     *                                 encoding a Smart Credential using
     * an
     *                                 external card reader.
     *                                 If suppportsExternalEncode is true,
     * 
     *                                 supportsPrinterEncode must be false.
     */
    public void setSupportsExternalEncode(Boolean supportsExternalEncode) {
        this.supportsExternalEncode = supportsExternalEncode;
    }


    /**
     * Gets the supportsProximity value for this SmartCredentialPrintModuleParms.
     * 
     * @return supportsProximity   * A flag indicating if this print module supports
     *                                 encoding physical access information
     * onto
     *                                 a Smart Credential.
     */
    public Boolean getSupportsProximity() {
        return supportsProximity;
    }


    /**
     * Sets the supportsProximity value for this SmartCredentialPrintModuleParms.
     * 
     * @param supportsProximity   * A flag indicating if this print module supports
     *                                 encoding physical access information
     * onto
     *                                 a Smart Credential.
     */
    public void setSupportsProximity(Boolean supportsProximity) {
        this.supportsProximity = supportsProximity;
    }


    /**
     * Gets the supportsPrinterWipe value for this SmartCredentialPrintModuleParms.
     * 
     * @return supportsPrinterWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * card 
     *                                 reader of the Print Module printer.
     */
    public Boolean getSupportsPrinterWipe() {
        return supportsPrinterWipe;
    }


    /**
     * Sets the supportsPrinterWipe value for this SmartCredentialPrintModuleParms.
     * 
     * @param supportsPrinterWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * card 
     *                                 reader of the Print Module printer.
     */
    public void setSupportsPrinterWipe(Boolean supportsPrinterWipe) {
        this.supportsPrinterWipe = supportsPrinterWipe;
    }


    /**
     * Gets the supportsExternalWipe value for this SmartCredentialPrintModuleParms.
     * 
     * @return supportsExternalWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * external card 
     *                                 reader of the Print Module.
     */
    public Boolean getSupportsExternalWipe() {
        return supportsExternalWipe;
    }


    /**
     * Sets the supportsExternalWipe value for this SmartCredentialPrintModuleParms.
     * 
     * @param supportsExternalWipe   * A flag indicating if this Print Module supports
     *                                 the card wipe operation using the
     * external card 
     *                                 reader of the Print Module.
     */
    public void setSupportsExternalWipe(Boolean supportsExternalWipe) {
        this.supportsExternalWipe = supportsExternalWipe;
    }


    /**
     * Gets the wipeState value for this SmartCredentialPrintModuleParms.
     * 
     * @return wipeState   * The state of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public SmartCredentialWipeState getWipeState() {
        return wipeState;
    }


    /**
     * Sets the wipeState value for this SmartCredentialPrintModuleParms.
     * 
     * @param wipeState   * The state of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public void setWipeState(SmartCredentialWipeState wipeState) {
        this.wipeState = wipeState;
    }


    /**
     * Gets the wipeDate value for this SmartCredentialPrintModuleParms.
     * 
     * @return wipeDate   * This argument is used by the print module.
     *                                 If specified as true, the wipe date
     * of
     *                                 this print module is updated to the
     * current date.
     */
    public Boolean getWipeDate() {
        return wipeDate;
    }


    /**
     * Sets the wipeDate value for this SmartCredentialPrintModuleParms.
     * 
     * @param wipeDate   * This argument is used by the print module.
     *                                 If specified as true, the wipe date
     * of
     *                                 this print module is updated to the
     * current date.
     */
    public void setWipeDate(Boolean wipeDate) {
        this.wipeDate = wipeDate;
    }


    /**
     * Gets the wipeInfo value for this SmartCredentialPrintModuleParms.
     * 
     * @return wipeInfo   * Status information of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public String getWipeInfo() {
        return wipeInfo;
    }


    /**
     * Sets the wipeInfo value for this SmartCredentialPrintModuleParms.
     * 
     * @param wipeInfo   * Status information of the current or last wipe
     *                                 operation performed against this Print
     * Module.
     */
    public void setWipeInfo(String wipeInfo) {
        this.wipeInfo = wipeInfo;
    }


    /**
     * Gets the wipeCount value for this SmartCredentialPrintModuleParms.
     * 
     * @return wipeCount   * A count of the number of cards wiped
     *                                 during the current or last wipe operation
     * performed against this Print Module.
     */
    public Integer getWipeCount() {
        return wipeCount;
    }


    /**
     * Sets the wipeCount value for this SmartCredentialPrintModuleParms.
     * 
     * @param wipeCount   * A count of the number of cards wiped
     *                                 during the current or last wipe operation
     * performed against this Print Module.
     */
    public void setWipeCount(Integer wipeCount) {
        this.wipeCount = wipeCount;
    }


    /**
     * Gets the proxy value for this SmartCredentialPrintModuleParms.
     * 
     * @return proxy   * The name of the proxy used to communicate
     *                                 with this print module.  Set the value
     * to
     *                                 an empty string to remove the existing
     * proxy value.
     */
    public String getProxy() {
        return proxy;
    }


    /**
     * Sets the proxy value for this SmartCredentialPrintModuleParms.
     * 
     * @param proxy   * The name of the proxy used to communicate
     *                                 with this print module.  Set the value
     * to
     *                                 an empty string to remove the existing
     * proxy value.
     */
    public void setProxy(String proxy) {
        this.proxy = proxy;
    }


    /**
     * Gets the description value for this SmartCredentialPrintModuleParms.
     * 
     * @return description   * Optional description.
     */
    public String getDescription() {
        return description;
    }


    /**
     * Sets the description value for this SmartCredentialPrintModuleParms.
     * 
     * @param description   * Optional description.
     */
    public void setDescription(String description) {
        this.description = description;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialPrintModuleParms)) return false;
        SmartCredentialPrintModuleParms other = (SmartCredentialPrintModuleParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.URL==null && other.getURL()==null) || 
             (this.URL!=null &&
              this.URL.equals(other.getURL()))) &&
            ((this.sharedKey==null && other.getSharedKey()==null) || 
             (this.sharedKey!=null &&
              this.sharedKey.equals(other.getSharedKey()))) &&
            ((this.connectionTimeout==null && other.getConnectionTimeout()==null) || 
             (this.connectionTimeout!=null &&
              this.connectionTimeout.equals(other.getConnectionTimeout()))) &&
            ((this.disableSSLHostnameValidation==null && other.getDisableSSLHostnameValidation()==null) || 
             (this.disableSSLHostnameValidation!=null &&
              this.disableSSLHostnameValidation.equals(other.getDisableSSLHostnameValidation()))) &&
            ((this.supportsPrint==null && other.getSupportsPrint()==null) || 
             (this.supportsPrint!=null &&
              this.supportsPrint.equals(other.getSupportsPrint()))) &&
            ((this.supportsPrinterEncode==null && other.getSupportsPrinterEncode()==null) || 
             (this.supportsPrinterEncode!=null &&
              this.supportsPrinterEncode.equals(other.getSupportsPrinterEncode()))) &&
            ((this.supportsExternalEncode==null && other.getSupportsExternalEncode()==null) || 
             (this.supportsExternalEncode!=null &&
              this.supportsExternalEncode.equals(other.getSupportsExternalEncode()))) &&
            ((this.supportsProximity==null && other.getSupportsProximity()==null) || 
             (this.supportsProximity!=null &&
              this.supportsProximity.equals(other.getSupportsProximity()))) &&
            ((this.supportsPrinterWipe==null && other.getSupportsPrinterWipe()==null) || 
             (this.supportsPrinterWipe!=null &&
              this.supportsPrinterWipe.equals(other.getSupportsPrinterWipe()))) &&
            ((this.supportsExternalWipe==null && other.getSupportsExternalWipe()==null) || 
             (this.supportsExternalWipe!=null &&
              this.supportsExternalWipe.equals(other.getSupportsExternalWipe()))) &&
            ((this.wipeState==null && other.getWipeState()==null) || 
             (this.wipeState!=null &&
              this.wipeState.equals(other.getWipeState()))) &&
            ((this.wipeDate==null && other.getWipeDate()==null) || 
             (this.wipeDate!=null &&
              this.wipeDate.equals(other.getWipeDate()))) &&
            ((this.wipeInfo==null && other.getWipeInfo()==null) || 
             (this.wipeInfo!=null &&
              this.wipeInfo.equals(other.getWipeInfo()))) &&
            ((this.wipeCount==null && other.getWipeCount()==null) || 
             (this.wipeCount!=null &&
              this.wipeCount.equals(other.getWipeCount()))) &&
            ((this.proxy==null && other.getProxy()==null) || 
             (this.proxy!=null &&
              this.proxy.equals(other.getProxy()))) &&
            ((this.description==null && other.getDescription()==null) || 
             (this.description!=null &&
              this.description.equals(other.getDescription())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getURL() != null) {
            _hashCode += getURL().hashCode();
        }
        if (getSharedKey() != null) {
            _hashCode += getSharedKey().hashCode();
        }
        if (getConnectionTimeout() != null) {
            _hashCode += getConnectionTimeout().hashCode();
        }
        if (getDisableSSLHostnameValidation() != null) {
            _hashCode += getDisableSSLHostnameValidation().hashCode();
        }
        if (getSupportsPrint() != null) {
            _hashCode += getSupportsPrint().hashCode();
        }
        if (getSupportsPrinterEncode() != null) {
            _hashCode += getSupportsPrinterEncode().hashCode();
        }
        if (getSupportsExternalEncode() != null) {
            _hashCode += getSupportsExternalEncode().hashCode();
        }
        if (getSupportsProximity() != null) {
            _hashCode += getSupportsProximity().hashCode();
        }
        if (getSupportsPrinterWipe() != null) {
            _hashCode += getSupportsPrinterWipe().hashCode();
        }
        if (getSupportsExternalWipe() != null) {
            _hashCode += getSupportsExternalWipe().hashCode();
        }
        if (getWipeState() != null) {
            _hashCode += getWipeState().hashCode();
        }
        if (getWipeDate() != null) {
            _hashCode += getWipeDate().hashCode();
        }
        if (getWipeInfo() != null) {
            _hashCode += getWipeInfo().hashCode();
        }
        if (getWipeCount() != null) {
            _hashCode += getWipeCount().hashCode();
        }
        if (getProxy() != null) {
            _hashCode += getProxy().hashCode();
        }
        if (getDescription() != null) {
            _hashCode += getDescription().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialPrintModuleParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialPrintModuleParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("URL");
        elemField.setXmlName(new javax.xml.namespace.QName("", "URL"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("sharedKey");
        elemField.setXmlName(new javax.xml.namespace.QName("", "sharedKey"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("connectionTimeout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "connectionTimeout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("disableSSLHostnameValidation");
        elemField.setXmlName(new javax.xml.namespace.QName("", "disableSSLHostnameValidation"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsPrint");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsPrint"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsPrinterEncode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsPrinterEncode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsExternalEncode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsExternalEncode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsProximity");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsProximity"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsPrinterWipe");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsPrinterWipe"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsExternalWipe");
        elemField.setXmlName(new javax.xml.namespace.QName("", "supportsExternalWipe"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeState");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeState"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialWipeState"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("wipeCount");
        elemField.setXmlName(new javax.xml.namespace.QName("", "wipeCount"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("proxy");
        elemField.setXmlName(new javax.xml.namespace.QName("", "proxy"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("description");
        elemField.setXmlName(new javax.xml.namespace.QName("", "description"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
