/**
 * SmartCredentialVariableFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines a filter that can be matched against
 *                         the name and value of a Smart Credential Variable.
 * The variable filter must always include a name and
 *                         at least one of the string, boolean, integer
 * or date
 *                         values.
 */
public class SmartCredentialVariableFilter  implements java.io.Serializable {
    /* The variable name to match. */
    private String name;

    /* If specified and true then all of the
     *                                 search criteria are negated. */
    private Boolean not;

    /* Match this value against string variable
     *                                 values.This value may include wildcards. */
    private String stringValue;

    /* Match this value against boolean variable
     *                                 values. */
    private Boolean booleanValue;

    /* Match this value against integer variable
     *                                 values. */
    private java.math.BigInteger intValue;

    /* Match this value against integer variable
     *                                 values matching all variables that
     * have
     *                                 values greater than or equal to this
     * value. */
    private java.math.BigInteger intValueStart;

    /* Match this value against integer variable
     *                                 values matching all variables that
     * have
     *                                 values less than or equal to this
     * value. */
    private java.math.BigInteger intValueEnd;

    /* Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates with this value. */
    private java.util.Calendar dateValue;

    /* Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates at or after this value. */
    private java.util.Calendar dateValueStart;

    /* Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates at or before this value. */
    private java.util.Calendar dateValueEnd;

    public SmartCredentialVariableFilter() {
    }

    public SmartCredentialVariableFilter(
           String name,
           Boolean not,
           String stringValue,
           Boolean booleanValue,
           java.math.BigInteger intValue,
           java.math.BigInteger intValueStart,
           java.math.BigInteger intValueEnd,
           java.util.Calendar dateValue,
           java.util.Calendar dateValueStart,
           java.util.Calendar dateValueEnd) {
           this.name = name;
           this.not = not;
           this.stringValue = stringValue;
           this.booleanValue = booleanValue;
           this.intValue = intValue;
           this.intValueStart = intValueStart;
           this.intValueEnd = intValueEnd;
           this.dateValue = dateValue;
           this.dateValueStart = dateValueStart;
           this.dateValueEnd = dateValueEnd;
    }


    /**
     * Gets the name value for this SmartCredentialVariableFilter.
     * 
     * @return name   * The variable name to match.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialVariableFilter.
     * 
     * @param name   * The variable name to match.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the not value for this SmartCredentialVariableFilter.
     * 
     * @return not   * If specified and true then all of the
     *                                 search criteria are negated.
     */
    public Boolean getNot() {
        return not;
    }


    /**
     * Sets the not value for this SmartCredentialVariableFilter.
     * 
     * @param not   * If specified and true then all of the
     *                                 search criteria are negated.
     */
    public void setNot(Boolean not) {
        this.not = not;
    }


    /**
     * Gets the stringValue value for this SmartCredentialVariableFilter.
     * 
     * @return stringValue   * Match this value against string variable
     *                                 values.This value may include wildcards.
     */
    public String getStringValue() {
        return stringValue;
    }


    /**
     * Sets the stringValue value for this SmartCredentialVariableFilter.
     * 
     * @param stringValue   * Match this value against string variable
     *                                 values.This value may include wildcards.
     */
    public void setStringValue(String stringValue) {
        this.stringValue = stringValue;
    }


    /**
     * Gets the booleanValue value for this SmartCredentialVariableFilter.
     * 
     * @return booleanValue   * Match this value against boolean variable
     *                                 values.
     */
    public Boolean getBooleanValue() {
        return booleanValue;
    }


    /**
     * Sets the booleanValue value for this SmartCredentialVariableFilter.
     * 
     * @param booleanValue   * Match this value against boolean variable
     *                                 values.
     */
    public void setBooleanValue(Boolean booleanValue) {
        this.booleanValue = booleanValue;
    }


    /**
     * Gets the intValue value for this SmartCredentialVariableFilter.
     * 
     * @return intValue   * Match this value against integer variable
     *                                 values.
     */
    public java.math.BigInteger getIntValue() {
        return intValue;
    }


    /**
     * Sets the intValue value for this SmartCredentialVariableFilter.
     * 
     * @param intValue   * Match this value against integer variable
     *                                 values.
     */
    public void setIntValue(java.math.BigInteger intValue) {
        this.intValue = intValue;
    }


    /**
     * Gets the intValueStart value for this SmartCredentialVariableFilter.
     * 
     * @return intValueStart   * Match this value against integer variable
     *                                 values matching all variables that
     * have
     *                                 values greater than or equal to this
     * value.
     */
    public java.math.BigInteger getIntValueStart() {
        return intValueStart;
    }


    /**
     * Sets the intValueStart value for this SmartCredentialVariableFilter.
     * 
     * @param intValueStart   * Match this value against integer variable
     *                                 values matching all variables that
     * have
     *                                 values greater than or equal to this
     * value.
     */
    public void setIntValueStart(java.math.BigInteger intValueStart) {
        this.intValueStart = intValueStart;
    }


    /**
     * Gets the intValueEnd value for this SmartCredentialVariableFilter.
     * 
     * @return intValueEnd   * Match this value against integer variable
     *                                 values matching all variables that
     * have
     *                                 values less than or equal to this
     * value.
     */
    public java.math.BigInteger getIntValueEnd() {
        return intValueEnd;
    }


    /**
     * Sets the intValueEnd value for this SmartCredentialVariableFilter.
     * 
     * @param intValueEnd   * Match this value against integer variable
     *                                 values matching all variables that
     * have
     *                                 values less than or equal to this
     * value.
     */
    public void setIntValueEnd(java.math.BigInteger intValueEnd) {
        this.intValueEnd = intValueEnd;
    }


    /**
     * Gets the dateValue value for this SmartCredentialVariableFilter.
     * 
     * @return dateValue   * Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates with this value.
     */
    public java.util.Calendar getDateValue() {
        return dateValue;
    }


    /**
     * Sets the dateValue value for this SmartCredentialVariableFilter.
     * 
     * @param dateValue   * Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates with this value.
     */
    public void setDateValue(java.util.Calendar dateValue) {
        this.dateValue = dateValue;
    }


    /**
     * Gets the dateValueStart value for this SmartCredentialVariableFilter.
     * 
     * @return dateValueStart   * Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates at or after this value.
     */
    public java.util.Calendar getDateValueStart() {
        return dateValueStart;
    }


    /**
     * Sets the dateValueStart value for this SmartCredentialVariableFilter.
     * 
     * @param dateValueStart   * Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates at or after this value.
     */
    public void setDateValueStart(java.util.Calendar dateValueStart) {
        this.dateValueStart = dateValueStart;
    }


    /**
     * Gets the dateValueEnd value for this SmartCredentialVariableFilter.
     * 
     * @return dateValueEnd   * Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates at or before this value.
     */
    public java.util.Calendar getDateValueEnd() {
        return dateValueEnd;
    }


    /**
     * Sets the dateValueEnd value for this SmartCredentialVariableFilter.
     * 
     * @param dateValueEnd   * Match this value against date variable
     *                                 values matching all variables that
     * have
     *                                 dates at or before this value.
     */
    public void setDateValueEnd(java.util.Calendar dateValueEnd) {
        this.dateValueEnd = dateValueEnd;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialVariableFilter)) return false;
        SmartCredentialVariableFilter other = (SmartCredentialVariableFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.not==null && other.getNot()==null) || 
             (this.not!=null &&
              this.not.equals(other.getNot()))) &&
            ((this.stringValue==null && other.getStringValue()==null) || 
             (this.stringValue!=null &&
              this.stringValue.equals(other.getStringValue()))) &&
            ((this.booleanValue==null && other.getBooleanValue()==null) || 
             (this.booleanValue!=null &&
              this.booleanValue.equals(other.getBooleanValue()))) &&
            ((this.intValue==null && other.getIntValue()==null) || 
             (this.intValue!=null &&
              this.intValue.equals(other.getIntValue()))) &&
            ((this.intValueStart==null && other.getIntValueStart()==null) || 
             (this.intValueStart!=null &&
              this.intValueStart.equals(other.getIntValueStart()))) &&
            ((this.intValueEnd==null && other.getIntValueEnd()==null) || 
             (this.intValueEnd!=null &&
              this.intValueEnd.equals(other.getIntValueEnd()))) &&
            ((this.dateValue==null && other.getDateValue()==null) || 
             (this.dateValue!=null &&
              this.dateValue.equals(other.getDateValue()))) &&
            ((this.dateValueStart==null && other.getDateValueStart()==null) || 
             (this.dateValueStart!=null &&
              this.dateValueStart.equals(other.getDateValueStart()))) &&
            ((this.dateValueEnd==null && other.getDateValueEnd()==null) || 
             (this.dateValueEnd!=null &&
              this.dateValueEnd.equals(other.getDateValueEnd())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getNot() != null) {
            _hashCode += getNot().hashCode();
        }
        if (getStringValue() != null) {
            _hashCode += getStringValue().hashCode();
        }
        if (getBooleanValue() != null) {
            _hashCode += getBooleanValue().hashCode();
        }
        if (getIntValue() != null) {
            _hashCode += getIntValue().hashCode();
        }
        if (getIntValueStart() != null) {
            _hashCode += getIntValueStart().hashCode();
        }
        if (getIntValueEnd() != null) {
            _hashCode += getIntValueEnd().hashCode();
        }
        if (getDateValue() != null) {
            _hashCode += getDateValue().hashCode();
        }
        if (getDateValueStart() != null) {
            _hashCode += getDateValueStart().hashCode();
        }
        if (getDateValueEnd() != null) {
            _hashCode += getDateValueEnd().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialVariableFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("not");
        elemField.setXmlName(new javax.xml.namespace.QName("", "not"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("stringValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "stringValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("booleanValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "booleanValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("intValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "intValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("intValueStart");
        elemField.setXmlName(new javax.xml.namespace.QName("", "intValueStart"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("intValueEnd");
        elemField.setXmlName(new javax.xml.namespace.QName("", "intValueEnd"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dateValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "dateValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dateValueStart");
        elemField.setXmlName(new javax.xml.namespace.QName("", "dateValueStart"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dateValueEnd");
        elemField.setXmlName(new javax.xml.namespace.QName("", "dateValueEnd"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
