/**
 * SmartCredentialVariableInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a Smart Credential Variable.
 */
public class SmartCredentialVariableInfo  implements java.io.Serializable {
    /* The name of the Smart Credential variable. */
    private String name;

    /* The type of the Smart Credential variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableType type;

    /* The type of the Smart Credential variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions restrictions;

    /* Specifies if the variable value is converted
     *                                 before being printed. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType conversion;

    /* For an enumerated type, specifies the list of
     *                                 allowed values. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] options;

    /* The default value for this variable.
     *                                 allowed values. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableDefault defaultValue;

    /* The required value specifies whether the
     *                                 variable requires a value. */
    private boolean required;

    /* The generated value specifies if and how the
     *                                 variable value is generated when the
     * user smart credential is created. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated generated;

    /* The displayable value specifies whether the
     *                                 variable value can be displayed by
     * the
     *                                 administration clients. */
    private boolean displayable;

    /* The modifiable value specifies whether the
     *                                 variable value can be modified by
     * the
     *                                 administration clients.  To be modifiable
     * the variable must also be displayable. */
    private boolean modifiable;

    /* The searchable value specifies whether the
     *                                 variable value can be searched by
     * the
     *                                 administration clients. */
    private boolean searchable;

    /* If a variable value is specified as private
     *                                 a clear text value of the variable
     * is not
     *                                 stored to allow for searching or to
     * ensure
     *                                 uniqueness.  Instead a HMAC of the
     * value 
     *                                 is stored.  When searching is enabled
     * for
     *                                 private values, only exact matching
     * is
     *                                 supported.  When searching is enabled
     * for
     *                                 non-private values, ranges and wildcard
     * matches are supported. */
    private boolean privateValue;

    /* Specifies if a variable value is unique
     *                                 and if unique in what scope. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableUnique unique;

    /* The keytype value specifies the type of
     *                                 a KEY variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType keyType;

    /* The unblock value specifies if the variable
     *                                 value can be used in the user smart
     * credential
     *                                 unblock operation.  Only variables
     * of type
     *                                 KEY can be used for unblock. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType unblock;

    /* The category of a smart credential variable
     *                                 corresponds to one of the user smart
     * credential
     *                                 category permissions.  To have access
     * to view
     *                                 or modify a variable in a given category
     * the
     *                                 administrator must have the corresponding
     * category permission.  The categories can be
     *                                 used to give administrators access
     * to only a
     *                                 subset of variable values. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType category;

    /* For each locale defined for the smart credential
     *                                 definition provide locale specific
     * text
     *                                 for this variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] locales;

    public SmartCredentialVariableInfo() {
    }

    public SmartCredentialVariableInfo(
           String name,
           com.good.adapters.entrust.stubs.SmartCredentialVariableType type,
           com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions restrictions,
           com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType conversion,
           com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] options,
           com.good.adapters.entrust.stubs.SmartCredentialVariableDefault defaultValue,
           boolean required,
           com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated generated,
           boolean displayable,
           boolean modifiable,
           boolean searchable,
           boolean privateValue,
           com.good.adapters.entrust.stubs.SmartCredentialVariableUnique unique,
           com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType keyType,
           com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType unblock,
           com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType category,
           com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] locales) {
           this.name = name;
           this.type = type;
           this.restrictions = restrictions;
           this.conversion = conversion;
           this.options = options;
           this.defaultValue = defaultValue;
           this.required = required;
           this.generated = generated;
           this.displayable = displayable;
           this.modifiable = modifiable;
           this.searchable = searchable;
           this.privateValue = privateValue;
           this.unique = unique;
           this.keyType = keyType;
           this.unblock = unblock;
           this.category = category;
           this.locales = locales;
    }


    /**
     * Gets the name value for this SmartCredentialVariableInfo.
     * 
     * @return name   * The name of the Smart Credential variable.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this SmartCredentialVariableInfo.
     * 
     * @param name   * The name of the Smart Credential variable.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the type value for this SmartCredentialVariableInfo.
     * 
     * @return type   * The type of the Smart Credential variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableType getType() {
        return type;
    }


    /**
     * Sets the type value for this SmartCredentialVariableInfo.
     * 
     * @param type   * The type of the Smart Credential variable.
     */
    public void setType(com.good.adapters.entrust.stubs.SmartCredentialVariableType type) {
        this.type = type;
    }


    /**
     * Gets the restrictions value for this SmartCredentialVariableInfo.
     * 
     * @return restrictions   * The type of the Smart Credential variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions getRestrictions() {
        return restrictions;
    }


    /**
     * Sets the restrictions value for this SmartCredentialVariableInfo.
     * 
     * @param restrictions   * The type of the Smart Credential variable.
     */
    public void setRestrictions(com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions restrictions) {
        this.restrictions = restrictions;
    }


    /**
     * Gets the conversion value for this SmartCredentialVariableInfo.
     * 
     * @return conversion   * Specifies if the variable value is converted
     *                                 before being printed.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType getConversion() {
        return conversion;
    }


    /**
     * Sets the conversion value for this SmartCredentialVariableInfo.
     * 
     * @param conversion   * Specifies if the variable value is converted
     *                                 before being printed.
     */
    public void setConversion(com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType conversion) {
        this.conversion = conversion;
    }


    /**
     * Gets the options value for this SmartCredentialVariableInfo.
     * 
     * @return options   * For an enumerated type, specifies the list of
     *                                 allowed values.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] getOptions() {
        return options;
    }


    /**
     * Sets the options value for this SmartCredentialVariableInfo.
     * 
     * @param options   * For an enumerated type, specifies the list of
     *                                 allowed values.
     */
    public void setOptions(com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] options) {
        this.options = options;
    }


    /**
     * Gets the defaultValue value for this SmartCredentialVariableInfo.
     * 
     * @return defaultValue   * The default value for this variable.
     *                                 allowed values.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableDefault getDefaultValue() {
        return defaultValue;
    }


    /**
     * Sets the defaultValue value for this SmartCredentialVariableInfo.
     * 
     * @param defaultValue   * The default value for this variable.
     *                                 allowed values.
     */
    public void setDefaultValue(com.good.adapters.entrust.stubs.SmartCredentialVariableDefault defaultValue) {
        this.defaultValue = defaultValue;
    }


    /**
     * Gets the required value for this SmartCredentialVariableInfo.
     * 
     * @return required   * The required value specifies whether the
     *                                 variable requires a value.
     */
    public boolean isRequired() {
        return required;
    }


    /**
     * Sets the required value for this SmartCredentialVariableInfo.
     * 
     * @param required   * The required value specifies whether the
     *                                 variable requires a value.
     */
    public void setRequired(boolean required) {
        this.required = required;
    }


    /**
     * Gets the generated value for this SmartCredentialVariableInfo.
     * 
     * @return generated   * The generated value specifies if and how the
     *                                 variable value is generated when the
     * user smart credential is created.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated getGenerated() {
        return generated;
    }


    /**
     * Sets the generated value for this SmartCredentialVariableInfo.
     * 
     * @param generated   * The generated value specifies if and how the
     *                                 variable value is generated when the
     * user smart credential is created.
     */
    public void setGenerated(com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated generated) {
        this.generated = generated;
    }


    /**
     * Gets the displayable value for this SmartCredentialVariableInfo.
     * 
     * @return displayable   * The displayable value specifies whether the
     *                                 variable value can be displayed by
     * the
     *                                 administration clients.
     */
    public boolean isDisplayable() {
        return displayable;
    }


    /**
     * Sets the displayable value for this SmartCredentialVariableInfo.
     * 
     * @param displayable   * The displayable value specifies whether the
     *                                 variable value can be displayed by
     * the
     *                                 administration clients.
     */
    public void setDisplayable(boolean displayable) {
        this.displayable = displayable;
    }


    /**
     * Gets the modifiable value for this SmartCredentialVariableInfo.
     * 
     * @return modifiable   * The modifiable value specifies whether the
     *                                 variable value can be modified by
     * the
     *                                 administration clients.  To be modifiable
     * the variable must also be displayable.
     */
    public boolean isModifiable() {
        return modifiable;
    }


    /**
     * Sets the modifiable value for this SmartCredentialVariableInfo.
     * 
     * @param modifiable   * The modifiable value specifies whether the
     *                                 variable value can be modified by
     * the
     *                                 administration clients.  To be modifiable
     * the variable must also be displayable.
     */
    public void setModifiable(boolean modifiable) {
        this.modifiable = modifiable;
    }


    /**
     * Gets the searchable value for this SmartCredentialVariableInfo.
     * 
     * @return searchable   * The searchable value specifies whether the
     *                                 variable value can be searched by
     * the
     *                                 administration clients.
     */
    public boolean isSearchable() {
        return searchable;
    }


    /**
     * Sets the searchable value for this SmartCredentialVariableInfo.
     * 
     * @param searchable   * The searchable value specifies whether the
     *                                 variable value can be searched by
     * the
     *                                 administration clients.
     */
    public void setSearchable(boolean searchable) {
        this.searchable = searchable;
    }


    /**
     * Gets the privateValue value for this SmartCredentialVariableInfo.
     * 
     * @return privateValue   * If a variable value is specified as private
     *                                 a clear text value of the variable
     * is not
     *                                 stored to allow for searching or to
     * ensure
     *                                 uniqueness.  Instead a HMAC of the
     * value 
     *                                 is stored.  When searching is enabled
     * for
     *                                 private values, only exact matching
     * is
     *                                 supported.  When searching is enabled
     * for
     *                                 non-private values, ranges and wildcard
     * matches are supported.
     */
    public boolean isPrivateValue() {
        return privateValue;
    }


    /**
     * Sets the privateValue value for this SmartCredentialVariableInfo.
     * 
     * @param privateValue   * If a variable value is specified as private
     *                                 a clear text value of the variable
     * is not
     *                                 stored to allow for searching or to
     * ensure
     *                                 uniqueness.  Instead a HMAC of the
     * value 
     *                                 is stored.  When searching is enabled
     * for
     *                                 private values, only exact matching
     * is
     *                                 supported.  When searching is enabled
     * for
     *                                 non-private values, ranges and wildcard
     * matches are supported.
     */
    public void setPrivateValue(boolean privateValue) {
        this.privateValue = privateValue;
    }


    /**
     * Gets the unique value for this SmartCredentialVariableInfo.
     * 
     * @return unique   * Specifies if a variable value is unique
     *                                 and if unique in what scope.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableUnique getUnique() {
        return unique;
    }


    /**
     * Sets the unique value for this SmartCredentialVariableInfo.
     * 
     * @param unique   * Specifies if a variable value is unique
     *                                 and if unique in what scope.
     */
    public void setUnique(com.good.adapters.entrust.stubs.SmartCredentialVariableUnique unique) {
        this.unique = unique;
    }


    /**
     * Gets the keyType value for this SmartCredentialVariableInfo.
     * 
     * @return keyType   * The keytype value specifies the type of
     *                                 a KEY variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType getKeyType() {
        return keyType;
    }


    /**
     * Sets the keyType value for this SmartCredentialVariableInfo.
     * 
     * @param keyType   * The keytype value specifies the type of
     *                                 a KEY variable.
     */
    public void setKeyType(com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType keyType) {
        this.keyType = keyType;
    }


    /**
     * Gets the unblock value for this SmartCredentialVariableInfo.
     * 
     * @return unblock   * The unblock value specifies if the variable
     *                                 value can be used in the user smart
     * credential
     *                                 unblock operation.  Only variables
     * of type
     *                                 KEY can be used for unblock.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType getUnblock() {
        return unblock;
    }


    /**
     * Sets the unblock value for this SmartCredentialVariableInfo.
     * 
     * @param unblock   * The unblock value specifies if the variable
     *                                 value can be used in the user smart
     * credential
     *                                 unblock operation.  Only variables
     * of type
     *                                 KEY can be used for unblock.
     */
    public void setUnblock(com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType unblock) {
        this.unblock = unblock;
    }


    /**
     * Gets the category value for this SmartCredentialVariableInfo.
     * 
     * @return category   * The category of a smart credential variable
     *                                 corresponds to one of the user smart
     * credential
     *                                 category permissions.  To have access
     * to view
     *                                 or modify a variable in a given category
     * the
     *                                 administrator must have the corresponding
     * category permission.  The categories can be
     *                                 used to give administrators access
     * to only a
     *                                 subset of variable values.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType getCategory() {
        return category;
    }


    /**
     * Sets the category value for this SmartCredentialVariableInfo.
     * 
     * @param category   * The category of a smart credential variable
     *                                 corresponds to one of the user smart
     * credential
     *                                 category permissions.  To have access
     * to view
     *                                 or modify a variable in a given category
     * the
     *                                 administrator must have the corresponding
     * category permission.  The categories can be
     *                                 used to give administrators access
     * to only a
     *                                 subset of variable values.
     */
    public void setCategory(com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType category) {
        this.category = category;
    }


    /**
     * Gets the locales value for this SmartCredentialVariableInfo.
     * 
     * @return locales   * For each locale defined for the smart credential
     *                                 definition provide locale specific
     * text
     *                                 for this variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] getLocales() {
        return locales;
    }


    /**
     * Sets the locales value for this SmartCredentialVariableInfo.
     * 
     * @param locales   * For each locale defined for the smart credential
     *                                 definition provide locale specific
     * text
     *                                 for this variable.
     */
    public void setLocales(com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] locales) {
        this.locales = locales;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialVariableInfo)) return false;
        SmartCredentialVariableInfo other = (SmartCredentialVariableInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.restrictions==null && other.getRestrictions()==null) || 
             (this.restrictions!=null &&
              this.restrictions.equals(other.getRestrictions()))) &&
            ((this.conversion==null && other.getConversion()==null) || 
             (this.conversion!=null &&
              this.conversion.equals(other.getConversion()))) &&
            ((this.options==null && other.getOptions()==null) || 
             (this.options!=null &&
              java.util.Arrays.equals(this.options, other.getOptions()))) &&
            ((this.defaultValue==null && other.getDefaultValue()==null) || 
             (this.defaultValue!=null &&
              this.defaultValue.equals(other.getDefaultValue()))) &&
            this.required == other.isRequired() &&
            ((this.generated==null && other.getGenerated()==null) || 
             (this.generated!=null &&
              this.generated.equals(other.getGenerated()))) &&
            this.displayable == other.isDisplayable() &&
            this.modifiable == other.isModifiable() &&
            this.searchable == other.isSearchable() &&
            this.privateValue == other.isPrivateValue() &&
            ((this.unique==null && other.getUnique()==null) || 
             (this.unique!=null &&
              this.unique.equals(other.getUnique()))) &&
            ((this.keyType==null && other.getKeyType()==null) || 
             (this.keyType!=null &&
              this.keyType.equals(other.getKeyType()))) &&
            ((this.unblock==null && other.getUnblock()==null) || 
             (this.unblock!=null &&
              this.unblock.equals(other.getUnblock()))) &&
            ((this.category==null && other.getCategory()==null) || 
             (this.category!=null &&
              this.category.equals(other.getCategory()))) &&
            ((this.locales==null && other.getLocales()==null) || 
             (this.locales!=null &&
              java.util.Arrays.equals(this.locales, other.getLocales())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getRestrictions() != null) {
            _hashCode += getRestrictions().hashCode();
        }
        if (getConversion() != null) {
            _hashCode += getConversion().hashCode();
        }
        if (getOptions() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getOptions());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getOptions(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getDefaultValue() != null) {
            _hashCode += getDefaultValue().hashCode();
        }
        _hashCode += (isRequired() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getGenerated() != null) {
            _hashCode += getGenerated().hashCode();
        }
        _hashCode += (isDisplayable() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isModifiable() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSearchable() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isPrivateValue() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getUnique() != null) {
            _hashCode += getUnique().hashCode();
        }
        if (getKeyType() != null) {
            _hashCode += getKeyType().hashCode();
        }
        if (getUnblock() != null) {
            _hashCode += getUnblock().hashCode();
        }
        if (getCategory() != null) {
            _hashCode += getCategory().hashCode();
        }
        if (getLocales() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getLocales());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getLocales(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialVariableInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("restrictions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "restrictions"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableRestrictions"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("conversion");
        elemField.setXmlName(new javax.xml.namespace.QName("", "conversion"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableConversionType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("options");
        elemField.setXmlName(new javax.xml.namespace.QName("", "options"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableOption"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableDefault"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("required");
        elemField.setXmlName(new javax.xml.namespace.QName("", "required"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("generated");
        elemField.setXmlName(new javax.xml.namespace.QName("", "generated"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableGenerated"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("displayable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "displayable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("modifiable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "modifiable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("searchable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "searchable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("privateValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "privateValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("unique");
        elemField.setXmlName(new javax.xml.namespace.QName("", "unique"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableUnique"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("keyType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "KeyType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableKeyType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("unblock");
        elemField.setXmlName(new javax.xml.namespace.QName("", "unblock"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableUnblockType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("category");
        elemField.setXmlName(new javax.xml.namespace.QName("", "category"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableCategoryType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("locales");
        elemField.setXmlName(new javax.xml.namespace.QName("", "locales"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableLocale"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
