/**
 * SmartCredentialVariableParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information about a Smart Credential Variable.
 */
public class SmartCredentialVariableParms  implements java.io.Serializable {
    /* The type of the Smart Credential variable. */
    private SmartCredentialVariableType type;

    /* If set to true, the existing restrictions
     *                                 are removed from the variable.  This
     * argument
     *                                 is ignored if restrictions is not
     * null. */
    private Boolean removeRestrictions;

    /* Specifies restrictions for the variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions restrictions;

    /* If set to true, the existing conversion
     *                                 is removed from the variable.  This
     * argument
     *                                 is ignored if conversion is not null. */
    private Boolean removeConversion;

    /* Specifies how the variable value is converted
     *                                 during printing. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType conversion;

    /* If specified as true, the existing options
     *                                 are removed. This argument is ignored
     * if the options argument is specified. */
    private Boolean removeOptions;

    /* Options for enumerated variables. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] options;

    /* If set to true, the existing default
     *                                 value is removed from the variable.
     * This argument is ignored if defaultValue is
     *                                 not null. */
    private Boolean removeDefaultValue;

    /* Specifies the default value for this variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableDefault defaultValue;

    /* If set to true, a value is required
     *                                 for the variable.
     *                                 This argument is ignored if generated
     * is
     *                                 not null. */
    private Boolean required;

    /* If set to true, the existing generated
     *                                 value is removed from the variable.
     * This argument is ignored if generated is
     *                                 not null. */
    private Boolean removeGenerated;

    /* Specifies how the value for the variable
     *                                 is generated when a user smart credential
     * is
     *                                 created. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated generated;

    /* If set to true, the value is displayed
     *                                 in administration clients such as
     *                                 Entrust IdentityGuard Enrollment Module. */
    private Boolean displayable;

    /* If set to true, the value can be modified
     *                                 in administration clients such as
     *                                 Entrust IdentityGuard Enrollment Module. */
    private Boolean modifiable;

    /* If set to true, the value can be used
     *                                 as a search criteria. */
    private Boolean searchable;

    /* If set to true, the value is treated as
     *                                 private and a cleartext value is not
     * stored in
     *                                 the repository for searching. */
    private Boolean privateVariable;

    /* If set to true, the existing unique
     *                                 value is removed from the variable.
     * This argument is ignored if unique is
     *                                 not null. */
    private Boolean removeUnique;

    /* Specifies the uniqueness constraints on
     *                                 the variable value. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableUnique unique;

    /* For KEY variables the KeyType specifies the
     *                                 type of the key. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType keyType;

    /* If set to X509 the variable can be used for
     *                                 X509 unblock.  If set to PIV the variable
     * can be used for PIV unblock.  Otherwise the
     *                                 variable can't be used for unblock.
     * This
     *                                 value can only be set for variables
     * with type
     *                                 KEY. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType unblock;

    /* Specifies the category of the variable.
     *                                 The categories correspond to user
     * smart
     *                                 credential category permissions that
     * restrict
     *                                 access to variable values. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType category;

    /* The specified locales update existing locale
     *                                 values for the variable. */
    private com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] locales;

    /* Specifies the name of an existing variable
     *                                 that this variable should be inserted
     * before.
     *                                 For the userSmartCredentialVariableCreate
     * operation, if a value is not specified then
     *                                 the new variable goes at the end of
     * the
     *                                 variable list.  For the
     *                                 userSmartCredentialVariableSet operation
     * if
     *                                 a value is not specified then the
     * variable
     *                                 is left in its current location in
     * the variable
     *                                 list.  If a value is specified and
     * the
     *                                 named variable does not exist, an
     * error is
     *                                 returned. */
    private String before;

    public SmartCredentialVariableParms() {
    }

    public SmartCredentialVariableParms(
           SmartCredentialVariableType type,
           Boolean removeRestrictions,
           com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions restrictions,
           Boolean removeConversion,
           com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType conversion,
           Boolean removeOptions,
           com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] options,
           Boolean removeDefaultValue,
           com.good.adapters.entrust.stubs.SmartCredentialVariableDefault defaultValue,
           Boolean required,
           Boolean removeGenerated,
           com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated generated,
           Boolean displayable,
           Boolean modifiable,
           Boolean searchable,
           Boolean privateVariable,
           Boolean removeUnique,
           com.good.adapters.entrust.stubs.SmartCredentialVariableUnique unique,
           com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType keyType,
           com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType unblock,
           com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType category,
           com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] locales,
           String before) {
           this.type = type;
           this.removeRestrictions = removeRestrictions;
           this.restrictions = restrictions;
           this.removeConversion = removeConversion;
           this.conversion = conversion;
           this.removeOptions = removeOptions;
           this.options = options;
           this.removeDefaultValue = removeDefaultValue;
           this.defaultValue = defaultValue;
           this.required = required;
           this.removeGenerated = removeGenerated;
           this.generated = generated;
           this.displayable = displayable;
           this.modifiable = modifiable;
           this.searchable = searchable;
           this.privateVariable = privateVariable;
           this.removeUnique = removeUnique;
           this.unique = unique;
           this.keyType = keyType;
           this.unblock = unblock;
           this.category = category;
           this.locales = locales;
           this.before = before;
    }


    /**
     * Gets the type value for this SmartCredentialVariableParms.
     * 
     * @return type   * The type of the Smart Credential variable.
     */
    public SmartCredentialVariableType getType() {
        return type;
    }


    /**
     * Sets the type value for this SmartCredentialVariableParms.
     * 
     * @param type   * The type of the Smart Credential variable.
     */
    public void setType(SmartCredentialVariableType type) {
        this.type = type;
    }


    /**
     * Gets the removeRestrictions value for this SmartCredentialVariableParms.
     * 
     * @return removeRestrictions   * If set to true, the existing restrictions
     *                                 are removed from the variable.  This
     * argument
     *                                 is ignored if restrictions is not
     * null.
     */
    public Boolean getRemoveRestrictions() {
        return removeRestrictions;
    }


    /**
     * Sets the removeRestrictions value for this SmartCredentialVariableParms.
     * 
     * @param removeRestrictions   * If set to true, the existing restrictions
     *                                 are removed from the variable.  This
     * argument
     *                                 is ignored if restrictions is not
     * null.
     */
    public void setRemoveRestrictions(Boolean removeRestrictions) {
        this.removeRestrictions = removeRestrictions;
    }


    /**
     * Gets the restrictions value for this SmartCredentialVariableParms.
     * 
     * @return restrictions   * Specifies restrictions for the variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions getRestrictions() {
        return restrictions;
    }


    /**
     * Sets the restrictions value for this SmartCredentialVariableParms.
     * 
     * @param restrictions   * Specifies restrictions for the variable.
     */
    public void setRestrictions(com.good.adapters.entrust.stubs.SmartCredentialVariableRestrictions restrictions) {
        this.restrictions = restrictions;
    }


    /**
     * Gets the removeConversion value for this SmartCredentialVariableParms.
     * 
     * @return removeConversion   * If set to true, the existing conversion
     *                                 is removed from the variable.  This
     * argument
     *                                 is ignored if conversion is not null.
     */
    public Boolean getRemoveConversion() {
        return removeConversion;
    }


    /**
     * Sets the removeConversion value for this SmartCredentialVariableParms.
     * 
     * @param removeConversion   * If set to true, the existing conversion
     *                                 is removed from the variable.  This
     * argument
     *                                 is ignored if conversion is not null.
     */
    public void setRemoveConversion(Boolean removeConversion) {
        this.removeConversion = removeConversion;
    }


    /**
     * Gets the conversion value for this SmartCredentialVariableParms.
     * 
     * @return conversion   * Specifies how the variable value is converted
     *                                 during printing.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType getConversion() {
        return conversion;
    }


    /**
     * Sets the conversion value for this SmartCredentialVariableParms.
     * 
     * @param conversion   * Specifies how the variable value is converted
     *                                 during printing.
     */
    public void setConversion(com.good.adapters.entrust.stubs.SmartCredentialVariableConversionType conversion) {
        this.conversion = conversion;
    }


    /**
     * Gets the removeOptions value for this SmartCredentialVariableParms.
     * 
     * @return removeOptions   * If specified as true, the existing options
     *                                 are removed. This argument is ignored
     * if the options argument is specified.
     */
    public Boolean getRemoveOptions() {
        return removeOptions;
    }


    /**
     * Sets the removeOptions value for this SmartCredentialVariableParms.
     * 
     * @param removeOptions   * If specified as true, the existing options
     *                                 are removed. This argument is ignored
     * if the options argument is specified.
     */
    public void setRemoveOptions(Boolean removeOptions) {
        this.removeOptions = removeOptions;
    }


    /**
     * Gets the options value for this SmartCredentialVariableParms.
     * 
     * @return options   * Options for enumerated variables.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] getOptions() {
        return options;
    }


    /**
     * Sets the options value for this SmartCredentialVariableParms.
     * 
     * @param options   * Options for enumerated variables.
     */
    public void setOptions(com.good.adapters.entrust.stubs.SmartCredentialVariableOption[] options) {
        this.options = options;
    }


    /**
     * Gets the removeDefaultValue value for this SmartCredentialVariableParms.
     * 
     * @return removeDefaultValue   * If set to true, the existing default
     *                                 value is removed from the variable.
     * This argument is ignored if defaultValue is
     *                                 not null.
     */
    public Boolean getRemoveDefaultValue() {
        return removeDefaultValue;
    }


    /**
     * Sets the removeDefaultValue value for this SmartCredentialVariableParms.
     * 
     * @param removeDefaultValue   * If set to true, the existing default
     *                                 value is removed from the variable.
     * This argument is ignored if defaultValue is
     *                                 not null.
     */
    public void setRemoveDefaultValue(Boolean removeDefaultValue) {
        this.removeDefaultValue = removeDefaultValue;
    }


    /**
     * Gets the defaultValue value for this SmartCredentialVariableParms.
     * 
     * @return defaultValue   * Specifies the default value for this variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableDefault getDefaultValue() {
        return defaultValue;
    }


    /**
     * Sets the defaultValue value for this SmartCredentialVariableParms.
     * 
     * @param defaultValue   * Specifies the default value for this variable.
     */
    public void setDefaultValue(com.good.adapters.entrust.stubs.SmartCredentialVariableDefault defaultValue) {
        this.defaultValue = defaultValue;
    }


    /**
     * Gets the required value for this SmartCredentialVariableParms.
     * 
     * @return required   * If set to true, a value is required
     *                                 for the variable.
     *                                 This argument is ignored if generated
     * is
     *                                 not null.
     */
    public Boolean getRequired() {
        return required;
    }


    /**
     * Sets the required value for this SmartCredentialVariableParms.
     * 
     * @param required   * If set to true, a value is required
     *                                 for the variable.
     *                                 This argument is ignored if generated
     * is
     *                                 not null.
     */
    public void setRequired(Boolean required) {
        this.required = required;
    }


    /**
     * Gets the removeGenerated value for this SmartCredentialVariableParms.
     * 
     * @return removeGenerated   * If set to true, the existing generated
     *                                 value is removed from the variable.
     * This argument is ignored if generated is
     *                                 not null.
     */
    public Boolean getRemoveGenerated() {
        return removeGenerated;
    }


    /**
     * Sets the removeGenerated value for this SmartCredentialVariableParms.
     * 
     * @param removeGenerated   * If set to true, the existing generated
     *                                 value is removed from the variable.
     * This argument is ignored if generated is
     *                                 not null.
     */
    public void setRemoveGenerated(Boolean removeGenerated) {
        this.removeGenerated = removeGenerated;
    }


    /**
     * Gets the generated value for this SmartCredentialVariableParms.
     * 
     * @return generated   * Specifies how the value for the variable
     *                                 is generated when a user smart credential
     * is
     *                                 created.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated getGenerated() {
        return generated;
    }


    /**
     * Sets the generated value for this SmartCredentialVariableParms.
     * 
     * @param generated   * Specifies how the value for the variable
     *                                 is generated when a user smart credential
     * is
     *                                 created.
     */
    public void setGenerated(com.good.adapters.entrust.stubs.SmartCredentialVariableGenerated generated) {
        this.generated = generated;
    }


    /**
     * Gets the displayable value for this SmartCredentialVariableParms.
     * 
     * @return displayable   * If set to true, the value is displayed
     *                                 in administration clients such as
     *                                 Entrust IdentityGuard Enrollment Module.
     */
    public Boolean getDisplayable() {
        return displayable;
    }


    /**
     * Sets the displayable value for this SmartCredentialVariableParms.
     * 
     * @param displayable   * If set to true, the value is displayed
     *                                 in administration clients such as
     *                                 Entrust IdentityGuard Enrollment Module.
     */
    public void setDisplayable(Boolean displayable) {
        this.displayable = displayable;
    }


    /**
     * Gets the modifiable value for this SmartCredentialVariableParms.
     * 
     * @return modifiable   * If set to true, the value can be modified
     *                                 in administration clients such as
     *                                 Entrust IdentityGuard Enrollment Module.
     */
    public Boolean getModifiable() {
        return modifiable;
    }


    /**
     * Sets the modifiable value for this SmartCredentialVariableParms.
     * 
     * @param modifiable   * If set to true, the value can be modified
     *                                 in administration clients such as
     *                                 Entrust IdentityGuard Enrollment Module.
     */
    public void setModifiable(Boolean modifiable) {
        this.modifiable = modifiable;
    }


    /**
     * Gets the searchable value for this SmartCredentialVariableParms.
     * 
     * @return searchable   * If set to true, the value can be used
     *                                 as a search criteria.
     */
    public Boolean getSearchable() {
        return searchable;
    }


    /**
     * Sets the searchable value for this SmartCredentialVariableParms.
     * 
     * @param searchable   * If set to true, the value can be used
     *                                 as a search criteria.
     */
    public void setSearchable(Boolean searchable) {
        this.searchable = searchable;
    }


    /**
     * Gets the privateVariable value for this SmartCredentialVariableParms.
     * 
     * @return privateVariable   * If set to true, the value is treated as
     *                                 private and a cleartext value is not
     * stored in
     *                                 the repository for searching.
     */
    public Boolean getPrivateVariable() {
        return privateVariable;
    }


    /**
     * Sets the privateVariable value for this SmartCredentialVariableParms.
     * 
     * @param privateVariable   * If set to true, the value is treated as
     *                                 private and a cleartext value is not
     * stored in
     *                                 the repository for searching.
     */
    public void setPrivateVariable(Boolean privateVariable) {
        this.privateVariable = privateVariable;
    }


    /**
     * Gets the removeUnique value for this SmartCredentialVariableParms.
     * 
     * @return removeUnique   * If set to true, the existing unique
     *                                 value is removed from the variable.
     * This argument is ignored if unique is
     *                                 not null.
     */
    public Boolean getRemoveUnique() {
        return removeUnique;
    }


    /**
     * Sets the removeUnique value for this SmartCredentialVariableParms.
     * 
     * @param removeUnique   * If set to true, the existing unique
     *                                 value is removed from the variable.
     * This argument is ignored if unique is
     *                                 not null.
     */
    public void setRemoveUnique(Boolean removeUnique) {
        this.removeUnique = removeUnique;
    }


    /**
     * Gets the unique value for this SmartCredentialVariableParms.
     * 
     * @return unique   * Specifies the uniqueness constraints on
     *                                 the variable value.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableUnique getUnique() {
        return unique;
    }


    /**
     * Sets the unique value for this SmartCredentialVariableParms.
     * 
     * @param unique   * Specifies the uniqueness constraints on
     *                                 the variable value.
     */
    public void setUnique(com.good.adapters.entrust.stubs.SmartCredentialVariableUnique unique) {
        this.unique = unique;
    }


    /**
     * Gets the keyType value for this SmartCredentialVariableParms.
     * 
     * @return keyType   * For KEY variables the KeyType specifies the
     *                                 type of the key.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType getKeyType() {
        return keyType;
    }


    /**
     * Sets the keyType value for this SmartCredentialVariableParms.
     * 
     * @param keyType   * For KEY variables the KeyType specifies the
     *                                 type of the key.
     */
    public void setKeyType(com.good.adapters.entrust.stubs.SmartCredentialVariableKeyType keyType) {
        this.keyType = keyType;
    }


    /**
     * Gets the unblock value for this SmartCredentialVariableParms.
     * 
     * @return unblock   * If set to X509 the variable can be used for
     *                                 X509 unblock.  If set to PIV the variable
     * can be used for PIV unblock.  Otherwise the
     *                                 variable can't be used for unblock.
     * This
     *                                 value can only be set for variables
     * with type
     *                                 KEY.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType getUnblock() {
        return unblock;
    }


    /**
     * Sets the unblock value for this SmartCredentialVariableParms.
     * 
     * @param unblock   * If set to X509 the variable can be used for
     *                                 X509 unblock.  If set to PIV the variable
     * can be used for PIV unblock.  Otherwise the
     *                                 variable can't be used for unblock.
     * This
     *                                 value can only be set for variables
     * with type
     *                                 KEY.
     */
    public void setUnblock(com.good.adapters.entrust.stubs.SmartCredentialVariableUnblockType unblock) {
        this.unblock = unblock;
    }


    /**
     * Gets the category value for this SmartCredentialVariableParms.
     * 
     * @return category   * Specifies the category of the variable.
     *                                 The categories correspond to user
     * smart
     *                                 credential category permissions that
     * restrict
     *                                 access to variable values.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType getCategory() {
        return category;
    }


    /**
     * Sets the category value for this SmartCredentialVariableParms.
     * 
     * @param category   * Specifies the category of the variable.
     *                                 The categories correspond to user
     * smart
     *                                 credential category permissions that
     * restrict
     *                                 access to variable values.
     */
    public void setCategory(com.good.adapters.entrust.stubs.SmartCredentialVariableCategoryType category) {
        this.category = category;
    }


    /**
     * Gets the locales value for this SmartCredentialVariableParms.
     * 
     * @return locales   * The specified locales update existing locale
     *                                 values for the variable.
     */
    public com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] getLocales() {
        return locales;
    }


    /**
     * Sets the locales value for this SmartCredentialVariableParms.
     * 
     * @param locales   * The specified locales update existing locale
     *                                 values for the variable.
     */
    public void setLocales(com.good.adapters.entrust.stubs.SmartCredentialVariableLocale[] locales) {
        this.locales = locales;
    }


    /**
     * Gets the before value for this SmartCredentialVariableParms.
     * 
     * @return before   * Specifies the name of an existing variable
     *                                 that this variable should be inserted
     * before.
     *                                 For the userSmartCredentialVariableCreate
     * operation, if a value is not specified then
     *                                 the new variable goes at the end of
     * the
     *                                 variable list.  For the
     *                                 userSmartCredentialVariableSet operation
     * if
     *                                 a value is not specified then the
     * variable
     *                                 is left in its current location in
     * the variable
     *                                 list.  If a value is specified and
     * the
     *                                 named variable does not exist, an
     * error is
     *                                 returned.
     */
    public String getBefore() {
        return before;
    }


    /**
     * Sets the before value for this SmartCredentialVariableParms.
     * 
     * @param before   * Specifies the name of an existing variable
     *                                 that this variable should be inserted
     * before.
     *                                 For the userSmartCredentialVariableCreate
     * operation, if a value is not specified then
     *                                 the new variable goes at the end of
     * the
     *                                 variable list.  For the
     *                                 userSmartCredentialVariableSet operation
     * if
     *                                 a value is not specified then the
     * variable
     *                                 is left in its current location in
     * the variable
     *                                 list.  If a value is specified and
     * the
     *                                 named variable does not exist, an
     * error is
     *                                 returned.
     */
    public void setBefore(String before) {
        this.before = before;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof SmartCredentialVariableParms)) return false;
        SmartCredentialVariableParms other = (SmartCredentialVariableParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.removeRestrictions==null && other.getRemoveRestrictions()==null) || 
             (this.removeRestrictions!=null &&
              this.removeRestrictions.equals(other.getRemoveRestrictions()))) &&
            ((this.restrictions==null && other.getRestrictions()==null) || 
             (this.restrictions!=null &&
              this.restrictions.equals(other.getRestrictions()))) &&
            ((this.removeConversion==null && other.getRemoveConversion()==null) || 
             (this.removeConversion!=null &&
              this.removeConversion.equals(other.getRemoveConversion()))) &&
            ((this.conversion==null && other.getConversion()==null) || 
             (this.conversion!=null &&
              this.conversion.equals(other.getConversion()))) &&
            ((this.removeOptions==null && other.getRemoveOptions()==null) || 
             (this.removeOptions!=null &&
              this.removeOptions.equals(other.getRemoveOptions()))) &&
            ((this.options==null && other.getOptions()==null) || 
             (this.options!=null &&
              java.util.Arrays.equals(this.options, other.getOptions()))) &&
            ((this.removeDefaultValue==null && other.getRemoveDefaultValue()==null) || 
             (this.removeDefaultValue!=null &&
              this.removeDefaultValue.equals(other.getRemoveDefaultValue()))) &&
            ((this.defaultValue==null && other.getDefaultValue()==null) || 
             (this.defaultValue!=null &&
              this.defaultValue.equals(other.getDefaultValue()))) &&
            ((this.required==null && other.getRequired()==null) || 
             (this.required!=null &&
              this.required.equals(other.getRequired()))) &&
            ((this.removeGenerated==null && other.getRemoveGenerated()==null) || 
             (this.removeGenerated!=null &&
              this.removeGenerated.equals(other.getRemoveGenerated()))) &&
            ((this.generated==null && other.getGenerated()==null) || 
             (this.generated!=null &&
              this.generated.equals(other.getGenerated()))) &&
            ((this.displayable==null && other.getDisplayable()==null) || 
             (this.displayable!=null &&
              this.displayable.equals(other.getDisplayable()))) &&
            ((this.modifiable==null && other.getModifiable()==null) || 
             (this.modifiable!=null &&
              this.modifiable.equals(other.getModifiable()))) &&
            ((this.searchable==null && other.getSearchable()==null) || 
             (this.searchable!=null &&
              this.searchable.equals(other.getSearchable()))) &&
            ((this.privateVariable==null && other.getPrivateVariable()==null) || 
             (this.privateVariable!=null &&
              this.privateVariable.equals(other.getPrivateVariable()))) &&
            ((this.removeUnique==null && other.getRemoveUnique()==null) || 
             (this.removeUnique!=null &&
              this.removeUnique.equals(other.getRemoveUnique()))) &&
            ((this.unique==null && other.getUnique()==null) || 
             (this.unique!=null &&
              this.unique.equals(other.getUnique()))) &&
            ((this.keyType==null && other.getKeyType()==null) || 
             (this.keyType!=null &&
              this.keyType.equals(other.getKeyType()))) &&
            ((this.unblock==null && other.getUnblock()==null) || 
             (this.unblock!=null &&
              this.unblock.equals(other.getUnblock()))) &&
            ((this.category==null && other.getCategory()==null) || 
             (this.category!=null &&
              this.category.equals(other.getCategory()))) &&
            ((this.locales==null && other.getLocales()==null) || 
             (this.locales!=null &&
              java.util.Arrays.equals(this.locales, other.getLocales()))) &&
            ((this.before==null && other.getBefore()==null) || 
             (this.before!=null &&
              this.before.equals(other.getBefore())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getRemoveRestrictions() != null) {
            _hashCode += getRemoveRestrictions().hashCode();
        }
        if (getRestrictions() != null) {
            _hashCode += getRestrictions().hashCode();
        }
        if (getRemoveConversion() != null) {
            _hashCode += getRemoveConversion().hashCode();
        }
        if (getConversion() != null) {
            _hashCode += getConversion().hashCode();
        }
        if (getRemoveOptions() != null) {
            _hashCode += getRemoveOptions().hashCode();
        }
        if (getOptions() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getOptions());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getOptions(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRemoveDefaultValue() != null) {
            _hashCode += getRemoveDefaultValue().hashCode();
        }
        if (getDefaultValue() != null) {
            _hashCode += getDefaultValue().hashCode();
        }
        if (getRequired() != null) {
            _hashCode += getRequired().hashCode();
        }
        if (getRemoveGenerated() != null) {
            _hashCode += getRemoveGenerated().hashCode();
        }
        if (getGenerated() != null) {
            _hashCode += getGenerated().hashCode();
        }
        if (getDisplayable() != null) {
            _hashCode += getDisplayable().hashCode();
        }
        if (getModifiable() != null) {
            _hashCode += getModifiable().hashCode();
        }
        if (getSearchable() != null) {
            _hashCode += getSearchable().hashCode();
        }
        if (getPrivateVariable() != null) {
            _hashCode += getPrivateVariable().hashCode();
        }
        if (getRemoveUnique() != null) {
            _hashCode += getRemoveUnique().hashCode();
        }
        if (getUnique() != null) {
            _hashCode += getUnique().hashCode();
        }
        if (getKeyType() != null) {
            _hashCode += getKeyType().hashCode();
        }
        if (getUnblock() != null) {
            _hashCode += getUnblock().hashCode();
        }
        if (getCategory() != null) {
            _hashCode += getCategory().hashCode();
        }
        if (getLocales() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getLocales());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getLocales(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getBefore() != null) {
            _hashCode += getBefore().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(SmartCredentialVariableParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeRestrictions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeRestrictions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("restrictions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "restrictions"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableRestrictions"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeConversion");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeConversion"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("conversion");
        elemField.setXmlName(new javax.xml.namespace.QName("", "conversion"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableConversionType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeOptions");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeOptions"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("options");
        elemField.setXmlName(new javax.xml.namespace.QName("", "options"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableOption"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeDefaultValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeDefaultValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultValue");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultValue"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableDefault"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("required");
        elemField.setXmlName(new javax.xml.namespace.QName("", "required"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeGenerated");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeGenerated"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("generated");
        elemField.setXmlName(new javax.xml.namespace.QName("", "generated"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableGenerated"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("displayable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "displayable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("modifiable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "modifiable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("searchable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "searchable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("privateVariable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "privateVariable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("removeUnique");
        elemField.setXmlName(new javax.xml.namespace.QName("", "removeUnique"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("unique");
        elemField.setXmlName(new javax.xml.namespace.QName("", "unique"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableUnique"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("keyType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "KeyType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableKeyType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("unblock");
        elemField.setXmlName(new javax.xml.namespace.QName("", "unblock"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableUnblockType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("category");
        elemField.setXmlName(new javax.xml.namespace.QName("", "category"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableCategoryType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("locales");
        elemField.setXmlName(new javax.xml.namespace.QName("", "locales"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "SmartCredentialVariableLocale"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("before");
        elemField.setXmlName(new javax.xml.namespace.QName("", "before"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
