/**
 * TokenChallenge.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure contains information about a token challenge.
 *             For a TOKENRO challenge, this includes a list of tokens
 * that can be used to authenticate the challenge.  For a TOKENCR
 *             challenge, this also includes the token challenge value
 * that
 *             must be entered into the token to generate the token response.
 * The token challenge also includes information about the
 *             temporary PIN that can be used to respond to a token challenge.
 */
public class TokenChallenge  implements java.io.Serializable {
    /* The token challenge.  This value will only be set
     *                   for TOKENCR authentication. */
    private String challenge;

    /* The tokens that can be used to authenticate the challenge. */
    private TokenData[] tokens;

    /* Flag indicating if user has a temporary PIN. */
    private Boolean hasTemporaryPIN;

    /* The characters allowed in a temporary PIN challenge response. */
    private String temporaryPINCellAlphabet;

    /* The number of characters in a temporary PIN cell. */
    private Integer temporaryPINCellSize;

    /* The number of cells in a temporary PIN challenge response. */
    private Integer temporaryPINChallengeSize;

    public TokenChallenge() {
    }

    public TokenChallenge(
           String challenge,
           TokenData[] tokens,
           Boolean hasTemporaryPIN,
           String temporaryPINCellAlphabet,
           Integer temporaryPINCellSize,
           Integer temporaryPINChallengeSize) {
           this.challenge = challenge;
           this.tokens = tokens;
           this.hasTemporaryPIN = hasTemporaryPIN;
           this.temporaryPINCellAlphabet = temporaryPINCellAlphabet;
           this.temporaryPINCellSize = temporaryPINCellSize;
           this.temporaryPINChallengeSize = temporaryPINChallengeSize;
    }


    /**
     * Gets the challenge value for this TokenChallenge.
     * 
     * @return challenge   * The token challenge.  This value will only be set
     *                   for TOKENCR authentication.
     */
    public String getChallenge() {
        return challenge;
    }


    /**
     * Sets the challenge value for this TokenChallenge.
     * 
     * @param challenge   * The token challenge.  This value will only be set
     *                   for TOKENCR authentication.
     */
    public void setChallenge(String challenge) {
        this.challenge = challenge;
    }


    /**
     * Gets the tokens value for this TokenChallenge.
     * 
     * @return tokens   * The tokens that can be used to authenticate the challenge.
     */
    public TokenData[] getTokens() {
        return tokens;
    }


    /**
     * Sets the tokens value for this TokenChallenge.
     * 
     * @param tokens   * The tokens that can be used to authenticate the challenge.
     */
    public void setTokens(TokenData[] tokens) {
        this.tokens = tokens;
    }


    /**
     * Gets the hasTemporaryPIN value for this TokenChallenge.
     * 
     * @return hasTemporaryPIN   * Flag indicating if user has a temporary PIN.
     */
    public Boolean getHasTemporaryPIN() {
        return hasTemporaryPIN;
    }


    /**
     * Sets the hasTemporaryPIN value for this TokenChallenge.
     * 
     * @param hasTemporaryPIN   * Flag indicating if user has a temporary PIN.
     */
    public void setHasTemporaryPIN(Boolean hasTemporaryPIN) {
        this.hasTemporaryPIN = hasTemporaryPIN;
    }


    /**
     * Gets the temporaryPINCellAlphabet value for this TokenChallenge.
     * 
     * @return temporaryPINCellAlphabet   * The characters allowed in a temporary PIN challenge response.
     */
    public String getTemporaryPINCellAlphabet() {
        return temporaryPINCellAlphabet;
    }


    /**
     * Sets the temporaryPINCellAlphabet value for this TokenChallenge.
     * 
     * @param temporaryPINCellAlphabet   * The characters allowed in a temporary PIN challenge response.
     */
    public void setTemporaryPINCellAlphabet(String temporaryPINCellAlphabet) {
        this.temporaryPINCellAlphabet = temporaryPINCellAlphabet;
    }


    /**
     * Gets the temporaryPINCellSize value for this TokenChallenge.
     * 
     * @return temporaryPINCellSize   * The number of characters in a temporary PIN cell.
     */
    public Integer getTemporaryPINCellSize() {
        return temporaryPINCellSize;
    }


    /**
     * Sets the temporaryPINCellSize value for this TokenChallenge.
     * 
     * @param temporaryPINCellSize   * The number of characters in a temporary PIN cell.
     */
    public void setTemporaryPINCellSize(Integer temporaryPINCellSize) {
        this.temporaryPINCellSize = temporaryPINCellSize;
    }


    /**
     * Gets the temporaryPINChallengeSize value for this TokenChallenge.
     * 
     * @return temporaryPINChallengeSize   * The number of cells in a temporary PIN challenge response.
     */
    public Integer getTemporaryPINChallengeSize() {
        return temporaryPINChallengeSize;
    }


    /**
     * Sets the temporaryPINChallengeSize value for this TokenChallenge.
     * 
     * @param temporaryPINChallengeSize   * The number of cells in a temporary PIN challenge response.
     */
    public void setTemporaryPINChallengeSize(Integer temporaryPINChallengeSize) {
        this.temporaryPINChallengeSize = temporaryPINChallengeSize;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenChallenge)) return false;
        TokenChallenge other = (TokenChallenge) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.challenge==null && other.getChallenge()==null) || 
             (this.challenge!=null &&
              this.challenge.equals(other.getChallenge()))) &&
            ((this.tokens==null && other.getTokens()==null) || 
             (this.tokens!=null &&
              java.util.Arrays.equals(this.tokens, other.getTokens()))) &&
            ((this.hasTemporaryPIN==null && other.getHasTemporaryPIN()==null) || 
             (this.hasTemporaryPIN!=null &&
              this.hasTemporaryPIN.equals(other.getHasTemporaryPIN()))) &&
            ((this.temporaryPINCellAlphabet==null && other.getTemporaryPINCellAlphabet()==null) || 
             (this.temporaryPINCellAlphabet!=null &&
              this.temporaryPINCellAlphabet.equals(other.getTemporaryPINCellAlphabet()))) &&
            ((this.temporaryPINCellSize==null && other.getTemporaryPINCellSize()==null) || 
             (this.temporaryPINCellSize!=null &&
              this.temporaryPINCellSize.equals(other.getTemporaryPINCellSize()))) &&
            ((this.temporaryPINChallengeSize==null && other.getTemporaryPINChallengeSize()==null) || 
             (this.temporaryPINChallengeSize!=null &&
              this.temporaryPINChallengeSize.equals(other.getTemporaryPINChallengeSize())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getChallenge() != null) {
            _hashCode += getChallenge().hashCode();
        }
        if (getTokens() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTokens());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTokens(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getHasTemporaryPIN() != null) {
            _hashCode += getHasTemporaryPIN().hashCode();
        }
        if (getTemporaryPINCellAlphabet() != null) {
            _hashCode += getTemporaryPINCellAlphabet().hashCode();
        }
        if (getTemporaryPINCellSize() != null) {
            _hashCode += getTemporaryPINCellSize().hashCode();
        }
        if (getTemporaryPINChallengeSize() != null) {
            _hashCode += getTemporaryPINChallengeSize().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenChallenge.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "TokenChallenge"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("challenge");
        elemField.setXmlName(new javax.xml.namespace.QName("", "challenge"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokens");
        elemField.setXmlName(new javax.xml.namespace.QName("", "tokens"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "TokenData"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("hasTemporaryPIN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "hasTemporaryPIN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("temporaryPINCellAlphabet");
        elemField.setXmlName(new javax.xml.namespace.QName("", "temporaryPINCellAlphabet"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("temporaryPINCellSize");
        elemField.setXmlName(new javax.xml.namespace.QName("", "temporaryPINCellSize"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("temporaryPINChallengeSize");
        elemField.setXmlName(new javax.xml.namespace.QName("", "temporaryPINChallengeSize"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
