/**
 * TokenData.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure contains information about a token that
 *             can be used to authenticate.
 */
public class TokenData  implements java.io.Serializable {
    /* This value will contain the name of the token vendor if
     *                   defined. Otherwise, this value will contain the
     * vendor id of
     *                   the token. */
    private String vendorId;

    /* The serial number of the token. */
    private String serialNumber;

    /* The set of the token. */
    private String tokenSet;

    /* A flag indicating if this token supports the data signature
     * operation.  Note that a value of true does not indicate if
     *                   the user's policy allows the data signature operation
     * to be
     *                   performed. */
    private boolean supportsDataSignature;

    /* A flag indicating if this token supports the delivery and
     *                   signature operation where Entrust IdentityGuard
     *                   delivers transaction details to the user's token
     * where
     *                   they are used to calculate the token response. */
    private boolean supportsDeliveryAndSignature;

    /* A value indicating if transaction details were delivered
     *                   as part of generating the challenge. */
    private DeliveryStatus deliveryStatus;

    public TokenData() {
    }

    public TokenData(
           String vendorId,
           String serialNumber,
           String tokenSet,
           boolean supportsDataSignature,
           boolean supportsDeliveryAndSignature,
           DeliveryStatus deliveryStatus) {
           this.vendorId = vendorId;
           this.serialNumber = serialNumber;
           this.tokenSet = tokenSet;
           this.supportsDataSignature = supportsDataSignature;
           this.supportsDeliveryAndSignature = supportsDeliveryAndSignature;
           this.deliveryStatus = deliveryStatus;
    }


    /**
     * Gets the vendorId value for this TokenData.
     * 
     * @return vendorId   * This value will contain the name of the token vendor if
     *                   defined. Otherwise, this value will contain the
     * vendor id of
     *                   the token.
     */
    public String getVendorId() {
        return vendorId;
    }


    /**
     * Sets the vendorId value for this TokenData.
     * 
     * @param vendorId   * This value will contain the name of the token vendor if
     *                   defined. Otherwise, this value will contain the
     * vendor id of
     *                   the token.
     */
    public void setVendorId(String vendorId) {
        this.vendorId = vendorId;
    }


    /**
     * Gets the serialNumber value for this TokenData.
     * 
     * @return serialNumber   * The serial number of the token.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this TokenData.
     * 
     * @param serialNumber   * The serial number of the token.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the tokenSet value for this TokenData.
     * 
     * @return tokenSet   * The set of the token.
     */
    public String getTokenSet() {
        return tokenSet;
    }


    /**
     * Sets the tokenSet value for this TokenData.
     * 
     * @param tokenSet   * The set of the token.
     */
    public void setTokenSet(String tokenSet) {
        this.tokenSet = tokenSet;
    }


    /**
     * Gets the supportsDataSignature value for this TokenData.
     * 
     * @return supportsDataSignature   * A flag indicating if this token supports the data signature
     * operation.  Note that a value of true does not indicate if
     *                   the user's policy allows the data signature operation
     * to be
     *                   performed.
     */
    public boolean isSupportsDataSignature() {
        return supportsDataSignature;
    }


    /**
     * Sets the supportsDataSignature value for this TokenData.
     * 
     * @param supportsDataSignature   * A flag indicating if this token supports the data signature
     * operation.  Note that a value of true does not indicate if
     *                   the user's policy allows the data signature operation
     * to be
     *                   performed.
     */
    public void setSupportsDataSignature(boolean supportsDataSignature) {
        this.supportsDataSignature = supportsDataSignature;
    }


    /**
     * Gets the supportsDeliveryAndSignature value for this TokenData.
     * 
     * @return supportsDeliveryAndSignature   * A flag indicating if this token supports the delivery and
     *                   signature operation where Entrust IdentityGuard
     *                   delivers transaction details to the user's token
     * where
     *                   they are used to calculate the token response.
     */
    public boolean isSupportsDeliveryAndSignature() {
        return supportsDeliveryAndSignature;
    }


    /**
     * Sets the supportsDeliveryAndSignature value for this TokenData.
     * 
     * @param supportsDeliveryAndSignature   * A flag indicating if this token supports the delivery and
     *                   signature operation where Entrust IdentityGuard
     *                   delivers transaction details to the user's token
     * where
     *                   they are used to calculate the token response.
     */
    public void setSupportsDeliveryAndSignature(boolean supportsDeliveryAndSignature) {
        this.supportsDeliveryAndSignature = supportsDeliveryAndSignature;
    }


    /**
     * Gets the deliveryStatus value for this TokenData.
     * 
     * @return deliveryStatus   * A value indicating if transaction details were delivered
     *                   as part of generating the challenge.
     */
    public DeliveryStatus getDeliveryStatus() {
        return deliveryStatus;
    }


    /**
     * Sets the deliveryStatus value for this TokenData.
     * 
     * @param deliveryStatus   * A value indicating if transaction details were delivered
     *                   as part of generating the challenge.
     */
    public void setDeliveryStatus(DeliveryStatus deliveryStatus) {
        this.deliveryStatus = deliveryStatus;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenData)) return false;
        TokenData other = (TokenData) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.vendorId==null && other.getVendorId()==null) || 
             (this.vendorId!=null &&
              this.vendorId.equals(other.getVendorId()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.tokenSet==null && other.getTokenSet()==null) || 
             (this.tokenSet!=null &&
              this.tokenSet.equals(other.getTokenSet()))) &&
            this.supportsDataSignature == other.isSupportsDataSignature() &&
            this.supportsDeliveryAndSignature == other.isSupportsDeliveryAndSignature() &&
            ((this.deliveryStatus==null && other.getDeliveryStatus()==null) || 
             (this.deliveryStatus!=null &&
              this.deliveryStatus.equals(other.getDeliveryStatus())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getVendorId() != null) {
            _hashCode += getVendorId().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getTokenSet() != null) {
            _hashCode += getTokenSet().hashCode();
        }
        _hashCode += (isSupportsDataSignature() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSupportsDeliveryAndSignature() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getDeliveryStatus() != null) {
            _hashCode += getDeliveryStatus().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenData.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "TokenData"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "VendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenSet");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenSet"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsDataSignature");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SupportsDataSignature"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supportsDeliveryAndSignature");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SupportsDeliveryAndSignature"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deliveryStatus");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DeliveryStatus"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "DeliveryStatus"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
