/**
 * TokenFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the filter to limit which unassigned tokens are
 *                         to be returned from the token list operation.
 */
public class TokenFilter  implements java.io.Serializable {
    /* If specified, only tokens with the given
     *                                 vendor are returned. */
    private String vendorId;

    /* If specified, only tokens whose serial numbers match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching. */
    private String serialNumber;

    /* If specified, returns only tokens whose load
     *                                 date is after the given date. */
    private java.util.Calendar loadStartDate;

    /* If specified, returns only tokens whose load
     *                                 date is before the given date. */
    private java.util.Calendar loadEndDate;

    /* If specified, provides a list of group names
     *                                 and returns only tokens in the specified
     * groups. */
    private String[] groups;

    /* The number of tokens to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100. */
    private Integer maxReturn;

    /* The vendor id of the next token to be
     *                                 returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * token. This
     *                                 value is used to get the next set
     * of tokens
     *                                 following a previous search. The value
     * can be found in the TokenListResult from the
     *                                 previous search.  This value is ignored
     * if
     *                                 the nextTokenSerialNumber is not specified.
     * If not specified when nextTokenSerialNumber
     *                                 is specified, the default vendorid
     * is used. */
    private String nextTokenVendorId;

    /* The serialNumber of the next token to be
     *                                 returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * token. This
     *                                 value is used to get the next set
     * of tokens
     *                                 following a previous search. The value
     * can be found in the TokenListResult from the
     *                                 previous search. */
    private String nextTokenSerialNumber;

    public TokenFilter() {
    }

    public TokenFilter(
           String vendorId,
           String serialNumber,
           java.util.Calendar loadStartDate,
           java.util.Calendar loadEndDate,
           String[] groups,
           Integer maxReturn,
           String nextTokenVendorId,
           String nextTokenSerialNumber) {
           this.vendorId = vendorId;
           this.serialNumber = serialNumber;
           this.loadStartDate = loadStartDate;
           this.loadEndDate = loadEndDate;
           this.groups = groups;
           this.maxReturn = maxReturn;
           this.nextTokenVendorId = nextTokenVendorId;
           this.nextTokenSerialNumber = nextTokenSerialNumber;
    }


    /**
     * Gets the vendorId value for this TokenFilter.
     * 
     * @return vendorId   * If specified, only tokens with the given
     *                                 vendor are returned.
     */
    public String getVendorId() {
        return vendorId;
    }


    /**
     * Sets the vendorId value for this TokenFilter.
     * 
     * @param vendorId   * If specified, only tokens with the given
     *                                 vendor are returned.
     */
    public void setVendorId(String vendorId) {
        this.vendorId = vendorId;
    }


    /**
     * Gets the serialNumber value for this TokenFilter.
     * 
     * @return serialNumber   * If specified, only tokens whose serial numbers match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this TokenFilter.
     * 
     * @param serialNumber   * If specified, only tokens whose serial numbers match
     *                                 this expression are returned. This
     * string can
     *                                 include the '*' character for wildcard
     * matching.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the loadStartDate value for this TokenFilter.
     * 
     * @return loadStartDate   * If specified, returns only tokens whose load
     *                                 date is after the given date.
     */
    public java.util.Calendar getLoadStartDate() {
        return loadStartDate;
    }


    /**
     * Sets the loadStartDate value for this TokenFilter.
     * 
     * @param loadStartDate   * If specified, returns only tokens whose load
     *                                 date is after the given date.
     */
    public void setLoadStartDate(java.util.Calendar loadStartDate) {
        this.loadStartDate = loadStartDate;
    }


    /**
     * Gets the loadEndDate value for this TokenFilter.
     * 
     * @return loadEndDate   * If specified, returns only tokens whose load
     *                                 date is before the given date.
     */
    public java.util.Calendar getLoadEndDate() {
        return loadEndDate;
    }


    /**
     * Sets the loadEndDate value for this TokenFilter.
     * 
     * @param loadEndDate   * If specified, returns only tokens whose load
     *                                 date is before the given date.
     */
    public void setLoadEndDate(java.util.Calendar loadEndDate) {
        this.loadEndDate = loadEndDate;
    }


    /**
     * Gets the groups value for this TokenFilter.
     * 
     * @return groups   * If specified, provides a list of group names
     *                                 and returns only tokens in the specified
     * groups.
     */
    public String[] getGroups() {
        return groups;
    }


    /**
     * Sets the groups value for this TokenFilter.
     * 
     * @param groups   * If specified, provides a list of group names
     *                                 and returns only tokens in the specified
     * groups.
     */
    public void setGroups(String[] groups) {
        this.groups = groups;
    }


    /**
     * Gets the maxReturn value for this TokenFilter.
     * 
     * @return maxReturn   * The number of tokens to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100.
     */
    public Integer getMaxReturn() {
        return maxReturn;
    }


    /**
     * Sets the maxReturn value for this TokenFilter.
     * 
     * @param maxReturn   * The number of tokens to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100.
     */
    public void setMaxReturn(Integer maxReturn) {
        this.maxReturn = maxReturn;
    }


    /**
     * Gets the nextTokenVendorId value for this TokenFilter.
     * 
     * @return nextTokenVendorId   * The vendor id of the next token to be
     *                                 returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * token. This
     *                                 value is used to get the next set
     * of tokens
     *                                 following a previous search. The value
     * can be found in the TokenListResult from the
     *                                 previous search.  This value is ignored
     * if
     *                                 the nextTokenSerialNumber is not specified.
     * If not specified when nextTokenSerialNumber
     *                                 is specified, the default vendorid
     * is used.
     */
    public String getNextTokenVendorId() {
        return nextTokenVendorId;
    }


    /**
     * Sets the nextTokenVendorId value for this TokenFilter.
     * 
     * @param nextTokenVendorId   * The vendor id of the next token to be
     *                                 returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * token. This
     *                                 value is used to get the next set
     * of tokens
     *                                 following a previous search. The value
     * can be found in the TokenListResult from the
     *                                 previous search.  This value is ignored
     * if
     *                                 the nextTokenSerialNumber is not specified.
     * If not specified when nextTokenSerialNumber
     *                                 is specified, the default vendorid
     * is used.
     */
    public void setNextTokenVendorId(String nextTokenVendorId) {
        this.nextTokenVendorId = nextTokenVendorId;
    }


    /**
     * Gets the nextTokenSerialNumber value for this TokenFilter.
     * 
     * @return nextTokenSerialNumber   * The serialNumber of the next token to be
     *                                 returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * token. This
     *                                 value is used to get the next set
     * of tokens
     *                                 following a previous search. The value
     * can be found in the TokenListResult from the
     *                                 previous search.
     */
    public String getNextTokenSerialNumber() {
        return nextTokenSerialNumber;
    }


    /**
     * Sets the nextTokenSerialNumber value for this TokenFilter.
     * 
     * @param nextTokenSerialNumber   * The serialNumber of the next token to be
     *                                 returned. If specified, indicates
     * that
     *                                 searching should start at the given
     * token. This
     *                                 value is used to get the next set
     * of tokens
     *                                 following a previous search. The value
     * can be found in the TokenListResult from the
     *                                 previous search.
     */
    public void setNextTokenSerialNumber(String nextTokenSerialNumber) {
        this.nextTokenSerialNumber = nextTokenSerialNumber;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenFilter)) return false;
        TokenFilter other = (TokenFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.vendorId==null && other.getVendorId()==null) || 
             (this.vendorId!=null &&
              this.vendorId.equals(other.getVendorId()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.loadStartDate==null && other.getLoadStartDate()==null) || 
             (this.loadStartDate!=null &&
              this.loadStartDate.equals(other.getLoadStartDate()))) &&
            ((this.loadEndDate==null && other.getLoadEndDate()==null) || 
             (this.loadEndDate!=null &&
              this.loadEndDate.equals(other.getLoadEndDate()))) &&
            ((this.groups==null && other.getGroups()==null) || 
             (this.groups!=null &&
              java.util.Arrays.equals(this.groups, other.getGroups()))) &&
            ((this.maxReturn==null && other.getMaxReturn()==null) || 
             (this.maxReturn!=null &&
              this.maxReturn.equals(other.getMaxReturn()))) &&
            ((this.nextTokenVendorId==null && other.getNextTokenVendorId()==null) || 
             (this.nextTokenVendorId!=null &&
              this.nextTokenVendorId.equals(other.getNextTokenVendorId()))) &&
            ((this.nextTokenSerialNumber==null && other.getNextTokenSerialNumber()==null) || 
             (this.nextTokenSerialNumber!=null &&
              this.nextTokenSerialNumber.equals(other.getNextTokenSerialNumber())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getVendorId() != null) {
            _hashCode += getVendorId().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getLoadStartDate() != null) {
            _hashCode += getLoadStartDate().hashCode();
        }
        if (getLoadEndDate() != null) {
            _hashCode += getLoadEndDate().hashCode();
        }
        if (getGroups() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getGroups());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getGroups(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getMaxReturn() != null) {
            _hashCode += getMaxReturn().hashCode();
        }
        if (getNextTokenVendorId() != null) {
            _hashCode += getNextTokenVendorId().hashCode();
        }
        if (getNextTokenSerialNumber() != null) {
            _hashCode += getNextTokenSerialNumber().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "vendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadStartDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loadStartDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadEndDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loadEndDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("groups");
        elemField.setXmlName(new javax.xml.namespace.QName("", "groups"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxReturn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxReturn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("nextTokenVendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "nextTokenVendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("nextTokenSerialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "nextTokenSerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
