/**
 * TokenInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned about an unassigned
 *                         token.
 */
public class TokenInfo  implements java.io.Serializable {
    /* This value will contain the name of the token
     *                                 vendor if it is defined.  Otherwise
     * it will
     *                                 contain the vendor id of the token. */
    private String vendorId;

    /* The serial number of the token. */
    private String serialNumber;

    /* The type of the token. */
    private String tokenType;

    /* Flag indicating if this token supports
     *                                 token response-only authentication. */
    private boolean responseSupported;

    /* Flag indicating if this token supports
     *                                 token challenge/response authentication. */
    private boolean challengeSupported;

    /* Flag indicating if this token supports
     *                                 the unlock operation. */
    private boolean unlockSupported;

    /* Flag indicating if this token supports
     *                                 the data signature operation. */
    private boolean signatureSupported;

    /* Value specifying what kind of activation
     *                                 is current configured for this token. */
    private TokenActivationType currentActivationType;

    /* Value specifying what kind of activation
     *                                 types are available for this token. */
    private TokenActivationType[] availableActivationTypes;

    /* The load date of the token. */
    private java.util.Calendar loadDate;

    /* The group this token belongs to. */
    private String group;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    /* The token comment. */
    private String comment;

    public TokenInfo() {
    }

    public TokenInfo(
           String vendorId,
           String serialNumber,
           String tokenType,
           boolean responseSupported,
           boolean challengeSupported,
           boolean unlockSupported,
           boolean signatureSupported,
           TokenActivationType currentActivationType,
           TokenActivationType[] availableActivationTypes,
           java.util.Calendar loadDate,
           String group,
           String[] rolesGrantingAccess,
           String comment) {
           this.vendorId = vendorId;
           this.serialNumber = serialNumber;
           this.tokenType = tokenType;
           this.responseSupported = responseSupported;
           this.challengeSupported = challengeSupported;
           this.unlockSupported = unlockSupported;
           this.signatureSupported = signatureSupported;
           this.currentActivationType = currentActivationType;
           this.availableActivationTypes = availableActivationTypes;
           this.loadDate = loadDate;
           this.group = group;
           this.rolesGrantingAccess = rolesGrantingAccess;
           this.comment = comment;
    }


    /**
     * Gets the vendorId value for this TokenInfo.
     * 
     * @return vendorId   * This value will contain the name of the token
     *                                 vendor if it is defined.  Otherwise
     * it will
     *                                 contain the vendor id of the token.
     */
    public String getVendorId() {
        return vendorId;
    }


    /**
     * Sets the vendorId value for this TokenInfo.
     * 
     * @param vendorId   * This value will contain the name of the token
     *                                 vendor if it is defined.  Otherwise
     * it will
     *                                 contain the vendor id of the token.
     */
    public void setVendorId(String vendorId) {
        this.vendorId = vendorId;
    }


    /**
     * Gets the serialNumber value for this TokenInfo.
     * 
     * @return serialNumber   * The serial number of the token.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this TokenInfo.
     * 
     * @param serialNumber   * The serial number of the token.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the tokenType value for this TokenInfo.
     * 
     * @return tokenType   * The type of the token.
     */
    public String getTokenType() {
        return tokenType;
    }


    /**
     * Sets the tokenType value for this TokenInfo.
     * 
     * @param tokenType   * The type of the token.
     */
    public void setTokenType(String tokenType) {
        this.tokenType = tokenType;
    }


    /**
     * Gets the responseSupported value for this TokenInfo.
     * 
     * @return responseSupported   * Flag indicating if this token supports
     *                                 token response-only authentication.
     */
    public boolean isResponseSupported() {
        return responseSupported;
    }


    /**
     * Sets the responseSupported value for this TokenInfo.
     * 
     * @param responseSupported   * Flag indicating if this token supports
     *                                 token response-only authentication.
     */
    public void setResponseSupported(boolean responseSupported) {
        this.responseSupported = responseSupported;
    }


    /**
     * Gets the challengeSupported value for this TokenInfo.
     * 
     * @return challengeSupported   * Flag indicating if this token supports
     *                                 token challenge/response authentication.
     */
    public boolean isChallengeSupported() {
        return challengeSupported;
    }


    /**
     * Sets the challengeSupported value for this TokenInfo.
     * 
     * @param challengeSupported   * Flag indicating if this token supports
     *                                 token challenge/response authentication.
     */
    public void setChallengeSupported(boolean challengeSupported) {
        this.challengeSupported = challengeSupported;
    }


    /**
     * Gets the unlockSupported value for this TokenInfo.
     * 
     * @return unlockSupported   * Flag indicating if this token supports
     *                                 the unlock operation.
     */
    public boolean isUnlockSupported() {
        return unlockSupported;
    }


    /**
     * Sets the unlockSupported value for this TokenInfo.
     * 
     * @param unlockSupported   * Flag indicating if this token supports
     *                                 the unlock operation.
     */
    public void setUnlockSupported(boolean unlockSupported) {
        this.unlockSupported = unlockSupported;
    }


    /**
     * Gets the signatureSupported value for this TokenInfo.
     * 
     * @return signatureSupported   * Flag indicating if this token supports
     *                                 the data signature operation.
     */
    public boolean isSignatureSupported() {
        return signatureSupported;
    }


    /**
     * Sets the signatureSupported value for this TokenInfo.
     * 
     * @param signatureSupported   * Flag indicating if this token supports
     *                                 the data signature operation.
     */
    public void setSignatureSupported(boolean signatureSupported) {
        this.signatureSupported = signatureSupported;
    }


    /**
     * Gets the currentActivationType value for this TokenInfo.
     * 
     * @return currentActivationType   * Value specifying what kind of activation
     *                                 is current configured for this token.
     */
    public TokenActivationType getCurrentActivationType() {
        return currentActivationType;
    }


    /**
     * Sets the currentActivationType value for this TokenInfo.
     * 
     * @param currentActivationType   * Value specifying what kind of activation
     *                                 is current configured for this token.
     */
    public void setCurrentActivationType(TokenActivationType currentActivationType) {
        this.currentActivationType = currentActivationType;
    }


    /**
     * Gets the availableActivationTypes value for this TokenInfo.
     * 
     * @return availableActivationTypes   * Value specifying what kind of activation
     *                                 types are available for this token.
     */
    public TokenActivationType[] getAvailableActivationTypes() {
        return availableActivationTypes;
    }


    /**
     * Sets the availableActivationTypes value for this TokenInfo.
     * 
     * @param availableActivationTypes   * Value specifying what kind of activation
     *                                 types are available for this token.
     */
    public void setAvailableActivationTypes(TokenActivationType[] availableActivationTypes) {
        this.availableActivationTypes = availableActivationTypes;
    }


    /**
     * Gets the loadDate value for this TokenInfo.
     * 
     * @return loadDate   * The load date of the token.
     */
    public java.util.Calendar getLoadDate() {
        return loadDate;
    }


    /**
     * Sets the loadDate value for this TokenInfo.
     * 
     * @param loadDate   * The load date of the token.
     */
    public void setLoadDate(java.util.Calendar loadDate) {
        this.loadDate = loadDate;
    }


    /**
     * Gets the group value for this TokenInfo.
     * 
     * @return group   * The group this token belongs to.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this TokenInfo.
     * 
     * @param group   * The group this token belongs to.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the rolesGrantingAccess value for this TokenInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this TokenInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the comment value for this TokenInfo.
     * 
     * @return comment   * The token comment.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this TokenInfo.
     * 
     * @param comment   * The token comment.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenInfo)) return false;
        TokenInfo other = (TokenInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.vendorId==null && other.getVendorId()==null) || 
             (this.vendorId!=null &&
              this.vendorId.equals(other.getVendorId()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.tokenType==null && other.getTokenType()==null) || 
             (this.tokenType!=null &&
              this.tokenType.equals(other.getTokenType()))) &&
            this.responseSupported == other.isResponseSupported() &&
            this.challengeSupported == other.isChallengeSupported() &&
            this.unlockSupported == other.isUnlockSupported() &&
            this.signatureSupported == other.isSignatureSupported() &&
            ((this.currentActivationType==null && other.getCurrentActivationType()==null) || 
             (this.currentActivationType!=null &&
              this.currentActivationType.equals(other.getCurrentActivationType()))) &&
            ((this.availableActivationTypes==null && other.getAvailableActivationTypes()==null) || 
             (this.availableActivationTypes!=null &&
              java.util.Arrays.equals(this.availableActivationTypes, other.getAvailableActivationTypes()))) &&
            ((this.loadDate==null && other.getLoadDate()==null) || 
             (this.loadDate!=null &&
              this.loadDate.equals(other.getLoadDate()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getVendorId() != null) {
            _hashCode += getVendorId().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getTokenType() != null) {
            _hashCode += getTokenType().hashCode();
        }
        _hashCode += (isResponseSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isChallengeSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isUnlockSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isSignatureSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getCurrentActivationType() != null) {
            _hashCode += getCurrentActivationType().hashCode();
        }
        if (getAvailableActivationTypes() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getAvailableActivationTypes());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getAvailableActivationTypes(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getLoadDate() != null) {
            _hashCode += getLoadDate().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "VendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenType"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("responseSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ResponseSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("challengeSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ChallengeSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("unlockSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UnlockSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("signatureSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SignatureSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("currentActivationType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CurrentActivationType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenActivationType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("availableActivationTypes");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AvailableActivationTypes"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenActivationType"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "LoadDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
