/**
 * TokenLicenseInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Information about the system's token license settings.
 */
public class TokenLicenseInfo  implements java.io.Serializable {
    /* The current number of licensed tokens in the system.
     *                                 Tokens added to the system using the
     * userTokenCreate
     *                                 operation are considered licensed,
     * in that they count against the maximum allowed by the
     *                                 token license. Tokens added to the
     * system using tokenLoad
     *                                 do not count against the license. */
    private java.math.BigInteger numTokens;

    /* The maximum number of licensed tokens that can
     *                                 exist in the system. The system will
     * not allow
     *                                 more than this many soft tokens to
     * be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of tokens in the system, or
     * the
     *                                 licenseCheck operation was called
     * to count
     *                                 licensed tokens and did not provide
     * installation
     *                                 and activation keys. */
    private java.math.BigInteger maxTokens;

    /* The date at which the token license expires. The
     *                                 system will stop allowing operations
     * on licensed
     *                                 tokens, including authentication,
     * 
     *                                 after this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the licenseCheck operation
     * was
     *                                 called to count licensed tokens and
     * did not
     *                                 provide installation and activation
     * keys. */
    private java.util.Calendar expiryDate;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public TokenLicenseInfo() {
    }

    public TokenLicenseInfo(
           java.math.BigInteger numTokens,
           java.math.BigInteger maxTokens,
           java.util.Calendar expiryDate,
           String[] rolesGrantingAccess) {
           this.numTokens = numTokens;
           this.maxTokens = maxTokens;
           this.expiryDate = expiryDate;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the numTokens value for this TokenLicenseInfo.
     * 
     * @return numTokens   * The current number of licensed tokens in the system.
     *                                 Tokens added to the system using the
     * userTokenCreate
     *                                 operation are considered licensed,
     * in that they count against the maximum allowed by the
     *                                 token license. Tokens added to the
     * system using tokenLoad
     *                                 do not count against the license.
     */
    public java.math.BigInteger getNumTokens() {
        return numTokens;
    }


    /**
     * Sets the numTokens value for this TokenLicenseInfo.
     * 
     * @param numTokens   * The current number of licensed tokens in the system.
     *                                 Tokens added to the system using the
     * userTokenCreate
     *                                 operation are considered licensed,
     * in that they count against the maximum allowed by the
     *                                 token license. Tokens added to the
     * system using tokenLoad
     *                                 do not count against the license.
     */
    public void setNumTokens(java.math.BigInteger numTokens) {
        this.numTokens = numTokens;
    }


    /**
     * Gets the maxTokens value for this TokenLicenseInfo.
     * 
     * @return maxTokens   * The maximum number of licensed tokens that can
     *                                 exist in the system. The system will
     * not allow
     *                                 more than this many soft tokens to
     * be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of tokens in the system, or
     * the
     *                                 licenseCheck operation was called
     * to count
     *                                 licensed tokens and did not provide
     * installation
     *                                 and activation keys.
     */
    public java.math.BigInteger getMaxTokens() {
        return maxTokens;
    }


    /**
     * Sets the maxTokens value for this TokenLicenseInfo.
     * 
     * @param maxTokens   * The maximum number of licensed tokens that can
     *                                 exist in the system. The system will
     * not allow
     *                                 more than this many soft tokens to
     * be created.
     * 
     *                                 If this value is nil, there is no
     * limit to the
     *                                 number of tokens in the system, or
     * the
     *                                 licenseCheck operation was called
     * to count
     *                                 licensed tokens and did not provide
     * installation
     *                                 and activation keys.
     */
    public void setMaxTokens(java.math.BigInteger maxTokens) {
        this.maxTokens = maxTokens;
    }


    /**
     * Gets the expiryDate value for this TokenLicenseInfo.
     * 
     * @return expiryDate   * The date at which the token license expires. The
     *                                 system will stop allowing operations
     * on licensed
     *                                 tokens, including authentication,
     * 
     *                                 after this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the licenseCheck operation
     * was
     *                                 called to count licensed tokens and
     * did not
     *                                 provide installation and activation
     * keys.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this TokenLicenseInfo.
     * 
     * @param expiryDate   * The date at which the token license expires. The
     *                                 system will stop allowing operations
     * on licensed
     *                                 tokens, including authentication,
     * 
     *                                 after this date.
     * 
     *                                 If this value is nil, the current
     * license never
     *                                 expires, or the licenseCheck operation
     * was
     *                                 called to count licensed tokens and
     * did not
     *                                 provide installation and activation
     * keys.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the rolesGrantingAccess value for this TokenLicenseInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this TokenLicenseInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenLicenseInfo)) return false;
        TokenLicenseInfo other = (TokenLicenseInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.numTokens==null && other.getNumTokens()==null) || 
             (this.numTokens!=null &&
              this.numTokens.equals(other.getNumTokens()))) &&
            ((this.maxTokens==null && other.getMaxTokens()==null) || 
             (this.maxTokens!=null &&
              this.maxTokens.equals(other.getMaxTokens()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getNumTokens() != null) {
            _hashCode += getNumTokens().hashCode();
        }
        if (getMaxTokens() != null) {
            _hashCode += getMaxTokens().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenLicenseInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenLicenseInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numTokens");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numTokens"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxTokens");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxTokens"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "integer"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "rolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
