/**
 * TokenParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when loading or modifying
 *                      unassigned tokens. All values can be null indicating
 * that the default is used when loading or the value is not
 *                      changed for modify.
 */
public class TokenParms  implements java.io.Serializable {
    /* When loading tokens, the vendor to use for
     *                            loading the tokens.  If not specified,
     * the
     *                            default vendor is used.
     *                            This value can contain either the name
     * or ID of
     *                            the token vendor.  Either value will match
     * the
     *                            token vendor.
     *                            This value is ignored when modifying tokens. */
    private String vendorId;

    /* The group this token belongs to. If null
     *                            during load, the token will belong to the
     * default
     *                            group. */
    private String group;

    /* The token data to load for the tokenLoad operation
     *                            where the data is specified as a list of
     * text lines.
     *                            Each element in the array is a line from
     * the token
     *                            data file.
     *                            Ignored when modifying tokens. */
    private String[] tokenData;

    /* The token data to load for the tokenLoad
     *                            operation where the data is specified as
     * binary
     *                            data.
     *                            Ignored when modifying tokens. */
    private byte[] tokenBinaryData;

    /* The token key used to unlock the token data in the
     *                            tokenLoad operation.
     *                            Ignored when modifying tokens. */
    private String tokenKey;

    /* The activation type to be used for this token.
     *                            Can be specified for the tokenLoad or tokenSet
     * methods. */
    private TokenActivationType activationType;

    /* The token comment. Defaults to an empty string if not
     *                            specified during a tokenLoad operation. */
    private String comment;

    public TokenParms() {
    }

    public TokenParms(
           String vendorId,
           String group,
           String[] tokenData,
           byte[] tokenBinaryData,
           String tokenKey,
           TokenActivationType activationType,
           String comment) {
           this.vendorId = vendorId;
           this.group = group;
           this.tokenData = tokenData;
           this.tokenBinaryData = tokenBinaryData;
           this.tokenKey = tokenKey;
           this.activationType = activationType;
           this.comment = comment;
    }


    /**
     * Gets the vendorId value for this TokenParms.
     * 
     * @return vendorId   * When loading tokens, the vendor to use for
     *                            loading the tokens.  If not specified,
     * the
     *                            default vendor is used.
     *                            This value can contain either the name
     * or ID of
     *                            the token vendor.  Either value will match
     * the
     *                            token vendor.
     *                            This value is ignored when modifying tokens.
     */
    public String getVendorId() {
        return vendorId;
    }


    /**
     * Sets the vendorId value for this TokenParms.
     * 
     * @param vendorId   * When loading tokens, the vendor to use for
     *                            loading the tokens.  If not specified,
     * the
     *                            default vendor is used.
     *                            This value can contain either the name
     * or ID of
     *                            the token vendor.  Either value will match
     * the
     *                            token vendor.
     *                            This value is ignored when modifying tokens.
     */
    public void setVendorId(String vendorId) {
        this.vendorId = vendorId;
    }


    /**
     * Gets the group value for this TokenParms.
     * 
     * @return group   * The group this token belongs to. If null
     *                            during load, the token will belong to the
     * default
     *                            group.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this TokenParms.
     * 
     * @param group   * The group this token belongs to. If null
     *                            during load, the token will belong to the
     * default
     *                            group.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the tokenData value for this TokenParms.
     * 
     * @return tokenData   * The token data to load for the tokenLoad operation
     *                            where the data is specified as a list of
     * text lines.
     *                            Each element in the array is a line from
     * the token
     *                            data file.
     *                            Ignored when modifying tokens.
     */
    public String[] getTokenData() {
        return tokenData;
    }


    /**
     * Sets the tokenData value for this TokenParms.
     * 
     * @param tokenData   * The token data to load for the tokenLoad operation
     *                            where the data is specified as a list of
     * text lines.
     *                            Each element in the array is a line from
     * the token
     *                            data file.
     *                            Ignored when modifying tokens.
     */
    public void setTokenData(String[] tokenData) {
        this.tokenData = tokenData;
    }


    /**
     * Gets the tokenBinaryData value for this TokenParms.
     * 
     * @return tokenBinaryData   * The token data to load for the tokenLoad
     *                            operation where the data is specified as
     * binary
     *                            data.
     *                            Ignored when modifying tokens.
     */
    public byte[] getTokenBinaryData() {
        return tokenBinaryData;
    }


    /**
     * Sets the tokenBinaryData value for this TokenParms.
     * 
     * @param tokenBinaryData   * The token data to load for the tokenLoad
     *                            operation where the data is specified as
     * binary
     *                            data.
     *                            Ignored when modifying tokens.
     */
    public void setTokenBinaryData(byte[] tokenBinaryData) {
        this.tokenBinaryData = tokenBinaryData;
    }


    /**
     * Gets the tokenKey value for this TokenParms.
     * 
     * @return tokenKey   * The token key used to unlock the token data in the
     *                            tokenLoad operation.
     *                            Ignored when modifying tokens.
     */
    public String getTokenKey() {
        return tokenKey;
    }


    /**
     * Sets the tokenKey value for this TokenParms.
     * 
     * @param tokenKey   * The token key used to unlock the token data in the
     *                            tokenLoad operation.
     *                            Ignored when modifying tokens.
     */
    public void setTokenKey(String tokenKey) {
        this.tokenKey = tokenKey;
    }


    /**
     * Gets the activationType value for this TokenParms.
     * 
     * @return activationType   * The activation type to be used for this token.
     *                            Can be specified for the tokenLoad or tokenSet
     * methods.
     */
    public TokenActivationType getActivationType() {
        return activationType;
    }


    /**
     * Sets the activationType value for this TokenParms.
     * 
     * @param activationType   * The activation type to be used for this token.
     *                            Can be specified for the tokenLoad or tokenSet
     * methods.
     */
    public void setActivationType(TokenActivationType activationType) {
        this.activationType = activationType;
    }


    /**
     * Gets the comment value for this TokenParms.
     * 
     * @return comment   * The token comment. Defaults to an empty string if not
     *                            specified during a tokenLoad operation.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this TokenParms.
     * 
     * @param comment   * The token comment. Defaults to an empty string if not
     *                            specified during a tokenLoad operation.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenParms)) return false;
        TokenParms other = (TokenParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.vendorId==null && other.getVendorId()==null) || 
             (this.vendorId!=null &&
              this.vendorId.equals(other.getVendorId()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.tokenData==null && other.getTokenData()==null) || 
             (this.tokenData!=null &&
              java.util.Arrays.equals(this.tokenData, other.getTokenData()))) &&
            ((this.tokenBinaryData==null && other.getTokenBinaryData()==null) || 
             (this.tokenBinaryData!=null &&
              java.util.Arrays.equals(this.tokenBinaryData, other.getTokenBinaryData()))) &&
            ((this.tokenKey==null && other.getTokenKey()==null) || 
             (this.tokenKey!=null &&
              this.tokenKey.equals(other.getTokenKey()))) &&
            ((this.activationType==null && other.getActivationType()==null) || 
             (this.activationType!=null &&
              this.activationType.equals(other.getActivationType()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getVendorId() != null) {
            _hashCode += getVendorId().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getTokenData() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTokenData());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTokenData(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getTokenBinaryData() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTokenBinaryData());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTokenBinaryData(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getTokenKey() != null) {
            _hashCode += getTokenKey().hashCode();
        }
        if (getActivationType() != null) {
            _hashCode += getActivationType().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "VendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenData");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenData"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenBinaryData");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenBinaryData"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenKey");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenKey"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("activationType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ActivationType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenActivationType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
