/**
 * TokenVendorInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure provides information about a
 *                         Token Vendor.
 */
public class TokenVendorInfo  implements java.io.Serializable {
    /* The id of the token vendor. */
    private String vendorId;

    /* The name of the token vendor. */
    private String vendorName;

    /* Flag indicating if this token vendor is the
     *                                 default.  At most one token vendor
     * will be
     *                                 the default. */
    private boolean defaultVendor;

    /* Flag indicating if the token data files loaded
     *                                 by this token vendor are binary or
     * not. */
    private boolean binary;

    /* The minimum number of responses required for
     *                                 the token reset operation on tokens
     * with this
     *                                 vendor. */
    private int minResetResponses;

    /* The maximum number of responses used for
     *                                 the token reset operation on tokens
     * with this
     *                                 vendor. */
    private int maxResetResponses;

    /* A flag indicating if the token vendor requires
     *                                 a key when loading tokens.  If a key
     * is
     *                                 not required, then it is optional. */
    private boolean requiresKey;

    /* A flag indicating if online activation
     *                                 is supported by this token vendor. */
    private boolean onlineActivationSupported;

    /* A flag indicating if the online activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor supports an activation
     * password. */
    private boolean onlineActivationSupportsPassword;

    /* A flag indicating if the online activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor requires that the activation
     * password be specified. */
    private boolean onlineActivationRequiresPassword;

    /* A flag indicating if offline activation
     *                                 is supported by this token vendor. */
    private boolean offlineActivationSupported;

    /* A flag indicating if the offline activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor supports activation passwords. */
    private boolean offlineActivationSupportsPassword;

    /* A flag indicating if the offline activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor requires that the activation
     * password be specified. */
    private boolean offlineActivationRequiresPassword;

    /* A flag indicating if this token vendor supports
     *                                 creation of tokens using the userTokenCreate
     * operations. */
    private boolean createSupported;

    /* A flag indicating if this token vendor supports
     *                                 loading of tokens using the tokenLoad
     * operation.
     *                                 If a vendor does not support loading
     * tokens, the
     *                                 Binary, requiresKey and
     *                                 serialNumberGeneratedByServer fields
     * in this
     *                                 structure are meaningless. */
    private boolean loadSupported;

    public TokenVendorInfo() {
    }

    public TokenVendorInfo(
           String vendorId,
           String vendorName,
           boolean defaultVendor,
           boolean binary,
           int minResetResponses,
           int maxResetResponses,
           boolean requiresKey,
           boolean onlineActivationSupported,
           boolean onlineActivationSupportsPassword,
           boolean onlineActivationRequiresPassword,
           boolean offlineActivationSupported,
           boolean offlineActivationSupportsPassword,
           boolean offlineActivationRequiresPassword,
           boolean createSupported,
           boolean loadSupported) {
           this.vendorId = vendorId;
           this.vendorName = vendorName;
           this.defaultVendor = defaultVendor;
           this.binary = binary;
           this.minResetResponses = minResetResponses;
           this.maxResetResponses = maxResetResponses;
           this.requiresKey = requiresKey;
           this.onlineActivationSupported = onlineActivationSupported;
           this.onlineActivationSupportsPassword = onlineActivationSupportsPassword;
           this.onlineActivationRequiresPassword = onlineActivationRequiresPassword;
           this.offlineActivationSupported = offlineActivationSupported;
           this.offlineActivationSupportsPassword = offlineActivationSupportsPassword;
           this.offlineActivationRequiresPassword = offlineActivationRequiresPassword;
           this.createSupported = createSupported;
           this.loadSupported = loadSupported;
    }


    /**
     * Gets the vendorId value for this TokenVendorInfo.
     * 
     * @return vendorId   * The id of the token vendor.
     */
    public String getVendorId() {
        return vendorId;
    }


    /**
     * Sets the vendorId value for this TokenVendorInfo.
     * 
     * @param vendorId   * The id of the token vendor.
     */
    public void setVendorId(String vendorId) {
        this.vendorId = vendorId;
    }


    /**
     * Gets the vendorName value for this TokenVendorInfo.
     * 
     * @return vendorName   * The name of the token vendor.
     */
    public String getVendorName() {
        return vendorName;
    }


    /**
     * Sets the vendorName value for this TokenVendorInfo.
     * 
     * @param vendorName   * The name of the token vendor.
     */
    public void setVendorName(String vendorName) {
        this.vendorName = vendorName;
    }


    /**
     * Gets the defaultVendor value for this TokenVendorInfo.
     * 
     * @return defaultVendor   * Flag indicating if this token vendor is the
     *                                 default.  At most one token vendor
     * will be
     *                                 the default.
     */
    public boolean isDefaultVendor() {
        return defaultVendor;
    }


    /**
     * Sets the defaultVendor value for this TokenVendorInfo.
     * 
     * @param defaultVendor   * Flag indicating if this token vendor is the
     *                                 default.  At most one token vendor
     * will be
     *                                 the default.
     */
    public void setDefaultVendor(boolean defaultVendor) {
        this.defaultVendor = defaultVendor;
    }


    /**
     * Gets the binary value for this TokenVendorInfo.
     * 
     * @return binary   * Flag indicating if the token data files loaded
     *                                 by this token vendor are binary or
     * not.
     */
    public boolean isBinary() {
        return binary;
    }


    /**
     * Sets the binary value for this TokenVendorInfo.
     * 
     * @param binary   * Flag indicating if the token data files loaded
     *                                 by this token vendor are binary or
     * not.
     */
    public void setBinary(boolean binary) {
        this.binary = binary;
    }


    /**
     * Gets the minResetResponses value for this TokenVendorInfo.
     * 
     * @return minResetResponses   * The minimum number of responses required for
     *                                 the token reset operation on tokens
     * with this
     *                                 vendor.
     */
    public int getMinResetResponses() {
        return minResetResponses;
    }


    /**
     * Sets the minResetResponses value for this TokenVendorInfo.
     * 
     * @param minResetResponses   * The minimum number of responses required for
     *                                 the token reset operation on tokens
     * with this
     *                                 vendor.
     */
    public void setMinResetResponses(int minResetResponses) {
        this.minResetResponses = minResetResponses;
    }


    /**
     * Gets the maxResetResponses value for this TokenVendorInfo.
     * 
     * @return maxResetResponses   * The maximum number of responses used for
     *                                 the token reset operation on tokens
     * with this
     *                                 vendor.
     */
    public int getMaxResetResponses() {
        return maxResetResponses;
    }


    /**
     * Sets the maxResetResponses value for this TokenVendorInfo.
     * 
     * @param maxResetResponses   * The maximum number of responses used for
     *                                 the token reset operation on tokens
     * with this
     *                                 vendor.
     */
    public void setMaxResetResponses(int maxResetResponses) {
        this.maxResetResponses = maxResetResponses;
    }


    /**
     * Gets the requiresKey value for this TokenVendorInfo.
     * 
     * @return requiresKey   * A flag indicating if the token vendor requires
     *                                 a key when loading tokens.  If a key
     * is
     *                                 not required, then it is optional.
     */
    public boolean isRequiresKey() {
        return requiresKey;
    }


    /**
     * Sets the requiresKey value for this TokenVendorInfo.
     * 
     * @param requiresKey   * A flag indicating if the token vendor requires
     *                                 a key when loading tokens.  If a key
     * is
     *                                 not required, then it is optional.
     */
    public void setRequiresKey(boolean requiresKey) {
        this.requiresKey = requiresKey;
    }


    /**
     * Gets the onlineActivationSupported value for this TokenVendorInfo.
     * 
     * @return onlineActivationSupported   * A flag indicating if online activation
     *                                 is supported by this token vendor.
     */
    public boolean isOnlineActivationSupported() {
        return onlineActivationSupported;
    }


    /**
     * Sets the onlineActivationSupported value for this TokenVendorInfo.
     * 
     * @param onlineActivationSupported   * A flag indicating if online activation
     *                                 is supported by this token vendor.
     */
    public void setOnlineActivationSupported(boolean onlineActivationSupported) {
        this.onlineActivationSupported = onlineActivationSupported;
    }


    /**
     * Gets the onlineActivationSupportsPassword value for this TokenVendorInfo.
     * 
     * @return onlineActivationSupportsPassword   * A flag indicating if the online activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor supports an activation
     * password.
     */
    public boolean isOnlineActivationSupportsPassword() {
        return onlineActivationSupportsPassword;
    }


    /**
     * Sets the onlineActivationSupportsPassword value for this TokenVendorInfo.
     * 
     * @param onlineActivationSupportsPassword   * A flag indicating if the online activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor supports an activation
     * password.
     */
    public void setOnlineActivationSupportsPassword(boolean onlineActivationSupportsPassword) {
        this.onlineActivationSupportsPassword = onlineActivationSupportsPassword;
    }


    /**
     * Gets the onlineActivationRequiresPassword value for this TokenVendorInfo.
     * 
     * @return onlineActivationRequiresPassword   * A flag indicating if the online activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor requires that the activation
     * password be specified.
     */
    public boolean isOnlineActivationRequiresPassword() {
        return onlineActivationRequiresPassword;
    }


    /**
     * Sets the onlineActivationRequiresPassword value for this TokenVendorInfo.
     * 
     * @param onlineActivationRequiresPassword   * A flag indicating if the online activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor requires that the activation
     * password be specified.
     */
    public void setOnlineActivationRequiresPassword(boolean onlineActivationRequiresPassword) {
        this.onlineActivationRequiresPassword = onlineActivationRequiresPassword;
    }


    /**
     * Gets the offlineActivationSupported value for this TokenVendorInfo.
     * 
     * @return offlineActivationSupported   * A flag indicating if offline activation
     *                                 is supported by this token vendor.
     */
    public boolean isOfflineActivationSupported() {
        return offlineActivationSupported;
    }


    /**
     * Sets the offlineActivationSupported value for this TokenVendorInfo.
     * 
     * @param offlineActivationSupported   * A flag indicating if offline activation
     *                                 is supported by this token vendor.
     */
    public void setOfflineActivationSupported(boolean offlineActivationSupported) {
        this.offlineActivationSupported = offlineActivationSupported;
    }


    /**
     * Gets the offlineActivationSupportsPassword value for this TokenVendorInfo.
     * 
     * @return offlineActivationSupportsPassword   * A flag indicating if the offline activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor supports activation passwords.
     */
    public boolean isOfflineActivationSupportsPassword() {
        return offlineActivationSupportsPassword;
    }


    /**
     * Sets the offlineActivationSupportsPassword value for this TokenVendorInfo.
     * 
     * @param offlineActivationSupportsPassword   * A flag indicating if the offline activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor supports activation passwords.
     */
    public void setOfflineActivationSupportsPassword(boolean offlineActivationSupportsPassword) {
        this.offlineActivationSupportsPassword = offlineActivationSupportsPassword;
    }


    /**
     * Gets the offlineActivationRequiresPassword value for this TokenVendorInfo.
     * 
     * @return offlineActivationRequiresPassword   * A flag indicating if the offline activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor requires that the activation
     * password be specified.
     */
    public boolean isOfflineActivationRequiresPassword() {
        return offlineActivationRequiresPassword;
    }


    /**
     * Sets the offlineActivationRequiresPassword value for this TokenVendorInfo.
     * 
     * @param offlineActivationRequiresPassword   * A flag indicating if the offline activation
     *                                 operation performed on tokens from
     * this
     *                                 token vendor requires that the activation
     * password be specified.
     */
    public void setOfflineActivationRequiresPassword(boolean offlineActivationRequiresPassword) {
        this.offlineActivationRequiresPassword = offlineActivationRequiresPassword;
    }


    /**
     * Gets the createSupported value for this TokenVendorInfo.
     * 
     * @return createSupported   * A flag indicating if this token vendor supports
     *                                 creation of tokens using the userTokenCreate
     * operations.
     */
    public boolean isCreateSupported() {
        return createSupported;
    }


    /**
     * Sets the createSupported value for this TokenVendorInfo.
     * 
     * @param createSupported   * A flag indicating if this token vendor supports
     *                                 creation of tokens using the userTokenCreate
     * operations.
     */
    public void setCreateSupported(boolean createSupported) {
        this.createSupported = createSupported;
    }


    /**
     * Gets the loadSupported value for this TokenVendorInfo.
     * 
     * @return loadSupported   * A flag indicating if this token vendor supports
     *                                 loading of tokens using the tokenLoad
     * operation.
     *                                 If a vendor does not support loading
     * tokens, the
     *                                 Binary, requiresKey and
     *                                 serialNumberGeneratedByServer fields
     * in this
     *                                 structure are meaningless.
     */
    public boolean isLoadSupported() {
        return loadSupported;
    }


    /**
     * Sets the loadSupported value for this TokenVendorInfo.
     * 
     * @param loadSupported   * A flag indicating if this token vendor supports
     *                                 loading of tokens using the tokenLoad
     * operation.
     *                                 If a vendor does not support loading
     * tokens, the
     *                                 Binary, requiresKey and
     *                                 serialNumberGeneratedByServer fields
     * in this
     *                                 structure are meaningless.
     */
    public void setLoadSupported(boolean loadSupported) {
        this.loadSupported = loadSupported;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TokenVendorInfo)) return false;
        TokenVendorInfo other = (TokenVendorInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.vendorId==null && other.getVendorId()==null) || 
             (this.vendorId!=null &&
              this.vendorId.equals(other.getVendorId()))) &&
            ((this.vendorName==null && other.getVendorName()==null) || 
             (this.vendorName!=null &&
              this.vendorName.equals(other.getVendorName()))) &&
            this.defaultVendor == other.isDefaultVendor() &&
            this.binary == other.isBinary() &&
            this.minResetResponses == other.getMinResetResponses() &&
            this.maxResetResponses == other.getMaxResetResponses() &&
            this.requiresKey == other.isRequiresKey() &&
            this.onlineActivationSupported == other.isOnlineActivationSupported() &&
            this.onlineActivationSupportsPassword == other.isOnlineActivationSupportsPassword() &&
            this.onlineActivationRequiresPassword == other.isOnlineActivationRequiresPassword() &&
            this.offlineActivationSupported == other.isOfflineActivationSupported() &&
            this.offlineActivationSupportsPassword == other.isOfflineActivationSupportsPassword() &&
            this.offlineActivationRequiresPassword == other.isOfflineActivationRequiresPassword() &&
            this.createSupported == other.isCreateSupported() &&
            this.loadSupported == other.isLoadSupported();
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getVendorId() != null) {
            _hashCode += getVendorId().hashCode();
        }
        if (getVendorName() != null) {
            _hashCode += getVendorName().hashCode();
        }
        _hashCode += (isDefaultVendor() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isBinary() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += getMinResetResponses();
        _hashCode += getMaxResetResponses();
        _hashCode += (isRequiresKey() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isOnlineActivationSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isOnlineActivationSupportsPassword() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isOnlineActivationRequiresPassword() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isOfflineActivationSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isOfflineActivationSupportsPassword() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isOfflineActivationRequiresPassword() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isCreateSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isLoadSupported() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TokenVendorInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TokenVendorInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "VendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "VendorName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultVendor");
        elemField.setXmlName(new javax.xml.namespace.QName("", "DefaultVendor"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("binary");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Binary"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("minResetResponses");
        elemField.setXmlName(new javax.xml.namespace.QName("", "minResetResponses"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxResetResponses");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxResetResponses"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("requiresKey");
        elemField.setXmlName(new javax.xml.namespace.QName("", "requiresKey"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("onlineActivationSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "onlineActivationSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("onlineActivationSupportsPassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "onlineActivationSupportsPassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("onlineActivationRequiresPassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "onlineActivationRequiresPassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("offlineActivationSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "offlineActivationSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("offlineActivationSupportsPassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "offlineActivationSupportsPassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("offlineActivationRequiresPassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "offlineActivationRequiresPassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "createSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("loadSupported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "loadSupported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
