/**
 * TransactionCertificateImportVerifyResult.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned from a 
 *                         transactionCertificateImportVerify operation.
 */
public class TransactionCertificateImportVerifyResult  implements java.io.Serializable {
    /* The type of data that was specified as an
     *                                 argument to the
     *                                 transactionCertificateImportVerify
     * operation.
     *                                 The value will be one of CERT or P7. */
    private TransactionCertificateDataType type;

    /* The issuer DN of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain. */
    private String issuerDN;

    /* The subject DN of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain. */
    private String subjectDN;

    /* The serial number of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain. */
    private String serialNumber;

    /* The expiry date of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain. */
    private java.util.Calendar expiryDate;

    /* The MD5 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain. */
    private String MD5Hash;

    /* The SHA1 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain. */
    private String SHA1Hash;

    /* The SHA256 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain. */
    private String SHA256Hash;

    public TransactionCertificateImportVerifyResult() {
    }

    public TransactionCertificateImportVerifyResult(
           TransactionCertificateDataType type,
           String issuerDN,
           String subjectDN,
           String serialNumber,
           java.util.Calendar expiryDate,
           String MD5Hash,
           String SHA1Hash,
           String SHA256Hash) {
           this.type = type;
           this.issuerDN = issuerDN;
           this.subjectDN = subjectDN;
           this.serialNumber = serialNumber;
           this.expiryDate = expiryDate;
           this.MD5Hash = MD5Hash;
           this.SHA1Hash = SHA1Hash;
           this.SHA256Hash = SHA256Hash;
    }


    /**
     * Gets the type value for this TransactionCertificateImportVerifyResult.
     * 
     * @return type   * The type of data that was specified as an
     *                                 argument to the
     *                                 transactionCertificateImportVerify
     * operation.
     *                                 The value will be one of CERT or P7.
     */
    public TransactionCertificateDataType getType() {
        return type;
    }


    /**
     * Sets the type value for this TransactionCertificateImportVerifyResult.
     * 
     * @param type   * The type of data that was specified as an
     *                                 argument to the
     *                                 transactionCertificateImportVerify
     * operation.
     *                                 The value will be one of CERT or P7.
     */
    public void setType(TransactionCertificateDataType type) {
        this.type = type;
    }


    /**
     * Gets the issuerDN value for this TransactionCertificateImportVerifyResult.
     * 
     * @return issuerDN   * The issuer DN of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public String getIssuerDN() {
        return issuerDN;
    }


    /**
     * Sets the issuerDN value for this TransactionCertificateImportVerifyResult.
     * 
     * @param issuerDN   * The issuer DN of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public void setIssuerDN(String issuerDN) {
        this.issuerDN = issuerDN;
    }


    /**
     * Gets the subjectDN value for this TransactionCertificateImportVerifyResult.
     * 
     * @return subjectDN   * The subject DN of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public String getSubjectDN() {
        return subjectDN;
    }


    /**
     * Sets the subjectDN value for this TransactionCertificateImportVerifyResult.
     * 
     * @param subjectDN   * The subject DN of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public void setSubjectDN(String subjectDN) {
        this.subjectDN = subjectDN;
    }


    /**
     * Gets the serialNumber value for this TransactionCertificateImportVerifyResult.
     * 
     * @return serialNumber   * The serial number of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this TransactionCertificateImportVerifyResult.
     * 
     * @param serialNumber   * The serial number of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the expiryDate value for this TransactionCertificateImportVerifyResult.
     * 
     * @return expiryDate   * The expiry date of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this TransactionCertificateImportVerifyResult.
     * 
     * @param expiryDate   * The expiry date of the certificate in the
     *                                 imported data.  For PKCS#7 data, the
     * certificate information is returned for
     *                                 the child certificate in the certificate
     * chain.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the MD5Hash value for this TransactionCertificateImportVerifyResult.
     * 
     * @return MD5Hash   * The MD5 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain.
     */
    public String getMD5Hash() {
        return MD5Hash;
    }


    /**
     * Sets the MD5Hash value for this TransactionCertificateImportVerifyResult.
     * 
     * @param MD5Hash   * The MD5 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain.
     */
    public void setMD5Hash(String MD5Hash) {
        this.MD5Hash = MD5Hash;
    }


    /**
     * Gets the SHA1Hash value for this TransactionCertificateImportVerifyResult.
     * 
     * @return SHA1Hash   * The SHA1 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain.
     */
    public String getSHA1Hash() {
        return SHA1Hash;
    }


    /**
     * Sets the SHA1Hash value for this TransactionCertificateImportVerifyResult.
     * 
     * @param SHA1Hash   * The SHA1 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain.
     */
    public void setSHA1Hash(String SHA1Hash) {
        this.SHA1Hash = SHA1Hash;
    }


    /**
     * Gets the SHA256Hash value for this TransactionCertificateImportVerifyResult.
     * 
     * @return SHA256Hash   * The SHA256 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain.
     */
    public String getSHA256Hash() {
        return SHA256Hash;
    }


    /**
     * Sets the SHA256Hash value for this TransactionCertificateImportVerifyResult.
     * 
     * @param SHA256Hash   * The SHA256 hash of the imported data.  The
     *                                 hash will be encoded as a string using
     * HEX encoding.  For a certificate the hash is
     *                                 calculated on the entire data.  For
     * PKCS#7
     *                                 data, the hash is calculated in the
     * root
     *                                 certificate in the certificate chain.
     */
    public void setSHA256Hash(String SHA256Hash) {
        this.SHA256Hash = SHA256Hash;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TransactionCertificateImportVerifyResult)) return false;
        TransactionCertificateImportVerifyResult other = (TransactionCertificateImportVerifyResult) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.issuerDN==null && other.getIssuerDN()==null) || 
             (this.issuerDN!=null &&
              this.issuerDN.equals(other.getIssuerDN()))) &&
            ((this.subjectDN==null && other.getSubjectDN()==null) || 
             (this.subjectDN!=null &&
              this.subjectDN.equals(other.getSubjectDN()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            ((this.MD5Hash==null && other.getMD5Hash()==null) || 
             (this.MD5Hash!=null &&
              this.MD5Hash.equals(other.getMD5Hash()))) &&
            ((this.SHA1Hash==null && other.getSHA1Hash()==null) || 
             (this.SHA1Hash!=null &&
              this.SHA1Hash.equals(other.getSHA1Hash()))) &&
            ((this.SHA256Hash==null && other.getSHA256Hash()==null) || 
             (this.SHA256Hash!=null &&
              this.SHA256Hash.equals(other.getSHA256Hash())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getIssuerDN() != null) {
            _hashCode += getIssuerDN().hashCode();
        }
        if (getSubjectDN() != null) {
            _hashCode += getSubjectDN().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        if (getMD5Hash() != null) {
            _hashCode += getMD5Hash().hashCode();
        }
        if (getSHA1Hash() != null) {
            _hashCode += getSHA1Hash().hashCode();
        }
        if (getSHA256Hash() != null) {
            _hashCode += getSHA256Hash().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TransactionCertificateImportVerifyResult.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TransactionCertificateImportVerifyResult"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TransactionCertificateDataType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("issuerDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "IssuerDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("subjectDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SubjectDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("MD5Hash");
        elemField.setXmlName(new javax.xml.namespace.QName("", "MD5Hash"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("SHA1Hash");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SHA1Hash"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("SHA256Hash");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SHA256Hash"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
