/**
 * TransactionCertificateInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned about a transaction
 *                         certificate
 */
public class TransactionCertificateInfo  implements java.io.Serializable {
    /* The name of the transaction certificate. */
    private String name;

    /* The state of the transaction certificate. */
    private com.good.adapters.entrust.stubs.TransactionCertificateState state;

    /* The subject DN of the transaction certificate. */
    private String subjectDN;

    /* The issuer DN of the transaction certificate.
     *                                 This value is not defined for transaction
     * certificates in the PENDING state. */
    private String issuerDN;

    /* The serial number of the transaction
     *                                 certificate.  This value is not defined
     * for
     *                                 transaction certificates in the PENDING
     * state. */
    private String serialNumber;

    /* The expiry date of the transaction certificate.
     *                                 This value is not defined for transaction
     * certificates in the PENDING state. */
    private java.util.Calendar expiryDate;

    /* The hashing algorithm used when this
     *                                 transaction certificate is used to
     * sign
     *                                 a transaction receipt.  Currently
     * the only
     *                                 supported value is SHA-1. */
    private String hashAlg;

    /* The key algorithm used to generate the
     *                                 key pair for this transaction certificate.
     * Possible values are RSA-1024 and RSA-2048. */
    private String keyAlg;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public TransactionCertificateInfo() {
    }

    public TransactionCertificateInfo(
           String name,
           com.good.adapters.entrust.stubs.TransactionCertificateState state,
           String subjectDN,
           String issuerDN,
           String serialNumber,
           java.util.Calendar expiryDate,
           String hashAlg,
           String keyAlg,
           String[] rolesGrantingAccess) {
           this.name = name;
           this.state = state;
           this.subjectDN = subjectDN;
           this.issuerDN = issuerDN;
           this.serialNumber = serialNumber;
           this.expiryDate = expiryDate;
           this.hashAlg = hashAlg;
           this.keyAlg = keyAlg;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the name value for this TransactionCertificateInfo.
     * 
     * @return name   * The name of the transaction certificate.
     */
    public String getName() {
        return name;
    }


    /**
     * Sets the name value for this TransactionCertificateInfo.
     * 
     * @param name   * The name of the transaction certificate.
     */
    public void setName(String name) {
        this.name = name;
    }


    /**
     * Gets the state value for this TransactionCertificateInfo.
     * 
     * @return state   * The state of the transaction certificate.
     */
    public com.good.adapters.entrust.stubs.TransactionCertificateState getState() {
        return state;
    }


    /**
     * Sets the state value for this TransactionCertificateInfo.
     * 
     * @param state   * The state of the transaction certificate.
     */
    public void setState(com.good.adapters.entrust.stubs.TransactionCertificateState state) {
        this.state = state;
    }


    /**
     * Gets the subjectDN value for this TransactionCertificateInfo.
     * 
     * @return subjectDN   * The subject DN of the transaction certificate.
     */
    public String getSubjectDN() {
        return subjectDN;
    }


    /**
     * Sets the subjectDN value for this TransactionCertificateInfo.
     * 
     * @param subjectDN   * The subject DN of the transaction certificate.
     */
    public void setSubjectDN(String subjectDN) {
        this.subjectDN = subjectDN;
    }


    /**
     * Gets the issuerDN value for this TransactionCertificateInfo.
     * 
     * @return issuerDN   * The issuer DN of the transaction certificate.
     *                                 This value is not defined for transaction
     * certificates in the PENDING state.
     */
    public String getIssuerDN() {
        return issuerDN;
    }


    /**
     * Sets the issuerDN value for this TransactionCertificateInfo.
     * 
     * @param issuerDN   * The issuer DN of the transaction certificate.
     *                                 This value is not defined for transaction
     * certificates in the PENDING state.
     */
    public void setIssuerDN(String issuerDN) {
        this.issuerDN = issuerDN;
    }


    /**
     * Gets the serialNumber value for this TransactionCertificateInfo.
     * 
     * @return serialNumber   * The serial number of the transaction
     *                                 certificate.  This value is not defined
     * for
     *                                 transaction certificates in the PENDING
     * state.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this TransactionCertificateInfo.
     * 
     * @param serialNumber   * The serial number of the transaction
     *                                 certificate.  This value is not defined
     * for
     *                                 transaction certificates in the PENDING
     * state.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the expiryDate value for this TransactionCertificateInfo.
     * 
     * @return expiryDate   * The expiry date of the transaction certificate.
     *                                 This value is not defined for transaction
     * certificates in the PENDING state.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this TransactionCertificateInfo.
     * 
     * @param expiryDate   * The expiry date of the transaction certificate.
     *                                 This value is not defined for transaction
     * certificates in the PENDING state.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the hashAlg value for this TransactionCertificateInfo.
     * 
     * @return hashAlg   * The hashing algorithm used when this
     *                                 transaction certificate is used to
     * sign
     *                                 a transaction receipt.  Currently
     * the only
     *                                 supported value is SHA-1.
     */
    public String getHashAlg() {
        return hashAlg;
    }


    /**
     * Sets the hashAlg value for this TransactionCertificateInfo.
     * 
     * @param hashAlg   * The hashing algorithm used when this
     *                                 transaction certificate is used to
     * sign
     *                                 a transaction receipt.  Currently
     * the only
     *                                 supported value is SHA-1.
     */
    public void setHashAlg(String hashAlg) {
        this.hashAlg = hashAlg;
    }


    /**
     * Gets the keyAlg value for this TransactionCertificateInfo.
     * 
     * @return keyAlg   * The key algorithm used to generate the
     *                                 key pair for this transaction certificate.
     * Possible values are RSA-1024 and RSA-2048.
     */
    public String getKeyAlg() {
        return keyAlg;
    }


    /**
     * Sets the keyAlg value for this TransactionCertificateInfo.
     * 
     * @param keyAlg   * The key algorithm used to generate the
     *                                 key pair for this transaction certificate.
     * Possible values are RSA-1024 and RSA-2048.
     */
    public void setKeyAlg(String keyAlg) {
        this.keyAlg = keyAlg;
    }


    /**
     * Gets the rolesGrantingAccess value for this TransactionCertificateInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this TransactionCertificateInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof TransactionCertificateInfo)) return false;
        TransactionCertificateInfo other = (TransactionCertificateInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.name==null && other.getName()==null) || 
             (this.name!=null &&
              this.name.equals(other.getName()))) &&
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              this.state.equals(other.getState()))) &&
            ((this.subjectDN==null && other.getSubjectDN()==null) || 
             (this.subjectDN!=null &&
              this.subjectDN.equals(other.getSubjectDN()))) &&
            ((this.issuerDN==null && other.getIssuerDN()==null) || 
             (this.issuerDN!=null &&
              this.issuerDN.equals(other.getIssuerDN()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            ((this.hashAlg==null && other.getHashAlg()==null) || 
             (this.hashAlg!=null &&
              this.hashAlg.equals(other.getHashAlg()))) &&
            ((this.keyAlg==null && other.getKeyAlg()==null) || 
             (this.keyAlg!=null &&
              this.keyAlg.equals(other.getKeyAlg()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getName() != null) {
            _hashCode += getName().hashCode();
        }
        if (getState() != null) {
            _hashCode += getState().hashCode();
        }
        if (getSubjectDN() != null) {
            _hashCode += getSubjectDN().hashCode();
        }
        if (getIssuerDN() != null) {
            _hashCode += getIssuerDN().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        if (getHashAlg() != null) {
            _hashCode += getHashAlg().hashCode();
        }
        if (getKeyAlg() != null) {
            _hashCode += getKeyAlg().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TransactionCertificateInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TransactionCertificateInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("name");
        elemField.setXmlName(new javax.xml.namespace.QName("", "name"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "state"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TransactionCertificateState"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("subjectDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "subjectDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("issuerDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "issuerDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("hashAlg");
        elemField.setXmlName(new javax.xml.namespace.QName("", "hashAlg"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("keyAlg");
        elemField.setXmlName(new javax.xml.namespace.QName("", "keyAlg"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
