/**
 * UserCardInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned about a user card.
 */
public class UserCardInfo  implements java.io.Serializable {
    /* The user ID that owns the card. */
    private String userid;

    /* The user name of the user ID that owns the card. */
    private String userName;

    /* The group of the user ID that owns the card. */
    private String group;

    /* The serial number of the card. */
    private String serialNumber;

    /* The state of the card. */
    private State state;

    /* The create date of the card. */
    private java.util.Calendar createDate;

    /* The expiry date of the card. A value of Date(0)
     *                                 indicates the card doesn't have an
     * expiry date. */
    private java.util.Calendar expireDate;

    /* The supersede date of the card. This is the date
     *                                 beyond which the card cannot be used
     * to
     *                                 authenticate because a newer card
     * exists.
     *                                 A value of null indicates that the
     * card has not
     *                                 been superseded. A value of Date(0)
     * indicates
     *                                 a superseded card that can be used
     * until the
     *                                 expiry date is reached. */
    private java.util.Calendar supersededDate;

    /* The contents of the card. The value will be null
     *                                 if the operation used to retrieve
     * the card did
     *                                 not request the grid, or if the caller
     * does not
     *                                 have permission to view the grid. */
    private Grid grid;

    /* The number of times this card has been used in successful
     *                                 authentication. This value will be
     * null if usage
     *                                 statistics are not gathered. */
    private Integer challengeCount;

    /* The number of times the least used cell on the card has
     *                                 been used in a successfully authenticated
     * challenge.
     *                                 This value will be null if usage statistics
     * are not
     *                                 gathered. */
    private Integer leastUsedCellUsageCount;

    /* An indicator that either the challenge count or
     *                                 the least-used cell usage count has
     * reached its 
     *                                 replacement or warning usage threshold
     * as
     *                                 defined in policy.
     *                                 This value will be null if usage statistics
     * are
     *                                 not gathered. */
    private com.good.adapters.entrust.stubs.CardUsageThresholdIndicator cardUsageThresholdIndicator;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    /* The comment for the card. */
    private String comment;

    /* An indicator for whether this card was created as a
     *                                 preproduced card. */
    private Boolean preproduced;

    public UserCardInfo() {
    }

    public UserCardInfo(
           String userid,
           String userName,
           String group,
           String serialNumber,
           State state,
           java.util.Calendar createDate,
           java.util.Calendar expireDate,
           java.util.Calendar supersededDate,
           Grid grid,
           Integer challengeCount,
           Integer leastUsedCellUsageCount,
           com.good.adapters.entrust.stubs.CardUsageThresholdIndicator cardUsageThresholdIndicator,
           String[] rolesGrantingAccess,
           String comment,
           Boolean preproduced) {
           this.userid = userid;
           this.userName = userName;
           this.group = group;
           this.serialNumber = serialNumber;
           this.state = state;
           this.createDate = createDate;
           this.expireDate = expireDate;
           this.supersededDate = supersededDate;
           this.grid = grid;
           this.challengeCount = challengeCount;
           this.leastUsedCellUsageCount = leastUsedCellUsageCount;
           this.cardUsageThresholdIndicator = cardUsageThresholdIndicator;
           this.rolesGrantingAccess = rolesGrantingAccess;
           this.comment = comment;
           this.preproduced = preproduced;
    }


    /**
     * Gets the userid value for this UserCardInfo.
     * 
     * @return userid   * The user ID that owns the card.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserCardInfo.
     * 
     * @param userid   * The user ID that owns the card.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the userName value for this UserCardInfo.
     * 
     * @return userName   * The user name of the user ID that owns the card.
     */
    public String getUserName() {
        return userName;
    }


    /**
     * Sets the userName value for this UserCardInfo.
     * 
     * @param userName   * The user name of the user ID that owns the card.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }


    /**
     * Gets the group value for this UserCardInfo.
     * 
     * @return group   * The group of the user ID that owns the card.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this UserCardInfo.
     * 
     * @param group   * The group of the user ID that owns the card.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the serialNumber value for this UserCardInfo.
     * 
     * @return serialNumber   * The serial number of the card.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this UserCardInfo.
     * 
     * @param serialNumber   * The serial number of the card.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the state value for this UserCardInfo.
     * 
     * @return state   * The state of the card.
     */
    public State getState() {
        return state;
    }


    /**
     * Sets the state value for this UserCardInfo.
     * 
     * @param state   * The state of the card.
     */
    public void setState(State state) {
        this.state = state;
    }


    /**
     * Gets the createDate value for this UserCardInfo.
     * 
     * @return createDate   * The create date of the card.
     */
    public java.util.Calendar getCreateDate() {
        return createDate;
    }


    /**
     * Sets the createDate value for this UserCardInfo.
     * 
     * @param createDate   * The create date of the card.
     */
    public void setCreateDate(java.util.Calendar createDate) {
        this.createDate = createDate;
    }


    /**
     * Gets the expireDate value for this UserCardInfo.
     * 
     * @return expireDate   * The expiry date of the card. A value of Date(0)
     *                                 indicates the card doesn't have an
     * expiry date.
     */
    public java.util.Calendar getExpireDate() {
        return expireDate;
    }


    /**
     * Sets the expireDate value for this UserCardInfo.
     * 
     * @param expireDate   * The expiry date of the card. A value of Date(0)
     *                                 indicates the card doesn't have an
     * expiry date.
     */
    public void setExpireDate(java.util.Calendar expireDate) {
        this.expireDate = expireDate;
    }


    /**
     * Gets the supersededDate value for this UserCardInfo.
     * 
     * @return supersededDate   * The supersede date of the card. This is the date
     *                                 beyond which the card cannot be used
     * to
     *                                 authenticate because a newer card
     * exists.
     *                                 A value of null indicates that the
     * card has not
     *                                 been superseded. A value of Date(0)
     * indicates
     *                                 a superseded card that can be used
     * until the
     *                                 expiry date is reached.
     */
    public java.util.Calendar getSupersededDate() {
        return supersededDate;
    }


    /**
     * Sets the supersededDate value for this UserCardInfo.
     * 
     * @param supersededDate   * The supersede date of the card. This is the date
     *                                 beyond which the card cannot be used
     * to
     *                                 authenticate because a newer card
     * exists.
     *                                 A value of null indicates that the
     * card has not
     *                                 been superseded. A value of Date(0)
     * indicates
     *                                 a superseded card that can be used
     * until the
     *                                 expiry date is reached.
     */
    public void setSupersededDate(java.util.Calendar supersededDate) {
        this.supersededDate = supersededDate;
    }


    /**
     * Gets the grid value for this UserCardInfo.
     * 
     * @return grid   * The contents of the card. The value will be null
     *                                 if the operation used to retrieve
     * the card did
     *                                 not request the grid, or if the caller
     * does not
     *                                 have permission to view the grid.
     */
    public Grid getGrid() {
        return grid;
    }


    /**
     * Sets the grid value for this UserCardInfo.
     * 
     * @param grid   * The contents of the card. The value will be null
     *                                 if the operation used to retrieve
     * the card did
     *                                 not request the grid, or if the caller
     * does not
     *                                 have permission to view the grid.
     */
    public void setGrid(Grid grid) {
        this.grid = grid;
    }


    /**
     * Gets the challengeCount value for this UserCardInfo.
     * 
     * @return challengeCount   * The number of times this card has been used in successful
     *                                 authentication. This value will be
     * null if usage
     *                                 statistics are not gathered.
     */
    public Integer getChallengeCount() {
        return challengeCount;
    }


    /**
     * Sets the challengeCount value for this UserCardInfo.
     * 
     * @param challengeCount   * The number of times this card has been used in successful
     *                                 authentication. This value will be
     * null if usage
     *                                 statistics are not gathered.
     */
    public void setChallengeCount(Integer challengeCount) {
        this.challengeCount = challengeCount;
    }


    /**
     * Gets the leastUsedCellUsageCount value for this UserCardInfo.
     * 
     * @return leastUsedCellUsageCount   * The number of times the least used cell on the card has
     *                                 been used in a successfully authenticated
     * challenge.
     *                                 This value will be null if usage statistics
     * are not
     *                                 gathered.
     */
    public Integer getLeastUsedCellUsageCount() {
        return leastUsedCellUsageCount;
    }


    /**
     * Sets the leastUsedCellUsageCount value for this UserCardInfo.
     * 
     * @param leastUsedCellUsageCount   * The number of times the least used cell on the card has
     *                                 been used in a successfully authenticated
     * challenge.
     *                                 This value will be null if usage statistics
     * are not
     *                                 gathered.
     */
    public void setLeastUsedCellUsageCount(Integer leastUsedCellUsageCount) {
        this.leastUsedCellUsageCount = leastUsedCellUsageCount;
    }


    /**
     * Gets the cardUsageThresholdIndicator value for this UserCardInfo.
     * 
     * @return cardUsageThresholdIndicator   * An indicator that either the challenge count or
     *                                 the least-used cell usage count has
     * reached its 
     *                                 replacement or warning usage threshold
     * as
     *                                 defined in policy.
     *                                 This value will be null if usage statistics
     * are
     *                                 not gathered.
     */
    public com.good.adapters.entrust.stubs.CardUsageThresholdIndicator getCardUsageThresholdIndicator() {
        return cardUsageThresholdIndicator;
    }


    /**
     * Sets the cardUsageThresholdIndicator value for this UserCardInfo.
     * 
     * @param cardUsageThresholdIndicator   * An indicator that either the challenge count or
     *                                 the least-used cell usage count has
     * reached its 
     *                                 replacement or warning usage threshold
     * as
     *                                 defined in policy.
     *                                 This value will be null if usage statistics
     * are
     *                                 not gathered.
     */
    public void setCardUsageThresholdIndicator(com.good.adapters.entrust.stubs.CardUsageThresholdIndicator cardUsageThresholdIndicator) {
        this.cardUsageThresholdIndicator = cardUsageThresholdIndicator;
    }


    /**
     * Gets the rolesGrantingAccess value for this UserCardInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this UserCardInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the comment value for this UserCardInfo.
     * 
     * @return comment   * The comment for the card.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this UserCardInfo.
     * 
     * @param comment   * The comment for the card.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }


    /**
     * Gets the preproduced value for this UserCardInfo.
     * 
     * @return preproduced   * An indicator for whether this card was created as a
     *                                 preproduced card.
     */
    public Boolean getPreproduced() {
        return preproduced;
    }


    /**
     * Sets the preproduced value for this UserCardInfo.
     * 
     * @param preproduced   * An indicator for whether this card was created as a
     *                                 preproduced card.
     */
    public void setPreproduced(Boolean preproduced) {
        this.preproduced = preproduced;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserCardInfo)) return false;
        UserCardInfo other = (UserCardInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.userName==null && other.getUserName()==null) || 
             (this.userName!=null &&
              this.userName.equals(other.getUserName()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              this.state.equals(other.getState()))) &&
            ((this.createDate==null && other.getCreateDate()==null) || 
             (this.createDate!=null &&
              this.createDate.equals(other.getCreateDate()))) &&
            ((this.expireDate==null && other.getExpireDate()==null) || 
             (this.expireDate!=null &&
              this.expireDate.equals(other.getExpireDate()))) &&
            ((this.supersededDate==null && other.getSupersededDate()==null) || 
             (this.supersededDate!=null &&
              this.supersededDate.equals(other.getSupersededDate()))) &&
            ((this.grid==null && other.getGrid()==null) || 
             (this.grid!=null &&
              this.grid.equals(other.getGrid()))) &&
            ((this.challengeCount==null && other.getChallengeCount()==null) || 
             (this.challengeCount!=null &&
              this.challengeCount.equals(other.getChallengeCount()))) &&
            ((this.leastUsedCellUsageCount==null && other.getLeastUsedCellUsageCount()==null) || 
             (this.leastUsedCellUsageCount!=null &&
              this.leastUsedCellUsageCount.equals(other.getLeastUsedCellUsageCount()))) &&
            ((this.cardUsageThresholdIndicator==null && other.getCardUsageThresholdIndicator()==null) || 
             (this.cardUsageThresholdIndicator!=null &&
              this.cardUsageThresholdIndicator.equals(other.getCardUsageThresholdIndicator()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment()))) &&
            ((this.preproduced==null && other.getPreproduced()==null) || 
             (this.preproduced!=null &&
              this.preproduced.equals(other.getPreproduced())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getUserName() != null) {
            _hashCode += getUserName().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getState() != null) {
            _hashCode += getState().hashCode();
        }
        if (getCreateDate() != null) {
            _hashCode += getCreateDate().hashCode();
        }
        if (getExpireDate() != null) {
            _hashCode += getExpireDate().hashCode();
        }
        if (getSupersededDate() != null) {
            _hashCode += getSupersededDate().hashCode();
        }
        if (getGrid() != null) {
            _hashCode += getGrid().hashCode();
        }
        if (getChallengeCount() != null) {
            _hashCode += getChallengeCount().hashCode();
        }
        if (getLeastUsedCellUsageCount() != null) {
            _hashCode += getLeastUsedCellUsageCount().hashCode();
        }
        if (getCardUsageThresholdIndicator() != null) {
            _hashCode += getCardUsageThresholdIndicator().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        if (getPreproduced() != null) {
            _hashCode += getPreproduced().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserCardInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserCardInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "State"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "State"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreateDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expireDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ExpireDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("supersededDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SupersededDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("grid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Grid"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "Grid"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("challengeCount");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ChallengeCount"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("leastUsedCellUsageCount");
        elemField.setXmlName(new javax.xml.namespace.QName("", "LeastUsedCellUsageCount"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("cardUsageThresholdIndicator");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CardUsageThresholdIndicator"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "CardUsageThresholdIndicator"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("preproduced");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Preproduced"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
