/**
 * UserCertificateAssignVerifyResult.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure defines the values returned by a call
 *                         to userCertificateAssignVerify.
 */
public class UserCertificateAssignVerifyResult  implements java.io.Serializable {
    /* The type of data being assigned.  Will be
     *                                 one of CERTIFICATE or P7. */
    private CertificateDataType type;

    /* The issuer DN of the certificate being assigned. */
    private String issuerDN;

    /* The subject DN of the certificate being
     *                                 assigned. */
    private String subjectDN;

    /* The serial number of the certificate being
     *                                 assigned. */
    private String serialNumber;

    /* The issue date of the certificate being
     *                                 assigned. */
    private java.util.Calendar issueDate;

    /* The expiry date of the certificate being
     *                                 assigned. */
    private java.util.Calendar expiryDate;

    /* The name of the registered CA that issued
     *                                 this certificate.  This value will
     * not be
     *                                 set if the user certificate is not
     * issued
     *                                 by a CA registered with Entrust IdentityGuard
     * or the user certificate is self-signed. */
    private String CA;

    /* A flag indicating if the user certificate
     *                                 is self-signed. */
    private boolean selfSigned;

    /* The MD5 Hash of the certificate or PKCS#7
     *                                 input data being assigned. */
    private String MD5Hash;

    /* The SHA-1 Hash of the certificate or PKCS#7
     *                                 input data being assigned. */
    private String SHA1Hash;

    /* The SHA-256 Hash of the certificate or PKCS#7
     *                                 input data being assigned. */
    private String SHA256Hash;

    public UserCertificateAssignVerifyResult() {
    }

    public UserCertificateAssignVerifyResult(
           CertificateDataType type,
           String issuerDN,
           String subjectDN,
           String serialNumber,
           java.util.Calendar issueDate,
           java.util.Calendar expiryDate,
           String CA,
           boolean selfSigned,
           String MD5Hash,
           String SHA1Hash,
           String SHA256Hash) {
           this.type = type;
           this.issuerDN = issuerDN;
           this.subjectDN = subjectDN;
           this.serialNumber = serialNumber;
           this.issueDate = issueDate;
           this.expiryDate = expiryDate;
           this.CA = CA;
           this.selfSigned = selfSigned;
           this.MD5Hash = MD5Hash;
           this.SHA1Hash = SHA1Hash;
           this.SHA256Hash = SHA256Hash;
    }


    /**
     * Gets the type value for this UserCertificateAssignVerifyResult.
     * 
     * @return type   * The type of data being assigned.  Will be
     *                                 one of CERTIFICATE or P7.
     */
    public CertificateDataType getType() {
        return type;
    }


    /**
     * Sets the type value for this UserCertificateAssignVerifyResult.
     * 
     * @param type   * The type of data being assigned.  Will be
     *                                 one of CERTIFICATE or P7.
     */
    public void setType(CertificateDataType type) {
        this.type = type;
    }


    /**
     * Gets the issuerDN value for this UserCertificateAssignVerifyResult.
     * 
     * @return issuerDN   * The issuer DN of the certificate being assigned.
     */
    public String getIssuerDN() {
        return issuerDN;
    }


    /**
     * Sets the issuerDN value for this UserCertificateAssignVerifyResult.
     * 
     * @param issuerDN   * The issuer DN of the certificate being assigned.
     */
    public void setIssuerDN(String issuerDN) {
        this.issuerDN = issuerDN;
    }


    /**
     * Gets the subjectDN value for this UserCertificateAssignVerifyResult.
     * 
     * @return subjectDN   * The subject DN of the certificate being
     *                                 assigned.
     */
    public String getSubjectDN() {
        return subjectDN;
    }


    /**
     * Sets the subjectDN value for this UserCertificateAssignVerifyResult.
     * 
     * @param subjectDN   * The subject DN of the certificate being
     *                                 assigned.
     */
    public void setSubjectDN(String subjectDN) {
        this.subjectDN = subjectDN;
    }


    /**
     * Gets the serialNumber value for this UserCertificateAssignVerifyResult.
     * 
     * @return serialNumber   * The serial number of the certificate being
     *                                 assigned.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this UserCertificateAssignVerifyResult.
     * 
     * @param serialNumber   * The serial number of the certificate being
     *                                 assigned.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the issueDate value for this UserCertificateAssignVerifyResult.
     * 
     * @return issueDate   * The issue date of the certificate being
     *                                 assigned.
     */
    public java.util.Calendar getIssueDate() {
        return issueDate;
    }


    /**
     * Sets the issueDate value for this UserCertificateAssignVerifyResult.
     * 
     * @param issueDate   * The issue date of the certificate being
     *                                 assigned.
     */
    public void setIssueDate(java.util.Calendar issueDate) {
        this.issueDate = issueDate;
    }


    /**
     * Gets the expiryDate value for this UserCertificateAssignVerifyResult.
     * 
     * @return expiryDate   * The expiry date of the certificate being
     *                                 assigned.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this UserCertificateAssignVerifyResult.
     * 
     * @param expiryDate   * The expiry date of the certificate being
     *                                 assigned.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the CA value for this UserCertificateAssignVerifyResult.
     * 
     * @return CA   * The name of the registered CA that issued
     *                                 this certificate.  This value will
     * not be
     *                                 set if the user certificate is not
     * issued
     *                                 by a CA registered with Entrust IdentityGuard
     * or the user certificate is self-signed.
     */
    public String getCA() {
        return CA;
    }


    /**
     * Sets the CA value for this UserCertificateAssignVerifyResult.
     * 
     * @param CA   * The name of the registered CA that issued
     *                                 this certificate.  This value will
     * not be
     *                                 set if the user certificate is not
     * issued
     *                                 by a CA registered with Entrust IdentityGuard
     * or the user certificate is self-signed.
     */
    public void setCA(String CA) {
        this.CA = CA;
    }


    /**
     * Gets the selfSigned value for this UserCertificateAssignVerifyResult.
     * 
     * @return selfSigned   * A flag indicating if the user certificate
     *                                 is self-signed.
     */
    public boolean isSelfSigned() {
        return selfSigned;
    }


    /**
     * Sets the selfSigned value for this UserCertificateAssignVerifyResult.
     * 
     * @param selfSigned   * A flag indicating if the user certificate
     *                                 is self-signed.
     */
    public void setSelfSigned(boolean selfSigned) {
        this.selfSigned = selfSigned;
    }


    /**
     * Gets the MD5Hash value for this UserCertificateAssignVerifyResult.
     * 
     * @return MD5Hash   * The MD5 Hash of the certificate or PKCS#7
     *                                 input data being assigned.
     */
    public String getMD5Hash() {
        return MD5Hash;
    }


    /**
     * Sets the MD5Hash value for this UserCertificateAssignVerifyResult.
     * 
     * @param MD5Hash   * The MD5 Hash of the certificate or PKCS#7
     *                                 input data being assigned.
     */
    public void setMD5Hash(String MD5Hash) {
        this.MD5Hash = MD5Hash;
    }


    /**
     * Gets the SHA1Hash value for this UserCertificateAssignVerifyResult.
     * 
     * @return SHA1Hash   * The SHA-1 Hash of the certificate or PKCS#7
     *                                 input data being assigned.
     */
    public String getSHA1Hash() {
        return SHA1Hash;
    }


    /**
     * Sets the SHA1Hash value for this UserCertificateAssignVerifyResult.
     * 
     * @param SHA1Hash   * The SHA-1 Hash of the certificate or PKCS#7
     *                                 input data being assigned.
     */
    public void setSHA1Hash(String SHA1Hash) {
        this.SHA1Hash = SHA1Hash;
    }


    /**
     * Gets the SHA256Hash value for this UserCertificateAssignVerifyResult.
     * 
     * @return SHA256Hash   * The SHA-256 Hash of the certificate or PKCS#7
     *                                 input data being assigned.
     */
    public String getSHA256Hash() {
        return SHA256Hash;
    }


    /**
     * Sets the SHA256Hash value for this UserCertificateAssignVerifyResult.
     * 
     * @param SHA256Hash   * The SHA-256 Hash of the certificate or PKCS#7
     *                                 input data being assigned.
     */
    public void setSHA256Hash(String SHA256Hash) {
        this.SHA256Hash = SHA256Hash;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserCertificateAssignVerifyResult)) return false;
        UserCertificateAssignVerifyResult other = (UserCertificateAssignVerifyResult) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.type==null && other.getType()==null) || 
             (this.type!=null &&
              this.type.equals(other.getType()))) &&
            ((this.issuerDN==null && other.getIssuerDN()==null) || 
             (this.issuerDN!=null &&
              this.issuerDN.equals(other.getIssuerDN()))) &&
            ((this.subjectDN==null && other.getSubjectDN()==null) || 
             (this.subjectDN!=null &&
              this.subjectDN.equals(other.getSubjectDN()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.issueDate==null && other.getIssueDate()==null) || 
             (this.issueDate!=null &&
              this.issueDate.equals(other.getIssueDate()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            ((this.CA==null && other.getCA()==null) || 
             (this.CA!=null &&
              this.CA.equals(other.getCA()))) &&
            this.selfSigned == other.isSelfSigned() &&
            ((this.MD5Hash==null && other.getMD5Hash()==null) || 
             (this.MD5Hash!=null &&
              this.MD5Hash.equals(other.getMD5Hash()))) &&
            ((this.SHA1Hash==null && other.getSHA1Hash()==null) || 
             (this.SHA1Hash!=null &&
              this.SHA1Hash.equals(other.getSHA1Hash()))) &&
            ((this.SHA256Hash==null && other.getSHA256Hash()==null) || 
             (this.SHA256Hash!=null &&
              this.SHA256Hash.equals(other.getSHA256Hash())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getType() != null) {
            _hashCode += getType().hashCode();
        }
        if (getIssuerDN() != null) {
            _hashCode += getIssuerDN().hashCode();
        }
        if (getSubjectDN() != null) {
            _hashCode += getSubjectDN().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getIssueDate() != null) {
            _hashCode += getIssueDate().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        if (getCA() != null) {
            _hashCode += getCA().hashCode();
        }
        _hashCode += (isSelfSigned() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getMD5Hash() != null) {
            _hashCode += getMD5Hash().hashCode();
        }
        if (getSHA1Hash() != null) {
            _hashCode += getSHA1Hash().hashCode();
        }
        if (getSHA256Hash() != null) {
            _hashCode += getSHA256Hash().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserCertificateAssignVerifyResult.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserCertificateAssignVerifyResult"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("type");
        elemField.setXmlName(new javax.xml.namespace.QName("", "type"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "CertificateDataType"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("issuerDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "issuerDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("subjectDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "subjectDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "serialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("issueDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "issueDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("CA");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CA"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("selfSigned");
        elemField.setXmlName(new javax.xml.namespace.QName("", "selfSigned"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("MD5Hash");
        elemField.setXmlName(new javax.xml.namespace.QName("", "MD5Hash"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("SHA1Hash");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SHA1Hash"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("SHA256Hash");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SHA256Hash"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
