/**
 * UserCertificateParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when assigning or
 *                         modifying a user certificate. All values can
 * be null
 *                         indicating that the default is used for assign
 * or the
 *                         value is not changed for modify.
 */
public class UserCertificateParms  implements java.io.Serializable {
    /* The state of the certificate. This value can
     *                                 be used to set the state of the certificate
     * when assigning or modifying a certificate.
     *                                 If not set during the assign operation,
     * it
     *                                 defaults to ACTIVE. */
    private CertificateState state;

    /* A Base-64 encoded X.509 certificate or
     *                                 P7.  This value must be specified
     * during an
     *                                 assign operation.  If specified during
     * a modify
     *                                 this value is ignored. */
    private String data;

    /* A comment for the certificate.  This value
     *                                 can be specified during either an
     * assign or
     *                                 modify operation. */
    private String comment;

    public UserCertificateParms() {
    }

    public UserCertificateParms(
           CertificateState state,
           String data,
           String comment) {
           this.state = state;
           this.data = data;
           this.comment = comment;
    }


    /**
     * Gets the state value for this UserCertificateParms.
     * 
     * @return state   * The state of the certificate. This value can
     *                                 be used to set the state of the certificate
     * when assigning or modifying a certificate.
     *                                 If not set during the assign operation,
     * it
     *                                 defaults to ACTIVE.
     */
    public CertificateState getState() {
        return state;
    }


    /**
     * Sets the state value for this UserCertificateParms.
     * 
     * @param state   * The state of the certificate. This value can
     *                                 be used to set the state of the certificate
     * when assigning or modifying a certificate.
     *                                 If not set during the assign operation,
     * it
     *                                 defaults to ACTIVE.
     */
    public void setState(CertificateState state) {
        this.state = state;
    }


    /**
     * Gets the data value for this UserCertificateParms.
     * 
     * @return data   * A Base-64 encoded X.509 certificate or
     *                                 P7.  This value must be specified
     * during an
     *                                 assign operation.  If specified during
     * a modify
     *                                 this value is ignored.
     */
    public String getData() {
        return data;
    }


    /**
     * Sets the data value for this UserCertificateParms.
     * 
     * @param data   * A Base-64 encoded X.509 certificate or
     *                                 P7.  This value must be specified
     * during an
     *                                 assign operation.  If specified during
     * a modify
     *                                 this value is ignored.
     */
    public void setData(String data) {
        this.data = data;
    }


    /**
     * Gets the comment value for this UserCertificateParms.
     * 
     * @return comment   * A comment for the certificate.  This value
     *                                 can be specified during either an
     * assign or
     *                                 modify operation.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this UserCertificateParms.
     * 
     * @param comment   * A comment for the certificate.  This value
     *                                 can be specified during either an
     * assign or
     *                                 modify operation.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserCertificateParms)) return false;
        UserCertificateParms other = (UserCertificateParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              this.state.equals(other.getState()))) &&
            ((this.data==null && other.getData()==null) || 
             (this.data!=null &&
              this.data.equals(other.getData()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getState() != null) {
            _hashCode += getState().hashCode();
        }
        if (getData() != null) {
            _hashCode += getData().hashCode();
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserCertificateParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserCertificateParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "State"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "CertificateState"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("data");
        elemField.setXmlName(new javax.xml.namespace.QName("", "data"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
