/**
 * UserContactInfoParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when creating or modifying
 *                         a user contactinfo instance. All values can
 * be null
 *                         indicating that the default is used for create
 * or the
 *                         value is not changed for modify.
 */
public class UserContactInfoParms  implements java.io.Serializable {
    /* The label of the contact info to be created or
     *                                 modified. */
    private String contactInfoLabel;

    /* The original label of the contact info, for
     *                                 when contact info are being updated
     * by a call
     *                                 to userSet.  This value is ignored
     * by other calls. */
    private String originalLabel;

    /* The value of the user contact info. */
    private String value;

    /* The label of the delivery configuration that is
     *                                 associated with this user contact
     * info. */
    private String deliveryConfigLabel;

    /* If true, it means this user contact info
     *                                 instance is default. The delivery
     * configuration
     *                                 associated with this contact info
     * is used for
     *                                 out-of-band data delivery when no
     * contact info
     *                                 is specified for delivery. Defaults
     * to false. */
    private Boolean defaultContactInfo;

    public UserContactInfoParms() {
    }

    public UserContactInfoParms(
           String contactInfoLabel,
           String originalLabel,
           String value,
           String deliveryConfigLabel,
           Boolean defaultContactInfo) {
           this.contactInfoLabel = contactInfoLabel;
           this.originalLabel = originalLabel;
           this.value = value;
           this.deliveryConfigLabel = deliveryConfigLabel;
           this.defaultContactInfo = defaultContactInfo;
    }


    /**
     * Gets the contactInfoLabel value for this UserContactInfoParms.
     * 
     * @return contactInfoLabel   * The label of the contact info to be created or
     *                                 modified.
     */
    public String getContactInfoLabel() {
        return contactInfoLabel;
    }


    /**
     * Sets the contactInfoLabel value for this UserContactInfoParms.
     * 
     * @param contactInfoLabel   * The label of the contact info to be created or
     *                                 modified.
     */
    public void setContactInfoLabel(String contactInfoLabel) {
        this.contactInfoLabel = contactInfoLabel;
    }


    /**
     * Gets the originalLabel value for this UserContactInfoParms.
     * 
     * @return originalLabel   * The original label of the contact info, for
     *                                 when contact info are being updated
     * by a call
     *                                 to userSet.  This value is ignored
     * by other calls.
     */
    public String getOriginalLabel() {
        return originalLabel;
    }


    /**
     * Sets the originalLabel value for this UserContactInfoParms.
     * 
     * @param originalLabel   * The original label of the contact info, for
     *                                 when contact info are being updated
     * by a call
     *                                 to userSet.  This value is ignored
     * by other calls.
     */
    public void setOriginalLabel(String originalLabel) {
        this.originalLabel = originalLabel;
    }


    /**
     * Gets the value value for this UserContactInfoParms.
     * 
     * @return value   * The value of the user contact info.
     */
    public String getValue() {
        return value;
    }


    /**
     * Sets the value value for this UserContactInfoParms.
     * 
     * @param value   * The value of the user contact info.
     */
    public void setValue(String value) {
        this.value = value;
    }


    /**
     * Gets the deliveryConfigLabel value for this UserContactInfoParms.
     * 
     * @return deliveryConfigLabel   * The label of the delivery configuration that is
     *                                 associated with this user contact
     * info.
     */
    public String getDeliveryConfigLabel() {
        return deliveryConfigLabel;
    }


    /**
     * Sets the deliveryConfigLabel value for this UserContactInfoParms.
     * 
     * @param deliveryConfigLabel   * The label of the delivery configuration that is
     *                                 associated with this user contact
     * info.
     */
    public void setDeliveryConfigLabel(String deliveryConfigLabel) {
        this.deliveryConfigLabel = deliveryConfigLabel;
    }


    /**
     * Gets the defaultContactInfo value for this UserContactInfoParms.
     * 
     * @return defaultContactInfo   * If true, it means this user contact info
     *                                 instance is default. The delivery
     * configuration
     *                                 associated with this contact info
     * is used for
     *                                 out-of-band data delivery when no
     * contact info
     *                                 is specified for delivery. Defaults
     * to false.
     */
    public Boolean getDefaultContactInfo() {
        return defaultContactInfo;
    }


    /**
     * Sets the defaultContactInfo value for this UserContactInfoParms.
     * 
     * @param defaultContactInfo   * If true, it means this user contact info
     *                                 instance is default. The delivery
     * configuration
     *                                 associated with this contact info
     * is used for
     *                                 out-of-band data delivery when no
     * contact info
     *                                 is specified for delivery. Defaults
     * to false.
     */
    public void setDefaultContactInfo(Boolean defaultContactInfo) {
        this.defaultContactInfo = defaultContactInfo;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserContactInfoParms)) return false;
        UserContactInfoParms other = (UserContactInfoParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.contactInfoLabel==null && other.getContactInfoLabel()==null) || 
             (this.contactInfoLabel!=null &&
              this.contactInfoLabel.equals(other.getContactInfoLabel()))) &&
            ((this.originalLabel==null && other.getOriginalLabel()==null) || 
             (this.originalLabel!=null &&
              this.originalLabel.equals(other.getOriginalLabel()))) &&
            ((this.value==null && other.getValue()==null) || 
             (this.value!=null &&
              this.value.equals(other.getValue()))) &&
            ((this.deliveryConfigLabel==null && other.getDeliveryConfigLabel()==null) || 
             (this.deliveryConfigLabel!=null &&
              this.deliveryConfigLabel.equals(other.getDeliveryConfigLabel()))) &&
            ((this.defaultContactInfo==null && other.getDefaultContactInfo()==null) || 
             (this.defaultContactInfo!=null &&
              this.defaultContactInfo.equals(other.getDefaultContactInfo())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getContactInfoLabel() != null) {
            _hashCode += getContactInfoLabel().hashCode();
        }
        if (getOriginalLabel() != null) {
            _hashCode += getOriginalLabel().hashCode();
        }
        if (getValue() != null) {
            _hashCode += getValue().hashCode();
        }
        if (getDeliveryConfigLabel() != null) {
            _hashCode += getDeliveryConfigLabel().hashCode();
        }
        if (getDefaultContactInfo() != null) {
            _hashCode += getDefaultContactInfo().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserContactInfoParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserContactInfoParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("contactInfoLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "contactInfoLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("originalLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "originalLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("value");
        elemField.setXmlName(new javax.xml.namespace.QName("", "value"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("deliveryConfigLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "deliveryConfigLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("defaultContactInfo");
        elemField.setXmlName(new javax.xml.namespace.QName("", "defaultContactInfo"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
