/**
 * UserDigitalIdCreateRecoverResult.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure contains the information returned by
 *                         a call to userDigitalIdCreateRecover or
 *                         userSmartCredentialDigitalIdCreateRecover.
 */
public class UserDigitalIdCreateRecoverResult  implements java.io.Serializable {
    /* Information about the digital identity that was 
     *                                 created or recovered. */
    private UserDigitalIdInfo digitalId;

    /* The reference number. When the create/recover 
     *                                 operation is performed against an
     * Entrust CA, 
     *                                 this value will be null if a Security
     * Store is 
     *                                 created or P10 requests are processed
     * as part 
     *                                 of the create/recover operation. When
     * the
     *                                 create/recover operation is performed
     * against
     *                                 a Microsoft CA, this value will always
     * be null. */
    private String refNum;

    /* The authorization code. When the create/recover 
     *                                 operation is performed against an
     * Entrust CA, 
     *                                 this value will be null if a Profile
     * is created 
     *                                 or P10 requests are processed as part
     * of the 
     *                                 create/recover operation. When the
     * create/recover operation is performed against
     *                                 a Microsoft CA, this value will always
     * be null. */
    private String authCode;

    /* If a security store was created as part of the
     *                                 create/recover operation, this attribute
     * will 
     *                                 specify the type of security store
     * created. */
    private DigitalIdSecurityStoreType securityStoreType;

    /* If a security store was created as part of the
     *                                 create/recover operation, this attribute
     * will 
     *                                 contain the security store. */
    private byte[] securityStore;

    /* If a password was generated when a security
     *                                 store was created as part of the create/recover
     * operation, this attribute will contain the
     *                                 generated password. */
    private String securityStorePassword;

    /* If P10 requests were processed as part of
     *                                 the create/recover operation the certificate
     * responses contain the certificates created
     *                                 for each P10 request. */
    private DigitalIdCertResponse[] certResponses;

    public UserDigitalIdCreateRecoverResult() {
    }

    public UserDigitalIdCreateRecoverResult(
           UserDigitalIdInfo digitalId,
           String refNum,
           String authCode,
           DigitalIdSecurityStoreType securityStoreType,
           byte[] securityStore,
           String securityStorePassword,
           DigitalIdCertResponse[] certResponses) {
           this.digitalId = digitalId;
           this.refNum = refNum;
           this.authCode = authCode;
           this.securityStoreType = securityStoreType;
           this.securityStore = securityStore;
           this.securityStorePassword = securityStorePassword;
           this.certResponses = certResponses;
    }


    /**
     * Gets the digitalId value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return digitalId   * Information about the digital identity that was 
     *                                 created or recovered.
     */
    public UserDigitalIdInfo getDigitalId() {
        return digitalId;
    }


    /**
     * Sets the digitalId value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param digitalId   * Information about the digital identity that was 
     *                                 created or recovered.
     */
    public void setDigitalId(UserDigitalIdInfo digitalId) {
        this.digitalId = digitalId;
    }


    /**
     * Gets the refNum value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return refNum   * The reference number. When the create/recover 
     *                                 operation is performed against an
     * Entrust CA, 
     *                                 this value will be null if a Security
     * Store is 
     *                                 created or P10 requests are processed
     * as part 
     *                                 of the create/recover operation. When
     * the
     *                                 create/recover operation is performed
     * against
     *                                 a Microsoft CA, this value will always
     * be null.
     */
    public String getRefNum() {
        return refNum;
    }


    /**
     * Sets the refNum value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param refNum   * The reference number. When the create/recover 
     *                                 operation is performed against an
     * Entrust CA, 
     *                                 this value will be null if a Security
     * Store is 
     *                                 created or P10 requests are processed
     * as part 
     *                                 of the create/recover operation. When
     * the
     *                                 create/recover operation is performed
     * against
     *                                 a Microsoft CA, this value will always
     * be null.
     */
    public void setRefNum(String refNum) {
        this.refNum = refNum;
    }


    /**
     * Gets the authCode value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return authCode   * The authorization code. When the create/recover 
     *                                 operation is performed against an
     * Entrust CA, 
     *                                 this value will be null if a Profile
     * is created 
     *                                 or P10 requests are processed as part
     * of the 
     *                                 create/recover operation. When the
     * create/recover operation is performed against
     *                                 a Microsoft CA, this value will always
     * be null.
     */
    public String getAuthCode() {
        return authCode;
    }


    /**
     * Sets the authCode value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param authCode   * The authorization code. When the create/recover 
     *                                 operation is performed against an
     * Entrust CA, 
     *                                 this value will be null if a Profile
     * is created 
     *                                 or P10 requests are processed as part
     * of the 
     *                                 create/recover operation. When the
     * create/recover operation is performed against
     *                                 a Microsoft CA, this value will always
     * be null.
     */
    public void setAuthCode(String authCode) {
        this.authCode = authCode;
    }


    /**
     * Gets the securityStoreType value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return securityStoreType   * If a security store was created as part of the
     *                                 create/recover operation, this attribute
     * will 
     *                                 specify the type of security store
     * created.
     */
    public DigitalIdSecurityStoreType getSecurityStoreType() {
        return securityStoreType;
    }


    /**
     * Sets the securityStoreType value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param securityStoreType   * If a security store was created as part of the
     *                                 create/recover operation, this attribute
     * will 
     *                                 specify the type of security store
     * created.
     */
    public void setSecurityStoreType(DigitalIdSecurityStoreType securityStoreType) {
        this.securityStoreType = securityStoreType;
    }


    /**
     * Gets the securityStore value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return securityStore   * If a security store was created as part of the
     *                                 create/recover operation, this attribute
     * will 
     *                                 contain the security store.
     */
    public byte[] getSecurityStore() {
        return securityStore;
    }


    /**
     * Sets the securityStore value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param securityStore   * If a security store was created as part of the
     *                                 create/recover operation, this attribute
     * will 
     *                                 contain the security store.
     */
    public void setSecurityStore(byte[] securityStore) {
        this.securityStore = securityStore;
    }


    /**
     * Gets the securityStorePassword value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return securityStorePassword   * If a password was generated when a security
     *                                 store was created as part of the create/recover
     * operation, this attribute will contain the
     *                                 generated password.
     */
    public String getSecurityStorePassword() {
        return securityStorePassword;
    }


    /**
     * Sets the securityStorePassword value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param securityStorePassword   * If a password was generated when a security
     *                                 store was created as part of the create/recover
     * operation, this attribute will contain the
     *                                 generated password.
     */
    public void setSecurityStorePassword(String securityStorePassword) {
        this.securityStorePassword = securityStorePassword;
    }


    /**
     * Gets the certResponses value for this UserDigitalIdCreateRecoverResult.
     * 
     * @return certResponses   * If P10 requests were processed as part of
     *                                 the create/recover operation the certificate
     * responses contain the certificates created
     *                                 for each P10 request.
     */
    public DigitalIdCertResponse[] getCertResponses() {
        return certResponses;
    }


    /**
     * Sets the certResponses value for this UserDigitalIdCreateRecoverResult.
     * 
     * @param certResponses   * If P10 requests were processed as part of
     *                                 the create/recover operation the certificate
     * responses contain the certificates created
     *                                 for each P10 request.
     */
    public void setCertResponses(DigitalIdCertResponse[] certResponses) {
        this.certResponses = certResponses;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserDigitalIdCreateRecoverResult)) return false;
        UserDigitalIdCreateRecoverResult other = (UserDigitalIdCreateRecoverResult) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.digitalId==null && other.getDigitalId()==null) || 
             (this.digitalId!=null &&
              this.digitalId.equals(other.getDigitalId()))) &&
            ((this.refNum==null && other.getRefNum()==null) || 
             (this.refNum!=null &&
              this.refNum.equals(other.getRefNum()))) &&
            ((this.authCode==null && other.getAuthCode()==null) || 
             (this.authCode!=null &&
              this.authCode.equals(other.getAuthCode()))) &&
            ((this.securityStoreType==null && other.getSecurityStoreType()==null) || 
             (this.securityStoreType!=null &&
              this.securityStoreType.equals(other.getSecurityStoreType()))) &&
            ((this.securityStore==null && other.getSecurityStore()==null) || 
             (this.securityStore!=null &&
              java.util.Arrays.equals(this.securityStore, other.getSecurityStore()))) &&
            ((this.securityStorePassword==null && other.getSecurityStorePassword()==null) || 
             (this.securityStorePassword!=null &&
              this.securityStorePassword.equals(other.getSecurityStorePassword()))) &&
            ((this.certResponses==null && other.getCertResponses()==null) || 
             (this.certResponses!=null &&
              java.util.Arrays.equals(this.certResponses, other.getCertResponses())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getDigitalId() != null) {
            _hashCode += getDigitalId().hashCode();
        }
        if (getRefNum() != null) {
            _hashCode += getRefNum().hashCode();
        }
        if (getAuthCode() != null) {
            _hashCode += getAuthCode().hashCode();
        }
        if (getSecurityStoreType() != null) {
            _hashCode += getSecurityStoreType().hashCode();
        }
        if (getSecurityStore() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getSecurityStore());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getSecurityStore(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getSecurityStorePassword() != null) {
            _hashCode += getSecurityStorePassword().hashCode();
        }
        if (getCertResponses() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCertResponses());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCertResponses(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    @Override
    public String toString() {
        return "UserDigitalIdCreateRecoverResult{" +
                "digitalId=" + digitalId.getDigitalIdConfig() +
                ", refNum='" + refNum + '\'' +
                ", authCode='" + "***" + '\'' +
                ", securityStoreType=" + securityStoreType +
                ", securityStore.length=" + (securityStore == null ? null : securityStore.length) +
                ", securityStorePassword='" + "***" + '\'' +
                '}';
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserDigitalIdCreateRecoverResult.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserDigitalIdCreateRecoverResult"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("digitalId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "digitalId"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserDigitalIdInfo"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("refNum");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RefNum"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("authCode");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AuthCode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("securityStoreType");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SecurityStoreType"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdSecurityStoreType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("securityStore");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SecurityStore"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "base64Binary"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("securityStorePassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SecurityStorePassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certResponses");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CertResponses"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "DigitalIdCertResponse"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
