/**
 * UserDigitalIdDetails.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines details about a Digital Id retrieved from the
 *                         CA.
 */
public class UserDigitalIdDetails  implements java.io.Serializable {
    /* The issuer DN of this digital id. */
    private String issuerDN;

    /* The subject DN of this digital id. */
    private String subjectDN;

    /* The certificate types for this digital id. */
    private UserDigitalIdCertType[] certTypes;

    /* The number of active certificates for this
     *                                 Digital Id. */
    private int numActiveCerts;

    /* The number of active certificates for this
     *                                 Digital Id that the hold operation
     * can
     *                                 be applied to. */
    private int numActiveCertsCanHold;

    /* The number of certificates on hold for this
     *                                 Digital Id. */
    private int numHoldCerts;

    /* The number of certificates permanently
     *                                 revoked for this Digital Id. */
    private int numCanceledCerts;

    /* The fault describing why the digital Id
     *                                 details could not be retrieved.  If
     * this
     *                                 attribute is set the values of the
     * other fields
     *                                 should be ignored. */
    private AdminServiceFault fault;

    public UserDigitalIdDetails() {
    }

    public UserDigitalIdDetails(
           String issuerDN,
           String subjectDN,
           UserDigitalIdCertType[] certTypes,
           int numActiveCerts,
           int numActiveCertsCanHold,
           int numHoldCerts,
           int numCanceledCerts,
           AdminServiceFault fault) {
           this.issuerDN = issuerDN;
           this.subjectDN = subjectDN;
           this.certTypes = certTypes;
           this.numActiveCerts = numActiveCerts;
           this.numActiveCertsCanHold = numActiveCertsCanHold;
           this.numHoldCerts = numHoldCerts;
           this.numCanceledCerts = numCanceledCerts;
           this.fault = fault;
    }


    /**
     * Gets the issuerDN value for this UserDigitalIdDetails.
     * 
     * @return issuerDN   * The issuer DN of this digital id.
     */
    public String getIssuerDN() {
        return issuerDN;
    }


    /**
     * Sets the issuerDN value for this UserDigitalIdDetails.
     * 
     * @param issuerDN   * The issuer DN of this digital id.
     */
    public void setIssuerDN(String issuerDN) {
        this.issuerDN = issuerDN;
    }


    /**
     * Gets the subjectDN value for this UserDigitalIdDetails.
     * 
     * @return subjectDN   * The subject DN of this digital id.
     */
    public String getSubjectDN() {
        return subjectDN;
    }


    /**
     * Sets the subjectDN value for this UserDigitalIdDetails.
     * 
     * @param subjectDN   * The subject DN of this digital id.
     */
    public void setSubjectDN(String subjectDN) {
        this.subjectDN = subjectDN;
    }


    /**
     * Gets the certTypes value for this UserDigitalIdDetails.
     * 
     * @return certTypes   * The certificate types for this digital id.
     */
    public UserDigitalIdCertType[] getCertTypes() {
        return certTypes;
    }


    /**
     * Sets the certTypes value for this UserDigitalIdDetails.
     * 
     * @param certTypes   * The certificate types for this digital id.
     */
    public void setCertTypes(UserDigitalIdCertType[] certTypes) {
        this.certTypes = certTypes;
    }


    /**
     * Gets the numActiveCerts value for this UserDigitalIdDetails.
     * 
     * @return numActiveCerts   * The number of active certificates for this
     *                                 Digital Id.
     */
    public int getNumActiveCerts() {
        return numActiveCerts;
    }


    /**
     * Sets the numActiveCerts value for this UserDigitalIdDetails.
     * 
     * @param numActiveCerts   * The number of active certificates for this
     *                                 Digital Id.
     */
    public void setNumActiveCerts(int numActiveCerts) {
        this.numActiveCerts = numActiveCerts;
    }


    /**
     * Gets the numActiveCertsCanHold value for this UserDigitalIdDetails.
     * 
     * @return numActiveCertsCanHold   * The number of active certificates for this
     *                                 Digital Id that the hold operation
     * can
     *                                 be applied to.
     */
    public int getNumActiveCertsCanHold() {
        return numActiveCertsCanHold;
    }


    /**
     * Sets the numActiveCertsCanHold value for this UserDigitalIdDetails.
     * 
     * @param numActiveCertsCanHold   * The number of active certificates for this
     *                                 Digital Id that the hold operation
     * can
     *                                 be applied to.
     */
    public void setNumActiveCertsCanHold(int numActiveCertsCanHold) {
        this.numActiveCertsCanHold = numActiveCertsCanHold;
    }


    /**
     * Gets the numHoldCerts value for this UserDigitalIdDetails.
     * 
     * @return numHoldCerts   * The number of certificates on hold for this
     *                                 Digital Id.
     */
    public int getNumHoldCerts() {
        return numHoldCerts;
    }


    /**
     * Sets the numHoldCerts value for this UserDigitalIdDetails.
     * 
     * @param numHoldCerts   * The number of certificates on hold for this
     *                                 Digital Id.
     */
    public void setNumHoldCerts(int numHoldCerts) {
        this.numHoldCerts = numHoldCerts;
    }


    /**
     * Gets the numCanceledCerts value for this UserDigitalIdDetails.
     * 
     * @return numCanceledCerts   * The number of certificates permanently
     *                                 revoked for this Digital Id.
     */
    public int getNumCanceledCerts() {
        return numCanceledCerts;
    }


    /**
     * Sets the numCanceledCerts value for this UserDigitalIdDetails.
     * 
     * @param numCanceledCerts   * The number of certificates permanently
     *                                 revoked for this Digital Id.
     */
    public void setNumCanceledCerts(int numCanceledCerts) {
        this.numCanceledCerts = numCanceledCerts;
    }


    /**
     * Gets the fault value for this UserDigitalIdDetails.
     * 
     * @return fault   * The fault describing why the digital Id
     *                                 details could not be retrieved.  If
     * this
     *                                 attribute is set the values of the
     * other fields
     *                                 should be ignored.
     */
    public AdminServiceFault getFault() {
        return fault;
    }


    /**
     * Sets the fault value for this UserDigitalIdDetails.
     * 
     * @param fault   * The fault describing why the digital Id
     *                                 details could not be retrieved.  If
     * this
     *                                 attribute is set the values of the
     * other fields
     *                                 should be ignored.
     */
    public void setFault(AdminServiceFault fault) {
        this.fault = fault;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserDigitalIdDetails)) return false;
        UserDigitalIdDetails other = (UserDigitalIdDetails) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.issuerDN==null && other.getIssuerDN()==null) || 
             (this.issuerDN!=null &&
              this.issuerDN.equals(other.getIssuerDN()))) &&
            ((this.subjectDN==null && other.getSubjectDN()==null) || 
             (this.subjectDN!=null &&
              this.subjectDN.equals(other.getSubjectDN()))) &&
            ((this.certTypes==null && other.getCertTypes()==null) || 
             (this.certTypes!=null &&
              java.util.Arrays.equals(this.certTypes, other.getCertTypes()))) &&
            this.numActiveCerts == other.getNumActiveCerts() &&
            this.numActiveCertsCanHold == other.getNumActiveCertsCanHold() &&
            this.numHoldCerts == other.getNumHoldCerts() &&
            this.numCanceledCerts == other.getNumCanceledCerts() &&
            ((this.fault==null && other.getFault()==null) || 
             (this.fault!=null &&
              this.fault.equals(other.getFault())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getIssuerDN() != null) {
            _hashCode += getIssuerDN().hashCode();
        }
        if (getSubjectDN() != null) {
            _hashCode += getSubjectDN().hashCode();
        }
        if (getCertTypes() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getCertTypes());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getCertTypes(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        _hashCode += getNumActiveCerts();
        _hashCode += getNumActiveCertsCanHold();
        _hashCode += getNumHoldCerts();
        _hashCode += getNumCanceledCerts();
        if (getFault() != null) {
            _hashCode += getFault().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserDigitalIdDetails.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserDigitalIdDetails"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("issuerDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "issuerDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("subjectDN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "subjectDN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certTypes");
        elemField.setXmlName(new javax.xml.namespace.QName("", "certTypes"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserDigitalIdCertType"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numActiveCerts");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numActiveCerts"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numActiveCertsCanHold");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numActiveCertsCanHold"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numHoldCerts");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numHoldCerts"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numCanceledCerts");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numCanceledCerts"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("fault");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Fault"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AdminServiceFault"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
