/**
 * UserEnrollFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the filter to limit which users are
 *                         to be returned from the user enroll list operation.
 */
public class UserEnrollFilter  implements java.io.Serializable {
    /* A group that is associated to at least one LDAP repository
     * that
     *                                 contains users that are not yet Entrust
     * IdentityGuard users.
     *                                 The LDAP repository must have user
     * enrollment enabled. */
    private String group;

    /* If specified, only users in this repository are returned.
     *                                 The repository must be associated
     * to the group. */
    private String repository;

    /* If specified, only users that match the LDAP filter 
     *                                 are returned. Note that the filter
     * is a partial LDAP
     *                                 filter.  Additional filtering criteria
     * is defined in 
     *                                 the Entrust IdentityGuard server. */
    private String ldapFilter;

    /* The number of users to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100. */
    private Integer maxReturn;

    /* If specified, identifies the next user block. The value,
     *                                 if applicable, will be available from
     * the result
     *                                 of a prior user enroll list operation. */
    private String pagedResultsCookie;

    public UserEnrollFilter() {
    }

    public UserEnrollFilter(
           String group,
           String repository,
           String ldapFilter,
           Integer maxReturn,
           String pagedResultsCookie) {
           this.group = group;
           this.repository = repository;
           this.ldapFilter = ldapFilter;
           this.maxReturn = maxReturn;
           this.pagedResultsCookie = pagedResultsCookie;
    }


    /**
     * Gets the group value for this UserEnrollFilter.
     * 
     * @return group   * A group that is associated to at least one LDAP repository
     * that
     *                                 contains users that are not yet Entrust
     * IdentityGuard users.
     *                                 The LDAP repository must have user
     * enrollment enabled.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this UserEnrollFilter.
     * 
     * @param group   * A group that is associated to at least one LDAP repository
     * that
     *                                 contains users that are not yet Entrust
     * IdentityGuard users.
     *                                 The LDAP repository must have user
     * enrollment enabled.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the repository value for this UserEnrollFilter.
     * 
     * @return repository   * If specified, only users in this repository are returned.
     *                                 The repository must be associated
     * to the group.
     */
    public String getRepository() {
        return repository;
    }


    /**
     * Sets the repository value for this UserEnrollFilter.
     * 
     * @param repository   * If specified, only users in this repository are returned.
     *                                 The repository must be associated
     * to the group.
     */
    public void setRepository(String repository) {
        this.repository = repository;
    }


    /**
     * Gets the ldapFilter value for this UserEnrollFilter.
     * 
     * @return ldapFilter   * If specified, only users that match the LDAP filter 
     *                                 are returned. Note that the filter
     * is a partial LDAP
     *                                 filter.  Additional filtering criteria
     * is defined in 
     *                                 the Entrust IdentityGuard server.
     */
    public String getLdapFilter() {
        return ldapFilter;
    }


    /**
     * Sets the ldapFilter value for this UserEnrollFilter.
     * 
     * @param ldapFilter   * If specified, only users that match the LDAP filter 
     *                                 are returned. Note that the filter
     * is a partial LDAP
     *                                 filter.  Additional filtering criteria
     * is defined in 
     *                                 the Entrust IdentityGuard server.
     */
    public void setLdapFilter(String ldapFilter) {
        this.ldapFilter = ldapFilter;
    }


    /**
     * Gets the maxReturn value for this UserEnrollFilter.
     * 
     * @return maxReturn   * The number of users to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100.
     */
    public Integer getMaxReturn() {
        return maxReturn;
    }


    /**
     * Sets the maxReturn value for this UserEnrollFilter.
     * 
     * @param maxReturn   * The number of users to return. If not
     *                                 specified or the value is 0 or less,
     * it
     *                                 defaults to 100.
     */
    public void setMaxReturn(Integer maxReturn) {
        this.maxReturn = maxReturn;
    }


    /**
     * Gets the pagedResultsCookie value for this UserEnrollFilter.
     * 
     * @return pagedResultsCookie   * If specified, identifies the next user block. The value,
     *                                 if applicable, will be available from
     * the result
     *                                 of a prior user enroll list operation.
     */
    public String getPagedResultsCookie() {
        return pagedResultsCookie;
    }


    /**
     * Sets the pagedResultsCookie value for this UserEnrollFilter.
     * 
     * @param pagedResultsCookie   * If specified, identifies the next user block. The value,
     *                                 if applicable, will be available from
     * the result
     *                                 of a prior user enroll list operation.
     */
    public void setPagedResultsCookie(String pagedResultsCookie) {
        this.pagedResultsCookie = pagedResultsCookie;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserEnrollFilter)) return false;
        UserEnrollFilter other = (UserEnrollFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.repository==null && other.getRepository()==null) || 
             (this.repository!=null &&
              this.repository.equals(other.getRepository()))) &&
            ((this.ldapFilter==null && other.getLdapFilter()==null) || 
             (this.ldapFilter!=null &&
              this.ldapFilter.equals(other.getLdapFilter()))) &&
            ((this.maxReturn==null && other.getMaxReturn()==null) || 
             (this.maxReturn!=null &&
              this.maxReturn.equals(other.getMaxReturn()))) &&
            ((this.pagedResultsCookie==null && other.getPagedResultsCookie()==null) || 
             (this.pagedResultsCookie!=null &&
              this.pagedResultsCookie.equals(other.getPagedResultsCookie())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getRepository() != null) {
            _hashCode += getRepository().hashCode();
        }
        if (getLdapFilter() != null) {
            _hashCode += getLdapFilter().hashCode();
        }
        if (getMaxReturn() != null) {
            _hashCode += getMaxReturn().hashCode();
        }
        if (getPagedResultsCookie() != null) {
            _hashCode += getPagedResultsCookie().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserEnrollFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserEnrollFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("repository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "repository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("ldapFilter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ldapFilter"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("maxReturn");
        elemField.setXmlName(new javax.xml.namespace.QName("", "maxReturn"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("pagedResultsCookie");
        elemField.setXmlName(new javax.xml.namespace.QName("", "pagedResultsCookie"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
