/**
 * UserEnrollInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned about a user that in not yet 
 *                         an Entrust IdentityGuard user.
 */
public class UserEnrollInfo  implements java.io.Serializable {
    /* The user ID of the user. */
    private String userid;

    /* The user name portion of the user ID. */
    private String userName;

    /* The group of the user. */
    private String group;

    /* The name of the repository that the user's
     *                                 information is stored in. */
    private String repository;

    /* The user's uniquely identifying name in the
     *                                 repository. For users stored in an
     * LDAP
     *                                 directory this is the user's distinguished
     * name (DN). */
    private String repositoryId;

    /* Is the user disabled in the repository? 
     *                                 Disabled entries will only be returned
     * if the
     *                                 policy allows creation of users in
     * disabled
     *                                 entries. */
    private boolean disabledInRepository;

    /* Is the user expired in the repository? 
     *                                 Expired entries will only be returned
     * if the
     *                                 policy allows creation of users in
     * expired
     *                                 entries. */
    private boolean expiredInRepository;

    public UserEnrollInfo() {
    }

    public UserEnrollInfo(
           String userid,
           String userName,
           String group,
           String repository,
           String repositoryId,
           boolean disabledInRepository,
           boolean expiredInRepository) {
           this.userid = userid;
           this.userName = userName;
           this.group = group;
           this.repository = repository;
           this.repositoryId = repositoryId;
           this.disabledInRepository = disabledInRepository;
           this.expiredInRepository = expiredInRepository;
    }


    /**
     * Gets the userid value for this UserEnrollInfo.
     * 
     * @return userid   * The user ID of the user.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserEnrollInfo.
     * 
     * @param userid   * The user ID of the user.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the userName value for this UserEnrollInfo.
     * 
     * @return userName   * The user name portion of the user ID.
     */
    public String getUserName() {
        return userName;
    }


    /**
     * Sets the userName value for this UserEnrollInfo.
     * 
     * @param userName   * The user name portion of the user ID.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }


    /**
     * Gets the group value for this UserEnrollInfo.
     * 
     * @return group   * The group of the user.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this UserEnrollInfo.
     * 
     * @param group   * The group of the user.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the repository value for this UserEnrollInfo.
     * 
     * @return repository   * The name of the repository that the user's
     *                                 information is stored in.
     */
    public String getRepository() {
        return repository;
    }


    /**
     * Sets the repository value for this UserEnrollInfo.
     * 
     * @param repository   * The name of the repository that the user's
     *                                 information is stored in.
     */
    public void setRepository(String repository) {
        this.repository = repository;
    }


    /**
     * Gets the repositoryId value for this UserEnrollInfo.
     * 
     * @return repositoryId   * The user's uniquely identifying name in the
     *                                 repository. For users stored in an
     * LDAP
     *                                 directory this is the user's distinguished
     * name (DN).
     */
    public String getRepositoryId() {
        return repositoryId;
    }


    /**
     * Sets the repositoryId value for this UserEnrollInfo.
     * 
     * @param repositoryId   * The user's uniquely identifying name in the
     *                                 repository. For users stored in an
     * LDAP
     *                                 directory this is the user's distinguished
     * name (DN).
     */
    public void setRepositoryId(String repositoryId) {
        this.repositoryId = repositoryId;
    }


    /**
     * Gets the disabledInRepository value for this UserEnrollInfo.
     * 
     * @return disabledInRepository   * Is the user disabled in the repository? 
     *                                 Disabled entries will only be returned
     * if the
     *                                 policy allows creation of users in
     * disabled
     *                                 entries.
     */
    public boolean isDisabledInRepository() {
        return disabledInRepository;
    }


    /**
     * Sets the disabledInRepository value for this UserEnrollInfo.
     * 
     * @param disabledInRepository   * Is the user disabled in the repository? 
     *                                 Disabled entries will only be returned
     * if the
     *                                 policy allows creation of users in
     * disabled
     *                                 entries.
     */
    public void setDisabledInRepository(boolean disabledInRepository) {
        this.disabledInRepository = disabledInRepository;
    }


    /**
     * Gets the expiredInRepository value for this UserEnrollInfo.
     * 
     * @return expiredInRepository   * Is the user expired in the repository? 
     *                                 Expired entries will only be returned
     * if the
     *                                 policy allows creation of users in
     * expired
     *                                 entries.
     */
    public boolean isExpiredInRepository() {
        return expiredInRepository;
    }


    /**
     * Sets the expiredInRepository value for this UserEnrollInfo.
     * 
     * @param expiredInRepository   * Is the user expired in the repository? 
     *                                 Expired entries will only be returned
     * if the
     *                                 policy allows creation of users in
     * expired
     *                                 entries.
     */
    public void setExpiredInRepository(boolean expiredInRepository) {
        this.expiredInRepository = expiredInRepository;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserEnrollInfo)) return false;
        UserEnrollInfo other = (UserEnrollInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.userName==null && other.getUserName()==null) || 
             (this.userName!=null &&
              this.userName.equals(other.getUserName()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.repository==null && other.getRepository()==null) || 
             (this.repository!=null &&
              this.repository.equals(other.getRepository()))) &&
            ((this.repositoryId==null && other.getRepositoryId()==null) || 
             (this.repositoryId!=null &&
              this.repositoryId.equals(other.getRepositoryId()))) &&
            this.disabledInRepository == other.isDisabledInRepository() &&
            this.expiredInRepository == other.isExpiredInRepository();
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getUserName() != null) {
            _hashCode += getUserName().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getRepository() != null) {
            _hashCode += getRepository().hashCode();
        }
        if (getRepositoryId() != null) {
            _hashCode += getRepositoryId().hashCode();
        }
        _hashCode += (isDisabledInRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        _hashCode += (isExpiredInRepository() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserEnrollInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserEnrollInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("repository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "repository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("repositoryId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "repositoryId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("disabledInRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "disabledInRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiredInRepository");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiredInRepository"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
