/**
 * UserFederationFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines a filter to limit which federations are 
 *                         returned for a user when the filter is used
 * with
 *                         userFederationGet, userFederationList, and
 * 
 *                         userFederationDelete. In these cases, if no
 * filter 
 *                         items are set then all federations for the
 * user are 
 *                         returned. Defines a filter in order to specify
 * a 
 *                         single type and partnerID when the filter
 * is used 
 *                         with userFederationSet.
 */
public class UserFederationFilter  implements java.io.Serializable {
    /* Return user federations whose type
     *                                matches one of the given value. */
    private String[] types;

    /* The partner ID of the federation. For example
     *                                 the SAML partner entity ID. */
    private String partnerID;

    /* A flag indicating if this server is the
     *                                 originator of the federation. */
    private Boolean originator;

    public UserFederationFilter() {
    }

    public UserFederationFilter(
           String[] types,
           String partnerID,
           Boolean originator) {
           this.types = types;
           this.partnerID = partnerID;
           this.originator = originator;
    }


    /**
     * Gets the types value for this UserFederationFilter.
     * 
     * @return types   * Return user federations whose type
     *                                matches one of the given value.
     */
    public String[] getTypes() {
        return types;
    }


    /**
     * Sets the types value for this UserFederationFilter.
     * 
     * @param types   * Return user federations whose type
     *                                matches one of the given value.
     */
    public void setTypes(String[] types) {
        this.types = types;
    }


    /**
     * Gets the partnerID value for this UserFederationFilter.
     * 
     * @return partnerID   * The partner ID of the federation. For example
     *                                 the SAML partner entity ID.
     */
    public String getPartnerID() {
        return partnerID;
    }


    /**
     * Sets the partnerID value for this UserFederationFilter.
     * 
     * @param partnerID   * The partner ID of the federation. For example
     *                                 the SAML partner entity ID.
     */
    public void setPartnerID(String partnerID) {
        this.partnerID = partnerID;
    }


    /**
     * Gets the originator value for this UserFederationFilter.
     * 
     * @return originator   * A flag indicating if this server is the
     *                                 originator of the federation.
     */
    public Boolean getOriginator() {
        return originator;
    }


    /**
     * Sets the originator value for this UserFederationFilter.
     * 
     * @param originator   * A flag indicating if this server is the
     *                                 originator of the federation.
     */
    public void setOriginator(Boolean originator) {
        this.originator = originator;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserFederationFilter)) return false;
        UserFederationFilter other = (UserFederationFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.types==null && other.getTypes()==null) || 
             (this.types!=null &&
              java.util.Arrays.equals(this.types, other.getTypes()))) &&
            ((this.partnerID==null && other.getPartnerID()==null) || 
             (this.partnerID!=null &&
              this.partnerID.equals(other.getPartnerID()))) &&
            ((this.originator==null && other.getOriginator()==null) || 
             (this.originator!=null &&
              this.originator.equals(other.getOriginator())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getTypes() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTypes());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTypes(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getPartnerID() != null) {
            _hashCode += getPartnerID().hashCode();
        }
        if (getOriginator() != null) {
            _hashCode += getOriginator().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserFederationFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserFederationFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("types");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Types"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("partnerID");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PartnerID"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("originator");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Originator"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
