/**
 * UserLocation.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines a user location.
 */
public class UserLocation  implements java.io.Serializable {
    /* If true, the IP address is a private IP address
     *                                 as defined by RFC 1918. */
    private boolean privateAddress;

    /* The IP address of the location. */
    private String IPAddress;

    /* The country code of the location.
     *                                 Private IP addresses do not have a
     * country. */
    private String country;

    /* The country name of the location.
     *                                 Private IP addresses do not have a
     * country. */
    private String countryName;

    /* The region code of the location.
     *                                 Private IP addresses do not have a
     * region. */
    private String region;

    /* The region name of the location.
     *                                 Private IP addresses do not have a
     * region. */
    private String regionName;

    /* The city of the location.
     *                                 Private IP addresses do not have a
     * city. */
    private String city;

    /* The ISP of the location.
     *                                 Private IP addresses do not have an
     * ISP. */
    private String ISP;

    /* The latitude of the location.
     *                                 Private IP addresses do not have a
     * latitude. */
    private Float latitude;

    /* The longitude of the location.
     *                                 Private IP addresses do not have a
     * longitude. */
    private Float longitude;

    /* The last time the user authenticated from
     *                                 this location. */
    private java.util.Calendar lastAuthentication;

    /* After the expiry time, this location will
     *                                 no longer be considered when performing
     * IP authentication.  A value of Date(0)
     *                                 means this location does not expire. */
    private java.util.Calendar expiryDate;

    /* The number of times the user has authenticated
     *                                 from this location. */
    private int numAuthentications;

    public UserLocation() {
    }

    public UserLocation(
           boolean privateAddress,
           String IPAddress,
           String country,
           String countryName,
           String region,
           String regionName,
           String city,
           String ISP,
           Float latitude,
           Float longitude,
           java.util.Calendar lastAuthentication,
           java.util.Calendar expiryDate,
           int numAuthentications) {
           this.privateAddress = privateAddress;
           this.IPAddress = IPAddress;
           this.country = country;
           this.countryName = countryName;
           this.region = region;
           this.regionName = regionName;
           this.city = city;
           this.ISP = ISP;
           this.latitude = latitude;
           this.longitude = longitude;
           this.lastAuthentication = lastAuthentication;
           this.expiryDate = expiryDate;
           this.numAuthentications = numAuthentications;
    }


    /**
     * Gets the privateAddress value for this UserLocation.
     * 
     * @return privateAddress   * If true, the IP address is a private IP address
     *                                 as defined by RFC 1918.
     */
    public boolean isPrivateAddress() {
        return privateAddress;
    }


    /**
     * Sets the privateAddress value for this UserLocation.
     * 
     * @param privateAddress   * If true, the IP address is a private IP address
     *                                 as defined by RFC 1918.
     */
    public void setPrivateAddress(boolean privateAddress) {
        this.privateAddress = privateAddress;
    }


    /**
     * Gets the IPAddress value for this UserLocation.
     * 
     * @return IPAddress   * The IP address of the location.
     */
    public String getIPAddress() {
        return IPAddress;
    }


    /**
     * Sets the IPAddress value for this UserLocation.
     * 
     * @param IPAddress   * The IP address of the location.
     */
    public void setIPAddress(String IPAddress) {
        this.IPAddress = IPAddress;
    }


    /**
     * Gets the country value for this UserLocation.
     * 
     * @return country   * The country code of the location.
     *                                 Private IP addresses do not have a
     * country.
     */
    public String getCountry() {
        return country;
    }


    /**
     * Sets the country value for this UserLocation.
     * 
     * @param country   * The country code of the location.
     *                                 Private IP addresses do not have a
     * country.
     */
    public void setCountry(String country) {
        this.country = country;
    }


    /**
     * Gets the countryName value for this UserLocation.
     * 
     * @return countryName   * The country name of the location.
     *                                 Private IP addresses do not have a
     * country.
     */
    public String getCountryName() {
        return countryName;
    }


    /**
     * Sets the countryName value for this UserLocation.
     * 
     * @param countryName   * The country name of the location.
     *                                 Private IP addresses do not have a
     * country.
     */
    public void setCountryName(String countryName) {
        this.countryName = countryName;
    }


    /**
     * Gets the region value for this UserLocation.
     * 
     * @return region   * The region code of the location.
     *                                 Private IP addresses do not have a
     * region.
     */
    public String getRegion() {
        return region;
    }


    /**
     * Sets the region value for this UserLocation.
     * 
     * @param region   * The region code of the location.
     *                                 Private IP addresses do not have a
     * region.
     */
    public void setRegion(String region) {
        this.region = region;
    }


    /**
     * Gets the regionName value for this UserLocation.
     * 
     * @return regionName   * The region name of the location.
     *                                 Private IP addresses do not have a
     * region.
     */
    public String getRegionName() {
        return regionName;
    }


    /**
     * Sets the regionName value for this UserLocation.
     * 
     * @param regionName   * The region name of the location.
     *                                 Private IP addresses do not have a
     * region.
     */
    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }


    /**
     * Gets the city value for this UserLocation.
     * 
     * @return city   * The city of the location.
     *                                 Private IP addresses do not have a
     * city.
     */
    public String getCity() {
        return city;
    }


    /**
     * Sets the city value for this UserLocation.
     * 
     * @param city   * The city of the location.
     *                                 Private IP addresses do not have a
     * city.
     */
    public void setCity(String city) {
        this.city = city;
    }


    /**
     * Gets the ISP value for this UserLocation.
     * 
     * @return ISP   * The ISP of the location.
     *                                 Private IP addresses do not have an
     * ISP.
     */
    public String getISP() {
        return ISP;
    }


    /**
     * Sets the ISP value for this UserLocation.
     * 
     * @param ISP   * The ISP of the location.
     *                                 Private IP addresses do not have an
     * ISP.
     */
    public void setISP(String ISP) {
        this.ISP = ISP;
    }


    /**
     * Gets the latitude value for this UserLocation.
     * 
     * @return latitude   * The latitude of the location.
     *                                 Private IP addresses do not have a
     * latitude.
     */
    public Float getLatitude() {
        return latitude;
    }


    /**
     * Sets the latitude value for this UserLocation.
     * 
     * @param latitude   * The latitude of the location.
     *                                 Private IP addresses do not have a
     * latitude.
     */
    public void setLatitude(Float latitude) {
        this.latitude = latitude;
    }


    /**
     * Gets the longitude value for this UserLocation.
     * 
     * @return longitude   * The longitude of the location.
     *                                 Private IP addresses do not have a
     * longitude.
     */
    public Float getLongitude() {
        return longitude;
    }


    /**
     * Sets the longitude value for this UserLocation.
     * 
     * @param longitude   * The longitude of the location.
     *                                 Private IP addresses do not have a
     * longitude.
     */
    public void setLongitude(Float longitude) {
        this.longitude = longitude;
    }


    /**
     * Gets the lastAuthentication value for this UserLocation.
     * 
     * @return lastAuthentication   * The last time the user authenticated from
     *                                 this location.
     */
    public java.util.Calendar getLastAuthentication() {
        return lastAuthentication;
    }


    /**
     * Sets the lastAuthentication value for this UserLocation.
     * 
     * @param lastAuthentication   * The last time the user authenticated from
     *                                 this location.
     */
    public void setLastAuthentication(java.util.Calendar lastAuthentication) {
        this.lastAuthentication = lastAuthentication;
    }


    /**
     * Gets the expiryDate value for this UserLocation.
     * 
     * @return expiryDate   * After the expiry time, this location will
     *                                 no longer be considered when performing
     * IP authentication.  A value of Date(0)
     *                                 means this location does not expire.
     */
    public java.util.Calendar getExpiryDate() {
        return expiryDate;
    }


    /**
     * Sets the expiryDate value for this UserLocation.
     * 
     * @param expiryDate   * After the expiry time, this location will
     *                                 no longer be considered when performing
     * IP authentication.  A value of Date(0)
     *                                 means this location does not expire.
     */
    public void setExpiryDate(java.util.Calendar expiryDate) {
        this.expiryDate = expiryDate;
    }


    /**
     * Gets the numAuthentications value for this UserLocation.
     * 
     * @return numAuthentications   * The number of times the user has authenticated
     *                                 from this location.
     */
    public int getNumAuthentications() {
        return numAuthentications;
    }


    /**
     * Sets the numAuthentications value for this UserLocation.
     * 
     * @param numAuthentications   * The number of times the user has authenticated
     *                                 from this location.
     */
    public void setNumAuthentications(int numAuthentications) {
        this.numAuthentications = numAuthentications;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserLocation)) return false;
        UserLocation other = (UserLocation) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            this.privateAddress == other.isPrivateAddress() &&
            ((this.IPAddress==null && other.getIPAddress()==null) || 
             (this.IPAddress!=null &&
              this.IPAddress.equals(other.getIPAddress()))) &&
            ((this.country==null && other.getCountry()==null) || 
             (this.country!=null &&
              this.country.equals(other.getCountry()))) &&
            ((this.countryName==null && other.getCountryName()==null) || 
             (this.countryName!=null &&
              this.countryName.equals(other.getCountryName()))) &&
            ((this.region==null && other.getRegion()==null) || 
             (this.region!=null &&
              this.region.equals(other.getRegion()))) &&
            ((this.regionName==null && other.getRegionName()==null) || 
             (this.regionName!=null &&
              this.regionName.equals(other.getRegionName()))) &&
            ((this.city==null && other.getCity()==null) || 
             (this.city!=null &&
              this.city.equals(other.getCity()))) &&
            ((this.ISP==null && other.getISP()==null) || 
             (this.ISP!=null &&
              this.ISP.equals(other.getISP()))) &&
            ((this.latitude==null && other.getLatitude()==null) || 
             (this.latitude!=null &&
              this.latitude.equals(other.getLatitude()))) &&
            ((this.longitude==null && other.getLongitude()==null) || 
             (this.longitude!=null &&
              this.longitude.equals(other.getLongitude()))) &&
            ((this.lastAuthentication==null && other.getLastAuthentication()==null) || 
             (this.lastAuthentication!=null &&
              this.lastAuthentication.equals(other.getLastAuthentication()))) &&
            ((this.expiryDate==null && other.getExpiryDate()==null) || 
             (this.expiryDate!=null &&
              this.expiryDate.equals(other.getExpiryDate()))) &&
            this.numAuthentications == other.getNumAuthentications();
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        _hashCode += (isPrivateAddress() ? Boolean.TRUE : Boolean.FALSE).hashCode();
        if (getIPAddress() != null) {
            _hashCode += getIPAddress().hashCode();
        }
        if (getCountry() != null) {
            _hashCode += getCountry().hashCode();
        }
        if (getCountryName() != null) {
            _hashCode += getCountryName().hashCode();
        }
        if (getRegion() != null) {
            _hashCode += getRegion().hashCode();
        }
        if (getRegionName() != null) {
            _hashCode += getRegionName().hashCode();
        }
        if (getCity() != null) {
            _hashCode += getCity().hashCode();
        }
        if (getISP() != null) {
            _hashCode += getISP().hashCode();
        }
        if (getLatitude() != null) {
            _hashCode += getLatitude().hashCode();
        }
        if (getLongitude() != null) {
            _hashCode += getLongitude().hashCode();
        }
        if (getLastAuthentication() != null) {
            _hashCode += getLastAuthentication().hashCode();
        }
        if (getExpiryDate() != null) {
            _hashCode += getExpiryDate().hashCode();
        }
        _hashCode += getNumAuthentications();
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserLocation.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserLocation"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("privateAddress");
        elemField.setXmlName(new javax.xml.namespace.QName("", "privateAddress"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("IPAddress");
        elemField.setXmlName(new javax.xml.namespace.QName("", "IPAddress"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("country");
        elemField.setXmlName(new javax.xml.namespace.QName("", "country"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("countryName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "countryName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("region");
        elemField.setXmlName(new javax.xml.namespace.QName("", "region"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("regionName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "regionName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("city");
        elemField.setXmlName(new javax.xml.namespace.QName("", "city"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("ISP");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ISP"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("latitude");
        elemField.setXmlName(new javax.xml.namespace.QName("", "latitude"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "float"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("longitude");
        elemField.setXmlName(new javax.xml.namespace.QName("", "longitude"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "float"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("lastAuthentication");
        elemField.setXmlName(new javax.xml.namespace.QName("", "lastAuthentication"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expiryDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "expiryDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numAuthentications");
        elemField.setXmlName(new javax.xml.namespace.QName("", "numAuthentications"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
