/**
 * UserLockoutInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines information a user's lockout state.
 */
public class UserLockoutInfo  implements java.io.Serializable {
    /* The user ID of the user. */
    private String userid;

    /* The user name portion of the user ID. */
    private String userName;

    /* The group of the user. */
    private String group;

    /* The number of failed authentications
     *                                 remaining before the user is locked
     * out. A value
     *                                 of 0 indicates user is locked out.
     * A negative
     *                                 value indicates the user will never
     * be locked
     *                                 out due to failing authentication.
     * This value is
     *                                 based on the lockout mode policy.
     *                                 In GLOBAL lockout mode, this value
     * represents 
     *                                 the global lockout counter.
     *                                 In ALL_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout counter.
     *                                 In PER_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout counter. This value should
     * not be used, 
     *                                 rather the AuthenticatorLockout data
     * should be 
     *                                 used instead. */
    private int failureCount;

    /* The date on which the lockout will expire.
     *                                 The value is only meaningful if the
     * FailureCount is 0.  A value of Date(0) means
     *                                 the lockout will not expire (i.e.,
     * it must
     *                                 be cleared by an administrator). This
     * value 
     *                                 is based on the lockout mode policy.
     * In GLOBAL lockout mode, this value represents 
     *                                 the global lockout expiry date.
     *                                 In ALL_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the highest individual
     * authenticator 
     *                                 lockout expiry date.
     *                                 In PER_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout expiry date. This value should
     * not be 
     *                                 used, rather the AuthenticatorLockout
     * data
     *                                 should be used instead. */
    private java.util.Calendar lockoutDate;

    /* The authenticator lockout information. This 
     *                                 is only used with the ALL_AUTHENTICATOR
     * and 
     *                                 PER_AUTHENTICATOR lockout modes. */
    private AuthenticatorLockout[] authenticatorLockouts;

    public UserLockoutInfo() {
    }

    public UserLockoutInfo(
           String userid,
           String userName,
           String group,
           int failureCount,
           java.util.Calendar lockoutDate,
           AuthenticatorLockout[] authenticatorLockouts) {
           this.userid = userid;
           this.userName = userName;
           this.group = group;
           this.failureCount = failureCount;
           this.lockoutDate = lockoutDate;
           this.authenticatorLockouts = authenticatorLockouts;
    }


    /**
     * Gets the userid value for this UserLockoutInfo.
     * 
     * @return userid   * The user ID of the user.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserLockoutInfo.
     * 
     * @param userid   * The user ID of the user.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the userName value for this UserLockoutInfo.
     * 
     * @return userName   * The user name portion of the user ID.
     */
    public String getUserName() {
        return userName;
    }


    /**
     * Sets the userName value for this UserLockoutInfo.
     * 
     * @param userName   * The user name portion of the user ID.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }


    /**
     * Gets the group value for this UserLockoutInfo.
     * 
     * @return group   * The group of the user.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this UserLockoutInfo.
     * 
     * @param group   * The group of the user.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the failureCount value for this UserLockoutInfo.
     * 
     * @return failureCount   * The number of failed authentications
     *                                 remaining before the user is locked
     * out. A value
     *                                 of 0 indicates user is locked out.
     * A negative
     *                                 value indicates the user will never
     * be locked
     *                                 out due to failing authentication.
     * This value is
     *                                 based on the lockout mode policy.
     *                                 In GLOBAL lockout mode, this value
     * represents 
     *                                 the global lockout counter.
     *                                 In ALL_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout counter.
     *                                 In PER_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout counter. This value should
     * not be used, 
     *                                 rather the AuthenticatorLockout data
     * should be 
     *                                 used instead.
     */
    public int getFailureCount() {
        return failureCount;
    }


    /**
     * Sets the failureCount value for this UserLockoutInfo.
     * 
     * @param failureCount   * The number of failed authentications
     *                                 remaining before the user is locked
     * out. A value
     *                                 of 0 indicates user is locked out.
     * A negative
     *                                 value indicates the user will never
     * be locked
     *                                 out due to failing authentication.
     * This value is
     *                                 based on the lockout mode policy.
     *                                 In GLOBAL lockout mode, this value
     * represents 
     *                                 the global lockout counter.
     *                                 In ALL_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout counter.
     *                                 In PER_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout counter. This value should
     * not be used, 
     *                                 rather the AuthenticatorLockout data
     * should be 
     *                                 used instead.
     */
    public void setFailureCount(int failureCount) {
        this.failureCount = failureCount;
    }


    /**
     * Gets the lockoutDate value for this UserLockoutInfo.
     * 
     * @return lockoutDate   * The date on which the lockout will expire.
     *                                 The value is only meaningful if the
     * FailureCount is 0.  A value of Date(0) means
     *                                 the lockout will not expire (i.e.,
     * it must
     *                                 be cleared by an administrator). This
     * value 
     *                                 is based on the lockout mode policy.
     * In GLOBAL lockout mode, this value represents 
     *                                 the global lockout expiry date.
     *                                 In ALL_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the highest individual
     * authenticator 
     *                                 lockout expiry date.
     *                                 In PER_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout expiry date. This value should
     * not be 
     *                                 used, rather the AuthenticatorLockout
     * data
     *                                 should be used instead.
     */
    public java.util.Calendar getLockoutDate() {
        return lockoutDate;
    }


    /**
     * Sets the lockoutDate value for this UserLockoutInfo.
     * 
     * @param lockoutDate   * The date on which the lockout will expire.
     *                                 The value is only meaningful if the
     * FailureCount is 0.  A value of Date(0) means
     *                                 the lockout will not expire (i.e.,
     * it must
     *                                 be cleared by an administrator). This
     * value 
     *                                 is based on the lockout mode policy.
     * In GLOBAL lockout mode, this value represents 
     *                                 the global lockout expiry date.
     *                                 In ALL_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the highest individual
     * authenticator 
     *                                 lockout expiry date.
     *                                 In PER_AUTHENTICATOR lockout mode,
     * this value
     *                                 represents the lowest individual authenticator
     * 
     *                                 lockout expiry date. This value should
     * not be 
     *                                 used, rather the AuthenticatorLockout
     * data
     *                                 should be used instead.
     */
    public void setLockoutDate(java.util.Calendar lockoutDate) {
        this.lockoutDate = lockoutDate;
    }


    /**
     * Gets the authenticatorLockouts value for this UserLockoutInfo.
     * 
     * @return authenticatorLockouts   * The authenticator lockout information. This 
     *                                 is only used with the ALL_AUTHENTICATOR
     * and 
     *                                 PER_AUTHENTICATOR lockout modes.
     */
    public AuthenticatorLockout[] getAuthenticatorLockouts() {
        return authenticatorLockouts;
    }


    /**
     * Sets the authenticatorLockouts value for this UserLockoutInfo.
     * 
     * @param authenticatorLockouts   * The authenticator lockout information. This 
     *                                 is only used with the ALL_AUTHENTICATOR
     * and 
     *                                 PER_AUTHENTICATOR lockout modes.
     */
    public void setAuthenticatorLockouts(AuthenticatorLockout[] authenticatorLockouts) {
        this.authenticatorLockouts = authenticatorLockouts;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserLockoutInfo)) return false;
        UserLockoutInfo other = (UserLockoutInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.userName==null && other.getUserName()==null) || 
             (this.userName!=null &&
              this.userName.equals(other.getUserName()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            this.failureCount == other.getFailureCount() &&
            ((this.lockoutDate==null && other.getLockoutDate()==null) || 
             (this.lockoutDate!=null &&
              this.lockoutDate.equals(other.getLockoutDate()))) &&
            ((this.authenticatorLockouts==null && other.getAuthenticatorLockouts()==null) || 
             (this.authenticatorLockouts!=null &&
              java.util.Arrays.equals(this.authenticatorLockouts, other.getAuthenticatorLockouts())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getUserName() != null) {
            _hashCode += getUserName().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        _hashCode += getFailureCount();
        if (getLockoutDate() != null) {
            _hashCode += getLockoutDate().hashCode();
        }
        if (getAuthenticatorLockouts() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getAuthenticatorLockouts());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getAuthenticatorLockouts(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserLockoutInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserLockoutInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("failureCount");
        elemField.setXmlName(new javax.xml.namespace.QName("", "FailureCount"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("lockoutDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "LockoutDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("authenticatorLockouts");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AuthenticatorLockouts"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuthenticatorLockout"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
