/**
 * UserLockoutParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when creating or modifying
 *                         a user. All values can be null indicating
 * that the
 *                         default is used when creating a user, or the
 * value is
 *                         not changed when modifying a user.
 */
public class UserLockoutParms  implements java.io.Serializable {
    /* If set to true, clear the global and
     *                                 authenticator lockout counters of
     * the user. 
     *                                 If not specified, this value defaults
     * to false. */
    private Boolean clearlockout;

    /* If set to true, update the
     *                                 lockout counters of the user specified
     * by the AuthenticatorLockoutIds parameters.
     *                                 I.e., this argument can be used by
     * an
     *                                 administration application to lockout
     * a user.
     *                                 If not specified, this value defaults
     * to false.
     *                                 This parameter is ignored if Clearlockout
     * is set to true. */
    private Boolean increaseLockout;

    /* Restricts the authenticator lockout counters 
     *                                 that are updated when the Clearlockout
     * 
     *                                 or IncreaseLockout options
     *                                 are set to true. Only the authenticator
     * lockout
     *                                 counters associated with the specified
     * 
     *                                 authenticators supplied here are updated
     * for 
     *                                 the user. If no values are present,
     * i.e.,  
     *                                 this option is not set or an an empty
     * array 
     *                                 is used, then all lockout counters
     * are 
     *                                 updated. This option only applies
     * to the 
     *                                 authenticator lockout counters. Therefore
     * the 
     *                                 global lockout counter is always updated. */
    private AuthenticatorLockoutId[] authenticatorLockoutIds;

    public UserLockoutParms() {
    }

    public UserLockoutParms(
           Boolean clearlockout,
           Boolean increaseLockout,
           AuthenticatorLockoutId[] authenticatorLockoutIds) {
           this.clearlockout = clearlockout;
           this.increaseLockout = increaseLockout;
           this.authenticatorLockoutIds = authenticatorLockoutIds;
    }


    /**
     * Gets the clearlockout value for this UserLockoutParms.
     * 
     * @return clearlockout   * If set to true, clear the global and
     *                                 authenticator lockout counters of
     * the user. 
     *                                 If not specified, this value defaults
     * to false.
     */
    public Boolean getClearlockout() {
        return clearlockout;
    }


    /**
     * Sets the clearlockout value for this UserLockoutParms.
     * 
     * @param clearlockout   * If set to true, clear the global and
     *                                 authenticator lockout counters of
     * the user. 
     *                                 If not specified, this value defaults
     * to false.
     */
    public void setClearlockout(Boolean clearlockout) {
        this.clearlockout = clearlockout;
    }


    /**
     * Gets the increaseLockout value for this UserLockoutParms.
     * 
     * @return increaseLockout   * If set to true, update the
     *                                 lockout counters of the user specified
     * by the AuthenticatorLockoutIds parameters.
     *                                 I.e., this argument can be used by
     * an
     *                                 administration application to lockout
     * a user.
     *                                 If not specified, this value defaults
     * to false.
     *                                 This parameter is ignored if Clearlockout
     * is set to true.
     */
    public Boolean getIncreaseLockout() {
        return increaseLockout;
    }


    /**
     * Sets the increaseLockout value for this UserLockoutParms.
     * 
     * @param increaseLockout   * If set to true, update the
     *                                 lockout counters of the user specified
     * by the AuthenticatorLockoutIds parameters.
     *                                 I.e., this argument can be used by
     * an
     *                                 administration application to lockout
     * a user.
     *                                 If not specified, this value defaults
     * to false.
     *                                 This parameter is ignored if Clearlockout
     * is set to true.
     */
    public void setIncreaseLockout(Boolean increaseLockout) {
        this.increaseLockout = increaseLockout;
    }


    /**
     * Gets the authenticatorLockoutIds value for this UserLockoutParms.
     * 
     * @return authenticatorLockoutIds   * Restricts the authenticator lockout counters 
     *                                 that are updated when the Clearlockout
     * 
     *                                 or IncreaseLockout options
     *                                 are set to true. Only the authenticator
     * lockout
     *                                 counters associated with the specified
     * 
     *                                 authenticators supplied here are updated
     * for 
     *                                 the user. If no values are present,
     * i.e.,  
     *                                 this option is not set or an an empty
     * array 
     *                                 is used, then all lockout counters
     * are 
     *                                 updated. This option only applies
     * to the 
     *                                 authenticator lockout counters. Therefore
     * the 
     *                                 global lockout counter is always updated.
     */
    public AuthenticatorLockoutId[] getAuthenticatorLockoutIds() {
        return authenticatorLockoutIds;
    }


    /**
     * Sets the authenticatorLockoutIds value for this UserLockoutParms.
     * 
     * @param authenticatorLockoutIds   * Restricts the authenticator lockout counters 
     *                                 that are updated when the Clearlockout
     * 
     *                                 or IncreaseLockout options
     *                                 are set to true. Only the authenticator
     * lockout
     *                                 counters associated with the specified
     * 
     *                                 authenticators supplied here are updated
     * for 
     *                                 the user. If no values are present,
     * i.e.,  
     *                                 this option is not set or an an empty
     * array 
     *                                 is used, then all lockout counters
     * are 
     *                                 updated. This option only applies
     * to the 
     *                                 authenticator lockout counters. Therefore
     * the 
     *                                 global lockout counter is always updated.
     */
    public void setAuthenticatorLockoutIds(AuthenticatorLockoutId[] authenticatorLockoutIds) {
        this.authenticatorLockoutIds = authenticatorLockoutIds;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserLockoutParms)) return false;
        UserLockoutParms other = (UserLockoutParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.clearlockout==null && other.getClearlockout()==null) || 
             (this.clearlockout!=null &&
              this.clearlockout.equals(other.getClearlockout()))) &&
            ((this.increaseLockout==null && other.getIncreaseLockout()==null) || 
             (this.increaseLockout!=null &&
              this.increaseLockout.equals(other.getIncreaseLockout()))) &&
            ((this.authenticatorLockoutIds==null && other.getAuthenticatorLockoutIds()==null) || 
             (this.authenticatorLockoutIds!=null &&
              java.util.Arrays.equals(this.authenticatorLockoutIds, other.getAuthenticatorLockoutIds())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getClearlockout() != null) {
            _hashCode += getClearlockout().hashCode();
        }
        if (getIncreaseLockout() != null) {
            _hashCode += getIncreaseLockout().hashCode();
        }
        if (getAuthenticatorLockoutIds() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getAuthenticatorLockoutIds());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getAuthenticatorLockoutIds(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserLockoutParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserLockoutParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("clearlockout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Clearlockout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("increaseLockout");
        elemField.setXmlName(new javax.xml.namespace.QName("", "IncreaseLockout"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("authenticatorLockoutIds");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AuthenticatorLockoutIds"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "AuthenticatorLockoutId"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
