/**
 * UserOTPParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when creating or modifying
 *                         a user's one-time password (OTP).  All values
 * can be null,
 *                         indicating that the default is used for create
 * or the value
 *                         is not changed for modify.
 */
public class UserOTPParms  implements java.io.Serializable {
    /* If true for OTP create, indicates an existing OTP is
     *                                 replaced. Otherwise, an existing OTP
     * results in
     *                                 an error. */
    private Boolean force;

    /* The lifetime of the OTP in milliseconds. The
     *                                 value must be a non-negative integer.
     * If set
     *                                 to 0, the OTP is valid until it is
     * used. */
    private Long lifetime;

    /* Used by userOTPDeliver.  If set to true, the
     *                                 user's OTPs are delivered to the user's
     * default contact. */
    private Boolean useDefaultDelivery;

    /* Used by userOTPDeliver.  If useDefaultDelivery
     *                                 is not set to true, the user's OTPs
     * are
     *                                 delivered to the contacts specified
     * by this
     *                                 value. */
    private String[] contactInfoLabel;

    public UserOTPParms() {
    }

    public UserOTPParms(
           Boolean force,
           Long lifetime,
           Boolean useDefaultDelivery,
           String[] contactInfoLabel) {
           this.force = force;
           this.lifetime = lifetime;
           this.useDefaultDelivery = useDefaultDelivery;
           this.contactInfoLabel = contactInfoLabel;
    }


    /**
     * Gets the force value for this UserOTPParms.
     * 
     * @return force   * If true for OTP create, indicates an existing OTP is
     *                                 replaced. Otherwise, an existing OTP
     * results in
     *                                 an error.
     */
    public Boolean getForce() {
        return force;
    }


    /**
     * Sets the force value for this UserOTPParms.
     * 
     * @param force   * If true for OTP create, indicates an existing OTP is
     *                                 replaced. Otherwise, an existing OTP
     * results in
     *                                 an error.
     */
    public void setForce(Boolean force) {
        this.force = force;
    }


    /**
     * Gets the lifetime value for this UserOTPParms.
     * 
     * @return lifetime   * The lifetime of the OTP in milliseconds. The
     *                                 value must be a non-negative integer.
     * If set
     *                                 to 0, the OTP is valid until it is
     * used.
     */
    public Long getLifetime() {
        return lifetime;
    }


    /**
     * Sets the lifetime value for this UserOTPParms.
     * 
     * @param lifetime   * The lifetime of the OTP in milliseconds. The
     *                                 value must be a non-negative integer.
     * If set
     *                                 to 0, the OTP is valid until it is
     * used.
     */
    public void setLifetime(Long lifetime) {
        this.lifetime = lifetime;
    }


    /**
     * Gets the useDefaultDelivery value for this UserOTPParms.
     * 
     * @return useDefaultDelivery   * Used by userOTPDeliver.  If set to true, the
     *                                 user's OTPs are delivered to the user's
     * default contact.
     */
    public Boolean getUseDefaultDelivery() {
        return useDefaultDelivery;
    }


    /**
     * Sets the useDefaultDelivery value for this UserOTPParms.
     * 
     * @param useDefaultDelivery   * Used by userOTPDeliver.  If set to true, the
     *                                 user's OTPs are delivered to the user's
     * default contact.
     */
    public void setUseDefaultDelivery(Boolean useDefaultDelivery) {
        this.useDefaultDelivery = useDefaultDelivery;
    }


    /**
     * Gets the contactInfoLabel value for this UserOTPParms.
     * 
     * @return contactInfoLabel   * Used by userOTPDeliver.  If useDefaultDelivery
     *                                 is not set to true, the user's OTPs
     * are
     *                                 delivered to the contacts specified
     * by this
     *                                 value.
     */
    public String[] getContactInfoLabel() {
        return contactInfoLabel;
    }


    /**
     * Sets the contactInfoLabel value for this UserOTPParms.
     * 
     * @param contactInfoLabel   * Used by userOTPDeliver.  If useDefaultDelivery
     *                                 is not set to true, the user's OTPs
     * are
     *                                 delivered to the contacts specified
     * by this
     *                                 value.
     */
    public void setContactInfoLabel(String[] contactInfoLabel) {
        this.contactInfoLabel = contactInfoLabel;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserOTPParms)) return false;
        UserOTPParms other = (UserOTPParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.force==null && other.getForce()==null) || 
             (this.force!=null &&
              this.force.equals(other.getForce()))) &&
            ((this.lifetime==null && other.getLifetime()==null) || 
             (this.lifetime!=null &&
              this.lifetime.equals(other.getLifetime()))) &&
            ((this.useDefaultDelivery==null && other.getUseDefaultDelivery()==null) || 
             (this.useDefaultDelivery!=null &&
              this.useDefaultDelivery.equals(other.getUseDefaultDelivery()))) &&
            ((this.contactInfoLabel==null && other.getContactInfoLabel()==null) || 
             (this.contactInfoLabel!=null &&
              java.util.Arrays.equals(this.contactInfoLabel, other.getContactInfoLabel())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getForce() != null) {
            _hashCode += getForce().hashCode();
        }
        if (getLifetime() != null) {
            _hashCode += getLifetime().hashCode();
        }
        if (getUseDefaultDelivery() != null) {
            _hashCode += getUseDefaultDelivery().hashCode();
        }
        if (getContactInfoLabel() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getContactInfoLabel());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getContactInfoLabel(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserOTPParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserOTPParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("force");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Force"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("lifetime");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Lifetime"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("useDefaultDelivery");
        elemField.setXmlName(new javax.xml.namespace.QName("", "useDefaultDelivery"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("contactInfoLabel");
        elemField.setXmlName(new javax.xml.namespace.QName("", "contactInfoLabel"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
