/**
 * UserPINInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned when querying a user PIN.
 */
public class UserPINInfo  implements java.io.Serializable {
    /* The user ID that owns the PIN. */
    private String userid;

    /* The user name of the user ID that owns the PIN. */
    private String userName;

    /* The group of the user ID that owns the PIN. */
    private String group;

    /* The number of uses remaining for the PIN. A value
     *                                 less than 0 indicates infinite uses. */
    private int numUses;

    /* The date the PIN was created. */
    private java.util.Calendar createDate;

    /* The date the PIN will expire. A value of Date(0)
     *                                 indicates the PIN doesn't have an
     * expiry date. */
    private java.util.Calendar expireDate;

    /* The value of the PIN. */
    private String[] PIN;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    /* The comment for the PIN. */
    private String comment;

    public UserPINInfo() {
    }

    public UserPINInfo(
           String userid,
           String userName,
           String group,
           int numUses,
           java.util.Calendar createDate,
           java.util.Calendar expireDate,
           String[] PIN,
           String[] rolesGrantingAccess,
           String comment) {
           this.userid = userid;
           this.userName = userName;
           this.group = group;
           this.numUses = numUses;
           this.createDate = createDate;
           this.expireDate = expireDate;
           this.PIN = PIN;
           this.rolesGrantingAccess = rolesGrantingAccess;
           this.comment = comment;
    }


    /**
     * Gets the userid value for this UserPINInfo.
     * 
     * @return userid   * The user ID that owns the PIN.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserPINInfo.
     * 
     * @param userid   * The user ID that owns the PIN.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the userName value for this UserPINInfo.
     * 
     * @return userName   * The user name of the user ID that owns the PIN.
     */
    public String getUserName() {
        return userName;
    }


    /**
     * Sets the userName value for this UserPINInfo.
     * 
     * @param userName   * The user name of the user ID that owns the PIN.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }


    /**
     * Gets the group value for this UserPINInfo.
     * 
     * @return group   * The group of the user ID that owns the PIN.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this UserPINInfo.
     * 
     * @param group   * The group of the user ID that owns the PIN.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the numUses value for this UserPINInfo.
     * 
     * @return numUses   * The number of uses remaining for the PIN. A value
     *                                 less than 0 indicates infinite uses.
     */
    public int getNumUses() {
        return numUses;
    }


    /**
     * Sets the numUses value for this UserPINInfo.
     * 
     * @param numUses   * The number of uses remaining for the PIN. A value
     *                                 less than 0 indicates infinite uses.
     */
    public void setNumUses(int numUses) {
        this.numUses = numUses;
    }


    /**
     * Gets the createDate value for this UserPINInfo.
     * 
     * @return createDate   * The date the PIN was created.
     */
    public java.util.Calendar getCreateDate() {
        return createDate;
    }


    /**
     * Sets the createDate value for this UserPINInfo.
     * 
     * @param createDate   * The date the PIN was created.
     */
    public void setCreateDate(java.util.Calendar createDate) {
        this.createDate = createDate;
    }


    /**
     * Gets the expireDate value for this UserPINInfo.
     * 
     * @return expireDate   * The date the PIN will expire. A value of Date(0)
     *                                 indicates the PIN doesn't have an
     * expiry date.
     */
    public java.util.Calendar getExpireDate() {
        return expireDate;
    }


    /**
     * Sets the expireDate value for this UserPINInfo.
     * 
     * @param expireDate   * The date the PIN will expire. A value of Date(0)
     *                                 indicates the PIN doesn't have an
     * expiry date.
     */
    public void setExpireDate(java.util.Calendar expireDate) {
        this.expireDate = expireDate;
    }


    /**
     * Gets the PIN value for this UserPINInfo.
     * 
     * @return PIN   * The value of the PIN.
     */
    public String[] getPIN() {
        return PIN;
    }


    /**
     * Sets the PIN value for this UserPINInfo.
     * 
     * @param PIN   * The value of the PIN.
     */
    public void setPIN(String[] PIN) {
        this.PIN = PIN;
    }


    /**
     * Gets the rolesGrantingAccess value for this UserPINInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this UserPINInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the comment value for this UserPINInfo.
     * 
     * @return comment   * The comment for the PIN.
     */
    public String getComment() {
        return comment;
    }


    /**
     * Sets the comment value for this UserPINInfo.
     * 
     * @param comment   * The comment for the PIN.
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserPINInfo)) return false;
        UserPINInfo other = (UserPINInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.userName==null && other.getUserName()==null) || 
             (this.userName!=null &&
              this.userName.equals(other.getUserName()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            this.numUses == other.getNumUses() &&
            ((this.createDate==null && other.getCreateDate()==null) || 
             (this.createDate!=null &&
              this.createDate.equals(other.getCreateDate()))) &&
            ((this.expireDate==null && other.getExpireDate()==null) || 
             (this.expireDate!=null &&
              this.expireDate.equals(other.getExpireDate()))) &&
            ((this.PIN==null && other.getPIN()==null) || 
             (this.PIN!=null &&
              java.util.Arrays.equals(this.PIN, other.getPIN()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess()))) &&
            ((this.comment==null && other.getComment()==null) || 
             (this.comment!=null &&
              this.comment.equals(other.getComment())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getUserName() != null) {
            _hashCode += getUserName().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        _hashCode += getNumUses();
        if (getCreateDate() != null) {
            _hashCode += getCreateDate().hashCode();
        }
        if (getExpireDate() != null) {
            _hashCode += getExpireDate().hashCode();
        }
        if (getPIN() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getPIN());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getPIN(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getComment() != null) {
            _hashCode += getComment().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserPINInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserPINInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("numUses");
        elemField.setXmlName(new javax.xml.namespace.QName("", "NumUses"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("createDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "CreateDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expireDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ExpireDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("PIN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PIN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("comment");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Comment"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
