/**
 * UserPVNCreateParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when creating
 *                         a user's personal verification number (PVN).
 * Either PVN or AutoGenerate must be specified.
 *                         The ChangeRequired flag may be specified.
 */
public class UserPVNCreateParms  implements java.io.Serializable {
    /* The new PVN value to assign to the user.
     *                                 This value must be numeric, and must
     * obey
     *                                 the PVN Length rule as defined by
     * policy.
     *                                 If using AutoGenerate, leave this
     * as null. */
    private String PVN;

    /* If true, indicates a random PVN value should
     *                                 be generated and assigned to the user.
     * If specifying the PVN value, leave this as null. */
    private Boolean autoGenerate;

    /* If true, indicates that the user will be required
     *                                 to change their PVN value. If false,
     * indicates
     *                                 that the user will not be required
     * to change their
     *                                 PVN value. Note that the policy may
     * not allow
     *                                 setting this value to false.
     *                                 If left as null, the user will be
     *                                 required to change their PVN. */
    private Boolean changeRequired;

    public UserPVNCreateParms() {
    }

    public UserPVNCreateParms(
           String PVN,
           Boolean autoGenerate,
           Boolean changeRequired) {
           this.PVN = PVN;
           this.autoGenerate = autoGenerate;
           this.changeRequired = changeRequired;
    }


    /**
     * Gets the PVN value for this UserPVNCreateParms.
     * 
     * @return PVN   * The new PVN value to assign to the user.
     *                                 This value must be numeric, and must
     * obey
     *                                 the PVN Length rule as defined by
     * policy.
     *                                 If using AutoGenerate, leave this
     * as null.
     */
    public String getPVN() {
        return PVN;
    }


    /**
     * Sets the PVN value for this UserPVNCreateParms.
     * 
     * @param PVN   * The new PVN value to assign to the user.
     *                                 This value must be numeric, and must
     * obey
     *                                 the PVN Length rule as defined by
     * policy.
     *                                 If using AutoGenerate, leave this
     * as null.
     */
    public void setPVN(String PVN) {
        this.PVN = PVN;
    }


    /**
     * Gets the autoGenerate value for this UserPVNCreateParms.
     * 
     * @return autoGenerate   * If true, indicates a random PVN value should
     *                                 be generated and assigned to the user.
     * If specifying the PVN value, leave this as null.
     */
    public Boolean getAutoGenerate() {
        return autoGenerate;
    }


    /**
     * Sets the autoGenerate value for this UserPVNCreateParms.
     * 
     * @param autoGenerate   * If true, indicates a random PVN value should
     *                                 be generated and assigned to the user.
     * If specifying the PVN value, leave this as null.
     */
    public void setAutoGenerate(Boolean autoGenerate) {
        this.autoGenerate = autoGenerate;
    }


    /**
     * Gets the changeRequired value for this UserPVNCreateParms.
     * 
     * @return changeRequired   * If true, indicates that the user will be required
     *                                 to change their PVN value. If false,
     * indicates
     *                                 that the user will not be required
     * to change their
     *                                 PVN value. Note that the policy may
     * not allow
     *                                 setting this value to false.
     *                                 If left as null, the user will be
     *                                 required to change their PVN.
     */
    public Boolean getChangeRequired() {
        return changeRequired;
    }


    /**
     * Sets the changeRequired value for this UserPVNCreateParms.
     * 
     * @param changeRequired   * If true, indicates that the user will be required
     *                                 to change their PVN value. If false,
     * indicates
     *                                 that the user will not be required
     * to change their
     *                                 PVN value. Note that the policy may
     * not allow
     *                                 setting this value to false.
     *                                 If left as null, the user will be
     *                                 required to change their PVN.
     */
    public void setChangeRequired(Boolean changeRequired) {
        this.changeRequired = changeRequired;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserPVNCreateParms)) return false;
        UserPVNCreateParms other = (UserPVNCreateParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.PVN==null && other.getPVN()==null) || 
             (this.PVN!=null &&
              this.PVN.equals(other.getPVN()))) &&
            ((this.autoGenerate==null && other.getAutoGenerate()==null) || 
             (this.autoGenerate!=null &&
              this.autoGenerate.equals(other.getAutoGenerate()))) &&
            ((this.changeRequired==null && other.getChangeRequired()==null) || 
             (this.changeRequired!=null &&
              this.changeRequired.equals(other.getChangeRequired())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getPVN() != null) {
            _hashCode += getPVN().hashCode();
        }
        if (getAutoGenerate() != null) {
            _hashCode += getAutoGenerate().hashCode();
        }
        if (getChangeRequired() != null) {
            _hashCode += getChangeRequired().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserPVNCreateParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserPVNCreateParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("PVN");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PVN"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("autoGenerate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "AutoGenerate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("changeRequired");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ChangeRequired"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
