/**
 * UserPasswordInfo.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the information returned when querying a user Password.
 */
public class UserPasswordInfo  implements java.io.Serializable {
    /* The user ID that owns the Password. */
    private String userid;

    /* The user name of the user ID that owns the Password. */
    private String userName;

    /* The group of the user ID that owns the Password. */
    private String group;

    /* The name of the password.  The default password
     *                                 will have a null value. */
    private String passwordName;

    /* The method used to encode this password in the repository. */
    private PasswordStorage passwordStorage;

    /* The retrievable password returned if available and
     *                                 proper permissions granted to admin. */
    private String retrievablePassword;

    /* The date the Password was last changed. */
    private java.util.Calendar lastChangeDate;

    /* The date the Password will expire. A value of Date(0)
     *                                 indicates the Password doesn't have
     * an expiry date. */
    private java.util.Calendar expireDate;

    /* Indicates if a password change is required. */
    private Boolean changeRequired;

    /* Indicates if a password change is required but
     *                                 the user hasn't changed the password
     * within
     *                                 the time specified by policy.  This
     * value will
     *                                 only be meaningful if ChangeRequired
     * is true. */
    private Boolean changeExpired;

    /* The number of password values stored in the history. */
    private Integer historySize;

    /* A flag indicating if this user password is
     *                                 an imported password.  For imported
     * passwords,
     *                                 this flag will be set to false once
     * the
     *                                 password has been converted to an
     * 
     *                                 Entrust IdentityGuard password after
     * the first
     *                                 successful authentication. */
    private Boolean imported;

    /* When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure. */
    private String[] rolesGrantingAccess;

    public UserPasswordInfo() {
    }

    public UserPasswordInfo(
           String userid,
           String userName,
           String group,
           String passwordName,
           PasswordStorage passwordStorage,
           String retrievablePassword,
           java.util.Calendar lastChangeDate,
           java.util.Calendar expireDate,
           Boolean changeRequired,
           Boolean changeExpired,
           Integer historySize,
           Boolean imported,
           String[] rolesGrantingAccess) {
           this.userid = userid;
           this.userName = userName;
           this.group = group;
           this.passwordName = passwordName;
           this.passwordStorage = passwordStorage;
           this.retrievablePassword = retrievablePassword;
           this.lastChangeDate = lastChangeDate;
           this.expireDate = expireDate;
           this.changeRequired = changeRequired;
           this.changeExpired = changeExpired;
           this.historySize = historySize;
           this.imported = imported;
           this.rolesGrantingAccess = rolesGrantingAccess;
    }


    /**
     * Gets the userid value for this UserPasswordInfo.
     * 
     * @return userid   * The user ID that owns the Password.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserPasswordInfo.
     * 
     * @param userid   * The user ID that owns the Password.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the userName value for this UserPasswordInfo.
     * 
     * @return userName   * The user name of the user ID that owns the Password.
     */
    public String getUserName() {
        return userName;
    }


    /**
     * Sets the userName value for this UserPasswordInfo.
     * 
     * @param userName   * The user name of the user ID that owns the Password.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }


    /**
     * Gets the group value for this UserPasswordInfo.
     * 
     * @return group   * The group of the user ID that owns the Password.
     */
    public String getGroup() {
        return group;
    }


    /**
     * Sets the group value for this UserPasswordInfo.
     * 
     * @param group   * The group of the user ID that owns the Password.
     */
    public void setGroup(String group) {
        this.group = group;
    }


    /**
     * Gets the passwordName value for this UserPasswordInfo.
     * 
     * @return passwordName   * The name of the password.  The default password
     *                                 will have a null value.
     */
    public String getPasswordName() {
        return passwordName;
    }


    /**
     * Sets the passwordName value for this UserPasswordInfo.
     * 
     * @param passwordName   * The name of the password.  The default password
     *                                 will have a null value.
     */
    public void setPasswordName(String passwordName) {
        this.passwordName = passwordName;
    }


    /**
     * Gets the passwordStorage value for this UserPasswordInfo.
     * 
     * @return passwordStorage   * The method used to encode this password in the repository.
     */
    public PasswordStorage getPasswordStorage() {
        return passwordStorage;
    }


    /**
     * Sets the passwordStorage value for this UserPasswordInfo.
     * 
     * @param passwordStorage   * The method used to encode this password in the repository.
     */
    public void setPasswordStorage(PasswordStorage passwordStorage) {
        this.passwordStorage = passwordStorage;
    }


    /**
     * Gets the retrievablePassword value for this UserPasswordInfo.
     * 
     * @return retrievablePassword   * The retrievable password returned if available and
     *                                 proper permissions granted to admin.
     */
    public String getRetrievablePassword() {
        return retrievablePassword;
    }


    /**
     * Sets the retrievablePassword value for this UserPasswordInfo.
     * 
     * @param retrievablePassword   * The retrievable password returned if available and
     *                                 proper permissions granted to admin.
     */
    public void setRetrievablePassword(String retrievablePassword) {
        this.retrievablePassword = retrievablePassword;
    }


    /**
     * Gets the lastChangeDate value for this UserPasswordInfo.
     * 
     * @return lastChangeDate   * The date the Password was last changed.
     */
    public java.util.Calendar getLastChangeDate() {
        return lastChangeDate;
    }


    /**
     * Sets the lastChangeDate value for this UserPasswordInfo.
     * 
     * @param lastChangeDate   * The date the Password was last changed.
     */
    public void setLastChangeDate(java.util.Calendar lastChangeDate) {
        this.lastChangeDate = lastChangeDate;
    }


    /**
     * Gets the expireDate value for this UserPasswordInfo.
     * 
     * @return expireDate   * The date the Password will expire. A value of Date(0)
     *                                 indicates the Password doesn't have
     * an expiry date.
     */
    public java.util.Calendar getExpireDate() {
        return expireDate;
    }


    /**
     * Sets the expireDate value for this UserPasswordInfo.
     * 
     * @param expireDate   * The date the Password will expire. A value of Date(0)
     *                                 indicates the Password doesn't have
     * an expiry date.
     */
    public void setExpireDate(java.util.Calendar expireDate) {
        this.expireDate = expireDate;
    }


    /**
     * Gets the changeRequired value for this UserPasswordInfo.
     * 
     * @return changeRequired   * Indicates if a password change is required.
     */
    public Boolean getChangeRequired() {
        return changeRequired;
    }


    /**
     * Sets the changeRequired value for this UserPasswordInfo.
     * 
     * @param changeRequired   * Indicates if a password change is required.
     */
    public void setChangeRequired(Boolean changeRequired) {
        this.changeRequired = changeRequired;
    }


    /**
     * Gets the changeExpired value for this UserPasswordInfo.
     * 
     * @return changeExpired   * Indicates if a password change is required but
     *                                 the user hasn't changed the password
     * within
     *                                 the time specified by policy.  This
     * value will
     *                                 only be meaningful if ChangeRequired
     * is true.
     */
    public Boolean getChangeExpired() {
        return changeExpired;
    }


    /**
     * Sets the changeExpired value for this UserPasswordInfo.
     * 
     * @param changeExpired   * Indicates if a password change is required but
     *                                 the user hasn't changed the password
     * within
     *                                 the time specified by policy.  This
     * value will
     *                                 only be meaningful if ChangeRequired
     * is true.
     */
    public void setChangeExpired(Boolean changeExpired) {
        this.changeExpired = changeExpired;
    }


    /**
     * Gets the historySize value for this UserPasswordInfo.
     * 
     * @return historySize   * The number of password values stored in the history.
     */
    public Integer getHistorySize() {
        return historySize;
    }


    /**
     * Sets the historySize value for this UserPasswordInfo.
     * 
     * @param historySize   * The number of password values stored in the history.
     */
    public void setHistorySize(Integer historySize) {
        this.historySize = historySize;
    }


    /**
     * Gets the imported value for this UserPasswordInfo.
     * 
     * @return imported   * A flag indicating if this user password is
     *                                 an imported password.  For imported
     * passwords,
     *                                 this flag will be set to false once
     * the
     *                                 password has been converted to an
     * 
     *                                 Entrust IdentityGuard password after
     * the first
     *                                 successful authentication.
     */
    public Boolean getImported() {
        return imported;
    }


    /**
     * Sets the imported value for this UserPasswordInfo.
     * 
     * @param imported   * A flag indicating if this user password is
     *                                 an imported password.  For imported
     * passwords,
     *                                 this flag will be set to false once
     * the
     *                                 password has been converted to an
     * 
     *                                 Entrust IdentityGuard password after
     * the first
     *                                 successful authentication.
     */
    public void setImported(Boolean imported) {
        this.imported = imported;
    }


    /**
     * Gets the rolesGrantingAccess value for this UserPasswordInfo.
     * 
     * @return rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public String[] getRolesGrantingAccess() {
        return rolesGrantingAccess;
    }


    /**
     * Sets the rolesGrantingAccess value for this UserPasswordInfo.
     * 
     * @param rolesGrantingAccess   * When this structure is returned by an admin
     *                                 service operation, this is the list
     * of the
     *                                 names of the roles that granted access
     * to this
     *                                 structure.
     */
    public void setRolesGrantingAccess(String[] rolesGrantingAccess) {
        this.rolesGrantingAccess = rolesGrantingAccess;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserPasswordInfo)) return false;
        UserPasswordInfo other = (UserPasswordInfo) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.userName==null && other.getUserName()==null) || 
             (this.userName!=null &&
              this.userName.equals(other.getUserName()))) &&
            ((this.group==null && other.getGroup()==null) || 
             (this.group!=null &&
              this.group.equals(other.getGroup()))) &&
            ((this.passwordName==null && other.getPasswordName()==null) || 
             (this.passwordName!=null &&
              this.passwordName.equals(other.getPasswordName()))) &&
            ((this.passwordStorage==null && other.getPasswordStorage()==null) || 
             (this.passwordStorage!=null &&
              this.passwordStorage.equals(other.getPasswordStorage()))) &&
            ((this.retrievablePassword==null && other.getRetrievablePassword()==null) || 
             (this.retrievablePassword!=null &&
              this.retrievablePassword.equals(other.getRetrievablePassword()))) &&
            ((this.lastChangeDate==null && other.getLastChangeDate()==null) || 
             (this.lastChangeDate!=null &&
              this.lastChangeDate.equals(other.getLastChangeDate()))) &&
            ((this.expireDate==null && other.getExpireDate()==null) || 
             (this.expireDate!=null &&
              this.expireDate.equals(other.getExpireDate()))) &&
            ((this.changeRequired==null && other.getChangeRequired()==null) || 
             (this.changeRequired!=null &&
              this.changeRequired.equals(other.getChangeRequired()))) &&
            ((this.changeExpired==null && other.getChangeExpired()==null) || 
             (this.changeExpired!=null &&
              this.changeExpired.equals(other.getChangeExpired()))) &&
            ((this.historySize==null && other.getHistorySize()==null) || 
             (this.historySize!=null &&
              this.historySize.equals(other.getHistorySize()))) &&
            ((this.imported==null && other.getImported()==null) || 
             (this.imported!=null &&
              this.imported.equals(other.getImported()))) &&
            ((this.rolesGrantingAccess==null && other.getRolesGrantingAccess()==null) || 
             (this.rolesGrantingAccess!=null &&
              java.util.Arrays.equals(this.rolesGrantingAccess, other.getRolesGrantingAccess())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getUserName() != null) {
            _hashCode += getUserName().hashCode();
        }
        if (getGroup() != null) {
            _hashCode += getGroup().hashCode();
        }
        if (getPasswordName() != null) {
            _hashCode += getPasswordName().hashCode();
        }
        if (getPasswordStorage() != null) {
            _hashCode += getPasswordStorage().hashCode();
        }
        if (getRetrievablePassword() != null) {
            _hashCode += getRetrievablePassword().hashCode();
        }
        if (getLastChangeDate() != null) {
            _hashCode += getLastChangeDate().hashCode();
        }
        if (getExpireDate() != null) {
            _hashCode += getExpireDate().hashCode();
        }
        if (getChangeRequired() != null) {
            _hashCode += getChangeRequired().hashCode();
        }
        if (getChangeExpired() != null) {
            _hashCode += getChangeExpired().hashCode();
        }
        if (getHistorySize() != null) {
            _hashCode += getHistorySize().hashCode();
        }
        if (getImported() != null) {
            _hashCode += getImported().hashCode();
        }
        if (getRolesGrantingAccess() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getRolesGrantingAccess());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getRolesGrantingAccess(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserPasswordInfo.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserPasswordInfo"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "UserName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("group");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Group"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("passwordName");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PasswordName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("passwordStorage");
        elemField.setXmlName(new javax.xml.namespace.QName("", "PasswordStorage"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "PasswordStorage"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("retrievablePassword");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RetrievablePassword"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("lastChangeDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "LastChangeDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("expireDate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ExpireDate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "dateTime"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("changeRequired");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ChangeRequired"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("changeExpired");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ChangeExpired"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("historySize");
        elemField.setXmlName(new javax.xml.namespace.QName("", "HistorySize"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "int"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("imported");
        elemField.setXmlName(new javax.xml.namespace.QName("", "Imported"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("rolesGrantingAccess");
        elemField.setXmlName(new javax.xml.namespace.QName("", "RolesGrantingAccess"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
