/**
 * UserSmartCredentialSignParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when using a smart
 *                      credential to sign a given digest.
 */
public class UserSmartCredentialSignParms  implements java.io.Serializable {
    /* The hash algorithm used to generate the digest.
     *                            Allowed values are SHA-1, SHA-224, SHA-256,
     * SHA-384
     *                            and SHA-512. */
    private String digestHashAlg;

    /* The base-64 encoded digest to be signed. */
    private String digest;

    /* A summary describing the information that is
     *                            being signed. */
    private String summary;

    /* A URL that will be called by Entrust IdentityGuard
     *                            when a response is ready for the signature.
     * After receiving the callback the client should
     *                            call userSmartCredentialSignComplete to
     * retrieve
     *                            the signature.
     *                            If the URL value includes the token <STATUS>
     * it will be replaced with one of the values CONFIRM,
     *                            CONCERN or CANCEL indicating the status
     * of the
     *                            operation.
     *                            If the URL value includes the token
     *                            <TRANSACTIONID> it will be replaced with
     * the
     *                            transaction Id of the transaction.
     *                            If the URL is not provided, the client
     * application
     *                            can poll Entrust Identity for a response
     * by
     *                            repeatedly calling userSmartCredentialSignComplete. */
    private String callback;

    public UserSmartCredentialSignParms() {
    }

    public UserSmartCredentialSignParms(
           String digestHashAlg,
           String digest,
           String summary,
           String callback) {
           this.digestHashAlg = digestHashAlg;
           this.digest = digest;
           this.summary = summary;
           this.callback = callback;
    }


    /**
     * Gets the digestHashAlg value for this UserSmartCredentialSignParms.
     * 
     * @return digestHashAlg   * The hash algorithm used to generate the digest.
     *                            Allowed values are SHA-1, SHA-224, SHA-256,
     * SHA-384
     *                            and SHA-512.
     */
    public String getDigestHashAlg() {
        return digestHashAlg;
    }


    /**
     * Sets the digestHashAlg value for this UserSmartCredentialSignParms.
     * 
     * @param digestHashAlg   * The hash algorithm used to generate the digest.
     *                            Allowed values are SHA-1, SHA-224, SHA-256,
     * SHA-384
     *                            and SHA-512.
     */
    public void setDigestHashAlg(String digestHashAlg) {
        this.digestHashAlg = digestHashAlg;
    }


    /**
     * Gets the digest value for this UserSmartCredentialSignParms.
     * 
     * @return digest   * The base-64 encoded digest to be signed.
     */
    public String getDigest() {
        return digest;
    }


    /**
     * Sets the digest value for this UserSmartCredentialSignParms.
     * 
     * @param digest   * The base-64 encoded digest to be signed.
     */
    public void setDigest(String digest) {
        this.digest = digest;
    }


    /**
     * Gets the summary value for this UserSmartCredentialSignParms.
     * 
     * @return summary   * A summary describing the information that is
     *                            being signed.
     */
    public String getSummary() {
        return summary;
    }


    /**
     * Sets the summary value for this UserSmartCredentialSignParms.
     * 
     * @param summary   * A summary describing the information that is
     *                            being signed.
     */
    public void setSummary(String summary) {
        this.summary = summary;
    }


    /**
     * Gets the callback value for this UserSmartCredentialSignParms.
     * 
     * @return callback   * A URL that will be called by Entrust IdentityGuard
     *                            when a response is ready for the signature.
     * After receiving the callback the client should
     *                            call userSmartCredentialSignComplete to
     * retrieve
     *                            the signature.
     *                            If the URL value includes the token <STATUS>
     * it will be replaced with one of the values CONFIRM,
     *                            CONCERN or CANCEL indicating the status
     * of the
     *                            operation.
     *                            If the URL value includes the token
     *                            <TRANSACTIONID> it will be replaced with
     * the
     *                            transaction Id of the transaction.
     *                            If the URL is not provided, the client
     * application
     *                            can poll Entrust Identity for a response
     * by
     *                            repeatedly calling userSmartCredentialSignComplete.
     */
    public String getCallback() {
        return callback;
    }


    /**
     * Sets the callback value for this UserSmartCredentialSignParms.
     * 
     * @param callback   * A URL that will be called by Entrust IdentityGuard
     *                            when a response is ready for the signature.
     * After receiving the callback the client should
     *                            call userSmartCredentialSignComplete to
     * retrieve
     *                            the signature.
     *                            If the URL value includes the token <STATUS>
     * it will be replaced with one of the values CONFIRM,
     *                            CONCERN or CANCEL indicating the status
     * of the
     *                            operation.
     *                            If the URL value includes the token
     *                            <TRANSACTIONID> it will be replaced with
     * the
     *                            transaction Id of the transaction.
     *                            If the URL is not provided, the client
     * application
     *                            can poll Entrust Identity for a response
     * by
     *                            repeatedly calling userSmartCredentialSignComplete.
     */
    public void setCallback(String callback) {
        this.callback = callback;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserSmartCredentialSignParms)) return false;
        UserSmartCredentialSignParms other = (UserSmartCredentialSignParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.digestHashAlg==null && other.getDigestHashAlg()==null) || 
             (this.digestHashAlg!=null &&
              this.digestHashAlg.equals(other.getDigestHashAlg()))) &&
            ((this.digest==null && other.getDigest()==null) || 
             (this.digest!=null &&
              this.digest.equals(other.getDigest()))) &&
            ((this.summary==null && other.getSummary()==null) || 
             (this.summary!=null &&
              this.summary.equals(other.getSummary()))) &&
            ((this.callback==null && other.getCallback()==null) || 
             (this.callback!=null &&
              this.callback.equals(other.getCallback())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getDigestHashAlg() != null) {
            _hashCode += getDigestHashAlg().hashCode();
        }
        if (getDigest() != null) {
            _hashCode += getDigest().hashCode();
        }
        if (getSummary() != null) {
            _hashCode += getSummary().hashCode();
        }
        if (getCallback() != null) {
            _hashCode += getCallback().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserSmartCredentialSignParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserSmartCredentialSignParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("digestHashAlg");
        elemField.setXmlName(new javax.xml.namespace.QName("", "digestHashAlg"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("digest");
        elemField.setXmlName(new javax.xml.namespace.QName("", "digest"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("summary");
        elemField.setXmlName(new javax.xml.namespace.QName("", "summary"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("callback");
        elemField.setXmlName(new javax.xml.namespace.QName("", "callback"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
