/**
 * UserSmartCredentialUnblockCallParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure contains the parameters passed in a call
 *                         to userSmartCredentialUnblock.
 */
public class UserSmartCredentialUnblockCallParms  implements java.io.Serializable {
    /* The user who owns the Smart Credential to be
     *                                 unblocked. */
    private String userid;

    /* The Id indicating which Smart Credential
     *                                 is to be unblocked. */
    private String id;

    /* The variable that stores the unblock key
     *                                 for the Smart Credential to be unblocked. */
    private String variable;

    /* The unblock challenge generated by the Smart
     *                                 Credential. */
    private String challenge;

    /* If specified, a delivery to be used to
     *                                 delivery the unblock response to the
     * user. */
    private String delivery;

    /* If specified optional parameters passed
     *                                 to the delivery operation.  This parameter
     * is ignored if the delivery is not performed. */
    private UserDeliveryParms parms;

    public UserSmartCredentialUnblockCallParms() {
    }

    public UserSmartCredentialUnblockCallParms(
           String userid,
           String id,
           String variable,
           String challenge,
           String delivery,
           UserDeliveryParms parms) {
           this.userid = userid;
           this.id = id;
           this.variable = variable;
           this.challenge = challenge;
           this.delivery = delivery;
           this.parms = parms;
    }


    /**
     * Gets the userid value for this UserSmartCredentialUnblockCallParms.
     * 
     * @return userid   * The user who owns the Smart Credential to be
     *                                 unblocked.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserSmartCredentialUnblockCallParms.
     * 
     * @param userid   * The user who owns the Smart Credential to be
     *                                 unblocked.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the id value for this UserSmartCredentialUnblockCallParms.
     * 
     * @return id   * The Id indicating which Smart Credential
     *                                 is to be unblocked.
     */
    public String getId() {
        return id;
    }


    /**
     * Sets the id value for this UserSmartCredentialUnblockCallParms.
     * 
     * @param id   * The Id indicating which Smart Credential
     *                                 is to be unblocked.
     */
    public void setId(String id) {
        this.id = id;
    }


    /**
     * Gets the variable value for this UserSmartCredentialUnblockCallParms.
     * 
     * @return variable   * The variable that stores the unblock key
     *                                 for the Smart Credential to be unblocked.
     */
    public String getVariable() {
        return variable;
    }


    /**
     * Sets the variable value for this UserSmartCredentialUnblockCallParms.
     * 
     * @param variable   * The variable that stores the unblock key
     *                                 for the Smart Credential to be unblocked.
     */
    public void setVariable(String variable) {
        this.variable = variable;
    }


    /**
     * Gets the challenge value for this UserSmartCredentialUnblockCallParms.
     * 
     * @return challenge   * The unblock challenge generated by the Smart
     *                                 Credential.
     */
    public String getChallenge() {
        return challenge;
    }


    /**
     * Sets the challenge value for this UserSmartCredentialUnblockCallParms.
     * 
     * @param challenge   * The unblock challenge generated by the Smart
     *                                 Credential.
     */
    public void setChallenge(String challenge) {
        this.challenge = challenge;
    }


    /**
     * Gets the delivery value for this UserSmartCredentialUnblockCallParms.
     * 
     * @return delivery   * If specified, a delivery to be used to
     *                                 delivery the unblock response to the
     * user.
     */
    public String getDelivery() {
        return delivery;
    }


    /**
     * Sets the delivery value for this UserSmartCredentialUnblockCallParms.
     * 
     * @param delivery   * If specified, a delivery to be used to
     *                                 delivery the unblock response to the
     * user.
     */
    public void setDelivery(String delivery) {
        this.delivery = delivery;
    }


    /**
     * Gets the parms value for this UserSmartCredentialUnblockCallParms.
     * 
     * @return parms   * If specified optional parameters passed
     *                                 to the delivery operation.  This parameter
     * is ignored if the delivery is not performed.
     */
    public UserDeliveryParms getParms() {
        return parms;
    }


    /**
     * Sets the parms value for this UserSmartCredentialUnblockCallParms.
     * 
     * @param parms   * If specified optional parameters passed
     *                                 to the delivery operation.  This parameter
     * is ignored if the delivery is not performed.
     */
    public void setParms(UserDeliveryParms parms) {
        this.parms = parms;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserSmartCredentialUnblockCallParms)) return false;
        UserSmartCredentialUnblockCallParms other = (UserSmartCredentialUnblockCallParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.id==null && other.getId()==null) || 
             (this.id!=null &&
              this.id.equals(other.getId()))) &&
            ((this.variable==null && other.getVariable()==null) || 
             (this.variable!=null &&
              this.variable.equals(other.getVariable()))) &&
            ((this.challenge==null && other.getChallenge()==null) || 
             (this.challenge!=null &&
              this.challenge.equals(other.getChallenge()))) &&
            ((this.delivery==null && other.getDelivery()==null) || 
             (this.delivery!=null &&
              this.delivery.equals(other.getDelivery()))) &&
            ((this.parms==null && other.getParms()==null) || 
             (this.parms!=null &&
              this.parms.equals(other.getParms())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getId() != null) {
            _hashCode += getId().hashCode();
        }
        if (getVariable() != null) {
            _hashCode += getVariable().hashCode();
        }
        if (getChallenge() != null) {
            _hashCode += getChallenge().hashCode();
        }
        if (getDelivery() != null) {
            _hashCode += getDelivery().hashCode();
        }
        if (getParms() != null) {
            _hashCode += getParms().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserSmartCredentialUnblockCallParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserSmartCredentialUnblockCallParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("id");
        elemField.setXmlName(new javax.xml.namespace.QName("", "id"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("variable");
        elemField.setXmlName(new javax.xml.namespace.QName("", "variable"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("challenge");
        elemField.setXmlName(new javax.xml.namespace.QName("", "challenge"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("delivery");
        elemField.setXmlName(new javax.xml.namespace.QName("", "delivery"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("parms");
        elemField.setXmlName(new javax.xml.namespace.QName("", "parms"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserDeliveryParms"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
