/**
 * UserSmartCredentialValidateParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines the parameters passed when validating a
 *                      specified request or a transaction. The parameters
 * are used for both the userSmartCredentialValidate and
 *                      the userSmartCredentialTransactionValidate methods.
 */
public class UserSmartCredentialValidateParms  implements java.io.Serializable {
    /* The userSmartCredentialValidate method validates
     *                            that the specified response is the signature
     * of
     *                            a request including the provided challenge. */
    private String challenge;

    /* The userSmartCredentialTransactionValidate
     *                            method validates that the specified response
     * is the signature of this transaction with
     *                            the transaction status specified in the
     * transactionStatus argument.
     *                            If this argument is specified in a call
     * to
     *                            userSmartCredentialValidate then Entrust
     * IdentityGuard verifies that the specified
     *                            value is the current transaction for the
     * specified user. */
    private String transactionId;

    /* The userSmartCredentialTransactionValidate
     *                            method validates that the specified response
     * is the signature of the transaction specified
     *                            in the transactionId argument with this
     * transaction
     *                            status. */
    private TransactionStatusType transactionStatus;

    /* If the security challenge included a digest
     *                            to be signed, the digestSignature parameter
     * in the validate request will be the signature
     *                            of that digest. */
    private String digestSignature;

    /* The response is the generated signature of either
     *                            the challenge (for the userSmartCredentialValidate
     * method) or the transaction (for the
     *                            userSmartCredentialTransactionValidate
     * method). */
    private String response;

    /* The certificate corresponding to the private key
     *                            used to generate the response. */
    private String certificate;

    public UserSmartCredentialValidateParms() {
    }

    public UserSmartCredentialValidateParms(
           String challenge,
           String transactionId,
           TransactionStatusType transactionStatus,
           String digestSignature,
           String response,
           String certificate) {
           this.challenge = challenge;
           this.transactionId = transactionId;
           this.transactionStatus = transactionStatus;
           this.digestSignature = digestSignature;
           this.response = response;
           this.certificate = certificate;
    }


    /**
     * Gets the challenge value for this UserSmartCredentialValidateParms.
     * 
     * @return challenge   * The userSmartCredentialValidate method validates
     *                            that the specified response is the signature
     * of
     *                            a request including the provided challenge.
     */
    public String getChallenge() {
        return challenge;
    }


    /**
     * Sets the challenge value for this UserSmartCredentialValidateParms.
     * 
     * @param challenge   * The userSmartCredentialValidate method validates
     *                            that the specified response is the signature
     * of
     *                            a request including the provided challenge.
     */
    public void setChallenge(String challenge) {
        this.challenge = challenge;
    }


    /**
     * Gets the transactionId value for this UserSmartCredentialValidateParms.
     * 
     * @return transactionId   * The userSmartCredentialTransactionValidate
     *                            method validates that the specified response
     * is the signature of this transaction with
     *                            the transaction status specified in the
     * transactionStatus argument.
     *                            If this argument is specified in a call
     * to
     *                            userSmartCredentialValidate then Entrust
     * IdentityGuard verifies that the specified
     *                            value is the current transaction for the
     * specified user.
     */
    public String getTransactionId() {
        return transactionId;
    }


    /**
     * Sets the transactionId value for this UserSmartCredentialValidateParms.
     * 
     * @param transactionId   * The userSmartCredentialTransactionValidate
     *                            method validates that the specified response
     * is the signature of this transaction with
     *                            the transaction status specified in the
     * transactionStatus argument.
     *                            If this argument is specified in a call
     * to
     *                            userSmartCredentialValidate then Entrust
     * IdentityGuard verifies that the specified
     *                            value is the current transaction for the
     * specified user.
     */
    public void setTransactionId(String transactionId) {
        this.transactionId = transactionId;
    }


    /**
     * Gets the transactionStatus value for this UserSmartCredentialValidateParms.
     * 
     * @return transactionStatus   * The userSmartCredentialTransactionValidate
     *                            method validates that the specified response
     * is the signature of the transaction specified
     *                            in the transactionId argument with this
     * transaction
     *                            status.
     */
    public TransactionStatusType getTransactionStatus() {
        return transactionStatus;
    }


    /**
     * Sets the transactionStatus value for this UserSmartCredentialValidateParms.
     * 
     * @param transactionStatus   * The userSmartCredentialTransactionValidate
     *                            method validates that the specified response
     * is the signature of the transaction specified
     *                            in the transactionId argument with this
     * transaction
     *                            status.
     */
    public void setTransactionStatus(TransactionStatusType transactionStatus) {
        this.transactionStatus = transactionStatus;
    }


    /**
     * Gets the digestSignature value for this UserSmartCredentialValidateParms.
     * 
     * @return digestSignature   * If the security challenge included a digest
     *                            to be signed, the digestSignature parameter
     * in the validate request will be the signature
     *                            of that digest.
     */
    public String getDigestSignature() {
        return digestSignature;
    }


    /**
     * Sets the digestSignature value for this UserSmartCredentialValidateParms.
     * 
     * @param digestSignature   * If the security challenge included a digest
     *                            to be signed, the digestSignature parameter
     * in the validate request will be the signature
     *                            of that digest.
     */
    public void setDigestSignature(String digestSignature) {
        this.digestSignature = digestSignature;
    }


    /**
     * Gets the response value for this UserSmartCredentialValidateParms.
     * 
     * @return response   * The response is the generated signature of either
     *                            the challenge (for the userSmartCredentialValidate
     * method) or the transaction (for the
     *                            userSmartCredentialTransactionValidate
     * method).
     */
    public String getResponse() {
        return response;
    }


    /**
     * Sets the response value for this UserSmartCredentialValidateParms.
     * 
     * @param response   * The response is the generated signature of either
     *                            the challenge (for the userSmartCredentialValidate
     * method) or the transaction (for the
     *                            userSmartCredentialTransactionValidate
     * method).
     */
    public void setResponse(String response) {
        this.response = response;
    }


    /**
     * Gets the certificate value for this UserSmartCredentialValidateParms.
     * 
     * @return certificate   * The certificate corresponding to the private key
     *                            used to generate the response.
     */
    public String getCertificate() {
        return certificate;
    }


    /**
     * Sets the certificate value for this UserSmartCredentialValidateParms.
     * 
     * @param certificate   * The certificate corresponding to the private key
     *                            used to generate the response.
     */
    public void setCertificate(String certificate) {
        this.certificate = certificate;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserSmartCredentialValidateParms)) return false;
        UserSmartCredentialValidateParms other = (UserSmartCredentialValidateParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.challenge==null && other.getChallenge()==null) || 
             (this.challenge!=null &&
              this.challenge.equals(other.getChallenge()))) &&
            ((this.transactionId==null && other.getTransactionId()==null) || 
             (this.transactionId!=null &&
              this.transactionId.equals(other.getTransactionId()))) &&
            ((this.transactionStatus==null && other.getTransactionStatus()==null) || 
             (this.transactionStatus!=null &&
              this.transactionStatus.equals(other.getTransactionStatus()))) &&
            ((this.digestSignature==null && other.getDigestSignature()==null) || 
             (this.digestSignature!=null &&
              this.digestSignature.equals(other.getDigestSignature()))) &&
            ((this.response==null && other.getResponse()==null) || 
             (this.response!=null &&
              this.response.equals(other.getResponse()))) &&
            ((this.certificate==null && other.getCertificate()==null) || 
             (this.certificate!=null &&
              this.certificate.equals(other.getCertificate())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getChallenge() != null) {
            _hashCode += getChallenge().hashCode();
        }
        if (getTransactionId() != null) {
            _hashCode += getTransactionId().hashCode();
        }
        if (getTransactionStatus() != null) {
            _hashCode += getTransactionStatus().hashCode();
        }
        if (getDigestSignature() != null) {
            _hashCode += getDigestSignature().hashCode();
        }
        if (getResponse() != null) {
            _hashCode += getResponse().hashCode();
        }
        if (getCertificate() != null) {
            _hashCode += getCertificate().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserSmartCredentialValidateParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserSmartCredentialValidateParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("challenge");
        elemField.setXmlName(new javax.xml.namespace.QName("", "challenge"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("transactionId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "transactionId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("transactionStatus");
        elemField.setXmlName(new javax.xml.namespace.QName("", "transactionStatus"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "TransactionStatusType"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("digestSignature");
        elemField.setXmlName(new javax.xml.namespace.QName("", "digestSignature"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("response");
        elemField.setXmlName(new javax.xml.namespace.QName("", "response"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("certificate");
        elemField.setXmlName(new javax.xml.namespace.QName("", "certificate"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
