/**
 * UserTokenActivateCompleteCallParms.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * This structure contains the parameters passed in a call
 *                         to userTokenActivateComplete.
 */
public class UserTokenActivateCompleteCallParms  implements java.io.Serializable {
    /* The user who owns the token to be activated. */
    private String userid;

    /* The filter indicating which token is to be
     *                                 activated.  This filter must specify
     * a single
     *                                 token. */
    private UserTokenFilter filter;

    /* Parameters required to activate the token. These the required
     * parameters vary depending on the token vendor implementation,
     *                                 what kind of activation is being performed,
     * and what stage
     *                                 of activation the token is at. For
     * the Entrust Soft Token
     *                                 vendor using the standard OFFLINE
     * activation method, there
     *                                 is one required parameter named "registrationCode",
     * whose
     *                                 value must be the registration code
     * generated by the soft token. */
    private NameValue[] activationParms;

    public UserTokenActivateCompleteCallParms() {
    }

    public UserTokenActivateCompleteCallParms(
           String userid,
           UserTokenFilter filter,
           NameValue[] activationParms) {
           this.userid = userid;
           this.filter = filter;
           this.activationParms = activationParms;
    }


    /**
     * Gets the userid value for this UserTokenActivateCompleteCallParms.
     * 
     * @return userid   * The user who owns the token to be activated.
     */
    public String getUserid() {
        return userid;
    }


    /**
     * Sets the userid value for this UserTokenActivateCompleteCallParms.
     * 
     * @param userid   * The user who owns the token to be activated.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }


    /**
     * Gets the filter value for this UserTokenActivateCompleteCallParms.
     * 
     * @return filter   * The filter indicating which token is to be
     *                                 activated.  This filter must specify
     * a single
     *                                 token.
     */
    public UserTokenFilter getFilter() {
        return filter;
    }


    /**
     * Sets the filter value for this UserTokenActivateCompleteCallParms.
     * 
     * @param filter   * The filter indicating which token is to be
     *                                 activated.  This filter must specify
     * a single
     *                                 token.
     */
    public void setFilter(UserTokenFilter filter) {
        this.filter = filter;
    }


    /**
     * Gets the activationParms value for this UserTokenActivateCompleteCallParms.
     * 
     * @return activationParms   * Parameters required to activate the token. These the required
     * parameters vary depending on the token vendor implementation,
     *                                 what kind of activation is being performed,
     * and what stage
     *                                 of activation the token is at. For
     * the Entrust Soft Token
     *                                 vendor using the standard OFFLINE
     * activation method, there
     *                                 is one required parameter named "registrationCode",
     * whose
     *                                 value must be the registration code
     * generated by the soft token.
     */
    public NameValue[] getActivationParms() {
        return activationParms;
    }


    /**
     * Sets the activationParms value for this UserTokenActivateCompleteCallParms.
     * 
     * @param activationParms   * Parameters required to activate the token. These the required
     * parameters vary depending on the token vendor implementation,
     *                                 what kind of activation is being performed,
     * and what stage
     *                                 of activation the token is at. For
     * the Entrust Soft Token
     *                                 vendor using the standard OFFLINE
     * activation method, there
     *                                 is one required parameter named "registrationCode",
     * whose
     *                                 value must be the registration code
     * generated by the soft token.
     */
    public void setActivationParms(NameValue[] activationParms) {
        this.activationParms = activationParms;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserTokenActivateCompleteCallParms)) return false;
        UserTokenActivateCompleteCallParms other = (UserTokenActivateCompleteCallParms) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.userid==null && other.getUserid()==null) || 
             (this.userid!=null &&
              this.userid.equals(other.getUserid()))) &&
            ((this.filter==null && other.getFilter()==null) || 
             (this.filter!=null &&
              this.filter.equals(other.getFilter()))) &&
            ((this.activationParms==null && other.getActivationParms()==null) || 
             (this.activationParms!=null &&
              java.util.Arrays.equals(this.activationParms, other.getActivationParms())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getUserid() != null) {
            _hashCode += getUserid().hashCode();
        }
        if (getFilter() != null) {
            _hashCode += getFilter().hashCode();
        }
        if (getActivationParms() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getActivationParms());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getActivationParms(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserTokenActivateCompleteCallParms.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserTokenActivateCompleteCallParms"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("userid");
        elemField.setXmlName(new javax.xml.namespace.QName("", "userid"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("filter");
        elemField.setXmlName(new javax.xml.namespace.QName("", "filter"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserTokenFilter"));
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("activationParms");
        elemField.setXmlName(new javax.xml.namespace.QName("", "activationParms"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:commonV9", "NameValue"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
