/**
 * UserTokenFilter.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Apr 22, 2006 (06:55:48 PDT) WSDL2Java emitter.
 */

package com.good.adapters.entrust.stubs;


/**
 * Defines a filter to limit which tokens are returned for
 *                         a user. If both VendorId/SerialNumber and
 * State are
 *                         set, VendorId/SerialNumber is used. If neither
 * are set,
 *                         all tokens for the user are returned.
 *                         If specified, the sets filter applies in addition
 * to
 *                         the other search criteria.
 */
public class UserTokenFilter  implements java.io.Serializable {
    /* Tokens that match the given vendor Id.
     *                                 This value is ignored if the serialNumber
     * is
     *                                 not specified.  If a serial number
     * is specified
     *                                 and this value is not, then the default
     * token
     *                                 vendor is assumed, and any token from
     * the
     *                                 default token vendor matching the
     * given serial
     *                                 number is returned. Note that
     *                                 this value can contain either the
     * name or
     *                                 id of the token vendor.  Either value
     * will
     *                                 match the token vendor. */
    private String vendorId;

    /* Tokens that match the given serial number.
     *                                 The value can include the '*' character
     * for wildcard matching. */
    private String serialNumber;

    /* Tokens that match one of the given states. */
    private State[] state;

    /* Tokens that match one of the given sets. */
    private String[] tokenSets;

    public UserTokenFilter() {
    }

    public UserTokenFilter(
           String vendorId,
           String serialNumber,
           State[] state,
           String[] tokenSets) {
           this.vendorId = vendorId;
           this.serialNumber = serialNumber;
           this.state = state;
           this.tokenSets = tokenSets;
    }


    /**
     * Gets the vendorId value for this UserTokenFilter.
     * 
     * @return vendorId   * Tokens that match the given vendor Id.
     *                                 This value is ignored if the serialNumber
     * is
     *                                 not specified.  If a serial number
     * is specified
     *                                 and this value is not, then the default
     * token
     *                                 vendor is assumed, and any token from
     * the
     *                                 default token vendor matching the
     * given serial
     *                                 number is returned. Note that
     *                                 this value can contain either the
     * name or
     *                                 id of the token vendor.  Either value
     * will
     *                                 match the token vendor.
     */
    public String getVendorId() {
        return vendorId;
    }


    /**
     * Sets the vendorId value for this UserTokenFilter.
     * 
     * @param vendorId   * Tokens that match the given vendor Id.
     *                                 This value is ignored if the serialNumber
     * is
     *                                 not specified.  If a serial number
     * is specified
     *                                 and this value is not, then the default
     * token
     *                                 vendor is assumed, and any token from
     * the
     *                                 default token vendor matching the
     * given serial
     *                                 number is returned. Note that
     *                                 this value can contain either the
     * name or
     *                                 id of the token vendor.  Either value
     * will
     *                                 match the token vendor.
     */
    public void setVendorId(String vendorId) {
        this.vendorId = vendorId;
    }


    /**
     * Gets the serialNumber value for this UserTokenFilter.
     * 
     * @return serialNumber   * Tokens that match the given serial number.
     *                                 The value can include the '*' character
     * for wildcard matching.
     */
    public String getSerialNumber() {
        return serialNumber;
    }


    /**
     * Sets the serialNumber value for this UserTokenFilter.
     * 
     * @param serialNumber   * Tokens that match the given serial number.
     *                                 The value can include the '*' character
     * for wildcard matching.
     */
    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }


    /**
     * Gets the state value for this UserTokenFilter.
     * 
     * @return state   * Tokens that match one of the given states.
     */
    public State[] getState() {
        return state;
    }


    /**
     * Sets the state value for this UserTokenFilter.
     * 
     * @param state   * Tokens that match one of the given states.
     */
    public void setState(State[] state) {
        this.state = state;
    }


    /**
     * Gets the tokenSets value for this UserTokenFilter.
     * 
     * @return tokenSets   * Tokens that match one of the given sets.
     */
    public String[] getTokenSets() {
        return tokenSets;
    }


    /**
     * Sets the tokenSets value for this UserTokenFilter.
     * 
     * @param tokenSets   * Tokens that match one of the given sets.
     */
    public void setTokenSets(String[] tokenSets) {
        this.tokenSets = tokenSets;
    }

    private Object __equalsCalc = null;
    public synchronized boolean equals(Object obj) {
        if (!(obj instanceof UserTokenFilter)) return false;
        UserTokenFilter other = (UserTokenFilter) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.vendorId==null && other.getVendorId()==null) || 
             (this.vendorId!=null &&
              this.vendorId.equals(other.getVendorId()))) &&
            ((this.serialNumber==null && other.getSerialNumber()==null) || 
             (this.serialNumber!=null &&
              this.serialNumber.equals(other.getSerialNumber()))) &&
            ((this.state==null && other.getState()==null) || 
             (this.state!=null &&
              java.util.Arrays.equals(this.state, other.getState()))) &&
            ((this.tokenSets==null && other.getTokenSets()==null) || 
             (this.tokenSets!=null &&
              java.util.Arrays.equals(this.tokenSets, other.getTokenSets())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getVendorId() != null) {
            _hashCode += getVendorId().hashCode();
        }
        if (getSerialNumber() != null) {
            _hashCode += getSerialNumber().hashCode();
        }
        if (getState() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getState());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getState(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        if (getTokenSets() != null) {
            for (int i=0;
                 i<java.lang.reflect.Array.getLength(getTokenSets());
                 i++) {
                Object obj = java.lang.reflect.Array.get(getTokenSets(), i);
                if (obj != null &&
                    !obj.getClass().isArray()) {
                    _hashCode += obj.hashCode();
                }
            }
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(UserTokenFilter.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "UserTokenFilter"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("vendorId");
        elemField.setXmlName(new javax.xml.namespace.QName("", "VendorId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("serialNumber");
        elemField.setXmlName(new javax.xml.namespace.QName("", "SerialNumber"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("state");
        elemField.setXmlName(new javax.xml.namespace.QName("", "State"));
        elemField.setXmlType(new javax.xml.namespace.QName("urn:entrust.com:ig:adminV9:wsdl", "State"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("tokenSets");
        elemField.setXmlName(new javax.xml.namespace.QName("", "TokenSets"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setNillable(true);
        elemField.setItemQName(new javax.xml.namespace.QName("", "item"));
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           String mechType,
           Class _javaType,
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
